/*
FILE:     CifViewObj.C
*/
/*
VERSION:  0.904-beta
*/
/*
DATE:     8/14/2003
*/
/*
  Comments and Questions to: sw-help@rcsb.rutgers.edu
*/
/*
COPYRIGHT 1999-2003 Rutgers - The State University of New Jersey

This software is provided WITHOUT WARRANTY OF MERCHANTABILITY OR
FITNESS FOR A PARTICULAR PURPOSE OR ANY OTHER WARRANTY, EXPRESS OR
IMPLIED.  RUTGERS MAKE NO REPRESENTATION OR WARRANTY THAT THE
SOFTWARE WILL NOT INFRINGE ANY PATENT, COPYRIGHT OR OTHER
PROPRIETARY RIGHT.

The user of this software shall indemnify, hold harmless and defend
Rutgers, its governors, trustees, officers, employees, students,
agents and the authors against any and all claims, suits,
losses, liabilities, damages, costs, fees, and expenses including
reasonable attorneys' fees resulting from or arising out of the
use of this software.  This indemnification shall include, but is
not limited to, any and all claims alleging products liability.
*/
/*
               PDB SOFTWARE LICENSE AGREEMENT

BY CLICKING THE ACCEPTANCE BUTTON OR INSTALLING OR USING 
THIS "SOFTWARE, THE INDIVIDUAL OR ENTITY LICENSING THE  
SOFTWARE ("LICENSEE") IS CONSENTING TO BE BOUND BY AND IS 
BECOMING A PARTY TO THIS AGREEMENT.  IF LICENSEE DOES NOT 
AGREE TO ALL OF THE TERMS OF THIS AGREEMENT
THE LICENSEE MUST NOT INSTALL OR USE THE SOFTWARE.

1. LICENSE AGREEMENT

This is a license between you ("Licensee") and the Protein Data Bank (PDB) 
at Rutgers, The State University of New Jersey (hereafter referred to 
as "RUTGERS").   The software is owned by RUTGERS and protected by 
copyright laws, and some elements are protected by laws governing 
trademarks, trade dress and trade secrets, and may be protected by 
patent laws. 

2. LICENSE GRANT

RUTGERS grants you, and you hereby accept, non-exclusive, royalty-free 
perpetual license to install, use, modify, prepare derivative works, 
incorporate into other computer software, and distribute in binary 
and source code format, or any derivative work thereof, together with 
any associated media, printed materials, and on-line or electronic 
documentation (if any) provided by RUTGERS (collectively, the "SOFTWARE"), 
subject to the following terms and conditions: (i) any distribution 
of the SOFTWARE shall bind the receiver to the terms and conditions 
of this Agreement; (ii) any distribution of the SOFTWARE in modified 
form shall clearly state that the SOFTWARE has been modified from 
the version originally obtained from RUTGERS.  

2. COPYRIGHT; RETENTION OF RIGHTS.  

The above license grant is conditioned on the following: (i) you must 
reproduce all copyright notices and other proprietary notices on any 
copies of the SOFTWARE and you must not remove such notices; (ii) in 
the event you compile the SOFTWARE, you will include the copyright 
notice with the binary in such a manner as to allow it to be easily 
viewable; (iii) if you incorporate the SOFTWARE into other code, you 
must provide notice that the code contains the SOFTWARE and include 
a copy of the copyright notices and other proprietary notices.  All 
copies of the SOFTWARE shall be subject to the terms of this Agreement.  

3. NO MAINTENANCE OR SUPPORT; TREATMENT OF ENHANCEMENTS 

RUTGERS is under no obligation whatsoever to: (i) provide maintenance 
or support for the SOFTWARE; or (ii) to notify you of bug fixes, patches, 
or upgrades to the features, functionality or performance of the 
SOFTWARE ("Enhancements") (if any), whether developed by RUTGERS 
or third parties.  If, in its sole discretion, RUTGERS makes an 
Enhancement available to you and RUTGERS does not separately enter 
into a written license agreement with you relating to such bug fix, 
patch or upgrade, then it shall be deemed incorporated into the SOFTWARE 
and subject to this Agreement. You are under no obligation whatsoever 
to provide any Enhancements to RUTGERS or the public that you may 
develop over time; however, if you choose to provide your Enhancements 
to RUTGERS, or if you choose to otherwise publish or distribute your 
Enhancements, in source code form without contemporaneously requiring 
end users or RUTGERS to enter into a separate written license agreement 
for such Enhancements, then you hereby grant RUTGERS a non-exclusive,
royalty-free perpetual license to install, use, modify, prepare
derivative works, incorporate into the SOFTWARE or other computer
software, distribute, and sublicense your Enhancements or derivative
works thereof, in binary and source code form.

4. FEES.  There is no license fee for the SOFTWARE.  If Licensee
wishes to receive the SOFTWARE on media, there may be a small charge
for the media and for shipping and handling.  Licensee is
responsible for any and all taxes.

5. TERMINATION.  Without prejudice to any other rights, Licensor
may terminate this Agreement if Licensee breaches any of its terms
and conditions.  Upon termination, Licensee shall destroy all
copies of the SOFTWARE.

6. PROPRIETARY RIGHTS.  Title, ownership rights, and intellectual
property rights in the Product shall remain with RUTGERS.  Licensee 
acknowledges such ownership and intellectual property rights and will 
not take any action to jeopardize, limit or interfere in any manner 
with RUTGERS' ownership of or rights with respect to the SOFTWARE.  
The SOFTWARE is protected by copyright and other intellectual 
property laws and by international treaties.  Title and related 
rights in the content accessed through the SOFTWARE is the property 
of the applicable content owner and is protected by applicable law.  
The license granted under this Agreement gives Licensee no rights to such
content.

7. DISCLAIMER OF WARRANTY.  THE SOFTWARE IS PROVIDED FREE OF 
CHARGE, AND, THEREFORE, ON AN "AS IS" BASIS, WITHOUT WARRANTY OF 
ANY KIND, INCLUDING WITHOUT LIMITATION THE WARRANTIES THAT IT 
IS FREE OF DEFECTS, MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE 
OR NON-INFRINGING.  THE ENTIRE RISK AS TO THE QUALITY AND 
PERFORMANCE OF THE SOFTWARE IS BORNE BY LICENSEE.  SHOULD THE 
SOFTWARE PROVE DEFECTIVE IN ANY RESPECT, THE LICENSEE AND NOT 
LICENSOR ASSUMES THE ENTIRE COST OF ANY SERVICE AND REPAIR.  
THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF 
THIS AGREEMENT.  NO USE OF THE PRODUCT IS AUTHORIZED HEREUNDER 
EXCEPT UNDER THIS DISCLAIMER.

8. LIMITATION OF LIABILITY.  TO THE MAXIMUM EXTENT PERMITTED BY
APPLICABLE LAW,  IN NO EVENT WILL LICENSOR BE LIABLE FOR ANY 
INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
OUT OF THE USE OF OR INABILITY TO USE THE SOFTWARE, INCLUDING, 
WITHOUT LIMITATION, DAMAGES FOR LOSS OF GOODWILL, WORK 
STOPPAGE, COMPUTER FAILURE OR MALFUNCTION, OR ANY AND ALL 
OTHER COMMERCIAL DAMAGES OR LOSSES, EVEN IF ADVISED OF THE
POSSIBILITY THEREOF. 
*/
#include "CifViewObj.h"


const int CifViewObj::TRUE  = 1;
const int CifViewObj::FALSE = 0;
void CifViewObj::Close(){
  //  cout << " Close View File" << endl;
  // _fobj->WriteTable(_categoryState,_viewBlockId,_categoryState->GetName()); 
  // _fobj->PrintHeaderInfo();
  _fobj->CloseFile();
};


CifViewObj::CifViewObj(char * objFileName, const char *blockId, int verbose) {
  //  int ierr;

  Clear();
  _verbose = verbose;

  if (_objFileName) delete _objFileName;
  _objFileName = new char[strlen(objFileName)+1];
  strcpy(_objFileName, objFileName);

  if (_viewBlockId) delete _viewBlockId;
  _viewBlockId = new char[strlen(blockId)+1];
  strcpy(_viewBlockId, blockId);

  //jdw  _fobj = new CifFileObj(objFileName,APPEND_MODE);
  //jdw  no public update methods on view.

  _fobj = new CifFileObj(objFileName,READ_MODE);

  // _fobj->PrintHeaderInfo();

  _GetView(blockId);
  //   ierr = _GetView(blockId);
  //   cout << "Error code is " << ierr << endl;

  _categoryState=_fobj->GetTablePtr(_viewBlockId,"ndb_tool_category_state");
  //  _categoryState=_InitCategoryStateTable();
}

CifViewObj::CifViewObj(char *viewFileName, char * objFileName, const char *blockId, int verbose) {
  Clear();
  //  cout << "Primary constructor" << endl;
  _verbose = verbose;
  if (viewFileName == NULL || !strlen(viewFileName)) return;
  if (objFileName == NULL  || !strlen(objFileName))  return;
  if (blockId == NULL      || !strlen(blockId))      return;

  if (_objFileName) delete _objFileName;
  _objFileName = new char[strlen(objFileName)+1];
  strcpy(_objFileName, objFileName);

  if (_viewFileName) delete _viewFileName;
  _viewFileName = new char[strlen(viewFileName)+1];
  strcpy(_viewFileName, viewFileName);

  if (_viewBlockId) delete _viewBlockId;
  _viewBlockId = new char[strlen(blockId)+1];
  strcpy(_viewBlockId, blockId);

  _fobj = new CifFileObj(objFileName,WRITE_MODE);
  _fobj->Read(_viewFileName, _viewDiagnostics);

  //   if (verbose)  cerr << "View diags " << _viewDiagnostics << endl; 
  //   int ierr;
  //  ierr = _GetView(blockId);
  _GetView(blockId);
  //   if (verbose)  cerr << "View diags ierr " << ierr << endl; 

  _categoryState=_InitCategoryStateTable();
  _fobj->WriteTable(_categoryState,_viewBlockId,_categoryState->GetName());
}


void CifViewObj::Clear() {
  _objFileName = NULL;
  _viewFileName = NULL;
  _viewDiagnostics = NULL;
  _viewBlockId = NULL;
  _fobj=NULL;
  _categories = NULL;
  _groups = NULL;
  _items = NULL;
  _categoryState = NULL;
  _verbose=0;
}

void CifViewObj::Reset() {
  if (_objFileName)     delete[] _objFileName;
  if (_viewFileName)    delete[] _viewFileName;
  if (_viewBlockId)     delete[] _viewBlockId;
  if (_fobj)            delete _fobj;
  //  if (_groups)          delete _groups;
  //  if (_categories)      delete _categories;
  //  if (_categoryState)   delete _categoryState;
  //  if (_items)           delete _items;
  if (_viewDiagnostics) delete _viewDiagnostics;
}

char * CifViewObj::GetViewDiagnostics() {
  char *diags=NULL;
  if (! _viewDiagnostics) return diags;
  diags = new char[strlen(_viewDiagnostics)+1];
  strcpy(diags, _viewDiagnostics);
  return (diags);
}

int CifViewObj::_GetView(const char *blockId) {
  if (!_fobj) return -1;
  if ((_categories=_fobj->GetTablePtr(blockId, "ndb_view_category")) == NULL) return -2;
  if ((_items=_fobj->GetTablePtr(blockId, "ndb_view_item")) == NULL) return -3;
  if ((_groups=_fobj->GetTablePtr(blockId, "ndb_view_category_group")) == NULL) return -4;
  return 0;
}


CifString * CifViewObj::GetGroupDescription(const char *group) {
  ReVarPCifArray<int>       *iResult = NULL;
  ReVarCifArray<CifString>  *sResult=NULL;
  int errCode=0, colIndex1, colIndex2;
  CifString cs;
  CifString *ret=NULL;

  if (!_fobj)  return ret;
  if (!_groups) return ret;
  if ( !group  || !strlen(group) ) return ret;

  cs.Clear(); cs.Copy(group);

  colIndex1 = _groups->GetColumnIndex("view_group_id"); 
  colIndex2 = _groups->GetColumnIndex("description"); 
  iResult   = _groups->SearchColumn(cs,colIndex1,errCode);
  if (!errCode  && iResult && (iResult->Length() > 0)) {
    sResult = _groups->GetSubRow((*iResult)[0],colIndex2,colIndex2);
    ret = &(*sResult)[0];
    return ret;
  } else {
    return ret;
  }
}

int CifViewObj::GetCategoryMandatoryCode(const char *category) {
  ReVarPCifArray<int>       *iResult = NULL;
  ReVarCifArray<CifString> *sResult=NULL;
  char tmp[21];
  int errCode=0, colIndex1, colIndex2, i, mCode=0;
  CifString cs;

  if (!_fobj) return -1;
  if (!_categories) return -1;
  if ( !category  || !strlen(category) ) return -1;

  cs.Clear(); cs.Copy(category);

  colIndex1 = _categories->GetColumnIndex("category_id"); 
  colIndex2 = _categories->GetColumnIndex("category_view_mandatory_code"); 
  iResult = _categories->SearchColumn(cs,colIndex1,errCode);
  if (!errCode  && iResult && (iResult->Length() > 0)) {
    sResult = _categories->GetSubRow((*iResult)[0],colIndex2,colIndex2);
    if (!strcmp((*sResult)[0].Text(),"H")) {
      mCode = 2;
    } else if (!strcmp((*sResult)[0].Text(),"Y")) {
      mCode = 1;
    } else {
      strncpy(tmp,(*sResult)[0].Text(),20);
      i= atoi(&tmp[1]);
      if ((i > 2) && (i < 10000)) mCode = i;
    }
    return mCode;
  } else {
    return -1;
  }
}


int CifViewObj::GetCategoryIndex(const char *category) {
  ReVarPCifArray<int>       *iResult = NULL;
  int errCode=0, colIndex1;
  CifString cs;

  if (!_fobj) return -1;
  if (!_categories) return -1;
  if ( !category  || !strlen(category) ) return -1;

  cs.Clear(); cs.Copy(category);
  colIndex1 = _categories->GetColumnIndex("category_id"); 
  iResult = _categories->SearchColumn(cs,colIndex1,errCode);

  if (!errCode  && iResult && (iResult->Length() > 0)) {
    return ((*iResult)[0]);
  } else {
    return -1;
  }
}

int CifViewObj::GetViewCategoryIndex(const char *category) {
  ReVarPCifArray<int>       *iResult = NULL;
  int errCode=0, colIndex1;
  CifString cs;

  if (!_fobj) return -1;
  if (!_categories) return -1;
  if ( !category  || !strlen(category) ) return -1;

  cs.Clear(); cs.Copy(category);
  colIndex1 = _categories->GetColumnIndex("category_view_name"); 
  iResult   = _categories->SearchColumn(cs,colIndex1,errCode);

  if (!errCode  && iResult && (iResult->Length() > 0)) {
    return ((*iResult)[0]);
  } else {
    return -1;
  }
}

int CifViewObj::GetNumViewCategories() {
  if (!_fobj) return 0;
  if (!_categories) return 0;
  return(_categories->GetNumRows());
}


int CifViewObj::GetCategoryDisplayCode(const char *category) {
  ReVarPCifArray<int>       *iResult = NULL;
  ReVarCifArray<CifString> *sResult=NULL;
  char tmp[21];
  int errCode=0, colIndex1, colIndex2, i, mCode=0;
  CifString cs;

  if (!_fobj) return -1;
  if (!_categories) return -1;
  if ( !category  || !strlen(category) ) return -1;

  cs.Clear(); cs.Copy(category);

  colIndex1 = _categories->GetColumnIndex("category_id"); 
  colIndex2 = _categories->GetColumnIndex("category_view_display_code"); 
  iResult = _categories->SearchColumn(cs,colIndex1,errCode);
  if (!errCode  && iResult && (iResult->Length() > 0)) {
    sResult = _categories->GetSubRow((*iResult)[0],colIndex2,colIndex2);
    strncpy(tmp,(*sResult)[0].Text(),20);
    if (tmp[0] == 'R' || tmp[0] =='r') {
      return 0;  // row-wise
    } else {
      i= atoi(&tmp[1]);
      if ((i >= 1) && (i < 10000)) mCode = i;
      return mCode;
    }
  } else {
    return -1;
  }
}


int CifViewObj::GetItemMandatoryCode(const char *item) {
  ReVarPCifArray<int>       *iResult = NULL;
  ReVarCifArray<CifString>  *sResult=NULL;
  int errCode=0, colIndex1, colIndex2, mCode=0;
  CifString cs;

  if (!_fobj)  return -1;
  if (!_items) return -1;
  if ( !item  || !strlen(item) ) return -1;

  cs.Clear(); cs.Copy(item);

  colIndex1 = _items->GetColumnIndex("item_name"); 
  colIndex2 = _items->GetColumnIndex("item_view_mandatory_code"); 
  iResult   = _items->SearchColumn(cs,colIndex1,errCode);
  if (!errCode  && iResult && (iResult->Length() > 0)) {
    sResult = _items->GetSubRow((*iResult)[0],colIndex2,colIndex2);
    if (!strcmp((*sResult)[0].Text(),"H")) mCode = 2;
    else if (!strcmp((*sResult)[0].Text(),"Y")) mCode = 1;
    return mCode;
  } else {
    return -1;
  }
}


CifString * CifViewObj::GetViewItem(const char *item) {
  ReVarPCifArray<int>       *iResult = NULL;
  ReVarCifArray<CifString>  *sResult=NULL;
  int errCode=0, colIndex1, colIndex2;
  CifString cs;
  CifString *ret=NULL;

  if (!_fobj)  return ret;
  if (!_items) return ret;
  if ( !item  || !strlen(item) ) return ret;

  cs.Clear(); cs.Copy(item);

  colIndex1 = _items->GetColumnIndex("item_name"); 
  colIndex2 = _items->GetColumnIndex("item_view_name"); 
  iResult   = _items->SearchColumn(cs,colIndex1,errCode);
  if (!errCode  && iResult && (iResult->Length() > 0)) {
    sResult = _items->GetSubRow((*iResult)[0],colIndex2,colIndex2);
    ret = &(*sResult)[0];
    return ret;
  } else {
    return ret;
  }
}


int CifViewObj::GetItemInfo(const char *item, char viewName[], 
			    int & mandatoryCode, 
			    int & allowAlternateCode) {
  ReVarPCifArray<int>       *iResult = NULL;
  ReVarCifArray<CifString>  *sResult=NULL;
  int errCode=0, colIndex1, colIndex2, colIndex3, colIndex4, mCode, aCode;
  CifString cs;


  if (!_fobj)  return -1;
  if (!_items) return -1;
  if ( !item  || !strlen(item) ) return -1;

  cs.Clear(); cs.Copy(item);

  colIndex1 = _items->GetColumnIndex("item_name"); 
  colIndex2 = _items->GetColumnIndex("item_view_name"); 
  colIndex3 = _items->GetColumnIndex("item_view_mandatory_code"); 
  colIndex4 = _items->GetColumnIndex("item_view_allow_alternate_value"); 
  iResult   = _items->SearchColumn(cs,colIndex1,errCode);
  aCode = mCode = 0;
  if (!errCode  && iResult && (iResult->Length() > 0)) {
    sResult = _items->GetSubRow((*iResult)[0],colIndex2,colIndex2);
    strcpy(viewName,(*sResult)[0].Text());
    if (sResult) delete sResult;
    sResult = _items->GetSubRow((*iResult)[0],colIndex3,colIndex3);
    if (!strcmp((*sResult)[0].Text(),"H")) 
      mCode = VOBJ_DATA_HIDDEN;
    else if (!strcmp((*sResult)[0].Text(),"Y")) 
      mCode = VOBJ_DATA_MANDATORY;
    else
      mCode = VOBJ_DATA_OPTIONAL;
    mandatoryCode = mCode;
    if (sResult) delete sResult;
    sResult = _items->GetSubRow((*iResult)[0],colIndex4,colIndex4);
    if (!strcmp((*sResult)[0].Text(),"MY"))
      aCode = VOBJ_ENUM_MULTI;
    else if (!strcmp((*sResult)[0].Text(),"MN")) 
      aCode = VOBJ_ENUM_MULTI_STRICT;
    else if (!strcmp((*sResult)[0].Text(),"Y")) 
      aCode = VOBJ_ENUM_SINGLE;
    else 
      aCode = VOBJ_ENUM_SINGLE_STRICT;
    allowAlternateCode = aCode;
    if (sResult) delete sResult;

    return 1;
  } else {
    return -1;
  }
}


CifString * CifViewObj::GetViewGroup(const char *category) {
  ReVarPCifArray<int>       *iResult = NULL;
  ReVarCifArray<CifString>  *sResult=NULL;
  int errCode=0, colIndex1, colIndex2;
  CifString cs;
  CifString *ret=NULL;

  if (!_fobj)  return ret;
  if (!_categories) return ret;
  if ( !category  || !strlen(category) ) return ret;

  cs.Clear(); cs.Copy(category);

  colIndex1 = _categories->GetColumnIndex("category_id"); 
  colIndex2 = _categories->GetColumnIndex("view_group_id"); 
  iResult   = _categories->SearchColumn(cs,colIndex1,errCode);
  if (!errCode  && iResult && (iResult->Length() > 0)) {
    sResult = _categories->GetSubRow((*iResult)[0],colIndex2,colIndex2);
    ret = &(*sResult)[0];
    return ret;
  } else {
    return ret;
  }
}


CifString * CifViewObj::GetViewCategory(const char *category) {
  ReVarPCifArray<int>       *iResult = NULL;
  ReVarCifArray<CifString>  *sResult=NULL;
  int errCode=0, colIndex1, colIndex2;
  CifString cs;
  CifString *ret=NULL;

  if (!_fobj)  return ret;
  if (!_categories) return ret;
  if ( !category  || !strlen(category) ) return ret;

  cs.Clear(); cs.Copy(category);

  colIndex1 = _categories->GetColumnIndex("category_id"); 
  colIndex2 = _categories->GetColumnIndex("category_view_name"); 
  iResult   = _categories->SearchColumn(cs,colIndex1,errCode);
  if (!errCode  && iResult && (iResult->Length() > 0)) {
    sResult = _categories->GetSubRow((*iResult)[0],colIndex2,colIndex2);
    ret = &(*sResult)[0];
    return ret;
  } else {
    return ret;
  }
}



int CifViewObj::GetItemAllowAlternateValue(const char *item) {
  ReVarPCifArray<int>       *iResult = NULL;
  ReVarCifArray<CifString>  *sResult=NULL;
  int errCode=0, colIndex1, colIndex2, mCode=0;
  CifString cs;

  if (!_fobj)  return -1;
  if (!_items) return -1;
  if ( !item  || !strlen(item) ) return -1;

  cs.Clear(); cs.Copy(item);

  colIndex1 = _items->GetColumnIndex("item_name"); 
  colIndex2 = _items->GetColumnIndex("item_view_allow_alternate_value"); 
  iResult   = _items->SearchColumn(cs,colIndex1,errCode);
  if (!errCode  && iResult && (iResult->Length() > 0)) {
    sResult = _items->GetSubRow((*iResult)[0],colIndex2,colIndex2);
    if (!strcmp((*sResult)[0].Text(),"MY")) 
      mCode = VOBJ_ENUM_MULTI;
    else if (!strcmp((*sResult)[0].Text(),"MN")) 
      mCode = VOBJ_ENUM_MULTI_STRICT;
    else if (!strcmp((*sResult)[0].Text(),"Y")) 
      mCode = VOBJ_ENUM_SINGLE;
    else 
      mCode = VOBJ_ENUM_SINGLE_STRICT;
    return mCode;
  } else {
    return -1;
  }
}


ReVarCifArray<CifString>  * CifViewObj::GetCategoryItems(const char *category) {
  ReVarPCifArray<int>       *iResult = NULL;
  ReVarCifArray<CifString>  *sResult=NULL;
  int errCode=0, colIndex1, colIndex2;
  CifString cs;
  
  if (!_fobj)  return sResult;
  if (!_items) return sResult;
  if ( !category || !strlen(category) ) return sResult;

  cs.Clear(); cs.Copy(category);
  colIndex1 = _items->GetColumnIndex("category_id"); 
  colIndex2 = _items->GetColumnIndex("item_name"); 
  iResult   = _items->SearchColumn(cs,colIndex1,errCode);
  if (!errCode  && iResult && (iResult->Length() > 0)) {
    sResult = _items->GetSubColumnByIndex(colIndex2,iResult);
  }
  if (iResult) delete iResult;
  return sResult;
}


ReVarCifArray<CifString>  * CifViewObj::GetCategoryViewItems(const char *category) {
  ReVarPCifArray<int>       *iResult = NULL;
  ReVarCifArray<CifString>  *sResult=NULL;
  int errCode=0, colIndex1, colIndex2;
  CifString cs;
  
  if (!_fobj)  return sResult;
  if (!_items) return sResult;
  if ( !category || !strlen(category) ) return sResult;

  cs.Clear(); cs.Copy(category);
  
  colIndex1 = _items->GetColumnIndex("category_id"); 
  colIndex2 = _items->GetColumnIndex("item_view_name"); 
  iResult   = _items->SearchColumn(cs,colIndex1,errCode);
  if (!errCode  && iResult && (iResult->Length() > 0)) {
    sResult = _items->GetSubColumnByIndex(colIndex2,iResult);
  }
  if (iResult) delete iResult;
  return sResult;
}


ReVarCifArray<CifString>  * CifViewObj::GetCategories() {
  ReVarCifArray<CifString>  *sResult=NULL;

  int colIndex1;
  
  if (!_fobj)  return sResult;
  if (!_categories) return sResult;
  
  colIndex1 = _categories->GetColumnIndex("category_id"); 
  sResult = _categories->GetColumn(colIndex1);
  return sResult;
}


ReVarCifArray<CifString>  * CifViewObj::GetViewCategories() {
  ReVarCifArray<CifString>  *sResult=NULL;

  int colIndex1;
  
  if (!_fobj)  return sResult;
  if (!_categories) return sResult;
  
  colIndex1 = _categories->GetColumnIndex("category_view_name"); 
  sResult = _categories->GetColumn(colIndex1);
  return sResult;
}

ReVarCifArray<CifString>  * CifViewObj::GetGroups() {
  ReVarCifArray<CifString>  *sResult=NULL;

  int colIndex1;
  
  if (!_fobj)   return sResult;
  if (!_groups) return sResult;
  
  colIndex1 = _groups->GetColumnIndex("view_group_id"); 
  sResult = _groups->GetColumn(colIndex1);
  return sResult;
}



ReVarCifArray<CifString>  * CifViewObj::GetGroupCategories(const char *group) {
  ReVarPCifArray<int>       *iResult = NULL;
  ReVarCifArray<CifString>  *sResult=NULL;
  int errCode=0, colIndex1, colIndex2;
  CifString cs;
  
  if (!_fobj)  return sResult;
  if (!_categories) return sResult;
  if ( !group || !strlen(group) ) return sResult;

  cs.Clear(); cs.Copy(group);
  
  colIndex1 = _categories->GetColumnIndex("view_group_id"); 
  colIndex2 = _categories->GetColumnIndex("category_id"); 
  iResult   = _categories->SearchColumn(cs,colIndex1,errCode);
  //  cerr << "i1 " << colIndex1 << " i2 " << colIndex2 << " length " << iResult->Length() << endl;
  if (!errCode  && iResult && (iResult->Length() > 0)) {
    sResult = _categories->GetSubColumnByIndex(colIndex2,iResult);
  }
  return sResult;
}


ReVarCifArray<CifString>  * CifViewObj::GetGroupViewCategories(const char *group) {
  ReVarPCifArray<int>       *iResult = NULL;
  ReVarCifArray<CifString>  *sResult=NULL;
  int errCode=0, colIndex1, colIndex2;
  CifString cs;
  
  if (!_fobj)  return sResult;
  if (!_categories) return sResult;
  if ( !group || !strlen(group) ) return sResult;

  cs.Clear(); cs.Copy(group);
  
  colIndex1 = _categories->GetColumnIndex("view_group_id"); 
  colIndex2 = _categories->GetColumnIndex("category_view_name"); 
  iResult   = _categories->SearchColumn(cs,colIndex1,errCode);
  if (!errCode  && iResult && (iResult->Length() > 0)) {
    sResult = _categories->GetSubColumnByIndex(colIndex2,iResult);
  }
  return sResult;
}


int CifViewObj::AddMissingTable(ISTable *t, CifString initValue) {

  ReVarCifArray<CifString> *viewItems=NULL;
  int i;
  CifString *cs=NULL;
  
  char keyword[MAX_CIF_NAME_LENGTH];

  if (!t) return -1;
  if (!t->GetName()) return -1;
  if (initValue.IsNull() || ! initValue.Length()) return -2;

  if (((viewItems=GetCategoryItems(t->GetName()))==NULL) || (viewItems->Length() <= 0)) return -3;

  cs = new CifString;
  cs->Copy(initValue.Text());

  if (!t->GetNumColumns()) { // Add columns and 1 blank row to empty tables .

    for (i=0; i < viewItems->Length(); i++) {
      _GetKeywordFromItemName(keyword,(*viewItems)[i].Text());
      t->AddColumn(keyword, FALSE);
    }
    t->AddRow();
    for (i=0; i < viewItems->Length(); i++) {
      t->AddElementToRow(*cs,0);
    }
    return viewItems->Length();
  }
  return 0;
}


int CifViewObj::FixMissingColumns(ISTable *t, CifString initValue) {
  /*
   *  To input table t, add columns not in view and removes any extra columns.
   *  Returns the number of columns added or removed or 0.
   */
  ReVarCifArray<CifString>  *items=NULL, *viewItems=NULL, *values=NULL;
  int i,j,k, iExists=0, icol, newColumns=0;
  CifString *cs=NULL;
  
  char keyword[MAX_CIF_NAME_LENGTH];

  if (!t) return -1;
  if (!t->GetName()) return -1;
  if (initValue.IsNull() || ! initValue.Length()) return -2;

  if (((viewItems=GetCategoryItems(t->GetName()))==NULL) || (viewItems->Length() <= 0)) return -3;

  cs = new CifString;
  cs->Copy(initValue.Text());

  if (!t->GetNumColumns()) { // Add columns and 1 blank row to empty tables .

    for (i=0; i < viewItems->Length(); i++) {
      _GetKeywordFromItemName(keyword,(*viewItems)[i].Text());
      t->AddColumn(keyword, FALSE);
    }
    t->AddRow();
    for (i=0; i < viewItems->Length(); i++) {
      t->AddElementToRow(*cs,0);
    }
    return viewItems->Length();
  }

  if ((t->GetName()) == NULL) return -4;

  items = t->GetItemNames();
  values = new ReVarCifArray<CifString>;
  for (i=0; i < viewItems->Length(); i++) {
    iExists = 0;
    for (j=0; j < items->Length(); j++) {
      //      if (!CompareNoCase((*viewItems)[i], (*items)[j])) {
      if (!strcmp((*viewItems)[i].Text(), (*items)[j].Text())) {
	iExists=1;
	break;
      }
    }


    if (!iExists) {
      //      cerr << "        missing column " << (*viewItems)[i].Text() << endl;
       _GetKeywordFromItemName(keyword,(*viewItems)[i].Text());
      icol=t->AddColumn(keyword);
      values->Clear();
      for (k=0; k < t->GetNumRows(); k++) {
	values->Add(*cs);
      }
      t->FillColumn(*values,icol);
      newColumns++;
    }
  }
  // JDW 31-JULY-98 - remove columns not in view.
#if 1
  delete (items);
  items = t->GetItemNames();
  for (j=0; j < items->Length(); j++) {
    iExists = 0;
    for (i=0; i < viewItems->Length(); i++) {
      //      if (!CompareNoCase((*viewItems)[i], (*items)[j])) {
      if (!strcmp((*viewItems)[i].Text(), (*items)[j].Text())) {
	iExists=1;
	break;
      }
    }
    if (!iExists) {
      newColumns++;
      //      cerr << "DELETED column" << (*items)[j].Text() << endl;
      t->DeleteColumn(j);  // just mark for removal
    }
  }
  for (j=0; j < items->Length(); j++) {
    if (t->ColumnLength(j) == 0) t->RemoveColumn(j);
  }

#endif
  if (items)  delete items;
  if (viewItems)  delete viewItems;
  if (values) delete values;

  return newColumns;
}


int CifViewObj::AddMissingColumns(ISTable *t, CifString initValue) {
  /*
   *  To input table t, add columns not in view.
   *  Returns the number of columns added or 0.
   */
  ReVarCifArray<CifString>  *items=NULL, *viewItems=NULL, *values=NULL;
  int i,j,k, iExists=0, icol, newColumns=0;
  CifString *cs=NULL;
  
  char keyword[MAX_CIF_NAME_LENGTH];

  if (!t) return -1;
  if (!t->GetName()) return -1;
  if (initValue.IsNull() || ! initValue.Length()) return -2;

  if (((viewItems=GetCategoryItems(t->GetName()))==NULL) || (viewItems->Length() <= 0)) return -3;

  cs = new CifString;
  cs->Copy(initValue.Text());

  if (!t->GetNumColumns()) { // Add columns and 1 blank row to empty tables .

    for (i=0; i < viewItems->Length(); i++) {
      _GetKeywordFromItemName(keyword,(*viewItems)[i].Text());
      t->AddColumn(keyword, FALSE);
    }
    t->AddRow();
    for (i=0; i < viewItems->Length(); i++) {
      t->AddElementToRow(*cs,0);
    }
    return viewItems->Length();
  }

  if ((t->GetName()) == NULL) return -4;

  items = t->GetItemNames();
  values = new ReVarCifArray<CifString>;
  for (i=0; i < viewItems->Length(); i++) {
    iExists = 0;
    for (j=0; j < items->Length(); j++) {
      //      if (!CompareNoCase((*viewItems)[i], (*items)[j])) {
      if (!strcmp((*viewItems)[i].Text(), (*items)[j].Text())) {
	iExists=1;
	break;
      }
    }


    if (!iExists) {
      //      cerr << "        missing column " << (*viewItems)[i].Text() << endl;
       _GetKeywordFromItemName(keyword,(*viewItems)[i].Text());
      icol=t->AddColumn(keyword);
      values->Clear();
      for (k=0; k < t->GetNumRows(); k++) {
	values->Add(*cs);
      }
      t->FillColumn(*values,icol);
      newColumns++;
    }
  }
  if (items)  delete items;
  if (viewItems)  delete viewItems;
  if (values) delete values;

  return newColumns;
}




int CifViewObj::_GetKeywordFromItemName(char keyword[MAX_CIF_NAME_LENGTH], const char *itemName) 
/* ----------------------------------------------------------------------
   Purpose: GetKeywordFromItemName(keyword, itemName) 
   
            Get the keyword part of an item name (ie. _<category>.<keyword>)
            Return 1 for success or 0 otherwise.

 * ---------------------------------------------------------------------- */
{
  int i,j,k,ilen;

  strcpy(keyword,"");
  if (!itemName ||   (ilen=strlen(itemName)) < 3 ) return(0);

  //  if (_verbose) log << "Item name is " << itemName << " len is " << ilen << endl;  
  for (k=1; k < ilen; k++) {
    if (itemName[k] == '.') break;
  }
  if ((k==1) || (k == ilen)) return(0);
  //  if (_verbose) log << "k " << k << " ilen " << ilen << endl;

  j=0;
  for (i=k+1; i < ilen; i++) {
    keyword[j] = itemName[i];
    j++;
  }
  keyword[j]='\0';
  return(1);

}


ReVarCifArray<CifString> * CifViewObj::GetCategoryItemsViewable(const char *category) {
  
  ReVarPCifArray<int> *iResult = NULL, *iResult1 = NULL, *iResult2 = NULL;
  ReVarCifArray<CifString> *l1=NULL; 
  
  int  errCode=0, colIndex1;
  ReVarPCifArray<int> colInds;
  ReVarCifArray<CifString> cs1, cs2;

  CifString groupS, yS, nS;

  //  cerr << "In: GetCategoryItemsViewable with " << category << endl;

  if (!_fobj)  return l1;
  if (!_items) return l1;
  if ( !category || !strlen(category) ) return l1;
  
  colInds.Clear();
  colInds.Add(_items->GetColumnIndex("category_id"));
  colInds.Add(_items->GetColumnIndex("item_view_mandatory_code")); 

  groupS.Clear(); groupS.Copy(category); 
  nS.Clear(); nS.Copy("N"); 
  cs2.Clear();    cs2.Add(groupS);   cs2.Add(nS);

  iResult2   = _items->Search(cs2,colInds,errCode);
  //  if (errCode) cerr << " errcode = " << errCode << endl;
  // if (iResult2)   cerr  << " iResult2 length " << iResult2->Length() << endl;

  groupS.Clear(); groupS.Copy(category); 
  yS.Clear(); yS.Copy("Y"); 
  cs1.Clear();    cs1.Add(groupS);   cs1.Add(yS);
  iResult1   = _items->Search(cs1,colInds,errCode);

  // if (errCode) cerr << " errcode = " << errCode << endl;
  // if (iResult1)  cerr << "iResult1 length " << iResult1->Length() << endl;


  iResult = ISTable::SetUnion(iResult1, iResult2);
    

  if (iResult && (iResult->Length() > 0)) {
    //cerr << "iResult length " << iResult->Length() << endl;
    //for (int i=0; i < iResult->Length(); i++) {
    //  cerr << "         i " << i << " index " << (*iResult)[i] << endl;
    //}
    colIndex1 = _items->GetColumnIndex("item_name"); 
    l1 = _items->GetSubColumnByIndex(colIndex1,iResult);
  }


  if (iResult1) delete iResult1;
  if (iResult2) delete iResult2;
  if (iResult)  delete iResult;

  return l1;
}


ReVarCifArray<CifString> * CifViewObj::GetCategoryItemViewNamesViewable(const char *category) {

  ReVarPCifArray<int> *iResult = NULL, *iResult1 = NULL, *iResult2 = NULL;
  
  int errCode=0, colIndex1;
  ReVarPCifArray<int> colInds;
  ReVarCifArray<CifString> cs1, cs2;
  ReVarCifArray<CifString> *l1=NULL; 
  CifString groupS, yS, nS;
  
  if (!_fobj)  return l1;
  if (!_items) return l1;
  if ( !category || !strlen(category) ) return l1;

  colInds.Clear();
  colInds.Add(_items->GetColumnIndex("category_id"));
  colInds.Add(_items->GetColumnIndex("item_view_mandatory_code")); 
  groupS.Copy(category); yS.Copy("Y"); nS.Copy("N");
  cs1.Clear();    cs1.Add(groupS);   cs1.Add(yS);
  cs2.Clear();    cs2.Add(groupS);   cs2.Add(nS);


  iResult1   = _items->Search(cs1,colInds,errCode);
  iResult2   = _items->Search(cs2,colInds,errCode);
  if (iResult1 && iResult2) 
    iResult = ISTable::SetUnion(iResult1, iResult2);
  else if (iResult1) 
    iResult = iResult1;
  else if (iResult2)
    iResult = iResult2;
  
  if (iResult && (iResult->Length() > 0)) {
    colIndex1 = _items->GetColumnIndex("item_view_name"); 
    l1 = _items->GetSubColumnByIndex(colIndex1,iResult);
  }

  if (iResult)  delete iResult;
  if (iResult1) delete iResult1;
  if (iResult2) delete iResult2;
  return l1;
  
}


ReVarCifArray<CifString> * CifViewObj::GetCategoryItemsMandatory(const char *category) {
  
  ReVarPCifArray<int> *iResult = NULL;

  int errCode=0, colIndex1;
  ReVarPCifArray<int> colInds;
  ReVarCifArray<CifString> cs1;
  ReVarCifArray<CifString> *l1 = NULL;
  CifString groupS, yS;

  if (!_fobj)  return l1;
  if (!_items) return l1;
  if ( !category || !strlen(category) ) return l1;

  colInds.Clear();
  colInds.Add(_items->GetColumnIndex("category_id"));
  colInds.Add(_items->GetColumnIndex("item_view_mandatory_code")); 
  groupS.Copy(category); yS.Copy("Y");
  cs1.Clear();    cs1.Add(groupS);   cs1.Add(yS);

  iResult   = _items->Search(cs1,colInds,errCode);

  if (iResult && (iResult->Length() > 0)) {
    colIndex1 = _items->GetColumnIndex("item_name"); 
    //    colIndex2 = _items->GetColumnIndex("item_view_name"); 
    l1 = _items->GetSubColumnByIndex(colIndex1,iResult);
  } 
  if (iResult) delete iResult;
  return l1;
}



ReVarCifArray<CifString> * CifViewObj::GetCategoryItemsViewNamesMandatory(const char *category) {
  
  ReVarPCifArray<int> *iResult = NULL;

  int  errCode=0, colIndex1;
  ReVarPCifArray<int> colInds;
  ReVarCifArray<CifString> cs1;
  ReVarCifArray<CifString> *l1 = NULL;
  CifString groupS, yS;

  if (!_fobj)  return l1;
  if (!_items) return l1;
  if ( !category || !strlen(category) ) return l1;

  colInds.Clear();
  colInds.Add(_items->GetColumnIndex("category_id"));
  colInds.Add(_items->GetColumnIndex("item_view_mandatory_code")); 
  groupS.Copy(category); yS.Copy("Y");
  cs1.Clear();    cs1.Add(groupS);   cs1.Add(yS);

  iResult   = _items->Search(cs1,colInds,errCode);

  if (iResult && (iResult->Length() > 0)) {
    colIndex1 = _items->GetColumnIndex("item_view_name"); 
    l1 = _items->GetSubColumnByIndex(colIndex1,iResult);
  } 
  if (iResult) delete iResult;
  return l1;
}


int * CifViewObj::GetItemColumnIndices(ISTable *t, ReVarCifArray<CifString>* viewItems) {

  int * ind=NULL;
  ReVarCifArray<CifString>  *items=NULL;
  
  int i,j,k,iok;
  
  if (!t) return ind;
  if ((t->GetName()) == NULL) return ind;
  if ( !viewItems  ||  viewItems->Length() <= 0 ) return ind;

  items = t->GetItemNames();
  if ( !items || items->Length() < viewItems->Length()) return ind;

  ind =   new int[items->Length()];
  k = 0;
  for (i=0; i < viewItems->Length(); i++) {
    for (j=0; j < items->Length(); j++) {
      if (!strcmp((*viewItems)[i].Text(), (*items)[j].Text())) {
	ind[k]=j; 	k++;
	break;
      }
    }
  }

// add items in *t (not in the view) at the end of the index list.

  if (items->Length() > k) {  
    for (j=0; j < items->Length(); j++) {
      iok = 0;
      for (i=0; i < viewItems->Length(); i++) {
	if (!strcmp((*viewItems)[i].Text(), (*items)[j].Text())) {
	  iok=1;
	  break;
	}
      }
      if (!iok) {
	ind[k] = j; 
	k++;
      }
    }
  }
  if (items) delete items;
  return ind;
}


int * CifViewObj::GetItemColumnIndices(ISTable *t) {

  int * ind=NULL;
  ReVarCifArray<CifString>  *items=NULL, *viewItems=NULL;

  int i,j,k,iok;
  
  if (!t) return ind;
  if ((t->GetName()) == NULL) return ind;

  viewItems=GetCategoryItems(t->GetName());
  if (!viewItems || (viewItems->Length() <= 0)) return ind;

  items = t->GetItemNames();

  ind =   new int[items->Length()];
  k = 0;
  for (i=0; i < viewItems->Length(); i++) {
    for (j=0; j < items->Length(); j++) {
      //      if (!CompareNoCase((*viewItems)[i], (*items)[j])) {
      if (!strcmp((*viewItems)[i].Text(), (*items)[j].Text())) {
	ind[k]=j; k++;
	break;
      }
    }
  }

// add items in *t (not in the view) at the end of the index list.

  if (items->Length() > k) {  
    for (j=0; j < items->Length(); j++) {
      iok = 0;
      for (i=0; i < viewItems->Length(); i++) {
	if (!strcmp((*viewItems)[i].Text(), (*items)[j].Text())) {
	  iok=1;
	  break;
	}
      }
      if (!iok) {
	ind[k] = j; 
	k++;
      }
    }
  }

  if (items)     delete items;
  if (viewItems) delete viewItems;

  return ind;
}


ReVarCifArray<CifString> * CifViewObj::GetCategoriesViewable() {

  ReVarPCifArray<int> *iResult = NULL, *iResult1 = NULL, *iResult2 = NULL;

  int errCode=0, colIndex1;


  ReVarCifArray<CifString> *l1=NULL;
  
  CifString yS, nS;

  if (!_fobj)  return l1;
  if (!_categories) return l1;

  colIndex1=_categories->GetColumnIndex("category_view_mandatory_code"); 

  yS.Copy("Y"); nS.Copy("N");

  iResult1   = _categories->SearchColumn(yS,colIndex1,errCode);
  iResult2   = _categories->SearchColumn(nS,colIndex1,errCode);
  iResult = ISTable::SetUnion(iResult1, iResult2);


  if (iResult && (iResult->Length() > 0)) {
    colIndex1 = _categories->GetColumnIndex("category_id"); 
    //    colIndex2 = _categories->GetColumnIndex("category_view_name"); 
    l1 = _categories->GetSubColumnByIndex(colIndex1,iResult);
    //    l2 = _categories->GetSubColumnByIndex(colIndex2,iResult);
  }
  if (iResult) delete iResult;
  if (iResult1) delete iResult1;
  if (iResult2) delete iResult2;

  return l1;
}


ReVarCifArray<CifString> * CifViewObj::GetCategoriesMandatory() {

  ReVarPCifArray<int> *iResult = NULL;

  int errCode=0, colIndex1;


  ReVarCifArray<CifString> *l1=NULL;
  
  CifString yS;

  if (!_fobj)  return l1;
  if (!_categories) return l1;

  colIndex1=_categories->GetColumnIndex("category_view_mandatory_code"); 

  yS.Copy("Y");

  iResult   = _categories->SearchColumn(yS,colIndex1,errCode);


  if (iResult && (iResult->Length() > 0)) {
    colIndex1 = _categories->GetColumnIndex("category_id"); 
    l1 = _categories->GetSubColumnByIndex(colIndex1,iResult);
  }
  if (iResult) delete iResult;
  return l1;
}


ReVarCifArray<CifString> * CifViewObj::GetGroupCategoriesViewable(const char *group) {

  ReVarPCifArray<int> *iResult = NULL, *iResult1 = NULL, *iResult2 = NULL;

  int  errCode=0, colIndex1;
  ReVarPCifArray<int> colInds;
  ReVarCifArray<CifString> cs1,cs2;
  ReVarCifArray<CifString> *l1=NULL;
  
  CifString groupS, yS, nS;

  if (!_fobj)  return l1;
  if (!_categories) return l1;
  if ( !group || !strlen(group) ) return l1;

  colInds.Clear();
  colInds.Add(_categories->GetColumnIndex("view_group_id"));
  colInds.Add(_categories->GetColumnIndex("category_view_mandatory_code")); 
  groupS.Copy(group); yS.Copy("Y"); nS.Copy("N");
  cs1.Clear();    cs1.Add(groupS);   cs1.Add(yS);
  cs2.Clear();    cs2.Add(groupS);   cs2.Add(nS);


  iResult1   = _categories->Search(cs1,colInds,errCode);
  iResult2   = _categories->Search(cs2,colInds,errCode);
  iResult = ISTable::SetUnion(iResult1, iResult2);


  if (iResult && (iResult->Length() > 0)) {
    colIndex1 = _categories->GetColumnIndex("category_id"); 
    //    colIndex2 = _categories->GetColumnIndex("category_view_name"); 
    l1 = _categories->GetSubColumnByIndex(colIndex1,iResult);
    //    l2 = _categories->GetSubColumnByIndex(colIndex2,iResult);
  }
  if (iResult) delete iResult;
  if (iResult1) delete iResult1;
  if (iResult2) delete iResult2;

  return l1;
}


ReVarCifArray<CifString> * CifViewObj::GetGroupCategoryViewNamesViewable(const char *group) {

  ReVarPCifArray<int> *iResult = NULL, *iResult1 = NULL, *iResult2 = NULL;

  int  errCode=0, colIndex1;
  ReVarPCifArray<int> colInds;
  ReVarCifArray<CifString> cs1,cs2;
  ReVarCifArray<CifString> *l1=NULL;
  
  CifString groupS, yS, nS;

  if (!_fobj)  return l1;
  if (!_categories) return l1;
  if ( !group || !strlen(group) ) return l1;

  colInds.Clear();
  colInds.Add(_categories->GetColumnIndex("view_group_id"));
  colInds.Add(_categories->GetColumnIndex("category_view_mandatory_code")); 
  groupS.Copy(group); yS.Copy("Y"); nS.Copy("N");
  cs1.Clear();    cs1.Add(groupS);   cs1.Add(yS);
  cs2.Clear();    cs2.Add(groupS);   cs2.Add(nS);


  iResult1   = _categories->Search(cs1,colInds,errCode);
  iResult2   = _categories->Search(cs2,colInds,errCode);
  iResult = ISTable::SetUnion(iResult1, iResult2);


  if (iResult && (iResult->Length() > 0)) {
    colIndex1 = _categories->GetColumnIndex("category_view_name"); 
    l1 = _categories->GetSubColumnByIndex(colIndex1,iResult);
  }
  if (iResult) delete iResult;
  if (iResult1) delete iResult1;
  if (iResult2) delete iResult2;
  return l1;
}


void CifViewObj::_UpdateCategoryState(CifFileObj *fobj, const char *blockId) {
  ReVarCifArray<CifString> *categories = NULL;
  ReVarCifArray<CifString> maxrow, status;
  ReVarCifArray<CifString> *manItems=NULL, *aRow=NULL;
  CifString cs;
  int *ind = NULL;
  ISTable *t=NULL;
  int i,j, state;

  categories = _categoryState->GetColumn(0);

  //  cerr << "Got state columns  length = " << categories->Length() << endl;
  maxrow.Clear(); status.Clear(); cs.Clear();
  for (i=0; i < categories->Length(); i++) {
    //    cerr << "Updating state for category " << (*categories)[i].Text() << endl;
    t = fobj->GetTablePtr(blockId,(*categories)[i].Text());
    cs.Clear(); cs += t->GetNumRows();
    maxrow.Add(cs);
    //    cerr << " Rows " << t->GetNumRows() << " Columns " << t->GetNumColumns() << endl;
    state = 1;
    manItems = GetCategoryItemsMandatory((*categories)[i].Text());
    if (manItems && (manItems->Length()>0)) {
      //      cerr << " manItems  length is " << manItems->Length() << endl;

      ind = GetItemColumnIndices(t, manItems);

      if (t->GetNumRows() > 0) {
	aRow=t->GetRow(0);
	for (j=0; j < manItems->Length(); j++) {
	  //	  cerr << " j " << j << " ind[j] " << ind[j]  << endl;

	  if ( (*aRow)[ind[j]].Length() <= 0 || !strcmp((*aRow)[ind[j]].Text(),"?")) state = 0;
	}
	if (aRow) delete aRow;
      }
      if (ind) delete ind;
    }
    if (manItems) delete manItems;
    cs.Clear(); cs += state;
    status.Add(cs);
  }
  _categoryState->DeleteColumn(2);
  _categoryState->DeleteColumn(3);  
  _categoryState->FillColumn(maxrow,2);
  _categoryState->FillColumn(status,3);  
}


int CifViewObj::_GetStateRowMaximum(const char * category) {
  ReVarPCifArray<int>       *iResult = NULL;
  int errCode=0, colIndex1, colIndex2;
  CifString cs;

  if (!_categoryState) return -1;
  if ( !category  || !strlen(category) ) return -1;


  cs.Clear(); cs.Copy(category);
  colIndex1 = _categoryState->GetColumnIndex("category_id");
  iResult = _categoryState->SearchColumn(cs,colIndex1,errCode);

  if (iResult && (iResult->Length() > 0)) {
    colIndex2 = _categoryState->GetColumnIndex("row_maximum"); 
    cs.Clear();
    _categoryState->GetCell(cs,colIndex2,(*iResult)[0]);
    if (iResult) delete iResult;
    if (cs.Length()) 
      return atoi(cs.Text());
    else
      return -1;
  } else
    return -1;
}


int CifViewObj::_GetStateRowCurrent(const char * category) {
  ReVarPCifArray<int>       *iResult = NULL;
  int errCode=0, colIndex1, colIndex2;
  CifString cs;


  if (!_categoryState) return -1;
  if ( !category  || !strlen(category) ) return -1;

  cs.Clear(); cs.Copy(category);
  colIndex1 = _categoryState->GetColumnIndex("category_id");
  iResult   = _categoryState->SearchColumn(cs,colIndex1,errCode);
  
  if (iResult && (iResult->Length() > 0)) {
    colIndex2 = _categoryState->GetColumnIndex("row_current"); 
    cs.Clear();
    _categoryState->GetCell(cs,colIndex2,(*iResult)[0]);
    if (iResult) delete iResult;
    if (cs.Length()) 
      return atoi(cs.Text());
    else
      return -1;
  } else
    return -1;
}


int CifViewObj::_GetStateStatus(const char * category) {
  ReVarPCifArray<int>       *iResult = NULL;
  int errCode=0, colIndex1, colIndex2;
  CifString cs;

  if (!_categoryState) return -1;
  if ( !category  || !strlen(category) ) return -1;

  cs.Clear(); cs.Copy(category);
  colIndex1 = _categoryState->GetColumnIndex("category_id");
  iResult = _categoryState->SearchColumn(cs,colIndex1,errCode);

  if (iResult && (iResult->Length() > 0)) {

    colIndex2 = _categoryState->GetColumnIndex("status"); 
    cs.Clear();
    _categoryState->GetCell(cs,colIndex2,(*iResult)[0]);
    if (iResult) delete iResult;
    if (cs.Length()) 
      return atoi(cs.Text());
    else
      return -1;
  } else
    return -1;
}


int CifViewObj::_SetStateRowMaximum(const char * category, int row) {
  ReVarPCifArray<int>       *iResult = NULL;
  int errCode=0, colIndex1, colIndex2;
  CifString cs;

  if (!_categoryState) return -1;
  if ( !category  || !strlen(category) ) return -1;
  if ( row < 0) return -1;

  cs.Clear(); cs.Copy(category);
  colIndex1 = _categoryState->GetColumnIndex("category_id");
  iResult = _categoryState->SearchColumn(cs,colIndex1,errCode);

  if (iResult && (iResult->Length() > 0)) {
    colIndex2 = _categoryState->GetColumnIndex("row_maximum"); 
    cs.Clear(); cs += row;
    _categoryState->UpdateCell(cs,colIndex2,(*iResult)[0]);
    if (iResult) delete iResult;
    return 0;
  } else
    return -1;
}


int CifViewObj::_SetStateRowCurrent(const char * category, int row) {
  ReVarPCifArray<int>       *iResult = NULL;
  int errCode=0, colIndex1, colIndex2;
  CifString cs;

  if (!_categoryState) return -1;
  if ( !category  || !strlen(category) ) return -1;
  if ( row < 0) return -1;

  cs.Clear(); cs.Copy(category);
  colIndex1 = _categoryState->GetColumnIndex("category_id");
  iResult = _categoryState->SearchColumn(cs,colIndex1,errCode);

  if (iResult && (iResult->Length() > 0)) {
    colIndex2 = _categoryState->GetColumnIndex("row_current"); 
    cs.Clear(); cs += row;
    _categoryState->UpdateCell(cs,colIndex2,(*iResult)[0]);
    if (iResult) delete iResult;
    return 0;
  } else
    return -1;
}

int CifViewObj::_SetStateStatus(const char * category, int status) {
  ReVarPCifArray<int>       *iResult = NULL;
  int errCode=0, colIndex1, colIndex2;
  CifString cs;

  if (!_categoryState) return -1;
  if ( !category  || !strlen(category) ) return -1;

  cs.Clear(); cs.Copy(category);
  colIndex1 = _categoryState->GetColumnIndex("category_id");
  iResult = _categoryState->SearchColumn(cs,colIndex1,errCode);

  if (iResult && (iResult->Length() > 0)) {
    colIndex2 = _categoryState->GetColumnIndex("status"); 
    cs.Clear(); cs += status;
    _categoryState->UpdateCell(cs,colIndex2,(*iResult)[0]);
    if (iResult) delete iResult;
    return 0;
  } else
    return -1;
}

ISTable *CifViewObj::_InitCategoryStateTable() {
  int i;
  ReVarCifArray<CifString> *categories = NULL, *data0=NULL, *data1=NULL;
  ISTable *t=NULL;
  CifString cs0, cs1;

  t = new ISTable("ndb_tool_category_state");
  t->AddColumn("category_id",   TRUE);
  t->AddColumn("row_current",   FALSE);
  t->AddColumn("row_maximum",   FALSE);
  t->AddColumn("status",        FALSE);
  
  categories = GetCategoriesViewable();

  t->FillColumn(*categories,0);
  cs0.Clear(); cs0.Copy("0");
  cs1.Clear(); cs1.Copy("1");
  data0 = new ReVarCifArray<CifString>;
  data1 = new ReVarCifArray<CifString>;
  data1->Clear();   data0->Clear();

  for (i=0; i < categories->Length(); i++) {
    data0->Add(cs0);  data1->Add(cs1);
  }
  t->FillColumn(*data0,1);   t->FillColumn(*data1,2);   t->FillColumn(*data0,3);
  if (data0) delete data0;
  if (data1) delete data1;
  return(t);
}


// ******************************************************************************
#if 0

int CifViewObj::GetCategoryItemsViewable(const char *category, 
					 ReVarCifArray<CifString> *itemNames,
					 ReVarCifArray<CifString> *itemViewNames) {

  ReVarPCifArray<int> *iResult = NULL, *iResult1 = NULL, *iResult2 = NULL;
    

  int i, errCode=0, colIndex1, colIndex2;
  ReVarPCifArray<int> colInds;
  ReVarCifArray<CifString> cs1, cs2;
  ReVarCifArray<CifString> *l1=NULL, *l2=NULL; 
  CifString groupS, yS, nS;

  if (!_fobj)  return 0;
  if (!_items) return 0;
  if ( !category || !strlen(category) ) return 0;

  colInds.Clear();
  colInds.Add(_items->GetColumnIndex("category_id"));
  colInds.Add(_items->GetColumnIndex("item_view_mandatory_code")); 
  groupS.Copy(category); yS.Copy("Y"); nS.Copy("N");
  cs1.Clear();    cs1.Add(groupS);   cs1.Add(yS);
  cs2.Clear();    cs2.Add(groupS);   cs2.Add(nS);


  iResult1   = _items->Search(cs1,colInds,errCode);
  iResult2   = _items->Search(cs2,colInds,errCode);
  if (iResult1 && iResult2) 
    iResult = ISTable::SetUnion(iResult1, iResult2);
  else if (iResult1) 
    iResult = iResult1;
  else if (iResult2)
    iResult = iResult2;

  if (iResult && (iResult->Length() > 0)) {
    colIndex1 = _items->GetColumnIndex("item_name"); 
    colIndex2 = _items->GetColumnIndex("item_view_name"); 
    l1 = _items->GetSubColumnByIndex(colIndex1,iResult);
    l2 = _items->GetSubColumnByIndex(colIndex2,iResult);
    itemNames->Clear();  
    itemViewNames->Clear();
    for (i=0; i < iResult->Length(); i++) {
      itemNames->Add((*l1)[i]);
      itemViewNames->Add((*l2)[i]);
    }
    if (l1) delete l1; 
    if (l2) delete l2;
    return iResult->Length();
  } else
    return 0;
}

int CifViewObj::GetCategoryItemsMandatory(const char *category, 
					  ReVarCifArray<CifString> *itemNames,
					  ReVarCifArray<CifString> *itemViewNames) {
  
  ReVarPCifArray<int> *iResult = NULL;

  int i, errCode=0, colIndex1, colIndex2;
  ReVarPCifArray<int> colInds;
  ReVarCifArray<CifString> cs1;
  ReVarCifArray<CifString> *l1 = NULL, *l2 = NULL;
  CifString groupS, yS;

  if (!_fobj)  return 0;
  if (!_items) return 0;
  if ( !category || !strlen(category) ) return 0;

  colInds.Clear();
  colInds.Add(_items->GetColumnIndex("category_id"));
  colInds.Add(_items->GetColumnIndex("item_view_mandatory_code")); 
  groupS.Copy(category); yS.Copy("Y");
  cs1.Clear();    cs1.Add(groupS);   cs1.Add(yS);

  iResult   = _items->Search(cs1,colInds,errCode);

  if (iResult && (iResult->Length() > 0)) {
    colIndex1 = _items->GetColumnIndex("item_name"); 
    colIndex2 = _items->GetColumnIndex("item_view_name"); 
    l1 = _items->GetSubColumnByIndex(colIndex1,iResult);
    l2 = _items->GetSubColumnByIndex(colIndex2,iResult);
    itemNames->Clear();  
    itemViewNames->Clear();
    for (i=0; i < iResult->Length(); i++) {
      itemNames->Add((*l1)[i]);
      itemViewNames->Add((*l2)[i]);
    }
    if (l1) delete l1; 
    if (l2) delete l2;

    return iResult->Length();
  } else
    return 0;
}


ISTable * CifViewObj::_MakeEmptyTable(const char *category) {

  int i, numItems;
  char keyword[MAX_CIF_NAME_LENGTH];
  ISTable *t = NULL;
  CifString tmpS;

  t = new ISTable(category);
  
  for (i=0,numItems=0; i < view->numItems; i++) {  // very inefficient
    if (!strcmp(view->iList[i].category,category)) {
      GetKeywordFromItemName(keyword,view->iList[i].item);
      t->AddColumn(keyword, FALSE);
      numItems++;
    }
  } 
  t->AddRow();
  for (i=0; i < numItems; i++) {
    tmpS.Copy("?");
    t->AddElementToRow(tmpS,0); tmpS.Clear();
  }
  return(t);
}


int * CifViewObj::GetViewableItemColumnIndices(ISTable *t) {

  int * ind=NULL;
  ReVarCifArray<CifString>  *items=NULL, *viewItems=NULL;
  
  int i,j;
  
  if (!t) return ind;
  if ((t->GetName()) == NULL) return ind;

  viewItems = GetCategoryItemsViewable(t->GetName());
  if (!viewItems || viewItems->Length() <= 0) return ind;

  //  cerr << "Viewable items in "  << t->GetName() << " = " << viewItems->Length() << endl;

  items = t->GetItemNames();
  ind =   new int[viewItems->Length()];
  for (i=0; i < viewItems->Length(); i++) {
    for (j=0; j < items->Length(); j++) {
      //      if (!CompareNoCase((*viewItems)[i], (*items)[j])) {
      if (!strcmp((*viewItems)[i].Text(), (*items)[j].Text())) {
	ind[i]=j;
	break;
      }
    }
  }
  if (items) delete items;
  if (viewItems) delete viewItems;

  return ind;
}


int * CifViewObj::GetMandatoryItemColumnIndices(ISTable *t) {

  int * ind=NULL;
  ReVarCifArray<CifString>  *items=NULL, *viewItems=NULL;
  
  int i,j;
  
  if (!t) return ind;
  if ((t->GetName()) == NULL) return ind;
  
  viewItems = GetCategoryItemsMandatory(t->GetName());
  if (!viewItems || viewItems->Length() <= 0) return ind;

  //  cerr << "Mandatory items in "  << t->GetName() << " " << viewItems->Length() << endl;
  items = t->GetItemNames();

  ind =   new int[viewItems->Length()];
  for (i=0; i < viewItems->Length(); i++) {
    for (j=0; j < items->Length(); j++) {
      //      if (!CompareNoCase((*viewItems)[i], (*items)[j])) {
      if (!strcmp((*viewItems)[i].Text(), (*items)[j].Text())) {
	ind[i]=j;
	break;
      }
    }
  }
  if (items) delete items;
  if (viewItems) delete viewItems;
  return ind;
}


int CifViewObj::GetGroupCategoriesViewable(const char *group, 
					   ReVarCifArray<CifString> *categoryNames,
					   ReVarCifArray<CifString> *categoryViewNames) {

  ReVarPCifArray<int> *iResult = NULL, *iResult1 = NULL, *iResult2 = NULL;
    

  int i, errCode=0, colIndex1, colIndex2;
  ReVarPCifArray<int> colInds;
  ReVarCifArray<CifString> cs1,cs2;
  ReVarCifArray<CifString> *l1=NULL, *l2=NULL;
  
  CifString groupS, yS, nS;

  if (!_fobj)  return 0;
  if (!_categories) return 0;
  if ( !group || !strlen(group) ) return 0;

  colInds.Clear();
  colInds.Add(_categories->GetColumnIndex("view_group_id"));
  colInds.Add(_categories->GetColumnIndex("category_view_mandatory_code")); 
  groupS.Copy(group); yS.Copy("Y"); nS.Copy("N");
  cs1.Clear();    cs1.Add(groupS);   cs1.Add(yS);
  cs2.Clear();    cs2.Add(groupS);   cs2.Add(nS);


  iResult1   = _categories->Search(cs1,colInds,errCode);
  iResult2   = _categories->Search(cs2,colInds,errCode);
  if (iResult1 && iResult2) 
    iResult = ISTable::SetUnion(iResult1, iResult2);
  else if (iResult1) 
    iResult = iResult1;
  else if (iResult2)
    iResult = iResult2;

  if (iResult && (iResult->Length() > 0)) {
    colIndex1 = _categories->GetColumnIndex("category_id"); 
    colIndex2 = _categories->GetColumnIndex("category_view_name"); 
    l1 = _categories->GetSubColumnByIndex(colIndex1,iResult);
    l2 = _categories->GetSubColumnByIndex(colIndex2,iResult);
    categoryNames->Clear();  
    categoryViewNames->Clear();
    for (i=0; i < iResult->Length(); i++) {
      categoryNames->Add((*l1)[i]);
      categoryViewNames->Add((*l2)[i]);
    }
    if (l1) delete l1; 
    if (l2) delete l2;
    return iResult->Length();
  } else
    return 0;
}


#endif

