/*
 * File: FOtest3.C
 *       View object test and diagnostic.
 */

#include "CifViewObj.h"
#include <iostream.h>


#define FALSE 0

void main(int argc, char *argv[]) {
  char *pname=NULL;
  char *iFile=NULL, *oFile=NULL;

  CifViewObj * vobj = NULL;
  ReVarCifArray<CifString> * c0 = NULL;
  ReVarCifArray<CifString> * c1 = NULL;
  ReVarCifArray<CifString> * c2 = NULL;

  //  ReVarCifArray<CifString> * c3 = NULL;
  //  ReVarCifArray<CifString> * c4 = NULL;

  char viewName[100];
  int mcode, acode;
  int i,j,k;



  pname = argv[0];

  if (argc < 2) {
    cerr << pname << ":  usage = -f <inputfile> -o <outputfile> " << endl;
    exit(1);
  }
  

  for (i=1; i < argc; i++) {
    if ( argv[i][0] == '-' ) {
      if (strcmp(argv[i],"-f") == 0 ) {
	i++;
	iFile = (char *) calloc(strlen(argv[i]) + 1, sizeof(char));
	strcpy(iFile,argv[i]);          
      }	else if (strcmp(argv[i],"-o") == 0 ) {
	i++;
	oFile = (char *) calloc(strlen(argv[i]) + 1, sizeof(char));
	strcpy(oFile,argv[i]);          
      } else {
	cerr << pname << ":  usage = -f <inputfile> -o <outputfile> " << endl;
 	exit(1);
      }
    } else {
      cerr << pname << ":  usage = -f <inputfile> -o <outputfile> " << endl;
      exit(1);
    }
  }



  vobj = new CifViewObj(iFile, "./test/TESTFILE", "viewndb", 1);
  cerr << "View Diagnostics " << vobj->GetViewDiagnostics() << endl;
  //

  c0 = vobj->GetGroups();
  for (i=0; i < c0->Length(); i++) {
    cerr << "Group " << i << " " << (*c0)[i].Text() << endl;
  }

  for (i=0; i < c0->Length(); i++) {
    cerr << "Group " << i << " " << (*c0)[i].Text() << endl;
    c1 = vobj->GetGroupCategories((*c0)[i].Text());

    for (j=0; j < c1->Length(); j++) {
      cerr << "    Category " << j << " " << (*c1)[j].Text() 
	   << " View Group  " << vobj->GetViewGroup((*c1)[j].Text())->Text()
	   << " View Name  " << vobj->GetViewCategory((*c1)[j].Text())->Text()
	   <<  " dcode " << vobj->GetCategoryDisplayCode((*c1)[j].Text()) << endl;
      c2 = vobj->GetCategoryItems((*c1)[j].Text());
      for (k=0; k < c2->Length(); k++) {
	cerr << "    Item " << k << " " << (*c2)[k].Text() 
	     << " View Name " << vobj->GetViewItem((*c2)[k].Text())->Text()
	     << " mcode "   << vobj->GetItemMandatoryCode((*c2)[k].Text()) 
	     << " altcode " <<  vobj->GetItemAllowAlternateValue((*c2)[k].Text()) << endl;
	vobj->GetItemInfo((*c2)[k].Text(), viewName, mcode,acode);
	cerr << "    ++ Item " << k << " " << (*c2)[k].Text() 
	     << " view name " << viewName << " mcode " << mcode 
	     << " acode " << acode << endl;
      }
    }
  }
  vobj->Close();
  if (vobj) delete vobj;
  exit(0);
}
