/*
FILE:     interface-defs.h
*/
/*
VERSION:  0.904-beta
*/
/*
DATE:     8/14/2003
*/
/*
  Comments and Questions to: sw-help@rcsb.rutgers.edu
*/
/*
COPYRIGHT 1999-2003 Rutgers - The State University of New Jersey

This software is provided WITHOUT WARRANTY OF MERCHANTABILITY OR
FITNESS FOR A PARTICULAR PURPOSE OR ANY OTHER WARRANTY, EXPRESS OR
IMPLIED.  RUTGERS MAKE NO REPRESENTATION OR WARRANTY THAT THE
SOFTWARE WILL NOT INFRINGE ANY PATENT, COPYRIGHT OR OTHER
PROPRIETARY RIGHT.

The user of this software shall indemnify, hold harmless and defend
Rutgers, its governors, trustees, officers, employees, students,
agents and the authors against any and all claims, suits,
losses, liabilities, damages, costs, fees, and expenses including
reasonable attorneys' fees resulting from or arising out of the
use of this software.  This indemnification shall include, but is
not limited to, any and all claims alleging products liability.
*/
/*
               PDB SOFTWARE LICENSE AGREEMENT

BY CLICKING THE ACCEPTANCE BUTTON OR INSTALLING OR USING 
THIS "SOFTWARE, THE INDIVIDUAL OR ENTITY LICENSING THE  
SOFTWARE ("LICENSEE") IS CONSENTING TO BE BOUND BY AND IS 
BECOMING A PARTY TO THIS AGREEMENT.  IF LICENSEE DOES NOT 
AGREE TO ALL OF THE TERMS OF THIS AGREEMENT
THE LICENSEE MUST NOT INSTALL OR USE THE SOFTWARE.

1. LICENSE AGREEMENT

This is a license between you ("Licensee") and the Protein Data Bank (PDB) 
at Rutgers, The State University of New Jersey (hereafter referred to 
as "RUTGERS").   The software is owned by RUTGERS and protected by 
copyright laws, and some elements are protected by laws governing 
trademarks, trade dress and trade secrets, and may be protected by 
patent laws. 

2. LICENSE GRANT

RUTGERS grants you, and you hereby accept, non-exclusive, royalty-free 
perpetual license to install, use, modify, prepare derivative works, 
incorporate into other computer software, and distribute in binary 
and source code format, or any derivative work thereof, together with 
any associated media, printed materials, and on-line or electronic 
documentation (if any) provided by RUTGERS (collectively, the "SOFTWARE"), 
subject to the following terms and conditions: (i) any distribution 
of the SOFTWARE shall bind the receiver to the terms and conditions 
of this Agreement; (ii) any distribution of the SOFTWARE in modified 
form shall clearly state that the SOFTWARE has been modified from 
the version originally obtained from RUTGERS.  

2. COPYRIGHT; RETENTION OF RIGHTS.  

The above license grant is conditioned on the following: (i) you must 
reproduce all copyright notices and other proprietary notices on any 
copies of the SOFTWARE and you must not remove such notices; (ii) in 
the event you compile the SOFTWARE, you will include the copyright 
notice with the binary in such a manner as to allow it to be easily 
viewable; (iii) if you incorporate the SOFTWARE into other code, you 
must provide notice that the code contains the SOFTWARE and include 
a copy of the copyright notices and other proprietary notices.  All 
copies of the SOFTWARE shall be subject to the terms of this Agreement.  

3. NO MAINTENANCE OR SUPPORT; TREATMENT OF ENHANCEMENTS 

RUTGERS is under no obligation whatsoever to: (i) provide maintenance 
or support for the SOFTWARE; or (ii) to notify you of bug fixes, patches, 
or upgrades to the features, functionality or performance of the 
SOFTWARE ("Enhancements") (if any), whether developed by RUTGERS 
or third parties.  If, in its sole discretion, RUTGERS makes an 
Enhancement available to you and RUTGERS does not separately enter 
into a written license agreement with you relating to such bug fix, 
patch or upgrade, then it shall be deemed incorporated into the SOFTWARE 
and subject to this Agreement. You are under no obligation whatsoever 
to provide any Enhancements to RUTGERS or the public that you may 
develop over time; however, if you choose to provide your Enhancements 
to RUTGERS, or if you choose to otherwise publish or distribute your 
Enhancements, in source code form without contemporaneously requiring 
end users or RUTGERS to enter into a separate written license agreement 
for such Enhancements, then you hereby grant RUTGERS a non-exclusive,
royalty-free perpetual license to install, use, modify, prepare
derivative works, incorporate into the SOFTWARE or other computer
software, distribute, and sublicense your Enhancements or derivative
works thereof, in binary and source code form.

4. FEES.  There is no license fee for the SOFTWARE.  If Licensee
wishes to receive the SOFTWARE on media, there may be a small charge
for the media and for shipping and handling.  Licensee is
responsible for any and all taxes.

5. TERMINATION.  Without prejudice to any other rights, Licensor
may terminate this Agreement if Licensee breaches any of its terms
and conditions.  Upon termination, Licensee shall destroy all
copies of the SOFTWARE.

6. PROPRIETARY RIGHTS.  Title, ownership rights, and intellectual
property rights in the Product shall remain with RUTGERS.  Licensee 
acknowledges such ownership and intellectual property rights and will 
not take any action to jeopardize, limit or interfere in any manner 
with RUTGERS' ownership of or rights with respect to the SOFTWARE.  
The SOFTWARE is protected by copyright and other intellectual 
property laws and by international treaties.  Title and related 
rights in the content accessed through the SOFTWARE is the property 
of the applicable content owner and is protected by applicable law.  
The license granted under this Agreement gives Licensee no rights to such
content.

7. DISCLAIMER OF WARRANTY.  THE SOFTWARE IS PROVIDED FREE OF 
CHARGE, AND, THEREFORE, ON AN "AS IS" BASIS, WITHOUT WARRANTY OF 
ANY KIND, INCLUDING WITHOUT LIMITATION THE WARRANTIES THAT IT 
IS FREE OF DEFECTS, MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE 
OR NON-INFRINGING.  THE ENTIRE RISK AS TO THE QUALITY AND 
PERFORMANCE OF THE SOFTWARE IS BORNE BY LICENSEE.  SHOULD THE 
SOFTWARE PROVE DEFECTIVE IN ANY RESPECT, THE LICENSEE AND NOT 
LICENSOR ASSUMES THE ENTIRE COST OF ANY SERVICE AND REPAIR.  
THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF 
THIS AGREEMENT.  NO USE OF THE PRODUCT IS AUTHORIZED HEREUNDER 
EXCEPT UNDER THIS DISCLAIMER.

8. LIMITATION OF LIABILITY.  TO THE MAXIMUM EXTENT PERMITTED BY
APPLICABLE LAW,  IN NO EVENT WILL LICENSOR BE LIABLE FOR ANY 
INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
OUT OF THE USE OF OR INABILITY TO USE THE SOFTWARE, INCLUDING, 
WITHOUT LIMITATION, DAMAGES FOR LOSS OF GOODWILL, WORK 
STOPPAGE, COMPUTER FAILURE OR MALFUNCTION, OR ANY AND ALL 
OTHER COMMERCIAL DAMAGES OR LOSSES, EVEN IF ADVISED OF THE
POSSIBILITY THEREOF. 
*/
/* 
  PURPOSE:      Miscellaneous definitions

*/


#ifndef __INTERFACE_DEFS_H__
#define __INTERFACE_DEFS_H__

#include <stdio.h>
#include <unistd.h>


// This toggles between validation server version and ADIT version.
//
#define     ADITAPPL 1

//
//   Turn on data collection demo code ---  JDW Nov 12 1999
#define     DCDEMO    0


#define     ADIT_VERSION_STRING            "ADITW V0.903"

//x#define     NDB_GLOBAL_DEBUG_LEVEL     NDB_MSG_ERR
#define     NDB_GLOBAL_DEBUG_LEVEL     NDB_MSG_DEBUG

// #define     NDBTOOL 1

#if defined (ADITAPPL)

#define     NDB_DEFAULT_BLOCK_ID                 "NEW-ENTRY"
#define     NDB_DEF_ROOT_FILE_NAME_XYZ           "new-entry"
#define     NDB_DEF_ROOT_FILE_NAME_SF            "new-entry-sf"
#define     NDB_DEF_ROOT_FILE_NAME_NC            "new-entry-nc"
#define     NDB_DEF_ROOT_FILE_NAME_FORM          "new-entry-form"
#define     NDB_DEF_ROOT_FILE_NAME_TEMPLATE      "new-entry-template"
#define     NDB_DEF_ROOT_FILE_NAME_CC            "new-entry-cc"
#define     NDB_DEF_ROOT_FILE_NAME_CS            "new-entry-cs"
#define     NDB_DEF_ROOT_FILE_NAME_DC            "new-entry-dc"

#define     NDB_CUR_ROOT_FILE_NAME_XYZ           "new-entry-current"

// Old name convention .
#if 1
#define     ONDB_DEFAULT_BLOCK_ID                 "DEPOSIT-0"
#define     ONDB_DEF_ROOT_FILE_NAME_XYZ           "deposit-0"
#define     ONDB_DEF_ROOT_FILE_NAME_SF            "deposit-0-sf"
#define     ONDB_DEF_ROOT_FILE_NAME_NC            "deposit-0-nc"
#define     ONDB_DEF_ROOT_FILE_NAME_FORM          "deposit-0-form"
#define     ONDB_DEF_ROOT_FILE_NAME_TEMPLATE      "deposit-0-template"
#define     ONDB_DEF_ROOT_FILE_NAME_CC            "deposit-0-cc"
#define     ONDB_DEF_ROOT_FILE_NAME_CS            "deposit-0-cs"
#define     ONDB_CUR_ROOT_FILE_NAME_XYZ           "deposit-1"

#endif



#else
#define     NDB_DEFAULT_BLOCK_ID                 "TEST-FILE"
#define     NDB_DEF_ROOT_FILE_NAME_XYZ           "test-file"
#define     NDB_DEF_ROOT_FILE_NAME_SF            "test-file-sf"
#define     NDB_DEF_ROOT_FILE_NAME_NC            "test-file-nc"
#define     NDB_DEF_ROOT_FILE_NAME_CC            "test-file-cc"
#define     NDB_DEF_ROOT_FILE_NAME_CS            "test-file-cs"
#define     NDB_DEF_ROOT_FILE_NAME_FORM          "test-file-form"
#define     NDB_DEF_ROOT_FILE_NAME_TEMPLATE      "test-file-template"
#define     NDB_CUR_ROOT_FILE_NAME_XYZ           "test-file-current"
#define     NDB_CUR_ROOT_FILE_NAME_DC            "test-file-dc"

// Old name convention .
#if 1
#define     ONDB_DEFAULT_BLOCK_ID                 "CHECK-0"
#define     ONDB_DEF_ROOT_FILE_NAME_XYZ           "check-0"
#define     ONDB_DEF_ROOT_FILE_NAME_SF            "check-0-sf"
#define     ONDB_DEF_ROOT_FILE_NAME_NC            "check-0-nc"
#define     ONDB_DEF_ROOT_FILE_NAME_FORM          "check-0-form"
#define     ONDB_DEF_ROOT_FILE_NAME_TEMPLATE      "check-0-template"
#define     ONDB_DEF_ROOT_FILE_NAME_CC            "check-0-cc"
#define     ONDB_DEF_ROOT_FILE_NAME_CS            "check-0-cs"
#define     ONDB_CUR_ROOT_FILE_NAME_XYZ           "deposit-1"
#endif


#endif




#define     NDB_ACK_DEPOSIT_LETTER               "ack-deposit-letter.txt"
#define     NDB_DEPOSITION_ID_FILE_NAME          "DEPOSITION_ID"

#define     NDB_STYLE_DEFAULT     0
#define     RCSB_STYLE_DEFAULT    1
#define     HT_CONTEXT_DEPOSIT    1
#define     HT_CONTEXT_ASSEMBLE   2
#define     HT_CONTEXT_ANNOTATE   3
#define     HT_CONTEXT_VALIDATE   4
#define     HT_CONTEXT_DOWNLOAD   5


#define     CIF_VALUE_BUF_LENGTH   4096
#define     CIF_MAX_NAME_LENGTH    100

#define     HT_DEFAULT_TEXT_FONT_SIZE    4

#define	    HT_INTERFACE_TOP_MENU                "mk-top-interface-screen"
#define	    HT_INTERFACE_CALL_TOP_MENU_VIEW      "start-session"
#define	    HT_INTERFACE_TOP_MENU_VIEW           "mk-top-interface-screen-view"
#define	    HT_INTERFACE_CATEGORY_GROUP_MENU     "mk-category-group-menu"
#define	    HT_INTERFACE_CATEGORY_MENU           "mk-category-menu"
#define	    HT_INTERFACE_CATEGORY_MENU_VIEW      "mk-category-view-menu"
#define	    HT_INTERFACE_ITEM_FORM               "process-item-action"
#define	    HT_INTERFACE_ITEM_FORM_VIEW          "process-item-action-view"
#define	    HT_INTERFACE_PREVIEW                 "preview-op"

#define	    HT_INTERFACE_GROUP_DESCRIPTION       "get-group-description"
#define	    HT_INTERFACE_GROUP_DESCRIPTION_VIEW  "get-group-description-from-view"
#define	    HT_INTERFACE_CATEGORY_DESCRIPTION    "get-category-description"
#define	    HT_INTERFACE_CATEGORY_HELP           "get-category-help"
#define	    HT_INTERFACE_CATEGORY_EXAMPLES       "get-category-examples"
#define	    HT_INTERFACE_ITEM_DESCRIPTION        "get-item-description"
#define	    HT_INTERFACE_ITEM_EXAMPLES           "get-item-examples"
#define	    HT_INTERFACE_ITEM_DESCRIPTION_VIEW   "get-item-description-view"
#define	    HT_INTERFACE_ITEM_HELP_VIEW          "get-item-help-view"
#define	    HT_INTERFACE_ITEM_EXAMPLES_VIEW      "get-item-examples-view"
#define	    HT_INTERFACE_VIEW_CIF                "view-data-as-cif"
#define	    HT_INTERFACE_VIEW_TABLE              "view-data-as-table"
#define	    HT_INTERFACE_VIEW_CATEGORY_TABLE     "view-category-as-table"
#define	    HT_INTERFACE_IMPORT_CIF              "import-cif-data-file"
#define	    HT_INTERFACE_WRITE_CIF               "write-data-as-ffile"
#define	    HT_INTERFACE_GET_HELP                "get-help"
#define	    HT_INTERFACE_DEPOSIT                 "mk-deposition"
#define	    HT_INTERFACE_VALIDATE                "validate-op"
#define	    HT_INTERFACE_LOAD_DB                 "db-load-op"
#define	    HT_INTERFACE_LOAD_DB_CIF             "db-load-cif-op"
#define	    HT_INTERFACE_MAIL_ACK                 "mail-ack-op"
#define	    HT_INTERFACE_STRUCTURE_DISPLAY       "display-op"
#define	    HT_INTERFACE_READ_FORM_ITEM          "read-item-form"
#define	    HT_INTERFACE_READ_FORM_CATEGORY      "read-category-form"
#define	    HT_INTERFACE_UPDATE_CATEGORY_STATUS  "update-category-status"
#define	    HT_INTERFACE_OPERATION_DRIVER        "adit-operation-driver"
#define	    HT_INTERFACE_SESSION_DRIVER          "adit-session-driver"
#define	    HT_INTERFACE_PRINTER_OP              "print-op"
#define	    HT_INTERFACE_MAXIT_CIF_OP            "maxit-cif-op"

#define	    HT_ATTRIBUTE_UNIQUE_ID           "ufid"
#define	    HT_ATTRIBUTE_GROUP_ID            "grpid"
#define	    HT_ATTRIBUTE_CATEGORY_ID         "catid"
#define	    HT_ATTRIBUTE_DATABLOCK_ID        "blockid"
#define	    HT_ATTRIBUTE_ITEM_ID             "itemid"
#define	    HT_ATTRIBUTE_ROW_ID              "rowid"
#define	    HT_ATTRIBUTE_NUM_ROWS            "rows"
#define	    HT_ATTRIBUTE_FORM_LAYOUT         "layout"
#define	    HT_ATTRIBUTE_ITEM_FORM_ACTION    "action"
#define	    HT_ATTRIBUTE_NUM_ITEMS           "nitems"
#define	    HT_ATTRIBUTE_FILE_ID             "fileid"
#define	    HT_ATTRIBUTE_FILE_ID_SF          "sffileid"
#define	    HT_ATTRIBUTE_FILE_ID_DF          "dffileid"
#define	    HT_ATTRIBUTE_FILE_ID_NC          "ncfileid"
#define	    HT_ATTRIBUTE_FILE_ID_CC          "ccfileid"
#define	    HT_ATTRIBUTE_FILE_ID_CS          "csfileid"
#define	    HT_ATTRIBUTE_FILE_ID_DC          "dcfileid"
#define	    HT_ATTRIBUTE_VIEW_ID             "viewid"
#define     HT_ATTRIBUTE_CONFIG_OPT          "config"
#define     HT_ATTRIBUTE_FORMAT_TYPE         "ftype"
#define     HT_ATTRIBUTE_FORMAT_TYPE_SF      "sfftype"
#define     HT_ATTRIBUTE_FORMAT_TYPE_NC      "ncftype"
#define     HT_ATTRIBUTE_FORMAT_TYPE_CC      "ccftype"
#define     HT_ATTRIBUTE_FORMAT_TYPE_CS      "csftype"
#define     HT_ATTRIBUTE_FORMAT_TYPE_DC      "dcftype"
#define     HT_ATTRIBUTE_MMCIF_TYPE          "ciftype"
#define     HT_ATTRIBUTE_DISPLAY_TYPE        "dtype"
#define     HT_ATTRIBUTE_CONTEXT             "context"
#define     HT_ATTRIBUTE_EMAIL               "email"
#define     HT_ATTRIBUTE_DBNAME              "dbname"
#define     HT_ATTRIBUTE_PROJDIR             "projdir"
#define     HT_ATTRIBUTE_SYNTAX_CHECK        "syntaxchk"
#define     HT_ATTRIBUTE_EXP_METH            "expmeth"
#define     HT_ATTRIBUTE_MOL_TYPE            "moltype"
#define     HT_ATTRIBUTE_VIEW_TYPE           "viewtype"
#define     HT_ATTRIBUTE_OPERATION           "op"
#define     HT_ATTRIBUTE_FILES_LOADED        "floaded"
#define     HT_ATTRIBUTE_SID_CODE            "sidcode"
#define     HT_ATTRIBUTE_APPL_NAME           "applname"
#define     HT_ATTRIBUTE_PREVIEW_MODE        "prvmode"
#define     HT_ATTRIBUTE_PRINTER_ID          "printer"
#define     HT_ATTRIBUTE_MAXIT_OP            "maxitop"
#define     HT_ATTRIBUTE_DEMO                "demo"

#define     HT_GROUP_TITLE_FILE              "group-title.html"
#define     HT_CATEGORY_TITLE_FILE           "category-title.html"
#define     HT_ITEM_TITLE_FILE               "item-title.html"
#define     HT_CONTROL_TITLE_FILE            "control-title.html"
#define     HT_TABLE_OBJECT_FILE             "Table-db.odb"
#define     HT_VIEW_OBJECT_FILE              "View-db.odb"

#define HT_ITEM_LIST_NAME      "item-list.html"
#define HT_CATEGORY_LIST_NAME  "category-list.html"
#define HT_OTHER_TEXT_NAME     "other-text.html"



#ifndef __HTML_TYPEDEF_ENTRY_H__
#define __HTML_TYPEDEF_ENTRY_H__
typedef struct {
    char *name;
    char *val;
    char *file;
    int  isFile;
} entry;
#endif

/*
 *  
 */

#define LANG_TYPE_EN  1    
#define LANG_TYPE_DE  2    
#define LANG_TYPE_FR  3    
#define LANG_TYPE_ES  4    


#define HT_ENV_MAX_NAME_LEN  255

#ifdef HTML_ENV_GLOBAL_INIT

char  HT_RESTART_ID[HT_ENV_MAX_NAME_LEN];
char  HT_STATE_FILE[HT_ENV_MAX_NAME_LEN];
char  HT_BLANK_HTML_FILE[HT_ENV_MAX_NAME_LEN];
char  HT_ICON_SAVE_ROW[HT_ENV_MAX_NAME_LEN];
char  HT_ICON_ITEM_ERROR[HT_ENV_MAX_NAME_LEN];
char  HT_ICON_KEY[HT_ENV_MAX_NAME_LEN];
char  HT_ICON_BULLET[HT_ENV_MAX_NAME_LEN];
char  HT_ICON_HELP[HT_ENV_MAX_NAME_LEN];
char  HT_ICON_EXAMPLES[HT_ENV_MAX_NAME_LEN];
char  HT_ICON_INSERT[HT_ENV_MAX_NAME_LEN];
char  HT_ICON_DELETE[HT_ENV_MAX_NAME_LEN];
char  HT_ICON_NEXT[HT_ENV_MAX_NAME_LEN];
char  HT_ICON_PREVIOUS[HT_ENV_MAX_NAME_LEN];
char  HT_ICON_LOGO[HT_ENV_MAX_NAME_LEN];
char  HT_RCSBAPPS_PATH[HT_ENV_MAX_NAME_LEN];
char  HT_SESSION_TMP_ROOT_PATH[HT_ENV_MAX_NAME_LEN];
char  HT_SYS_TMP_PATH[HT_ENV_MAX_NAME_LEN];
char  HT_SERVER_PATH[HT_ENV_MAX_NAME_LEN];
char  HT_SERVER_NAME[HT_ENV_MAX_NAME_LEN];
char  HT_CGI_PATH[HT_ENV_MAX_NAME_LEN];
char  HT_LOGFILE_NAME[HT_ENV_MAX_NAME_LEN];
char  HT_CIFDB_PATH[HT_ENV_MAX_NAME_LEN];
char  HT_CIFDB_DICT[HT_ENV_MAX_NAME_LEN];
char  HT_VIEWFILE_NAME[HT_ENV_MAX_NAME_LEN];
char  HT_VIEW_TYPE[HT_ENV_MAX_NAME_LEN];
char  HT_VIEW_NAME[HT_ENV_MAX_NAME_LEN];
char  HT_BVIEW_PATH[HT_ENV_MAX_NAME_LEN];
char  HT_CONFIG_PATH[HT_ENV_MAX_NAME_LEN];
char  HT_HOME_PATH[HT_ENV_MAX_NAME_LEN];
char  HT_TRANSLATOR_NAME[HT_ENV_MAX_NAME_LEN];
char  HT_DBLOADER_NAME[HT_ENV_MAX_NAME_LEN];
char  HT_ARCHIVE_DIRECTORY[HT_ENV_MAX_NAME_LEN];
char  HT_ANNOTATOR_EMAIL[HT_ENV_MAX_NAME_LEN];
char  HT_TARGET_DBNAME[HT_ENV_MAX_NAME_LEN];
char  HT_APPL_CONTEXT[HT_ENV_MAX_NAME_LEN];
int   HT_APPL_CONTEXT_TYPE;
int   HT_APPL_CONTEXT_DEMO;
int   HT_APPL_CONTEXT_TEST;
int   HT_OSAKA_SITE_FLAG;
char  HT_ARCHIVE_PATH[HT_ENV_MAX_NAME_LEN];
char  HT_CVS_COMMAND[HT_ENV_MAX_NAME_LEN];
char  HT_CVS_ARCHIVE_PATH[HT_ENV_MAX_NAME_LEN];
char  HT_DBPW[HT_ENV_MAX_NAME_LEN];
char  HT_DBUSER[HT_ENV_MAX_NAME_LEN];
char  HT_SYBASE_PATH[HT_ENV_MAX_NAME_LEN];
char  HT_SYBASE_SERVER[HT_ENV_MAX_NAME_LEN];
char  HT_APPLICATION_NAME[HT_ENV_MAX_NAME_LEN];

char LANG_CATEGORY_TITLE[HT_ENV_MAX_NAME_LEN];
char LANG_ITEM_TITLE[HT_ENV_MAX_NAME_LEN];
char LANG_HELP[HT_ENV_MAX_NAME_LEN];
char LANG_DESCRIBE[HT_ENV_MAX_NAME_LEN];
char LANG_EXAMPLES[HT_ENV_MAX_NAME_LEN];
char LANG_HTML_BODY_SCHEME[HT_ENV_MAX_NAME_LEN];
char LANG_HTML_BODY_SCHEME_ALT_1[HT_ENV_MAX_NAME_LEN];
char LANG_HTML_BODY_SCHEME_ALT_2[HT_ENV_MAX_NAME_LEN];
char LANG_HTML_FONT_FACE[HT_ENV_MAX_NAME_LEN];
char LANG_DISPLAY_TABLE[HT_ENV_MAX_NAME_LEN];
char LANG_MMCIFIT[HT_ENV_MAX_NAME_LEN];
char LANG_RESTART_ID[HT_ENV_MAX_NAME_LEN];
char LANG_CHECK[HT_ENV_MAX_NAME_LEN];

char LANG_DEPOSIT[HT_ENV_MAX_NAME_LEN];
char LANG_QUIT[HT_ENV_MAX_NAME_LEN];
char LANG_NOTIFY_AUTHOR[HT_ENV_MAX_NAME_LEN];
char LANG_RASMOL[HT_ENV_MAX_NAME_LEN];
char LANG_NDBVIEW[HT_ENV_MAX_NAME_LEN];
char LANG_WRITE_CIF[HT_ENV_MAX_NAME_LEN];
char LANG_WRITE_PDB[HT_ENV_MAX_NAME_LEN];
char LANG_WRITE_NDB[HT_ENV_MAX_NAME_LEN];
char LANG_DB_LOAD[HT_ENV_MAX_NAME_LEN];

char LANG_DESCRIPTION_TITLE[HT_ENV_MAX_NAME_LEN];
char LANG_EXAMPLE_TITLE[HT_ENV_MAX_NAME_LEN];
char LANG_HELP_TITLE[HT_ENV_MAX_NAME_LEN];
char LANG_ENTER_DATA_TITLE[HT_ENV_MAX_NAME_LEN];
char LANG_DATA_TABLE_TITLE[HT_ENV_MAX_NAME_LEN];
char LANG_DIAGNOSTICS_TITLE[HT_ENV_MAX_NAME_LEN];
int   HT_CURRENT_LANG;

char HT_ASCII_FILTER_COMMAND[HT_ENV_MAX_NAME_LEN];
char HT_GZCAT_COMMAND[HT_ENV_MAX_NAME_LEN];
char HT_ZCAT_COMMAND[HT_ENV_MAX_NAME_LEN];
char HT_PDB_PREFILTER_NAME[HT_ENV_MAX_NAME_LEN];
char HT_CIF_PREFILTER_NAME[HT_ENV_MAX_NAME_LEN];
char HT_PENDING_PATH[HT_ENV_MAX_NAME_LEN];

char HT_MOL_TYPE[HT_ENV_MAX_NAME_LEN];
char HT_EXP_METHOD[HT_ENV_MAX_NAME_LEN];
char HT_SESSION_ROOT_PATH[HT_ENV_MAX_NAME_LEN];
char HT_SITE_PATH[HT_ENV_MAX_NAME_LEN];
char HT_SESSION_REL_TMP_ROOT_PATH[HT_ENV_MAX_NAME_LEN];
char HT_SCHEMA_OBJ_PATH[HT_ENV_MAX_NAME_LEN];
char HT_SCHEMA_CIF_PATH[HT_ENV_MAX_NAME_LEN];
char HT_PDB_ID_FILE[HT_ENV_MAX_NAME_LEN];
char HT_HTML_TRANSLATOR_NAME[HT_ENV_MAX_NAME_LEN];
char HT_VALIDATOR_NAME[HT_ENV_MAX_NAME_LEN];
char HT_SPLUS_INTERPRETER[HT_ENV_MAX_NAME_LEN];
char HT_CIFEXCH_IN_TRANSLATOR[HT_ENV_MAX_NAME_LEN];
char HT_CIFEXCH_OUT_TRANSLATOR[HT_ENV_MAX_NAME_LEN];

#else 

extern char  HT_RESTART_ID[HT_ENV_MAX_NAME_LEN];
extern char  HT_STATE_FILE[HT_ENV_MAX_NAME_LEN];
extern char  HT_BLANK_HTML_FILE[HT_ENV_MAX_NAME_LEN];
extern char  HT_ICON_KEY[HT_ENV_MAX_NAME_LEN];
extern char  HT_ICON_BULLET[HT_ENV_MAX_NAME_LEN];
extern char  HT_ICON_SAVE_ROW[HT_ENV_MAX_NAME_LEN];
extern char  HT_ICON_ITEM_ERROR[HT_ENV_MAX_NAME_LEN];
extern char  HT_ICON_HELP[HT_ENV_MAX_NAME_LEN];
extern char  HT_ICON_EXAMPLES[HT_ENV_MAX_NAME_LEN];
extern char  HT_ICON_INSERT[HT_ENV_MAX_NAME_LEN];
extern char  HT_ICON_DELETE[HT_ENV_MAX_NAME_LEN];
extern char  HT_ICON_NEXT[HT_ENV_MAX_NAME_LEN];
extern char  HT_ICON_PREVIOUS[HT_ENV_MAX_NAME_LEN];
extern char  HT_ICON_LOGO[HT_ENV_MAX_NAME_LEN];
extern char  HT_RCSBAPPS_PATH[HT_ENV_MAX_NAME_LEN];
extern char  HT_SESSION_TMP_ROOT_PATH[HT_ENV_MAX_NAME_LEN];
extern char  HT_SYS_TMP_PATH[HT_ENV_MAX_NAME_LEN];
extern char  HT_SERVER_PATH[HT_ENV_MAX_NAME_LEN];
extern char  HT_SERVER_NAME[HT_ENV_MAX_NAME_LEN];
extern char  HT_CGI_PATH[HT_ENV_MAX_NAME_LEN];
extern char  HT_LOGFILE_NAME[HT_ENV_MAX_NAME_LEN];
extern char  HT_CIFDB_PATH[HT_ENV_MAX_NAME_LEN];
extern char  HT_CIFDB_DICT[HT_ENV_MAX_NAME_LEN];
extern char  HT_VIEWFILE_NAME[HT_ENV_MAX_NAME_LEN];
extern char  HT_VIEW_TYPE[HT_ENV_MAX_NAME_LEN];
extern char  HT_VIEW_NAME[HT_ENV_MAX_NAME_LEN];
extern char  HT_BVIEW_PATH[HT_ENV_MAX_NAME_LEN];
extern char  HT_CONFIG_PATH[HT_ENV_MAX_NAME_LEN];
extern char  HT_HOME_PATH[HT_ENV_MAX_NAME_LEN];
extern char  HT_TRANSLATOR_NAME[HT_ENV_MAX_NAME_LEN];
extern char  HT_DBLOADER_NAME[HT_ENV_MAX_NAME_LEN];
extern char  HT_ARCHIVE_DIRECTORY[HT_ENV_MAX_NAME_LEN];
extern char  HT_ANNOTATOR_EMAIL[HT_ENV_MAX_NAME_LEN];
extern char  HT_TARGET_DBNAME[HT_ENV_MAX_NAME_LEN];
extern char  HT_APPL_CONTEXT[HT_ENV_MAX_NAME_LEN];
extern int   HT_APPL_CONTEXT_TYPE;
extern int   HT_APPL_CONTEXT_DEMO;
extern int   HT_APPL_CONTEXT_TEST;
extern int   HT_OSAKA_SITE_FLAG;
extern char  HT_ARCHIVE_PATH[HT_ENV_MAX_NAME_LEN];
extern char  HT_CVS_COMMAND[HT_ENV_MAX_NAME_LEN];
extern char  HT_CVS_ARCHIVE_PATH[HT_ENV_MAX_NAME_LEN];
extern char  HT_DBPW[HT_ENV_MAX_NAME_LEN];
extern char  HT_DBUSER[HT_ENV_MAX_NAME_LEN];
extern char  HT_SYBASE_PATH[HT_ENV_MAX_NAME_LEN];
extern char  HT_SYBASE_SERVER[HT_ENV_MAX_NAME_LEN];
extern char  HT_APPLICATION_NAME[HT_ENV_MAX_NAME_LEN];

extern char LANG_CATEGORY_TITLE[HT_ENV_MAX_NAME_LEN];
extern char LANG_ITEM_TITLE[HT_ENV_MAX_NAME_LEN];
extern char LANG_HELP[HT_ENV_MAX_NAME_LEN];
extern char LANG_DESCRIBE[HT_ENV_MAX_NAME_LEN];
extern char LANG_EXAMPLES[HT_ENV_MAX_NAME_LEN];
extern char LANG_HTML_BODY_SCHEME[HT_ENV_MAX_NAME_LEN];
extern char LANG_HTML_BODY_SCHEME_ALT_1[HT_ENV_MAX_NAME_LEN];
extern char LANG_HTML_BODY_SCHEME_ALT_2[HT_ENV_MAX_NAME_LEN];
extern char LANG_HTML_FONT_FACE[HT_ENV_MAX_NAME_LEN];
extern char LANG_DISPLAY_TABLE[HT_ENV_MAX_NAME_LEN];

extern char LANG_MMCIFIT[HT_ENV_MAX_NAME_LEN];
extern char LANG_RESTART_ID[HT_ENV_MAX_NAME_LEN];
extern char LANG_CHECK[HT_ENV_MAX_NAME_LEN];
extern char LANG_DEPOSIT[HT_ENV_MAX_NAME_LEN];
extern char LANG_QUIT[HT_ENV_MAX_NAME_LEN];
extern char LANG_NOTIFY_AUTHOR[HT_ENV_MAX_NAME_LEN];
extern char LANG_RASMOL[HT_ENV_MAX_NAME_LEN];
extern char LANG_NDBVIEW[HT_ENV_MAX_NAME_LEN];
extern char LANG_WRITE_CIF[HT_ENV_MAX_NAME_LEN];
extern char LANG_WRITE_PDB[HT_ENV_MAX_NAME_LEN];
extern char LANG_WRITE_NDB[HT_ENV_MAX_NAME_LEN];
extern char LANG_DB_LOAD[HT_ENV_MAX_NAME_LEN];

extern char LANG_DESCRIPTION_TITLE[HT_ENV_MAX_NAME_LEN];
extern char LANG_EXAMPLE_TITLE[HT_ENV_MAX_NAME_LEN];
extern char LANG_HELP_TITLE[HT_ENV_MAX_NAME_LEN];
extern char LANG_ENTER_DATA_TITLE[HT_ENV_MAX_NAME_LEN];
extern char LANG_DATA_TABLE_TITLE[HT_ENV_MAX_NAME_LEN];
extern char LANG_DIAGNOSTICS_TITLE[HT_ENV_MAX_NAME_LEN];

extern int  HT_CURRENT_LANG;
extern char HT_ASCII_FILTER_COMMAND[HT_ENV_MAX_NAME_LEN];
extern char HT_GZCAT_COMMAND[HT_ENV_MAX_NAME_LEN];
extern char HT_ZCAT_COMMAND[HT_ENV_MAX_NAME_LEN];
extern char HT_PDB_PREFILTER_NAME[HT_ENV_MAX_NAME_LEN];
extern char HT_CIF_PREFILTER_NAME[HT_ENV_MAX_NAME_LEN];
extern char HT_PENDING_PATH[HT_ENV_MAX_NAME_LEN];

extern char HT_MOL_TYPE[HT_ENV_MAX_NAME_LEN];
extern char HT_EXP_METHOD[HT_ENV_MAX_NAME_LEN];
extern char HT_SESSION_ROOT_PATH[HT_ENV_MAX_NAME_LEN];
extern char HT_SITE_PATH[HT_ENV_MAX_NAME_LEN];
extern char HT_SESSION_REL_TMP_ROOT_PATH[HT_ENV_MAX_NAME_LEN];
extern char HT_SCHEMA_OBJ_PATH[HT_ENV_MAX_NAME_LEN];
extern char HT_SCHEMA_CIF_PATH[HT_ENV_MAX_NAME_LEN];
extern char HT_PDB_ID_FILE[HT_ENV_MAX_NAME_LEN];
extern char HT_HTML_TRANSLATOR_NAME[HT_ENV_MAX_NAME_LEN];
extern char HT_VALIDATOR_NAME[HT_ENV_MAX_NAME_LEN];
extern char HT_SPLUS_INTERPRETER[HT_ENV_MAX_NAME_LEN];
extern char HT_CIFEXCH_IN_TRANSLATOR[HT_ENV_MAX_NAME_LEN];
extern char HT_CIFEXCH_OUT_TRANSLATOR[HT_ENV_MAX_NAME_LEN];
#endif


/**PROTO*******************************************************************
 *       Prototypes for file:  interface-util.C
 */

extern "C" {
int check_input_data_syntax(FILE *io, const char * dirPath, 
			    int flagXYZ, const char *formatTypeXYZ, const char *rootNameXYZ,
			    int flagSF,  const char *formatTypeSF, const char *rootNameSF,
			    const char *returnText, const char *returnURL);

char *mk_db_load_object(const char *idNameLC, const char *archPath);
void update_cvs_archive_directory(const char *idNameLC, const char *annotPath);


void html_display_return_tool_top(FILE *io, const char *ufid );
void html_display_return_to_page(FILE *io, const char *text, const char *page );
void html_display_open_page(FILE *io, const char *title, int style);
void html_display_open_page_w_target(FILE *io, const char *title, int style, const char *target);
void html_display_close_page(FILE *io, int style);
void html_display_page_title_logo(FILE *io, const char *title, int style);
void html_display_redeposit_block_message(FILE *io, const char *ufid, const char *dirPath,  int style);

int html_advise_missing_file(FILE *io, const char *fileid, const char *returnURL);
int html_advise_missing_directory(FILE *io, const char *dirId, const char *returnURL);
int is_directory(char *dirId);
// int html_advise_missing_file(const char *fileid);
int coordinate_format_ok(const char *formatType, const char *dirPath, const char *rootName, const char *rptFile);
int sf_format_ok(const char *formatType, const char *dirPath, const char *rootName, const char *rptFile);

int capture_input_data(const char *fileid, const char *formatType, 
		       const char *dirPath, const char *rootName);
int display_raw_file(FILE *io, const char *fName);
void html_display_raw_file(FILE *io, const char *fName);

int translate_coordinate_format(const char *formatTypeIn, const char *formatTypeOut, 
				const char *dirPath, const char *rootName);


void update_aux_files(const char *idname, const char *dirPath, const char *archPath);
void release_lock(const char *path);
int acquire_lock(const char *path);

int get_current_deposition_count(void);
void set_deposition_count(int count);

void  mk_diag_help_frame(char *fname);
void  mk_help_frame(char *fname, char *ufid);
void  mk_help_frame_fp(FILE *fp, char *ufid);

void putfield(FILE *fp, const char *field);
int getfield(FILE *fp, char *field, int Mxlen);
void skipfield(FILE *fp);



void get_current_view_address(const char *dirpath, char *block, char *category, char *viewCategory);
void set_current_view_address(const char *dirpath,  const char *block, const char *category, const char *viewCategory);

void set_current_group(const char *dirpath,  const char *group);
char *get_current_group(const char *dirpath);

char *ht_get_projdir(const char *moltype, const char *expmeth);
char *ht_get_dbname(const char *moltype, const char *expmeth);
char *ht_get_view_id(const char *moltype, const char *expmeth, const char *viewtype);
void ht_set_httpd_environment(entry entries[], int nentries);

void format_cif_definition(FILE *fp, const char *string);
int wsystem(char *cmdstring);
char *ndb_root_id_name(char *path);

void check_input_data_drv(entry entries[], int nentries, const char *ufid);
void validate_input_data_drv(entry entries[], int nentries, const char *ufid);

  //  int strcasecmp (const char *s1, const char *s2);
  //  int strncasecmp (const char *s1, const char *s2, size_t n);
#ifdef GNU2_COMPILER
  int symlink(const char *s1, const char *s2) __THROW;
#endif // GNU2_COMPILER defined
int html_decode_multipart_form_data(entry *entries, const char *path);
void html_failure_message(FILE *io, const char *returnURL, const char *title, const char *message, int style);
void capture_cgi_stdin(void);
	   }

#if 0

void put_item_list(const char *dirpath, const char *category, 
                   const char **ilist, int nitem);
char **get_item_list(const char *dirpath, const char * category, int *nitems);

void append_category_list(const char *dirpath, const char *category);
char **get_category_list(const char *dirpath, int *ncat);
void set_current_category(const char *dirpath,  const char *category);
char *get_current_category(const char *dirpath);
void get_category_state(const char *dirpath,  const char *category, int *curRow, int *maxRow);
void set_category_state(const char *dirpath,  const char *category, int curRow, int maxRow);
void   free_row(char **row, int nCols);
char **get_row(const char *dirPath, const char *category, 
               int rowId, int nCols);
void put_row(const char *dirPath, const char *category,  
             const char **row,  int rowId, int nCols);

void delete_row(const char *dirPath, const char *category, int rowId, int nCols);
void insert_row(const char *dirPath, const char *category, int rowId, int nCols);


#endif

#endif
