/*
FILE:     interface-lang.h
*/
/*
VERSION:  0.904-beta
*/
/*
DATE:     8/14/2003
*/
/*
  Comments and Questions to: sw-help@rcsb.rutgers.edu
*/
/*
COPYRIGHT 1999-2003 Rutgers - The State University of New Jersey

This software is provided WITHOUT WARRANTY OF MERCHANTABILITY OR
FITNESS FOR A PARTICULAR PURPOSE OR ANY OTHER WARRANTY, EXPRESS OR
IMPLIED.  RUTGERS MAKE NO REPRESENTATION OR WARRANTY THAT THE
SOFTWARE WILL NOT INFRINGE ANY PATENT, COPYRIGHT OR OTHER
PROPRIETARY RIGHT.

The user of this software shall indemnify, hold harmless and defend
Rutgers, its governors, trustees, officers, employees, students,
agents and the authors against any and all claims, suits,
losses, liabilities, damages, costs, fees, and expenses including
reasonable attorneys' fees resulting from or arising out of the
use of this software.  This indemnification shall include, but is
not limited to, any and all claims alleging products liability.
*/
/*
               PDB SOFTWARE LICENSE AGREEMENT

BY CLICKING THE ACCEPTANCE BUTTON OR INSTALLING OR USING 
THIS "SOFTWARE, THE INDIVIDUAL OR ENTITY LICENSING THE  
SOFTWARE ("LICENSEE") IS CONSENTING TO BE BOUND BY AND IS 
BECOMING A PARTY TO THIS AGREEMENT.  IF LICENSEE DOES NOT 
AGREE TO ALL OF THE TERMS OF THIS AGREEMENT
THE LICENSEE MUST NOT INSTALL OR USE THE SOFTWARE.

1. LICENSE AGREEMENT

This is a license between you ("Licensee") and the Protein Data Bank (PDB) 
at Rutgers, The State University of New Jersey (hereafter referred to 
as "RUTGERS").   The software is owned by RUTGERS and protected by 
copyright laws, and some elements are protected by laws governing 
trademarks, trade dress and trade secrets, and may be protected by 
patent laws. 

2. LICENSE GRANT

RUTGERS grants you, and you hereby accept, non-exclusive, royalty-free 
perpetual license to install, use, modify, prepare derivative works, 
incorporate into other computer software, and distribute in binary 
and source code format, or any derivative work thereof, together with 
any associated media, printed materials, and on-line or electronic 
documentation (if any) provided by RUTGERS (collectively, the "SOFTWARE"), 
subject to the following terms and conditions: (i) any distribution 
of the SOFTWARE shall bind the receiver to the terms and conditions 
of this Agreement; (ii) any distribution of the SOFTWARE in modified 
form shall clearly state that the SOFTWARE has been modified from 
the version originally obtained from RUTGERS.  

2. COPYRIGHT; RETENTION OF RIGHTS.  

The above license grant is conditioned on the following: (i) you must 
reproduce all copyright notices and other proprietary notices on any 
copies of the SOFTWARE and you must not remove such notices; (ii) in 
the event you compile the SOFTWARE, you will include the copyright 
notice with the binary in such a manner as to allow it to be easily 
viewable; (iii) if you incorporate the SOFTWARE into other code, you 
must provide notice that the code contains the SOFTWARE and include 
a copy of the copyright notices and other proprietary notices.  All 
copies of the SOFTWARE shall be subject to the terms of this Agreement.  

3. NO MAINTENANCE OR SUPPORT; TREATMENT OF ENHANCEMENTS 

RUTGERS is under no obligation whatsoever to: (i) provide maintenance 
or support for the SOFTWARE; or (ii) to notify you of bug fixes, patches, 
or upgrades to the features, functionality or performance of the 
SOFTWARE ("Enhancements") (if any), whether developed by RUTGERS 
or third parties.  If, in its sole discretion, RUTGERS makes an 
Enhancement available to you and RUTGERS does not separately enter 
into a written license agreement with you relating to such bug fix, 
patch or upgrade, then it shall be deemed incorporated into the SOFTWARE 
and subject to this Agreement. You are under no obligation whatsoever 
to provide any Enhancements to RUTGERS or the public that you may 
develop over time; however, if you choose to provide your Enhancements 
to RUTGERS, or if you choose to otherwise publish or distribute your 
Enhancements, in source code form without contemporaneously requiring 
end users or RUTGERS to enter into a separate written license agreement 
for such Enhancements, then you hereby grant RUTGERS a non-exclusive,
royalty-free perpetual license to install, use, modify, prepare
derivative works, incorporate into the SOFTWARE or other computer
software, distribute, and sublicense your Enhancements or derivative
works thereof, in binary and source code form.

4. FEES.  There is no license fee for the SOFTWARE.  If Licensee
wishes to receive the SOFTWARE on media, there may be a small charge
for the media and for shipping and handling.  Licensee is
responsible for any and all taxes.

5. TERMINATION.  Without prejudice to any other rights, Licensor
may terminate this Agreement if Licensee breaches any of its terms
and conditions.  Upon termination, Licensee shall destroy all
copies of the SOFTWARE.

6. PROPRIETARY RIGHTS.  Title, ownership rights, and intellectual
property rights in the Product shall remain with RUTGERS.  Licensee 
acknowledges such ownership and intellectual property rights and will 
not take any action to jeopardize, limit or interfere in any manner 
with RUTGERS' ownership of or rights with respect to the SOFTWARE.  
The SOFTWARE is protected by copyright and other intellectual 
property laws and by international treaties.  Title and related 
rights in the content accessed through the SOFTWARE is the property 
of the applicable content owner and is protected by applicable law.  
The license granted under this Agreement gives Licensee no rights to such
content.

7. DISCLAIMER OF WARRANTY.  THE SOFTWARE IS PROVIDED FREE OF 
CHARGE, AND, THEREFORE, ON AN "AS IS" BASIS, WITHOUT WARRANTY OF 
ANY KIND, INCLUDING WITHOUT LIMITATION THE WARRANTIES THAT IT 
IS FREE OF DEFECTS, MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE 
OR NON-INFRINGING.  THE ENTIRE RISK AS TO THE QUALITY AND 
PERFORMANCE OF THE SOFTWARE IS BORNE BY LICENSEE.  SHOULD THE 
SOFTWARE PROVE DEFECTIVE IN ANY RESPECT, THE LICENSEE AND NOT 
LICENSOR ASSUMES THE ENTIRE COST OF ANY SERVICE AND REPAIR.  
THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF 
THIS AGREEMENT.  NO USE OF THE PRODUCT IS AUTHORIZED HEREUNDER 
EXCEPT UNDER THIS DISCLAIMER.

8. LIMITATION OF LIABILITY.  TO THE MAXIMUM EXTENT PERMITTED BY
APPLICABLE LAW,  IN NO EVENT WILL LICENSOR BE LIABLE FOR ANY 
INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
OUT OF THE USE OF OR INABILITY TO USE THE SOFTWARE, INCLUDING, 
WITHOUT LIMITATION, DAMAGES FOR LOSS OF GOODWILL, WORK 
STOPPAGE, COMPUTER FAILURE OR MALFUNCTION, OR ANY AND ALL 
OTHER COMMERCIAL DAMAGES OR LOSSES, EVEN IF ADVISED OF THE
POSSIBILITY THEREOF. 
*/
/*
  PURPOSE:      Language specific definitions .

*/


#ifndef __INTERFACE_LANG_H__
#define __INTERFACE_LANG_H__

static char help_en_deposit[]="\
<HTML>\n\
<BODY BGCOLOR=\"#ffffff\" TEXT=\"#000080\" LINK=\"#000080\" VLINK=\"#000080\">\n\
<BR><CENTER>\n\
<FONT SIZE=7><BOLD>How to use the</BOLD></FONT><br>\n\
<FONT SIZE=7><BOLD>AUTO DEP INPUT TOOL</BOLD></FONT>\n\
</CENTER>\n\
<ul>\n\
<li>\n\
 <b>BEGIN ENTERING DATA</b>: For each category, a set of instructions and places to\n\
enter data will be displayed in this frame.  Fill in any relevant missing \n\
 information.   \n\
<br><br>\n\
<li>\n\
 <b>RESTART</b>:  if you want to restart your session at a later time, \n\
 record the restart ID for this session: \n\
 <font color=red><b>%s</b></font>.  \n\
 This ID is also displayed in the title bar of your browser. \n\
 When you are ready to continue,   enter this code \n\
 in the appropriate box at the bottom of the ADIT HOME page. \n\
<br><br>\n\
<li>\n\
 <b>HELP</b>: An explanation for any item can be obtained by selecting \n\
 the Help button within the table. This information will appear in the bottom \n\
 frame.  Pressing the Help button in the top frame will display these instructions. \n\
<br><br>\n\
<li>\n\
 <b>EXAMPLE</b>: An example for any item can be obtained by selecting \n\
 the Example button within the table. This information will appear in the bottom \n\
 frame. \n\
<br><br> \n\
<li> \n\
<b>SAVING YOUR DATA</b>: You must press the Save button in each category \n\
after entering data.  Switching to another category without saving your data will erase \n\
the information that you have entered. \n\
<br><br> \n\
<li> \n\
<b>DISPLAYING AS A TABLE</b>: To display the data in the selected category in \n\
tabular form, press the DISPLAY AS TABLE button located above this frame.  \n\
 This information will appear in the bottom  frame.  \n\
 <br><br> \n\
<li> \n\
<b>PREVIEWING YOUR ENTRY</b>: You can preview your entry at any time by \n\
selecting the PREVIEW ENTRY button located in the top frame. \n\
<br><br> \n\
<li> \n\
<b>DEPOSITING YOUR STRUCTURE</b>: \n\
 To send your deposition to the archive, press DEPOSIT in the top frame.  \n\
 <br><br> \n\
</ul> \n\
</BODY> \n\
</HTML> \n\
";


//
static char help_en_deposit_old[]="\
<HTML>\n\
<BODY BGCOLOR=\"#ffffff\" TEXT=\"#000080\" LINK=\"#000080\" VLINK=\"#000080\">\n\
<BR><CENTER>\n\
<FONT SIZE=7><BOLD>How to use the</BOLD></FONT><br>\n\
<FONT SIZE=7><BOLD>AUTO DEP INPUT TOOL</BOLD></FONT>\n\
</CENTER>\n\
<ul>\n\
<li>\n\
 To <b>RESTART</b> your session at a later time record the restart ID \n\
 that is displayed in the title bar of your browser. \n\
 To restore this deposition session, supply this code\n\
 in the appropriate box at the bottom of the DEPOSITION HOME page. Your\n\
 restart ID for this session is <font color=red><b>%s</b></font>.\n\
<br><br>\n\
<li>\n\
 Select a category from the list in the left hand frame.  Double arrows \n\
 (<font color=\"#a00000\"><b>>></b></font>)\n\
 next to a category name indicate that <I>mandatory</I> data items are missing. \n\
 A single arrow  (<font color=\"#a00000\"><b>></b></font>)\n\
 next to a category name indicates that <I>optional</I> data\n\
 items are missing.  If there are no arrows, the category is complete.\n\
<br><br>\n\
<li>\n\
 A set of instructions and a table listing the data items in the selected\n\
 category will be displayed in this frame.  Follow the instructions at the top\n\
 and fill in any missing information relevant to your structure in the boxes \n\
 provided for each item.  The names of mandatory data items are displayed in\n\
<font color=red>RED</font>. An explanation for any item can be obtained by selecting \n\
 <font color=black><b>Help</b></font>  and an example by \n\
 selecting <font color=black><b>Example</b></font>.  \n\
 This information will appear in  the bottom frame.  \n\
<br><br>\n\
<li> You must press the <font color=red>Save</font> button after entering data in\n\
each category.  Switching to another category without saving your data will erase\n\
the information that you have entered.\n\
<br><br>\n\
<li>\n\
 To display the data in the selected category in tabular form, press the\n\
 <font color=\"#909000\"><b>DISPLAY AS TABLE</b></font> button located above this frame.  \n\
 A table including any information you have entered for the selected category \n\
 will appear in the bottom frame. \n\
 <br><br>\n\
<li>\n\
 You can preview your entry at any time by selecting the <b>PREVIEW ENTRY</b>\n\
 button located in the top frame.\n\
<br><br>\n\
<li>\n\
If you would like to add additional information about your structure, please\n\
do this in the data items named <b>details</b>.\n\
<br><br>\n\
<li>\n\
 To send your deposition to the archive, press DEPOSIT in the top frame. \n\
 <br><br>\n\
</ul>\n\
</BODY>\n\
</HTML>\n\
";

//
static char help_en_deposit_alt[]="\
<HTML>\n\
<BODY BGCOLOR=\"#ffffff\" TEXT=\"#000080\" LINK=\"#000080\" VLINK=\"#000080\">\n\
<BR><CENTER>\n\
<FONT SIZE=7><BOLD>How to use the</BOLD></FONT><br>\n\
<FONT SIZE=7><BOLD>mmCIF DEPOSITION TOOL</BOLD></FONT>\n\
</CENTER>\n\
<UL>\n\
<LI>To <font color=\"#000080\"><B>RESTART</B></font> your session at a later time \n\
save the  restart identifier in the upper right corner of the title frame. \n\
Supply this value in the form box for <font color=\"#000000\"><B>Restart Session</B></font> \n\
on the preceding page to restore this input session.\n\
Your restart ID is <b>%s<b>\n\
<LI>Select a category from the category list to the left.  Categories with \n\
missing mandatory data items are marked with two arrows (<font color=\"#a00000\"><b>>></b></font>).\n\
Categories with missing optional data items are marked with a single arrow (<font color=\"#a00000\"><b>></b></font>).\n\
Other categories without the arrow indicators are complete.\n\
\n\
<LI>A list of the data items in this category will be displayed in this \n\
frame. Follow the instructions at the top of the form and fill in any \n\
missing data items appropriate for your structure in the boxes provided for each item.\n\
The names of mandatory data items are displayed in <font color=\"red\">RED</font>.\n\
\n\
<LI>To display the data in the current category as in tabular form in the \n\
frame below, press the <font color=\"#909000\"><B>DISPLAY DATA AS TABLE</B></font> \n\
button above.\n\
\n\
<LI>Press the <font color=\"#000080\"><B>DEPOSIT</B></font> in the top frame to send \n\
your deposition to the archive.\n\
\n\
</ul>\n\
</BODY>\n\
</HTML>\n\
";


//
static char help_en_annot[]="\
<HTML>\n\
<BODY BGCOLOR=\"#ffffff\" TEXT=\"#000080\" LINK=\"#000080\" VLINK=\"#000080\">\n\
<BR><CENTER>\n\
<FONT SIZE=7><BOLD>How to use the</BOLD></FONT><br>\n\
<FONT SIZE=7><BOLD>AUTO DEP INPUT TOOL</BOLD></FONT>\n\
</CENTER>\n\
<UL>\n\
<LI>Select a category from the category list to the left.  Categories with \n\
missing mandatory data items are marked with two arrows (<font color=\"#a00000\"><b>>></b></font>).\n\
Categories with missing optional data items are marked with a single arrow (<font color=\"#a00000\"><b>></b></font>).\n\
Other without the arrow indicators are complete.\n\
\n\
<LI>A list of the data items in this category will be displayed in this \n\
frame. Follow the instructions at the top of the form and fill in any \n\
missing data items appropriate for your structure in the boxes provided for each item.\n\
The names of mandatory data items are displayed in <font color=\"red\">RED</font>.\n\
\n\
<LI>To display the data in the current category as in tabular form in the \n\
frame below, press the <font color=\"#909000\"><B>DISPLAY DATA AS TABLE</B></font> \n\
button above.\n\
\n\
<LI>Press the <font color=\"#000080\"><B>DEPOSIT</B></font> in the top frame to send \n\
your deposition to the archive.\n\
\n\
<LI>To <font color=\"#000080\"><B>RESTART</B></font> your session at a later time \n\
save the  restart identifier in the upper right corner of the title frame. \n\
Supply this value in the form box for <font color=\"#000000\"><B>Restart Session</B></font> \n\
on the preceding page to restore this input session.\n\
</ul>\n\
</BODY>\n\
</HTML>\n\
";


//
static char help_fr[]="\
<HTML><BODY BGCOLOR=\"#ffffff\" TEXT=\"#000080\" LINK=\"#000080\" VLINK=\"#000080\">\n\
<BR><CENTER>\n\
<FONT SIZE=7><BOLD>Comment utiliser</BOLD></FONT><br>\n\
<FONT SIZE=7><BOLD>OUTIL d'cEntr&eacute;e de MSD mmCIF</BOLD></FONT>\n\
</CENTER>\n\
<UL>\n\
<LI>Choisissez une cat&eacute;gorie &agrave; partir de la liste de cat&eacute;gorie\n\
vers la gauche\n\
<LI>Une liste des donn&eacute;es &eacute;l&eacute;mentaires dans cette cat&eacute;gorie\n\
sera affich&eacute;e dans cette trame.  Suivez les instructions au dessus de\n\
la forme et compl&eacute;tez toutes les donn&eacute;es &eacute;l&eacute;mentaires manquantes\n\
appropri&eacute;es pour votre structure dans les cadres donn&eacute;s pour chaque\n\
&eacute;l&eacute;ment.\n\
<LI>Pour afficher les donn&eacute;es dans la cat&eacute;gorie actuelle en\n\
tant qu'en forme de tableaux dans la trame ci-dessous, appuyez sur le\n\
bouton qui est &eacute;tiquet&eacute; des donn&eacute;es d'affichage comme une table\n\
dans la trame ci-dessus.\n\
<LI>Appuyez le d&eacute;p&ocirc;t dans la trame sup&eacute;rieure pour envoyer\n\
votre d&eacute;p&ocirc;t aux archives de MSD.\n\
<LI>Pour relancer votre session &agrave; un temps post&eacute;rieur\n\
&eacute;conomiser l'identificateur de relancement dans le bon coin\n\
sup&eacute;rieur de la trame de titre.  Tapez cette valeur dans le cadre de\n\
forme nomm&eacute; session de relancement &agrave; la page pr&eacute;c&eacute;dente pour\n\
restaurer cette session d'entr&eacute;e.\n\
</ul>\n\
</BODY>\n\
</HTML>\n\
";

//
static char help_de[]="\
<HTML><BODY BGCOLOR=\"#ffffff\" TEXT=\"#000080\" LINK=\"#000080\" VLINK=\"#000080\">\n\
<BR><CENTER>\n\
<FONT SIZE=7><BOLD>Wie man verwendet</BOLD></FONT><br>\n\
<FONT SIZE=7><BOLD>INPUTCHilfsmittel MSD mmCIF</BOLD></FONT>\n\
</CENTER><UL>\n\
<LI>W&auml;hlen Sie eine Kategorie von der Kategorie Liste nach links\n\
aus\n\
<LI>Eine Liste der Datenelemente in dieser Kategorie wird in\n\
diesem Feld angezeigt.  Befolgen Sie die Anweisungen an der Oberseite\n\
des Formulars und f&uuml;llen Sie alle fehlenden Datenelemente aus, die\n\
f&uuml;r Ihre Struktur in den K&auml;sten passend sind, die f&uuml;r jedes\n\
Einzelteil bereitgestellt werden.\n\
<LI>, um die Daten in der aktuellen Kategorie als in\n\
tabellarischer Darstellung im Feld anzuzeigen unten, bet&auml;tigen Sie\n\
die Taste, die Bildschirmanzeigedaten wie eine Tabelle im Feld oben\n\
beschriftet wird.\n\
<LI>Bet&auml;tigen Sie die Ablagerung im oberen Feld, um Ihre\n\
Absetzung zum MSD-Archiv zu schicken.\n\
<LI>Ihre Sitzung zu einer neueren Zeit au&szlig;er der Wiederanlauf\n\
Kennung in der oberen rechten Ecke des Namefeldes wiederbeginnen.\n\
Schreiben Sie diesen Wert im Formularkasten, der Wiederanlauf Sitzung\n\
auf der vorhergehenden Seite, um diese Inputsitzung wiederhzuerstellen\n\
benannt wird.\n\
</ul>\n\
</BODY></HTML>\n\
";

//
//
static char help_es[]="\
<HTML><BODY BGCOLOR=\"#ffffff\" TEXT=\"#000080\" LINK=\"#000080\" VLINK=\"#000080\">\n\
<BR><CENTER>\n\
<FONT SIZE=7><BOLD>C&oacute;mo utilizar</BOLD></FONT><br>\n\
<FONT SIZE=7><BOLD>HERRAMIENTA de la ENTRADA DE INFORMACI&Oacute;N de MSD mmCIF</BOLD></FONT>\n\
</CENTER>\n\
<UL>\n\
<LI>Seleccione una categor&iacute;a de la lista de la categor&iacute;a a la\n\
izquierda\n\
<LI>Una lista de los items de datos en esta categor&iacute;a ser&aacute;\n\
visualizada en este marco.  Siga las instrucciones en la tapa de la\n\
forma y complete cualquier item de datos que falta apropiado para su\n\
estructura en los rect&aacute;ngulos proporcionados para cada item.\n\
<LI>Para visualizar los datos en la categor&iacute;a actual como en\n\
forma tabular en el marco abajo, presione el bot&oacute;n que se etiqueta\n\
los datos de la visualizaci&oacute;n como un vector en el marco arriba.\n\
<LI>Presione el dep&oacute;sito en el marco superior para enviar su\n\
00@deposici&oacute;n al archivo de MSD.\n\
<LI>Para recomenzar su sesi&oacute;n en un rato posterior excepto el\n\
identificador del relanzar en la esquina derecha superior del bastidor\n\
del t&iacute;tulo.  Pulse este valor en el rect&aacute;ngulo de la forma nombrado\n\
sesi&oacute;n del relanzar en la paginaci&oacute;n precedente para restablecer\n\
esta sesi&oacute;n de la entrada de informaci&oacute;n.</ul>\n\
</BODY></HTML>\n\
";

//

static char other_en_deposit[]="\
<HTML><BODY BGCOLOR=\"#ffffff\" TEXT=\"#000080\" LINK=\"#000080\" VLINK=\"#000080\">\n\
<center><FONT SIZE=7><BOLD>This is the HELP frame</BOLD>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp</FONT>\n\
<br>\n\
</center><br><p>This frame is used to display dictionary descriptions, examples, tables \n\
and diagnostic information.\n\
<h2>For Data Items:</h2>\n\
<UL>\n\
<LI>Press the <font color=\"black\"><b>HELP</b></font> button for advice about how \n\
to enter data in the item.\n\
<LI>Press the <font color=\"black\"><b>EXAMPLE</b></font> button in the item \n\
frame to view examples of the item.\n\
<UL>\n\
</BODY>\n\
</HTML>\n\
";




static char other_en_annot[]="\
<HTML><BODY BGCOLOR=\"#ffffff\" TEXT=\"#000080\" LINK=\"#000080\" VLINK=\"#000080\">\n\
<center><FONT SIZE=7><BOLD>This is the HELP frame</BOLD>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp</FONT>\n\
<br>\n\
</center><br><p>This frame is used to display dictionary descriptions, examples, tables \n\
and diagnostic information.\n\
<h2>For Categories:</h2>\n\
<UL>\n\
<LI>Press the <font color=\"#909000\"><b>HELP</b></font> button for an overview of \n\
how to enter data in the category.\n\
<LI>Press the <font color=\"#909000\"><b>DESCRIBE</b></font> button in the category frame \n\
to view the category description.\n\
<LI>Press the <font color=\"#909000\"><b>EXAMPLE</b></font> button in the category frame \n\
to view complete examples of the current category.\n\
</UL>\n\
<h2>For Data Items:</h2>\n\
<UL>\n\
<LI>Press the <font color=\"black\"><b>HELP</b></font> button for advice about how \n\
to enter data in the item.\n\
<LI>Press the <font color=\"black\"><b>DESCRIBE</b></font> button in the item \n\
frame to view definition of the item.\n\
<LI>Press the <font color=\"black\"><b>EXAMPLE</b></font> button in the item \n\
frame to view examples of the item.\n\
<UL>\n\
</BODY>\n\
</HTML>\n\
";

static char other_fr[]="\
<HTML>\n\
<BODY BGCOLOR=\"#ffffff\" TEXT=\"#000080\" LINK=\"#000080\" VLINK=\"#000080\">\n\
<center><FONT SIZE=7><BOLD>C'est la trame</BOLD>d'cAide</FONT><br>\n\
</center>\n\
<br><p>Cette trame est employ&eacute;e pour afficher des descriptions de\n\
dictionnaire, des exemples, des tables et l'information diagnostique.\n\
\n\
<h2>Pour Des Cat&eacute;gories:</h2>\n\
<UL>\n\
<LI>Appuyez sur le bouton &eacute;tiquet&eacute; aide pour une vue d'ensemble\n\
de la fa&ccedil;on saisir des donn&eacute;es dans la cat&eacute;gorie.\n\
<LI>Appuyez sur le bouton &eacute;tiquet&eacute; d&eacute;crivent dans la trame de\n\
cat&eacute;gorie pour visualiser la description de cat&eacute;gorie.\n\
<LI>Appuyez sur le bouton &eacute;tiquet&eacute; des exemples dans la trame\n\
de cat&eacute;gorie pour visualiser des exemples complets de la cat&eacute;gorie\n\
actuelle.\n\
</UL>\n\
\n\
<h2>Pour des &eacute;l&eacute;ments des donn&eacute;es:</h2>\n\
<UL>\n\
<LI>Appuyez sur le bouton &eacute;tiquet&eacute; bouton d'aide pour le\n\
conseil sur la fa&ccedil;on saisir des donn&eacute;es dans l'&eacute;l&eacute;ment.\n\
<LI>Appuyez sur le bouton &eacute;tiquet&eacute; d&eacute;crivent dans la trame\n\
d'&eacute;l&eacute;ment pour visualiser la d&eacute;finition de l'&eacute;l&eacute;ment.\n\
<LI>Appuyez sur le bouton &eacute;tiquet&eacute; des exemples dans la trame\n\
d'&eacute;l&eacute;ment pour visualiser des exemples de l'&eacute;l&eacute;ment.\n\
<UL>\n\
</BODY>\n\
</HTML> \n\
";

//
static char other_de[]="\
<HTML>\n\
<BODY BGCOLOR=\"#ffffff\" TEXT=\"#000080\" LINK=\"#000080\" VLINK=\"#000080\">\n\
<center><FONT SIZE=7><BOLD>Dieses ist das HILFE Feld</BOLD></FONT><br>\n\
</center>\n\
<br><p>Dieses Feld wird benutzt, um Verzeichnisbeschreibungen,\n\
Beispiele, Tabellen und Diagnoseinformationen anzuzeigen.\n\
\n\
<h2>F&uuml;r Kategorien:</h2>\n\
<UL>\n\
<LI>Bet&auml;tigen Sie die Taste, die Hilfe f&uuml;r einen &Uuml;berblick\n\
beschriftet wird &uuml;ber, wie man Daten in der Kategorie eingibt.\n\
<LI>Bet&auml;tigen Sie die beschriftete Taste beschreiben im\n\
Kategorie Feld, um die Kategorie Beschreibung anzusehen.\n\
<LI>Bet&auml;tigen Sie die Taste, die Beispiele im Kategorie Feld, um\n\
komplette Beispiele der aktuellen Kategorie anzusehen beschriftet\n\
wird.\n\
</UL>\n\
<h2>F&uuml;r Einzelteile von Daten:</h2>\n\
<UL>\n\
<LI>Bet&auml;tigen Sie die Taste, die Hilfe Taste f&uuml;r Rat\n\
beschriftet wird Fuuml;ber, wie man Daten im Einzelteil eingibt.\n\
<LI>Bet&auml;tigen Sie die beschriftete Taste beschreiben im\n\
Einzelteilfeld, um Definition des Einzelteils anzusehen.\n\
<LI>Bet&auml;tigen Sie die Taste, die Beispiele im Einzelteilfeld, um\n\
Beispiele des Einzelteils anzusehen beschriftet wird.\n\
<UL>\n\
</BODY>\n\
</HTML>\n\
";

//
static char other_es[]="\
<HTML>\n\
<BODY BGCOLOR=\"#ffffff\" TEXT=\"#000080\" LINK=\"#000080\" VLINK=\"#000080\">\n\
<center><FONT SIZE=7><BOLD>&Eacute;ste es el del marco</BOLD>de la AYUDA</FONT><br>\n\
</center>\n\
<br><p>Este marco se utiliza para visualizar descripciones del\n\
diccionario, ejemplos, los vectores y la informaci&oacute;n de diagn&oacute;stico.\n\
\n\
<h2>Para Las Categor&iacute;as:</h2>\n\
\n\
<UL>\n\
<LI>Presione el bot&oacute;n etiquetado ayuda para una descripci&oacute;n de\n\
c&oacute;mo incorporar datos en la categor&iacute;a.\n\
<LI>Presione el bot&oacute;n etiquetado describen en el marco de la\n\
categor&iacute;a para visi&oacute;n la descripci&oacute;n de la categor&iacute;a.\n\
<LI>Presione el bot&oacute;n etiquetado los ejemplos en el marco de la\n\
categor&iacute;a para visi&oacute;n ejemplos completos de la categor&iacute;a actual.\n\
</UL>\n\
<h2>Para los items de datos:</h2>\n\
<UL>\n\
<LI>Presione el bot&oacute;n etiquetado bot&oacute;n de la ayuda para el\n\
consejo sobre c&oacute;mo incorporar datos en el item.\n\
<LI>Presione el bot&oacute;n etiquetado describen en el marco del item\n\
para visi&oacute;n la definici&oacute;n del item.\n\
<LI>Presione el bot&oacute;n etiquetado los ejemplos en el marco del\n\
item para visi&oacute;n los ejemplos del item.\n\
<UL>\n\
</BODY></HTML>\n\
";
//


#endif
