/*
FILE:     view-obj-util.h
*/
/*
VERSION:  0.904-beta
*/
/*
DATE:     8/14/2003
*/
/*
  Comments and Questions to: sw-help@rcsb.rutgers.edu
*/
/*
COPYRIGHT 1999-2003 Rutgers - The State University of New Jersey

This software is provided WITHOUT WARRANTY OF MERCHANTABILITY OR
FITNESS FOR A PARTICULAR PURPOSE OR ANY OTHER WARRANTY, EXPRESS OR
IMPLIED.  RUTGERS MAKE NO REPRESENTATION OR WARRANTY THAT THE
SOFTWARE WILL NOT INFRINGE ANY PATENT, COPYRIGHT OR OTHER
PROPRIETARY RIGHT.

The user of this software shall indemnify, hold harmless and defend
Rutgers, its governors, trustees, officers, employees, students,
agents and the authors against any and all claims, suits,
losses, liabilities, damages, costs, fees, and expenses including
reasonable attorneys' fees resulting from or arising out of the
use of this software.  This indemnification shall include, but is
not limited to, any and all claims alleging products liability.
*/
/*
               PDB SOFTWARE LICENSE AGREEMENT

BY CLICKING THE ACCEPTANCE BUTTON OR INSTALLING OR USING 
THIS "SOFTWARE, THE INDIVIDUAL OR ENTITY LICENSING THE  
SOFTWARE ("LICENSEE") IS CONSENTING TO BE BOUND BY AND IS 
BECOMING A PARTY TO THIS AGREEMENT.  IF LICENSEE DOES NOT 
AGREE TO ALL OF THE TERMS OF THIS AGREEMENT
THE LICENSEE MUST NOT INSTALL OR USE THE SOFTWARE.

1. LICENSE AGREEMENT

This is a license between you ("Licensee") and the Protein Data Bank (PDB) 
at Rutgers, The State University of New Jersey (hereafter referred to 
as "RUTGERS").   The software is owned by RUTGERS and protected by 
copyright laws, and some elements are protected by laws governing 
trademarks, trade dress and trade secrets, and may be protected by 
patent laws. 

2. LICENSE GRANT

RUTGERS grants you, and you hereby accept, non-exclusive, royalty-free 
perpetual license to install, use, modify, prepare derivative works, 
incorporate into other computer software, and distribute in binary 
and source code format, or any derivative work thereof, together with 
any associated media, printed materials, and on-line or electronic 
documentation (if any) provided by RUTGERS (collectively, the "SOFTWARE"), 
subject to the following terms and conditions: (i) any distribution 
of the SOFTWARE shall bind the receiver to the terms and conditions 
of this Agreement; (ii) any distribution of the SOFTWARE in modified 
form shall clearly state that the SOFTWARE has been modified from 
the version originally obtained from RUTGERS.  

2. COPYRIGHT; RETENTION OF RIGHTS.  

The above license grant is conditioned on the following: (i) you must 
reproduce all copyright notices and other proprietary notices on any 
copies of the SOFTWARE and you must not remove such notices; (ii) in 
the event you compile the SOFTWARE, you will include the copyright 
notice with the binary in such a manner as to allow it to be easily 
viewable; (iii) if you incorporate the SOFTWARE into other code, you 
must provide notice that the code contains the SOFTWARE and include 
a copy of the copyright notices and other proprietary notices.  All 
copies of the SOFTWARE shall be subject to the terms of this Agreement.  

3. NO MAINTENANCE OR SUPPORT; TREATMENT OF ENHANCEMENTS 

RUTGERS is under no obligation whatsoever to: (i) provide maintenance 
or support for the SOFTWARE; or (ii) to notify you of bug fixes, patches, 
or upgrades to the features, functionality or performance of the 
SOFTWARE ("Enhancements") (if any), whether developed by RUTGERS 
or third parties.  If, in its sole discretion, RUTGERS makes an 
Enhancement available to you and RUTGERS does not separately enter 
into a written license agreement with you relating to such bug fix, 
patch or upgrade, then it shall be deemed incorporated into the SOFTWARE 
and subject to this Agreement. You are under no obligation whatsoever 
to provide any Enhancements to RUTGERS or the public that you may 
develop over time; however, if you choose to provide your Enhancements 
to RUTGERS, or if you choose to otherwise publish or distribute your 
Enhancements, in source code form without contemporaneously requiring 
end users or RUTGERS to enter into a separate written license agreement 
for such Enhancements, then you hereby grant RUTGERS a non-exclusive,
royalty-free perpetual license to install, use, modify, prepare
derivative works, incorporate into the SOFTWARE or other computer
software, distribute, and sublicense your Enhancements or derivative
works thereof, in binary and source code form.

4. FEES.  There is no license fee for the SOFTWARE.  If Licensee
wishes to receive the SOFTWARE on media, there may be a small charge
for the media and for shipping and handling.  Licensee is
responsible for any and all taxes.

5. TERMINATION.  Without prejudice to any other rights, Licensor
may terminate this Agreement if Licensee breaches any of its terms
and conditions.  Upon termination, Licensee shall destroy all
copies of the SOFTWARE.

6. PROPRIETARY RIGHTS.  Title, ownership rights, and intellectual
property rights in the Product shall remain with RUTGERS.  Licensee 
acknowledges such ownership and intellectual property rights and will 
not take any action to jeopardize, limit or interfere in any manner 
with RUTGERS' ownership of or rights with respect to the SOFTWARE.  
The SOFTWARE is protected by copyright and other intellectual 
property laws and by international treaties.  Title and related 
rights in the content accessed through the SOFTWARE is the property 
of the applicable content owner and is protected by applicable law.  
The license granted under this Agreement gives Licensee no rights to such
content.

7. DISCLAIMER OF WARRANTY.  THE SOFTWARE IS PROVIDED FREE OF 
CHARGE, AND, THEREFORE, ON AN "AS IS" BASIS, WITHOUT WARRANTY OF 
ANY KIND, INCLUDING WITHOUT LIMITATION THE WARRANTIES THAT IT 
IS FREE OF DEFECTS, MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE 
OR NON-INFRINGING.  THE ENTIRE RISK AS TO THE QUALITY AND 
PERFORMANCE OF THE SOFTWARE IS BORNE BY LICENSEE.  SHOULD THE 
SOFTWARE PROVE DEFECTIVE IN ANY RESPECT, THE LICENSEE AND NOT 
LICENSOR ASSUMES THE ENTIRE COST OF ANY SERVICE AND REPAIR.  
THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF 
THIS AGREEMENT.  NO USE OF THE PRODUCT IS AUTHORIZED HEREUNDER 
EXCEPT UNDER THIS DISCLAIMER.

8. LIMITATION OF LIABILITY.  TO THE MAXIMUM EXTENT PERMITTED BY
APPLICABLE LAW,  IN NO EVENT WILL LICENSOR BE LIABLE FOR ANY 
INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
OUT OF THE USE OF OR INABILITY TO USE THE SOFTWARE, INCLUDING, 
WITHOUT LIMITATION, DAMAGES FOR LOSS OF GOODWILL, WORK 
STOPPAGE, COMPUTER FAILURE OR MALFUNCTION, OR ANY AND ALL 
OTHER COMMERCIAL DAMAGES OR LOSSES, EVEN IF ADVISED OF THE
POSSIBILITY THEREOF. 
*/
/*
  PURPOSE:      View function prototypes and defintions.

*/

#ifndef __VIEW_OBJ_UTIL_H__
#define __VIEW_OBJ_UTIL_H__

#include <iostream.h>
#include <stdlib.h>
#include <sys/types.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>
#include <sys/wait.h>
#include <time.h>

#include "ndb_misclib.h"
#include "ndb_htmllib.h"

#include "interface-defs.h"
#include "CifViewObj.h"
#include "CifBuilder.h"
#include "CifStateObj.h"
#include "search-util.h"

#define CIF_ITEM_IS_KEY             1
#define CIF_ITEM_IS_MANDATORY       2
#define CIF_ITEM_IS_NOT_MANDATORY   3
#define CIF_ITEM_IS_IMPLICIT        4
#define CIF_ITEM_IS_IMPLICIT_KEY    5

#define VIEW_ITEM_IS_NOT_MANDATORY   0
#define VIEW_ITEM_IS_MANDATORY       1
#define VIEW_ITEM_IS_HIDDEN          2

#define VIEW_TYPE_UNKNOWN 0
#define VIEW_TYPE_TEXT    1
#define VIEW_TYPE_LINE    2
#define VIEW_TYPE_CODE    3
#define VIEW_TYPE_FLOAT   4
#define VIEW_TYPE_INT     5
#define VIEW_TYPE_DATE    6
#define VIEW_TYPE_TIME    7

#define MAX_VIEW_NAME_LENGTH            100

typedef struct {
  char category[MAX_VIEW_NAME_LENGTH];
  char item[MAX_VIEW_NAME_LENGTH];
  char viewName[MAX_VIEW_NAME_LENGTH];
  int mandatoryCode, allowAlternateCode, multipleSelection;
  char *defaultValue;
} CIFVIEWOBJITEM;

//
// Structure for flags that control the auto update action of the 
// input and output filters ... 
//
typedef struct {
  int iXYZ, iSF, iDF, iNC, iCC, iCS, iDC, context;
} UPD_HANDLE;


// void import_input_file_to_view_drv(entry entries[], int nentries, const char *ufid);

void update_cif_context(CifFileObj *&fobj, CifViewObj *vobj, const char *dirPath,
			       const char *idName);

void update_cif_context_exchange(CifFileObj *&fobj, CifViewObj *vobj, const char *dirPath,
				 const char *idName);

ReVarCifArray<CifString> *mk_category_list_from_view_obj(CifViewObj *vobj);

void mk_validation_report(FILE *io, const char *ufid, const char *idName, 
			  const char *fName, const char *fType,
			  const char *fNameSF, const char *fTypeSF, 
			  int preCheckFlag, CifFileObj *fobj, const char *blockId);

char *update_db_status(CifFileObj *fobj, const char *dirPath, const char *blockId);

int item_integrity_check(FILE *fp, CifBuilder &cb, 
			 const char *item, char *value, int mCodeView);

void adit_editor_drv(const char *ufid,  UPD_HANDLE *upd, CifStateObj *sobj);
UPD_HANDLE *adit_file_import_drv(entry entries[], int nentries, const char *ufid, 
				 CifStateObj *sobj);

void adit_data_check_drv(const char *ufid, UPD_HANDLE *upd, CifStateObj *sobj);
void adit_validation_drv(const char *ufid, UPD_HANDLE *upd, CifStateObj *sobj, int syncheck);


void html_display_return_to_session(FILE *io, const char *ufid, const char *text );

UPD_HANDLE *get_file_upload_status(CifStateObj *sobj);
void adit_editor_restart(const char *ufid);
int adit_check_input_data_syntax(FILE *io, const char * dirPath, 
				 int flagXYZ, const char *formatTypeXYZ, const char *rootNameXYZ,
				 int flagSF,  const char *formatTypeSF, const char *rootNameSF,
				 const char *returnText);

void  auto_update_on_input(UPD_HANDLE *upd, CifFileObj *fobj, const char *blockId);
void  fix_misc_items(CifFileObj *fobj, const char *blockId);
char *set_category_state_string(CifViewObj *vobj, CifFileObj *fobj, const char *blockId);
void sync_categories_to_view(CifViewObj *vobj, CifFileObj *fobj, const char *blockId );

char *get_category_status_string(const char *fName);

#if 0
char get_category_status(const char *fName, int iCat);
void set_category_status(const char *fName, int iCat, char status);
void write_category_status(const char *fName, const char *string);
#endif

void encode_table_param_name(char name[MAX_CIF_NAME_LENGTH], int row, int col, int altFlag);

int decode_table_param_name(char *name, int &row, int &col, int altFlag);
void  mk_category_frame_from_view_obj(char *fname, char *ufid, CifViewObj *vobj);

char *get_dictionary_item_name(CifBuilder &cb, const char *item);

CIFVIEWOBJITEM *build_item_obj_list(CifViewObj *vobj, const char *category, int *nItems);
CIFVIEWOBJITEM *build_item_obj_list_w_table(CifViewObj *vobj, const char *category, int *nItems, ISTable *t);


int display_view_category_as_table(FILE *fp, CifFileObj *fobj, CifViewObj *vobj, const char *blockId, const char *category );

int display_view_category_as_table_w_check(FILE *fp, CifFileObj *fobj, CifViewObj *vobj,  CifBuilder &cb,
					   const char *blockId, const char *category );

double compute_view_category_completeness(FILE *fp, CifFileObj *fobj, CifViewObj *vobj,  
					  const char *blockId, const char *category );
double compute_view_category_completeness_1(FILE *fp, CifFileObj *fobj, CifViewObj *vobj,  
					  const char *blockId, const char *category, 
					  int &numMandatory, int &numMandatoryTotal);

void print_table_attribute_name(FILE *fp, const char *string);

void scale_up_R_factor_values(CifFileObj *fobj, const char *blockId);
void scale_down_R_factor_values(CifFileObj *fobj, const char *blockId);

void  set_initial_db_status(CifFileObj *fobj, const char *blockId, int iXYZ, int iSF, int iDF, int iNC);
void  set_initial_deposit_status(CifFileObj *fobj, const char *blockId);

extern "C" {
  //  int strcasecmp (const char *s1, const char *s2);
  //  int strncasecmp (const char *s1, const char *s2, size_t n);
	   }

#endif

