/*
FILE:     adit-download-driver.C
*/
/*
VERSION:  0.904-beta
*/
/*
DATE:     8/14/2003
*/
/*
  Comments and Questions to: sw-help@rcsb.rutgers.edu
*/
/*
COPYRIGHT 1999-2003 Rutgers - The State University of New Jersey

This software is provided WITHOUT WARRANTY OF MERCHANTABILITY OR
FITNESS FOR A PARTICULAR PURPOSE OR ANY OTHER WARRANTY, EXPRESS OR
IMPLIED.  RUTGERS MAKE NO REPRESENTATION OR WARRANTY THAT THE
SOFTWARE WILL NOT INFRINGE ANY PATENT, COPYRIGHT OR OTHER
PROPRIETARY RIGHT.

The user of this software shall indemnify, hold harmless and defend
Rutgers, its governors, trustees, officers, employees, students,
agents and the authors against any and all claims, suits,
losses, liabilities, damages, costs, fees, and expenses including
reasonable attorneys' fees resulting from or arising out of the
use of this software.  This indemnification shall include, but is
not limited to, any and all claims alleging products liability.
*/
/*
               PDB SOFTWARE LICENSE AGREEMENT

BY CLICKING THE ACCEPTANCE BUTTON OR INSTALLING OR USING 
THIS "SOFTWARE, THE INDIVIDUAL OR ENTITY LICENSING THE  
SOFTWARE ("LICENSEE") IS CONSENTING TO BE BOUND BY AND IS 
BECOMING A PARTY TO THIS AGREEMENT.  IF LICENSEE DOES NOT 
AGREE TO ALL OF THE TERMS OF THIS AGREEMENT
THE LICENSEE MUST NOT INSTALL OR USE THE SOFTWARE.

1. LICENSE AGREEMENT

This is a license between you ("Licensee") and the Protein Data Bank (PDB) 
at Rutgers, The State University of New Jersey (hereafter referred to 
as "RUTGERS").   The software is owned by RUTGERS and protected by 
copyright laws, and some elements are protected by laws governing 
trademarks, trade dress and trade secrets, and may be protected by 
patent laws. 

2. LICENSE GRANT

RUTGERS grants you, and you hereby accept, non-exclusive, royalty-free 
perpetual license to install, use, modify, prepare derivative works, 
incorporate into other computer software, and distribute in binary 
and source code format, or any derivative work thereof, together with 
any associated media, printed materials, and on-line or electronic 
documentation (if any) provided by RUTGERS (collectively, the "SOFTWARE"), 
subject to the following terms and conditions: (i) any distribution 
of the SOFTWARE shall bind the receiver to the terms and conditions 
of this Agreement; (ii) any distribution of the SOFTWARE in modified 
form shall clearly state that the SOFTWARE has been modified from 
the version originally obtained from RUTGERS.  

2. COPYRIGHT; RETENTION OF RIGHTS.  

The above license grant is conditioned on the following: (i) you must 
reproduce all copyright notices and other proprietary notices on any 
copies of the SOFTWARE and you must not remove such notices; (ii) in 
the event you compile the SOFTWARE, you will include the copyright 
notice with the binary in such a manner as to allow it to be easily 
viewable; (iii) if you incorporate the SOFTWARE into other code, you 
must provide notice that the code contains the SOFTWARE and include 
a copy of the copyright notices and other proprietary notices.  All 
copies of the SOFTWARE shall be subject to the terms of this Agreement.  

3. NO MAINTENANCE OR SUPPORT; TREATMENT OF ENHANCEMENTS 

RUTGERS is under no obligation whatsoever to: (i) provide maintenance 
or support for the SOFTWARE; or (ii) to notify you of bug fixes, patches, 
or upgrades to the features, functionality or performance of the 
SOFTWARE ("Enhancements") (if any), whether developed by RUTGERS 
or third parties.  If, in its sole discretion, RUTGERS makes an 
Enhancement available to you and RUTGERS does not separately enter 
into a written license agreement with you relating to such bug fix, 
patch or upgrade, then it shall be deemed incorporated into the SOFTWARE 
and subject to this Agreement. You are under no obligation whatsoever 
to provide any Enhancements to RUTGERS or the public that you may 
develop over time; however, if you choose to provide your Enhancements 
to RUTGERS, or if you choose to otherwise publish or distribute your 
Enhancements, in source code form without contemporaneously requiring 
end users or RUTGERS to enter into a separate written license agreement 
for such Enhancements, then you hereby grant RUTGERS a non-exclusive,
royalty-free perpetual license to install, use, modify, prepare
derivative works, incorporate into the SOFTWARE or other computer
software, distribute, and sublicense your Enhancements or derivative
works thereof, in binary and source code form.

4. FEES.  There is no license fee for the SOFTWARE.  If Licensee
wishes to receive the SOFTWARE on media, there may be a small charge
for the media and for shipping and handling.  Licensee is
responsible for any and all taxes.

5. TERMINATION.  Without prejudice to any other rights, Licensor
may terminate this Agreement if Licensee breaches any of its terms
and conditions.  Upon termination, Licensee shall destroy all
copies of the SOFTWARE.

6. PROPRIETARY RIGHTS.  Title, ownership rights, and intellectual
property rights in the Product shall remain with RUTGERS.  Licensee 
acknowledges such ownership and intellectual property rights and will 
not take any action to jeopardize, limit or interfere in any manner 
with RUTGERS' ownership of or rights with respect to the SOFTWARE.  
The SOFTWARE is protected by copyright and other intellectual 
property laws and by international treaties.  Title and related 
rights in the content accessed through the SOFTWARE is the property 
of the applicable content owner and is protected by applicable law.  
The license granted under this Agreement gives Licensee no rights to such
content.

7. DISCLAIMER OF WARRANTY.  THE SOFTWARE IS PROVIDED FREE OF 
CHARGE, AND, THEREFORE, ON AN "AS IS" BASIS, WITHOUT WARRANTY OF 
ANY KIND, INCLUDING WITHOUT LIMITATION THE WARRANTIES THAT IT 
IS FREE OF DEFECTS, MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE 
OR NON-INFRINGING.  THE ENTIRE RISK AS TO THE QUALITY AND 
PERFORMANCE OF THE SOFTWARE IS BORNE BY LICENSEE.  SHOULD THE 
SOFTWARE PROVE DEFECTIVE IN ANY RESPECT, THE LICENSEE AND NOT 
LICENSOR ASSUMES THE ENTIRE COST OF ANY SERVICE AND REPAIR.  
THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF 
THIS AGREEMENT.  NO USE OF THE PRODUCT IS AUTHORIZED HEREUNDER 
EXCEPT UNDER THIS DISCLAIMER.

8. LIMITATION OF LIABILITY.  TO THE MAXIMUM EXTENT PERMITTED BY
APPLICABLE LAW,  IN NO EVENT WILL LICENSOR BE LIABLE FOR ANY 
INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
OUT OF THE USE OF OR INABILITY TO USE THE SOFTWARE, INCLUDING, 
WITHOUT LIMITATION, DAMAGES FOR LOSS OF GOODWILL, WORK 
STOPPAGE, COMPUTER FAILURE OR MALFUNCTION, OR ANY AND ALL 
OTHER COMMERCIAL DAMAGES OR LOSSES, EVEN IF ADVISED OF THE
POSSIBILITY THEREOF. 
*/
/*
  PURPOSE:      Software download driver

*/


#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <string.h>

//#include "CifBuilder.h"
//#include "CifFileObj.h"

#include "ndb_htmllib.h"
#include "ndb_misclib.h"

#define  HTML_ENV_GLOBAL_INIT
#include "interface-defs.h"

#define HT_ATTRIBUTE_PROGRAM_NAME          "progname"
#define HT_ATTRIBUTE_FIRST_NAME            "firstname"
#define HT_ATTRIBUTE_LAST_NAME             "lastname"
#define HT_ATTRIBUTE_ADDRESS               "address"
#define HT_ATTRIBUTE_EMAIL                 "email"

#define HT_ATTRIBUTE_DOWNLOAD_CONTEXT      "context"
#define HT_INTERFACE_DOWNLOAD_DRIVER       "adit-download-driver"


//
// --------------------------------------------------------------------------------
//                   Text for software download registration
//
static char p0_en_download[]="\
<h3>Download Registration Form</h3> \n\
\n\
<br> \n\
<p>\n\
Please fill in <b>all</b> of the information in the form below and press the <b>ACCEPT</b> \n\
button for further download instructions.\n\
<br>\n\
";

//
#if 0
static char p0_en_license[]="\
<h3>Copyright statement and conditions of use:  </h3> \n\
<pre>\n\
COPYRIGHT 2000 Rutgers, The State University of New Jersey\n\
\n\
This software is provided WITHOUT WARRANTY OF MERCHANTABILITY OR\n\
FITNESS FOR A PARTICULAR PURPOSE OR ANY OTHER WARRANTY, EXPRESS OR\n\
IMPLIED.  RUTGERS MAKES NO REPRESENTATION OR WARRANTY THAT THE\n\
SOFTWARE WILL NOT INFRINGE ANY PATENT, COPYRIGHT OR OTHER\n\
PROPRIETARY RIGHT.\n\
\n\
The user of this software shall indemnify, hold harmless and defend\n\
Rutgers, its governors, trustees, officers, employees, students,\n\
agents and the authors against any and all claims, suits,\n\
losses, liabilities, damages, costs, fees, and expenses including\n\
reasonable attorneys' fees resulting from or arising out of the\n\
use of this software.  This indemnification shall include, but is\n\
not limited to, any and all claims alleging products liability.\n\
\n\
Permission is granted to install and use this software on a \n\
computer system at your site.  This software should not be\n\
transfered or made available to other sites, or incorporated\n\
in any form into a marketable product without the expressed \n\
written permission of the Protein Data Bank at Rutgers University. \n\
</pre>\n\
\n\
";
#endif

//
static char p1_en_license[]="\
<h3>License statement and conditions of use:  </h3> \n\
<pre>\n\
               PDB SOFTWARE LICENSE AGREEMENT\n\
           Redistribution Or Rental Not Permitted\n\
\n\
BY CLICKING THE ACCEPTANCE BUTTON OR INSTALLING OR USING \n\
THIS \"SOFTWARE, THE INDIVIDUAL OR ENTITY LICENSING THE  \n\
SOFTWARE (\"LICENSEE\") IS CONSENTING TO BE BOUND BY AND IS \n\
BECOMING A PARTY TO THIS AGREEMENT.  IF LICENSEE DOES NOT \n\
AGREE TO ALL OF THE TERMS OF THIS AGREEMENT\n\
THE LICENSEE MUST NOT INSTALL OR USE THE SOFTWARE.\n\
\n\
1. LICENSE AGREEMENT\n\
This is a license between you (\"Licensee\") and the Protein Data Bank (PDB) \n\
at Rutgers, The State University of New Jersey (hereafter referred to \n\
as \"RUTGERS\").   The software is owned by RUTGERS and protected by \n\
copyright laws, and some elements are protected by laws governing \n\
trademarks, trade dress and trade secrets, and may be protected by \n\
patent laws. \n\
\n\
2. LICENSE GRANT.  \n\
\n\
RUTGERS grants Licensee a non-exclusive and\n\
non-transferable license to reproduce and use for personal or\n\
internal business purposes the executable code version of the\n\
SOFTWARE, provided any copy must contain all of the original\n\
proprietary notices.  This license does not entitle Licensee to\n\
receive from RUTGERS hard-copy documentation, technical support,\n\
telephone assistance, or enhancements or updates to the Product.\n\
Licensee may not redistribute the SOFTWARE unless\n\
Licensee has separately entered into a distribution agreement with\n\
RUTGERS. \n\
\n\
3. RESTRICTIONS.  Licensee may not: (i) modify or create\n\
any derivative works of the SOFTWARE or documentation, including\n\
translation or localization; (ii) decompile, disassemble, reverse\n\
engineer, or otherwise attempt to derive the source code for the\n\
SOFTWARE ; (iii) redistribute, encumber, sell, rent, lease,\n\
sublicense, or otherwise transfer rights to the SOFTWARE; (iv)\n\
remove or alter any trademark, logo, copyright or other proprietary\n\
notices, legends, symbols or labels in the SOFTWARE.\n\
\n\
4. FEES.  There is no license fee for the SOFTWARE.  If Licensee\n\
wishes to receive the SOFTWARE on media, there may be a small charge\n\
for the media and for shipping and handling.  Licensee is\n\
responsible for any and all taxes.\n\
\n\
5. TERMINATION.  Without prejudice to any other rights, Licensor\n\
may terminate this Agreement if Licensee breaches any of its terms\n\
and conditions.  Upon termination, Licensee shall destroy all\n\
copies of the SOFTWARE.\n\
\n\
6. PROPRIETARY RIGHTS.  Title, ownership rights, and intellectual\n\
property rights in the Product shall remain with RUTGERS.  Licensee \n\
acknowledges such ownership and intellectual\n\
property rights and will not take any action to jeopardize, limit\n\
or interfere in any manner with RUTGERS' ownership of or rights\n\
 with respect to the SOFTWARE.  The SOFTWARE\n\
is protected by copyright and other intellectual property laws and\n\
by international treaties.  Title and related rights in the content\n\
accessed through the SOFTWARE is the property of the applicable\n\
content owner and is protected by applicable law.  The license\n\
granted under this Agreement gives Licensee no rights to such\n\
content.\n\
\n\
7. DISCLAIMER OF WARRANTY.  THE SOFTWARE IS PROVIDED FREE OF \n\
CHARGE, AND, THEREFORE, ON AN \"AS IS\" BASIS, WITHOUT WARRANTY OF \n\
ANY KIND, INCLUDING WITHOUT LIMITATION THE WARRANTIES THAT IT \n\
IS FREE OF DEFECTS, MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE \n\
OR NON-INFRINGING.  THE ENTIRE RISK AS TO THE QUALITY AND \n\
PERFORMANCE OF THE SOFTWARE IS BORNE BY LICENSEE.  SHOULD THE \n\
SOFTWARE PROVE DEFECTIVE IN ANY RESPECT, THE LICENSEE AND NOT \n\
LICENSOR ASSUMES THE ENTIRE COST OF ANY SERVICE AND REPAIR.  \n\
THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF \n\
THIS AGREEMENT.  NO USE OF THE PRODUCT IS AUTHORIZED HEREUNDER \n\
EXCEPT UNDER THIS DISCLAIMER.\n\
\n\
8. LIMITATION OF LIABILITY.  TO THE MAXIMUM EXTENT PERMITTED BY\n\
APPLICABLE LAW,  IN NO EVENT WILL LICENSOR BE LIABLE FOR ANY \n\
INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING \n\
OUT OF THE USE OF OR INABILITY TO USE THE SOFTWARE, INCLUDING, \n\
WITHOUT LIMITATION, DAMAGES FOR LOSS OF GOODWILL, WORK \n\
STOPPAGE, COMPUTER FAILURE OR MALFUNCTION, OR ANY AND ALL \n\
OTHER COMMERCIAL DAMAGES OR LOSSES, EVEN IF ADVISED OF THE\n\
POSSIBILITY THEREOF. \n\
</pre>\n\
";


static char p0_en_ciftr[]="\
<h3>Download Instructions:</h3> \n\
<p>\n\
Thank you for registering to download CIFTr. \n\
<br>\n\
\n\
<p>\n\
Installation instructions for CIFTr are in the following README file.\n\
<br>\n\
\n\
<ul>\n\
<li> <a href=\"/software/ciftr/index.html\">README</a>\n\
</ul>\n\
\n\
<br>\n\
<p>\n\
CIFTr is currently available in binary form for the following Unix platforms \n\
and operating system versions: \n\
<br>\n\
<ul>\n\
<li>SGI IRIX 6.[2-5], \n\
<li>Linux/Intel (built on release 2.2.16-22)\n\
<li>SUN Solaris (using GNU gcc/g++) \n\
</ul>\n\
<br>\n\
<p>\n\
Please select from the list below the compressed tar file appropriate for your site:\n\
<br>\n\
<ul>\n\
<li> <a href=\"/software/ciftr/ciftr-sgi.tar.gz\">Download CIFTr for SGI</a>\n\
<li> <a href=\"/software/ciftr/ciftr-linux.tar.gz\">Download CIFTr for Linux</a>\n\
<li> <a href=\"/software/ciftr/ciftr-sun.tar.gz\">Download CIFTr for SUN</a>\n\
</ul>\n\
<br>\n\
";



static char p0_en_validation[]="\
<h3>Download Instructions:</h3> \n\
<p>\n\
Thank you for registering to download the PDB Validation Suite (beta version). \n\
<br>\n\
\n\
<p>\n\
Installation instructions for this sofware are in the following README file.\n\
<br>\n\
\n\
<ul>\n\
<li> <a href=\"/software/validation/index.html\">README</a>\n\
</ul>\n\
<p>\n\
The license and conditions of use associated with this software are in the following LICENSE file.\n\
<br>\n\
\n\
<ul>\n\
<li> <a href=\"/software/validation/LICENSE.txt\">LICENSE</a>\n\
</ul>\n\
\n\
<br>\n\
<p>\n\
The PDB Validation Suite is currently available in binary form for the following Unix platforms \n\
and operating system versions: \n\
<br>\n\
<ul>\n\
<li>SGI IRIX 6.[2-5], \n\
<li>Linux/Intel (built on release 2.2.16-3)\n\
<li>SUN Solaris (using GNU gcc/g++) \n\
</ul>\n\
<br>\n\
<p>\n\
Please select from the list below the compressed tar file appropriate for your site:\n\
<br>\n\
<ul>\n\
<li> <a href=\"/software/validation/validation-sgi.tar.gz\">Download for SGI</a>\n\
<li> <a href=\"/software/validation/validation-linux.tar.gz\">Download for Linux</a>\n\
<li> <a href=\"/software/validation/validation-sun.tar.gz\">Download for SUN</a>\n\
</ul>\n\
<br>\n\
";



//
// ---------------------------------------------------------------------------------------------
// 

//static char *root_file_name(char *path);
//static int get_index_in_list(const char **list, const char *target);
   
//static char TBL_BG_COLOR[]="#c0c0c0";
static char TBL_BG_COLOR[]="#9999cc";

static char *programs[]={"ciftr","validationbeta",""};
static char *programsDisplay[]={"CIFTr","PDB Validation Suite (beta version)",""};


void write_download_registration_1(FILE *io, entry entries[HT_MAX_ENTRIES], int nentries,
				   const char *ufid);
int check_registration_data(entry entries[HT_MAX_ENTRIES], int nentries);

void write_download_app_1(FILE *io, entry entries[HT_MAX_ENTRIES], int nentries,
				   const char *ufid);

int main(int argc, char ** argv) {
  entry entries[HT_MAX_ENTRIES];
  int  nentries;
  char  *prog_name=NULL;
  char *ufid=NULL, *context=NULL; 
  int iComplete;

  prog_name = argv[0];

  nentries = ht_decode_cgi_query(entries);

  ht_set_httpd_environment(entries,nentries);
  ht_set_server_url(HT_SERVER_NAME);
  ht_set_server_cgi_path(HT_CGI_PATH);
  
  ndb_open_log(prog_name,HT_LOGFILE_NAME);
  ndb_set_debug_level(NDB_GLOBAL_DEBUG_LEVEL);
  ndb_log_message(NDB_MSG_DEBUG,"STARTING adit-download-driver");
  
  ufid      = ht_get_keyword_value(HT_ATTRIBUTE_UNIQUE_ID,entries,nentries);
  context   = ht_get_keyword_value(HT_ATTRIBUTE_DOWNLOAD_CONTEXT,entries,nentries);

  if (ufid == NULL)  ufid = ht_get_unique_name();

  ndb_log_message_text(NDB_MSG_DEBUG,"Got %d entries",nentries);
  for (int i=0; i < nentries; i++) {
    ndb_log_message_text(NDB_MSG_DEBUG,"adit-download-driver: entry=%d name=%s val=%s file=%s isfile=%d",
			 i,
			 entries[i].name,
			 entries[i].val,
			 entries[i].file,
			 entries[i].isFile);
  }
  
  ndb_log_message_text(NDB_MSG_DEBUG,"Using ufid        %s",ufid);
  ndb_log_message_text(NDB_MSG_DEBUG,"Using context     %s",context);

  iComplete = check_registration_data(entries,nentries);

  ndb_log_message_text(NDB_MSG_DEBUG,"Completeness flag     %d",iComplete);

  if ( !strcmp(context,"register") || !iComplete) {
    write_download_registration_1(stdout,entries,nentries,ufid);
    //  } else if (!strcmp(context,"download") && iComplete) {
    //
  } else   if ( !strcmp(context,"download") && iComplete) {
    write_download_app_1(stdout, entries, nentries, ufid);
  }
  
    
  ndb_close_log();    
  exit(0);
}


int check_registration_data(entry entries[HT_MAX_ENTRIES], int nentries)
{
  int iComplete = 0;

  char *programName=NULL;
  char *firstName=NULL, *lastName=NULL, *email=NULL, *address=NULL;

  programName      = ht_get_keyword_value(HT_ATTRIBUTE_PROGRAM_NAME,entries,nentries);
  firstName        = ht_get_keyword_value(HT_ATTRIBUTE_FIRST_NAME,entries,nentries);
  lastName         = ht_get_keyword_value(HT_ATTRIBUTE_LAST_NAME,entries,nentries);
  email            = ht_get_keyword_value(HT_ATTRIBUTE_EMAIL,entries,nentries);
  address          = ht_get_keyword_value(HT_ATTRIBUTE_ADDRESS,entries,nentries);

  ndb_log_message_text(NDB_MSG_DEBUG,"adit-download-driver: programName %s",programName);
  ndb_log_message_text(NDB_MSG_DEBUG,"adit-download-driver: firstName %s",firstName);
  ndb_log_message_text(NDB_MSG_DEBUG,"adit-download-driver: lastName %s",lastName);
  ndb_log_message_text(NDB_MSG_DEBUG,"adit-download-driver: email  %s",email);
  ndb_log_message_text(NDB_MSG_DEBUG,"adit-download-driver: address  %s",address);

  iComplete = 0;

  if (programName == NULL  || !strlen(programName)) return iComplete;
  if (firstName == NULL  || !strlen(firstName)) return iComplete;
  if (lastName == NULL  || !strlen(lastName)) return iComplete;
  if (address == NULL  || !strlen(address)) return iComplete;
  if (email == NULL  || !strlen(email)) return iComplete;

  iComplete = 1;
  return(iComplete);
}


//
void write_download_registration_1(FILE *io, entry entries[HT_MAX_ENTRIES], int nentries,
				   const char *ufid)
{
  int i;
  char *programName=NULL;
  char *firstName=NULL, *lastName=NULL, *email=NULL, *address=NULL;



  programName      = ht_get_keyword_value(HT_ATTRIBUTE_PROGRAM_NAME,entries,nentries);
  firstName        = ht_get_keyword_value(HT_ATTRIBUTE_FIRST_NAME,entries,nentries);
  lastName         = ht_get_keyword_value(HT_ATTRIBUTE_LAST_NAME,entries,nentries);
  email            = ht_get_keyword_value(HT_ATTRIBUTE_EMAIL,entries,nentries);
  address          = ht_get_keyword_value(HT_ATTRIBUTE_ADDRESS,entries,nentries);



  ndb_log_message_text(NDB_MSG_DEBUG,"In write_download_registration_1 *************");

  ndb_log_message_text(NDB_MSG_DEBUG,"adit-download-driver: programName %s",programName);
  ndb_log_message_text(NDB_MSG_DEBUG,"adit-download-driver: firstName %s",firstName);
  ndb_log_message_text(NDB_MSG_DEBUG,"adit-download-driver: lastName %s",lastName);
  ndb_log_message_text(NDB_MSG_DEBUG,"adit-download-driver: email  %s",email);
  ndb_log_message_text(NDB_MSG_DEBUG,"adit-download-driver: address  %s",address);
  
  ht_put_content_type_target(io,"_top");
  html_display_open_page(io,"Download options", RCSB_STYLE_DEFAULT);

  html_display_page_title_logo(io,"", HT_CONTEXT_DOWNLOAD);
  html_display_return_to_page(io, "Software Page", "/software");

  fprintf(io,"%s",p0_en_download);

  //
  //    
  //
  fprintf(io,"<FORM METHOD=\"POST\" ACTION=\"%s%s%s\" TARGET=\"_top\">\n",
	  HT_SERVER_NAME,
	  HT_CGI_PATH,
	  HT_INTERFACE_DOWNLOAD_DRIVER);

  fprintf(io,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_UNIQUE_ID, ufid);
  fprintf(io,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_DOWNLOAD_CONTEXT, "download");

  fprintf(io,"<table cellpadding=10 bgcolor=\"%s\">\n",TBL_BG_COLOR);

  //
  //

  fprintf(io,"<tr><td align=center><b>First<BR>Name: </b></td>\n");
  if (firstName) {
    fprintf(io,"<td><INPUT name=\"%s\" type=text  size=\"30\" value=\"%s\"></td>\n",
	    HT_ATTRIBUTE_FIRST_NAME,  firstName, firstName);
  } else {
    fprintf(io,"<td><INPUT name=\"%s\" type=text  size=\"30\" value=\"%s\"></td>\n",
	    HT_ATTRIBUTE_FIRST_NAME,  "", "");
  }

  fprintf(io,"<td align=center><b>Last<BR>Name: </b></td>\n");
  if (lastName) {
    fprintf(io,"<td><INPUT name=\"%s\" type=text  size=\"30\" value=\"%s\"></td></tr>\n",
	    HT_ATTRIBUTE_LAST_NAME,  lastName, lastName);
  } else {
    fprintf(io,"<td><INPUT name=\"%s\" type=text  size=\"30\" value=\"%s\"></td></tr>\n",
	    HT_ATTRIBUTE_LAST_NAME,  "", "");
  }

  fprintf(io,"<tr><td align=center><b>Address: </b></td>\n");
  if (address) {
    fprintf(io,"<td><TEXTAREA name=\"%s\" cols=\"30\" rows=\"5\">%s</TEXTAREA></td>\n",
	    HT_ATTRIBUTE_ADDRESS,  address);
  } else {
    fprintf(io,"<td><TEXTAREA name=\"%s\" cols=\"30\" rows=\"5\">%s</TEXTAREA></td>\n",
	    HT_ATTRIBUTE_ADDRESS,  "");
  }


  fprintf(io,"<td align=center><b>e-mail: </b></td>\n");
  if (email) {
    fprintf(io,"<td><INPUT name=\"%s\" type=text  size=\"30\" value=\"%s\"></td></tr>\n",
	    HT_ATTRIBUTE_EMAIL,  email, email);
  } else {
    fprintf(io,"<td><INPUT name=\"%s\" type=text  size=\"30\" value=\"%s\"></td></tr>\n",
	    HT_ATTRIBUTE_EMAIL,  "", "");
  }

  //
  // Display program list... 
  //
  fprintf(io,"<tr><td>&nbsp</td><td align=center><b>Program name</b></td>\n");
  fprintf(io,"<td><SELECT NAME=\"%s\" WIDTH=10>\n",HT_ATTRIBUTE_PROGRAM_NAME);
  i=0;
  while ( strlen(programsDisplay[i]) ) {
    if (programName &&  !strcmp(programs[i],programName)) 
      fprintf(io,"<OPTION SELECTED VALUE=\"%s\">%s\n",programs[i],programsDisplay[i]);
    else
      fprintf(io,"<OPTION VALUE=\"%s\">%s\n",programs[i],programsDisplay[i]);
    i++;
  }
  fprintf(io,"</SELECT></td><td>&nbsp</td></tr>\n");
  fprintf(io,"</table>\n");

  //

  fprintf(io,"%s",p1_en_license);

  //  fprintf(io,"<tr><td align=center><font COLOR=\"blue\" size=4>\n");

  fprintf(io,"<center><font COLOR=\"blue\" size=4>\n");
  fprintf(io,"<INPUT TYPE=\"SUBMIT\" VALUE=\"ACCEPT\"></font></center>\n");



  fprintf(io,"</FORM>\n");
  //


  html_display_close_page(io, RCSB_STYLE_DEFAULT);
}

//
void write_download_app_1(FILE *io, entry entries[HT_MAX_ENTRIES], int nentries,
				   const char *ufid)
{

  char *programName=NULL;
  char *firstName=NULL, *lastName=NULL, *email=NULL, *address=NULL;


  programName      = ht_get_keyword_value(HT_ATTRIBUTE_PROGRAM_NAME,entries,nentries);
  firstName        = ht_get_keyword_value(HT_ATTRIBUTE_FIRST_NAME,entries,nentries);
  lastName         = ht_get_keyword_value(HT_ATTRIBUTE_LAST_NAME,entries,nentries);
  email            = ht_get_keyword_value(HT_ATTRIBUTE_EMAIL,entries,nentries);
  address          = ht_get_keyword_value(HT_ATTRIBUTE_ADDRESS,entries,nentries);

  if (ufid != NULL && (strlen(ufid) > 0)) {
    FILE *fp=NULL;
    char regPath[HT_MAX_NAME_LENGTH];
    strcpy(regPath,HT_SERVER_PATH);
    strcat(regPath,"/software/register/");
    strcat(regPath,ufid);
    fp = fopen(regPath,"w");
    if (fp != NULL) {
      fprintf(fp,"data_%s\n\n",ufid);
      fprintf(fp,"_pdbx_registration.program_name\n;%s\n;\n",programName);
      fprintf(fp,"_pdbx_registration.first_name\n;%s\n;\n",firstName);
      fprintf(fp,"_pdbx_registration.last_name\n;%s\n;\n",lastName);
      fprintf(fp,"_pdbx_registration.email_address\n;%s\n;\n",email);
      fprintf(fp,"_pdbx_registration.address\n;%s\n;\n\n\n",address);
      fclose(fp);
    }
  }

  ndb_log_message_text(NDB_MSG_DEBUG,"In write_download_app_1 *************");
    ht_put_content_type_target(io,"_top");
    html_display_open_page(io,"Download options", RCSB_STYLE_DEFAULT);
    
    html_display_page_title_logo(io,"", HT_CONTEXT_DOWNLOAD);
    html_display_return_to_page(io, "Software Page", "/software");

  if (programName && !strcmp(programName,"ciftr")) {
    fprintf(io,"%s",p0_en_ciftr);
  } else if (programName && !strcmp(programName,"validationbeta")) {
    fprintf(io,"%s",p0_en_validation);
  }

  //

  //    
  

  html_display_close_page(io, RCSB_STYLE_DEFAULT);
}


#if 0

static int get_index_in_list(const char **list, const char *target) 
{
  int i,ret = -1;
  if (target == NULL) return(ret);
  i=0;
  while (strlen(list[i])) {
    if (!strcmp(target,list[i])) return(i);
    i++;
  }
  return(ret);
}


static char *root_file_name(char *path)
{
  char *p1=NULL, *root=NULL;
  int len=0;

  ndb_log_message_text(NDB_MSG_DEBUG,"root_file_name: input path %s",path);

  if (path == NULL || (strlen(path) == 0)) {
    root = (char *) calloc(6, sizeof(char));
    strcpy(root,"&nbsp");
    ndb_log_message_text(NDB_MSG_DEBUG,"root_file_name: return %s",root);
    return(root);
  }

  p1=strrchr(path,'/');
  if ( p1 == NULL || strlen(p1) <= 1) {
    root = (char *) calloc(6, sizeof(char));
    strcpy(root,"&nbsp");

  } else {
    p1++;
    len = strlen(p1);
    root = (char *) calloc(len+1, sizeof(char));
    strcpy(root,p1);

  }
  ndb_log_message_text(NDB_MSG_DEBUG,"root_file_name: return %s",root);
  return(root);
}


#endif
