/*
FILE:     get-item-examples-view.C
*/
/*
VERSION:  0.904-beta
*/
/*
DATE:     8/14/2003
*/
/*
  Comments and Questions to: sw-help@rcsb.rutgers.edu
*/
/*
COPYRIGHT 1999-2003 Rutgers - The State University of New Jersey

This software is provided WITHOUT WARRANTY OF MERCHANTABILITY OR
FITNESS FOR A PARTICULAR PURPOSE OR ANY OTHER WARRANTY, EXPRESS OR
IMPLIED.  RUTGERS MAKE NO REPRESENTATION OR WARRANTY THAT THE
SOFTWARE WILL NOT INFRINGE ANY PATENT, COPYRIGHT OR OTHER
PROPRIETARY RIGHT.

The user of this software shall indemnify, hold harmless and defend
Rutgers, its governors, trustees, officers, employees, students,
agents and the authors against any and all claims, suits,
losses, liabilities, damages, costs, fees, and expenses including
reasonable attorneys' fees resulting from or arising out of the
use of this software.  This indemnification shall include, but is
not limited to, any and all claims alleging products liability.
*/
/*
               PDB SOFTWARE LICENSE AGREEMENT

BY CLICKING THE ACCEPTANCE BUTTON OR INSTALLING OR USING 
THIS "SOFTWARE, THE INDIVIDUAL OR ENTITY LICENSING THE  
SOFTWARE ("LICENSEE") IS CONSENTING TO BE BOUND BY AND IS 
BECOMING A PARTY TO THIS AGREEMENT.  IF LICENSEE DOES NOT 
AGREE TO ALL OF THE TERMS OF THIS AGREEMENT
THE LICENSEE MUST NOT INSTALL OR USE THE SOFTWARE.

1. LICENSE AGREEMENT

This is a license between you ("Licensee") and the Protein Data Bank (PDB) 
at Rutgers, The State University of New Jersey (hereafter referred to 
as "RUTGERS").   The software is owned by RUTGERS and protected by 
copyright laws, and some elements are protected by laws governing 
trademarks, trade dress and trade secrets, and may be protected by 
patent laws. 

2. LICENSE GRANT

RUTGERS grants you, and you hereby accept, non-exclusive, royalty-free 
perpetual license to install, use, modify, prepare derivative works, 
incorporate into other computer software, and distribute in binary 
and source code format, or any derivative work thereof, together with 
any associated media, printed materials, and on-line or electronic 
documentation (if any) provided by RUTGERS (collectively, the "SOFTWARE"), 
subject to the following terms and conditions: (i) any distribution 
of the SOFTWARE shall bind the receiver to the terms and conditions 
of this Agreement; (ii) any distribution of the SOFTWARE in modified 
form shall clearly state that the SOFTWARE has been modified from 
the version originally obtained from RUTGERS.  

2. COPYRIGHT; RETENTION OF RIGHTS.  

The above license grant is conditioned on the following: (i) you must 
reproduce all copyright notices and other proprietary notices on any 
copies of the SOFTWARE and you must not remove such notices; (ii) in 
the event you compile the SOFTWARE, you will include the copyright 
notice with the binary in such a manner as to allow it to be easily 
viewable; (iii) if you incorporate the SOFTWARE into other code, you 
must provide notice that the code contains the SOFTWARE and include 
a copy of the copyright notices and other proprietary notices.  All 
copies of the SOFTWARE shall be subject to the terms of this Agreement.  

3. NO MAINTENANCE OR SUPPORT; TREATMENT OF ENHANCEMENTS 

RUTGERS is under no obligation whatsoever to: (i) provide maintenance 
or support for the SOFTWARE; or (ii) to notify you of bug fixes, patches, 
or upgrades to the features, functionality or performance of the 
SOFTWARE ("Enhancements") (if any), whether developed by RUTGERS 
or third parties.  If, in its sole discretion, RUTGERS makes an 
Enhancement available to you and RUTGERS does not separately enter 
into a written license agreement with you relating to such bug fix, 
patch or upgrade, then it shall be deemed incorporated into the SOFTWARE 
and subject to this Agreement. You are under no obligation whatsoever 
to provide any Enhancements to RUTGERS or the public that you may 
develop over time; however, if you choose to provide your Enhancements 
to RUTGERS, or if you choose to otherwise publish or distribute your 
Enhancements, in source code form without contemporaneously requiring 
end users or RUTGERS to enter into a separate written license agreement 
for such Enhancements, then you hereby grant RUTGERS a non-exclusive,
royalty-free perpetual license to install, use, modify, prepare
derivative works, incorporate into the SOFTWARE or other computer
software, distribute, and sublicense your Enhancements or derivative
works thereof, in binary and source code form.

4. FEES.  There is no license fee for the SOFTWARE.  If Licensee
wishes to receive the SOFTWARE on media, there may be a small charge
for the media and for shipping and handling.  Licensee is
responsible for any and all taxes.

5. TERMINATION.  Without prejudice to any other rights, Licensor
may terminate this Agreement if Licensee breaches any of its terms
and conditions.  Upon termination, Licensee shall destroy all
copies of the SOFTWARE.

6. PROPRIETARY RIGHTS.  Title, ownership rights, and intellectual
property rights in the Product shall remain with RUTGERS.  Licensee 
acknowledges such ownership and intellectual property rights and will 
not take any action to jeopardize, limit or interfere in any manner 
with RUTGERS' ownership of or rights with respect to the SOFTWARE.  
The SOFTWARE is protected by copyright and other intellectual 
property laws and by international treaties.  Title and related 
rights in the content accessed through the SOFTWARE is the property 
of the applicable content owner and is protected by applicable law.  
The license granted under this Agreement gives Licensee no rights to such
content.

7. DISCLAIMER OF WARRANTY.  THE SOFTWARE IS PROVIDED FREE OF 
CHARGE, AND, THEREFORE, ON AN "AS IS" BASIS, WITHOUT WARRANTY OF 
ANY KIND, INCLUDING WITHOUT LIMITATION THE WARRANTIES THAT IT 
IS FREE OF DEFECTS, MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE 
OR NON-INFRINGING.  THE ENTIRE RISK AS TO THE QUALITY AND 
PERFORMANCE OF THE SOFTWARE IS BORNE BY LICENSEE.  SHOULD THE 
SOFTWARE PROVE DEFECTIVE IN ANY RESPECT, THE LICENSEE AND NOT 
LICENSOR ASSUMES THE ENTIRE COST OF ANY SERVICE AND REPAIR.  
THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF 
THIS AGREEMENT.  NO USE OF THE PRODUCT IS AUTHORIZED HEREUNDER 
EXCEPT UNDER THIS DISCLAIMER.

8. LIMITATION OF LIABILITY.  TO THE MAXIMUM EXTENT PERMITTED BY
APPLICABLE LAW,  IN NO EVENT WILL LICENSOR BE LIABLE FOR ANY 
INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
OUT OF THE USE OF OR INABILITY TO USE THE SOFTWARE, INCLUDING, 
WITHOUT LIMITATION, DAMAGES FOR LOSS OF GOODWILL, WORK 
STOPPAGE, COMPUTER FAILURE OR MALFUNCTION, OR ANY AND ALL 
OTHER COMMERCIAL DAMAGES OR LOSSES, EVEN IF ADVISED OF THE
POSSIBILITY THEREOF. 
*/
/*
  PURPOSE:      Gets and displays the examples for the input 
                item in the frame, "other".

                get-item-examples-view?ufid=<unique fid>&itemid=<item name>
*/

#include <iostream.h>
#include <stdlib.h>
#include <sys/types.h>

#include "CifBuilder.h"
#include "CifFileObj.h"
#include "CifViewObj.h"

#include "ndb_htmllib.h"
#include "ndb_misclib.h"

#define  HTML_ENV_GLOBAL_INIT
#include "interface-defs.h"


int main(int argc, char ** argv) {
    entry entries[HT_MAX_ENTRIES];
    int  nentries, i;
    char  *ufid=NULL, *prog_name=NULL;
    char dirPath[CIF_MAX_NAME_LENGTH];
    char fobjPath[CIF_MAX_NAME_LENGTH];
    char vobjPath[CIF_MAX_NAME_LENGTH];
    char *itemid, **exampleCase=NULL, **exampleDetail=NULL;
    uWord nexamples=0, n=0;


    prog_name = argv[0];
    nentries = ht_decode_get_query(entries);
    ht_set_httpd_environment(entries,nentries);
    ht_set_server_url(HT_SERVER_NAME);
    ht_set_server_cgi_path(HT_CGI_PATH);
   
    ndb_open_log(prog_name,HT_LOGFILE_NAME);
    ndb_set_debug_level(NDB_GLOBAL_DEBUG_LEVEL);

    ufid    = ht_get_keyword_value(HT_ATTRIBUTE_UNIQUE_ID,entries,nentries);
    itemid  = ht_get_keyword_value(HT_ATTRIBUTE_ITEM_ID,entries,nentries);
    ndb_log_message_text(NDB_MSG_DEBUG,"Got ufid:  %s",ufid);
    ndb_log_message_text(NDB_MSG_DEBUG,"Got itemid:  %s",itemid);

    strcpy(dirPath,HT_SESSION_ROOT_PATH);
    strcat(dirPath,ufid);
    strcat(dirPath,"/");

    ht_put_content_type_target(stdout,"other");
    printf("<HTML>\n");
    printf("%s\n",LANG_HTML_BODY_SCHEME_ALT_2);

    if ((itemid != NULL) && (strlen(itemid) > 0)) {
      ndb_log_message_text(NDB_MSG_INFO,"Getting examples for itemid:  %s",itemid);
      strcpy(fobjPath,dirPath);
      strcat(fobjPath,HT_TABLE_OBJECT_FILE);
      ndb_log_message(NDB_MSG_INFO,"Opening table object store %s",fobjPath);
      
      CifFileObj *fobj = new CifFileObj(fobjPath,READ_MODE);
      
      strcpy(vobjPath,dirPath);
      strcat(vobjPath,HT_VIEW_OBJECT_FILE);
      CifViewObj *vobj = new CifViewObj(vobjPath,(const char *)HT_VIEW_NAME,0);
      ndb_log_message_text(NDB_MSG_DEBUG,"Read view object from %s",vobjPath);
      
      CifString * viewName = vobj->GetViewItem(itemid);
      
      CifBuilder cb(HT_CIFDB_PATH);
      cb.BuildDictionaryList();
      cb.SetContext(HT_CIFDB_DICT);
      
      if ((viewName != NULL) && strcmp(viewName->Text(),itemid) ) { 
	printf("<center><font face=\"%s\" size=5>%s &nbsp</font><font size=5 color=\"#900000\">%s</font></center>\n",
	       LANG_HTML_FONT_FACE,
	       LANG_EXAMPLE_TITLE,	       
	       viewName->Text());
	printf("<center><font size=3 >(mmCIF item %s)</font></center>",itemid);			
      } else {
	printf("<center><font face=\"%s\" size=5>%s &nbsp</font><font size=5 color=\"#900000\">%s</font></center>\n",
	       LANG_HTML_FONT_FACE,
	       LANG_EXAMPLE_TITLE,	       
	       itemid);
      }
      
      ndb_log_message_text(NDB_MSG_DEBUG,"For %s viewName is %s",itemid,viewName->Text());

      exampleCase   =  cb.GetItemExamplesCaseNDB(itemid,nexamples);
      if (nexamples > 0) 	exampleDetail =  cb.GetItemExamplesDetailNDB(itemid,n);
      
      if ((nexamples == 0) && (exampleCase == NULL)) {
	exampleCase   =  cb.GetItemExamplesCase(itemid,nexamples);
	if (nexamples > 0) exampleDetail =  cb.GetItemExamplesDetail(itemid,n);
      }
      ndb_log_message_text(NDB_MSG_DEBUG,"Got %d example details for %s",nexamples,itemid);
      ndb_log_message_text(NDB_MSG_DEBUG,"Got %d example cases for %s",nexamples,itemid);
      
      if (nexamples > 0) {
	for (i=0; i < nexamples; i++) {
	  //	  printf("<IMG SRC=\"%s\" ALIGN=TOP><font size=4><b>%s %d:</b></font>", HT_ICON_BULLET,LANG_EXAMPLES,i+1);
	  ndb_log_message_text(NDB_MSG_DEBUG,"Example %d",i);
	  ndb_log_message_text(NDB_MSG_DEBUG,"font %d text %s number %d",HT_DEFAULT_TEXT_FONT_SIZE, LANG_EXAMPLES,i+1);

	  printf("<br><font size=%d><b>%s %d:</b></font>", HT_DEFAULT_TEXT_FONT_SIZE, LANG_EXAMPLES,i+1);

	  printf("<p><font size=%d>\n",HT_DEFAULT_TEXT_FONT_SIZE);
	  printf("<pre>\n");
	  ndb_log_message_text(NDB_MSG_DEBUG,"Here A   Example %d",i);

	  if ( (exampleDetail !=NULL) && (exampleDetail[i] != NULL) && (strlen(exampleDetail[i]) > 0)) {

	    ndb_log_message_text(NDB_MSG_DEBUG,"For %s detail is %s",itemid,exampleDetail[i]);
	    format_cif_definition(stdout, exampleDetail[i]);
	  }
	  printf("</pre><br>\n");
	  printf("<pre>\n");

	  if ( (exampleCase != NULL)  && (exampleCase[i] != NULL) && (strlen(exampleCase[i]) > 0)) {
	    ndb_log_message_text(NDB_MSG_DEBUG,"For %s case is %s",itemid,exampleCase[i]);
	    format_cif_definition(stdout, exampleCase[i]);
	  }
	  printf("</pre><br>\n");
	  printf("</font>\n");
	}
      } else {
	printf("<H4>Sorry, there are no examples for this item  ...</h4>\n");
      }
    } else {
      printf("<H4>No item was selected ...</h4>\n");
    }

    printf("</BODY>\n");
    printf("</HTML>\n");
    ndb_close_log();    
    exit(0);
}







