/*
FILE:     read-category-form.C
*/
/*
VERSION:  0.904-beta
*/
/*
DATE:     8/14/2003
*/
/*
  Comments and Questions to: sw-help@rcsb.rutgers.edu
*/
/*
COPYRIGHT 1999-2003 Rutgers - The State University of New Jersey

This software is provided WITHOUT WARRANTY OF MERCHANTABILITY OR
FITNESS FOR A PARTICULAR PURPOSE OR ANY OTHER WARRANTY, EXPRESS OR
IMPLIED.  RUTGERS MAKE NO REPRESENTATION OR WARRANTY THAT THE
SOFTWARE WILL NOT INFRINGE ANY PATENT, COPYRIGHT OR OTHER
PROPRIETARY RIGHT.

The user of this software shall indemnify, hold harmless and defend
Rutgers, its governors, trustees, officers, employees, students,
agents and the authors against any and all claims, suits,
losses, liabilities, damages, costs, fees, and expenses including
reasonable attorneys' fees resulting from or arising out of the
use of this software.  This indemnification shall include, but is
not limited to, any and all claims alleging products liability.
*/
/*
               PDB SOFTWARE LICENSE AGREEMENT

BY CLICKING THE ACCEPTANCE BUTTON OR INSTALLING OR USING 
THIS "SOFTWARE, THE INDIVIDUAL OR ENTITY LICENSING THE  
SOFTWARE ("LICENSEE") IS CONSENTING TO BE BOUND BY AND IS 
BECOMING A PARTY TO THIS AGREEMENT.  IF LICENSEE DOES NOT 
AGREE TO ALL OF THE TERMS OF THIS AGREEMENT
THE LICENSEE MUST NOT INSTALL OR USE THE SOFTWARE.

1. LICENSE AGREEMENT

This is a license between you ("Licensee") and the Protein Data Bank (PDB) 
at Rutgers, The State University of New Jersey (hereafter referred to 
as "RUTGERS").   The software is owned by RUTGERS and protected by 
copyright laws, and some elements are protected by laws governing 
trademarks, trade dress and trade secrets, and may be protected by 
patent laws. 

2. LICENSE GRANT

RUTGERS grants you, and you hereby accept, non-exclusive, royalty-free 
perpetual license to install, use, modify, prepare derivative works, 
incorporate into other computer software, and distribute in binary 
and source code format, or any derivative work thereof, together with 
any associated media, printed materials, and on-line or electronic 
documentation (if any) provided by RUTGERS (collectively, the "SOFTWARE"), 
subject to the following terms and conditions: (i) any distribution 
of the SOFTWARE shall bind the receiver to the terms and conditions 
of this Agreement; (ii) any distribution of the SOFTWARE in modified 
form shall clearly state that the SOFTWARE has been modified from 
the version originally obtained from RUTGERS.  

2. COPYRIGHT; RETENTION OF RIGHTS.  

The above license grant is conditioned on the following: (i) you must 
reproduce all copyright notices and other proprietary notices on any 
copies of the SOFTWARE and you must not remove such notices; (ii) in 
the event you compile the SOFTWARE, you will include the copyright 
notice with the binary in such a manner as to allow it to be easily 
viewable; (iii) if you incorporate the SOFTWARE into other code, you 
must provide notice that the code contains the SOFTWARE and include 
a copy of the copyright notices and other proprietary notices.  All 
copies of the SOFTWARE shall be subject to the terms of this Agreement.  

3. NO MAINTENANCE OR SUPPORT; TREATMENT OF ENHANCEMENTS 

RUTGERS is under no obligation whatsoever to: (i) provide maintenance 
or support for the SOFTWARE; or (ii) to notify you of bug fixes, patches, 
or upgrades to the features, functionality or performance of the 
SOFTWARE ("Enhancements") (if any), whether developed by RUTGERS 
or third parties.  If, in its sole discretion, RUTGERS makes an 
Enhancement available to you and RUTGERS does not separately enter 
into a written license agreement with you relating to such bug fix, 
patch or upgrade, then it shall be deemed incorporated into the SOFTWARE 
and subject to this Agreement. You are under no obligation whatsoever 
to provide any Enhancements to RUTGERS or the public that you may 
develop over time; however, if you choose to provide your Enhancements 
to RUTGERS, or if you choose to otherwise publish or distribute your 
Enhancements, in source code form without contemporaneously requiring 
end users or RUTGERS to enter into a separate written license agreement 
for such Enhancements, then you hereby grant RUTGERS a non-exclusive,
royalty-free perpetual license to install, use, modify, prepare
derivative works, incorporate into the SOFTWARE or other computer
software, distribute, and sublicense your Enhancements or derivative
works thereof, in binary and source code form.

4. FEES.  There is no license fee for the SOFTWARE.  If Licensee
wishes to receive the SOFTWARE on media, there may be a small charge
for the media and for shipping and handling.  Licensee is
responsible for any and all taxes.

5. TERMINATION.  Without prejudice to any other rights, Licensor
may terminate this Agreement if Licensee breaches any of its terms
and conditions.  Upon termination, Licensee shall destroy all
copies of the SOFTWARE.

6. PROPRIETARY RIGHTS.  Title, ownership rights, and intellectual
property rights in the Product shall remain with RUTGERS.  Licensee 
acknowledges such ownership and intellectual property rights and will 
not take any action to jeopardize, limit or interfere in any manner 
with RUTGERS' ownership of or rights with respect to the SOFTWARE.  
The SOFTWARE is protected by copyright and other intellectual 
property laws and by international treaties.  Title and related 
rights in the content accessed through the SOFTWARE is the property 
of the applicable content owner and is protected by applicable law.  
The license granted under this Agreement gives Licensee no rights to such
content.

7. DISCLAIMER OF WARRANTY.  THE SOFTWARE IS PROVIDED FREE OF 
CHARGE, AND, THEREFORE, ON AN "AS IS" BASIS, WITHOUT WARRANTY OF 
ANY KIND, INCLUDING WITHOUT LIMITATION THE WARRANTIES THAT IT 
IS FREE OF DEFECTS, MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE 
OR NON-INFRINGING.  THE ENTIRE RISK AS TO THE QUALITY AND 
PERFORMANCE OF THE SOFTWARE IS BORNE BY LICENSEE.  SHOULD THE 
SOFTWARE PROVE DEFECTIVE IN ANY RESPECT, THE LICENSEE AND NOT 
LICENSOR ASSUMES THE ENTIRE COST OF ANY SERVICE AND REPAIR.  
THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF 
THIS AGREEMENT.  NO USE OF THE PRODUCT IS AUTHORIZED HEREUNDER 
EXCEPT UNDER THIS DISCLAIMER.

8. LIMITATION OF LIABILITY.  TO THE MAXIMUM EXTENT PERMITTED BY
APPLICABLE LAW,  IN NO EVENT WILL LICENSOR BE LIABLE FOR ANY 
INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
OUT OF THE USE OF OR INABILITY TO USE THE SOFTWARE, INCLUDING, 
WITHOUT LIMITATION, DAMAGES FOR LOSS OF GOODWILL, WORK 
STOPPAGE, COMPUTER FAILURE OR MALFUNCTION, OR ANY AND ALL 
OTHER COMMERCIAL DAMAGES OR LOSSES, EVEN IF ADVISED OF THE
POSSIBILITY THEREOF. 
*/
/*

  PURPOSE:      This module processes a category form via a post query.

                The input form must provide:
                        ufid = unique path data
                       catid = current category 
                       rows  = number of table rows in form
                      nitems = number items in category
		      layout = code to describe the category form layout
                 _R###C###   = value of each data item 
              ALT_R###C###   = alternative values of each data item 

              Non-blank rows in the category will overwrite/append to 
              the persistent contents of the category.
*/

#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>



#include "CifBuilder.h"

#include "ndb_htmllib.h"
#include "ndb_misclib.h"



#define HTML_ENV_GLOBAL_INIT
#include "interface-defs.h"
#include "view-obj-util.h"
#include "CifFileObj.h"
#include "CifViewObj.h"
#include "CifStateObj.h"

#include "regex.h"

//#include "regex.h"
//#include "regex-util.h"

static int html_integrity_check(FILE *fp, CifBuilder &cb, 
				  const char *item, char *value, int mCodeView);
static char *strip_special_chars(const char *in);
static int detect_valid_row(int iLayout, char **row, int nCols, CIFVIEWOBJITEM *itemList);
static int * xGetItemColumnIndices(ISTable *t, ReVarCifArray<CifString>* viewItems);

int main(int argc, char ** argv) {
    entry entries[HT_MAX_ENTRIES];
    char  *ufid=NULL, *category=NULL, *blockId=NULL, *rows=NULL,*cols=NULL, *prog_name=NULL;
    int  nCols=0,  nColsForm=0, nColsView=0;
    char ***values=NULL, *layout=NULL;

    char dirPath[HT_MAX_NAME_LENGTH];
    char  fn[HT_MAX_NAME_LENGTH];
    char fobjPath[HT_MAX_NAME_LENGTH];
    char vobjPath[HT_MAX_NAME_LENGTH];
    char statePath[HT_MAX_NAME_LENGTH];
    char  script[HT_MAX_NAME_LENGTH];
    char  fn_categories[HT_MAX_NAME_LENGTH];
    char  fn_other[HT_MAX_NAME_LENGTH];

    int  i,j, k, nentries, irow, icol, iLayout,iok;

    int istatus=0, istatusC=0, iCat=0, numMissMan=0, numMissOpt=0;
    char cstat;

    CIFVIEWOBJITEM *itemList=NULL;
    int nRows=0, nRowsForm=0;
    CifString tmpS;
    ISTable *t=NULL;
    ReVarCifArray<CifString> *colNamesView=NULL, *rowValues=NULL;
    int *ind=NULL;

    FILE *fp=NULL;

    prog_name = argv[0];

    //    ndb_open_log(prog_name,"/var/tmp/XXLOG");
    //    ndb_set_debug_level(NDB_GLOBAL_DEBUG_LEVEL);   

    nentries  = ht_decode_post_query(entries);


    ht_set_httpd_environment(entries,nentries);
    ht_set_server_url(HT_SERVER_NAME);
    ht_set_server_cgi_path(HT_CGI_PATH);

    ndb_open_log(prog_name,HT_LOGFILE_NAME);
    ndb_set_debug_level(NDB_GLOBAL_DEBUG_LEVEL);   

    //    re_syntax_options =  RE_DOT_NEWLINE | RE_DOT_NOT_NULL | RE_NO_BK_VBAR | RE_NO_BK_PARENS;

    ndb_log_message(NDB_MSG_DEBUG,"In READ-CATEGORY-FORM Decoded post query ...");


    ufid      = ht_get_keyword_value(HT_ATTRIBUTE_UNIQUE_ID,entries,nentries);
    category  = ht_get_keyword_value(HT_ATTRIBUTE_CATEGORY_ID,entries,nentries);
    blockId   = ht_get_keyword_value(HT_ATTRIBUTE_DATABLOCK_ID,entries,nentries);
    rows      = ht_get_keyword_value(HT_ATTRIBUTE_NUM_ROWS,entries,nentries);
    cols      = ht_get_keyword_value(HT_ATTRIBUTE_NUM_ITEMS,entries,nentries);
    layout    = ht_get_keyword_value(HT_ATTRIBUTE_FORM_LAYOUT,entries,nentries);

    sscanf(cols,"%d",&nColsForm);
    sscanf(rows,"%d",&nRowsForm);
    sscanf(layout,"%d",&iLayout);

    ndb_log_message(NDB_MSG_DEBUG,"read-category-form: got ufid:  %s",ufid);
    ndb_log_message_text(NDB_MSG_DEBUG,"Got category: %s",category);
    ndb_log_message_text(NDB_MSG_DEBUG,"Got form rows: %d",nRowsForm);
    ndb_log_message_text(NDB_MSG_DEBUG,"Got form columns: %d",nColsForm);
    ndb_log_message_text(NDB_MSG_DEBUG,"Got layout:  %s",layout);
    ndb_log_message_text(NDB_MSG_DEBUG,"Got iLayout: %d",iLayout);

    strcpy(dirPath,HT_SESSION_ROOT_PATH);
    strcat(dirPath,ufid);
    strcat(dirPath,"/");

    //jdw April 14 - block access after deposition.
    if (HT_APPL_CONTEXT_TYPE == HT_CONTEXT_DEPOSIT) {
      html_display_redeposit_block_message(stdout, ufid, dirPath, RCSB_STYLE_DEFAULT);
    }

    if (!acquire_lock(dirPath)) {
      ndb_log_message_text(NDB_MSG_DEBUG,"Read category encountered locked file");
      ht_put_content_type_target(stdout,"other");
      fprintf(stdout,"<HTML>\n");
      fprintf(stdout,"%s\n",LANG_HTML_BODY_SCHEME_ALT_2);
      
      fprintf(stdout,"<center><font face=\"%s\" size=5>%s</font></center>\n",
	      LANG_HTML_FONT_FACE,
	      "Please Slow down <br>Allow each operation to complete before continuing.");

      fprintf(stdout,"<br><br><center><font face=\"%s\" size=5>%s</font></center>\n",
	      LANG_HTML_FONT_FACE,
	      "Please press the HELP button above to continue your session.");
      fprintf(stdout,"</HTML>\n");
      exit(0);
    }

    //
    // Allocate the table to hold the form data  ....
    //

    values    = (char ***) calloc(nRowsForm+1, sizeof(char **));
    for (i=0; i < nRowsForm; i++) {    
      values[i] = (char **) calloc(nColsForm+1, sizeof(char *));
    }

    //  Get the data items from the input form ...
    //
    //  Loop over the form once for the standard element names
    //  and a second time to pick up any alternate names.


    for (j=0; j < nentries; j++) {
      if (decode_table_param_name(entries[j].name, irow, icol, 0)) {
	values[irow][icol]=strip_special_chars(entries[j].val);
      }
    }

    for (j=0; j < nentries; j++) {
      if (decode_table_param_name(entries[j].name, irow, icol, 1)) {
	if ((entries[j].val != NULL) && (strlen(entries[j].val) > 0) && (entries[j].val[0] != '?')) {
	  if (values[irow][icol] != NULL) free(values[irow][icol]);
	  values[irow][icol]=strip_special_chars(entries[j].val);
	}
      }
    }
  
//
//  Get the corresonding item list
//
    CifBuilder cb(HT_CIFDB_PATH);
    cb.BuildDictionaryList();
    cb.SetContext(HT_CIFDB_DICT);
    ndb_log_message(NDB_MSG_INFO,"Got dictionary context");

    strcpy(fobjPath,dirPath);
    strcat(fobjPath,HT_TABLE_OBJECT_FILE);
    ndb_log_message_text(NDB_MSG_DEBUG,"Opening table object at %s",fobjPath);
    CifFileObj *fobj  = new CifFileObj(fobjPath,APPEND_MODE);

    strcpy(vobjPath,dirPath);
    strcat(vobjPath,HT_VIEW_OBJECT_FILE);
    ndb_log_message_text(NDB_MSG_DEBUG,"Opening view object at %s",vobjPath);
    CifViewObj *vobj = new CifViewObj(vobjPath,(const char *)HT_VIEW_NAME,0);

    itemList = build_item_obj_list(vobj, category, &nColsView);
    ndb_log_message_text(NDB_MSG_DEBUG,"Found %d items in this category %s",
			 nColsView,category);

    for (j=0; j < nColsView; j++) {
      itemList[j].defaultValue = cb.GetItemDefaultValue(itemList[j].item);
      ndb_log_message_text(NDB_MSG_DEBUG,"Default value for %s is %s",
			   itemList[j].item,
			   itemList[j].defaultValue);
    }
    
    //    rowCurrent = vobj->GetStateRowCurrent(category);

    //
    // Print diagnostics in  ..other.. frame...
    //

    strcpy(fn_other,HT_SESSION_REL_TMP_ROOT_PATH);
    strcat(fn_other,ufid);
    strcat(fn_other,"/");
    strcat(fn_other,HT_OTHER_TEXT_NAME);
    
    //    ht_put_content_type_target(stdout,"other");

    strcpy(fn,HT_SERVER_PATH);
    strcat(fn,fn_other);


    fp = fopen(fn,"w");
    if (fp != NULL) {
      ndb_log_message_text(NDB_MSG_DEBUG,"WRITING DIAGNOSTICS IN FILE %s",fn);
      fprintf(fp,"<HTML>\n");
      fprintf(fp,"%s\n",LANG_HTML_BODY_SCHEME_ALT_2);
      CifString *viewName=vobj->GetViewCategory(category);
      if (viewName != NULL && viewName->Length() > 0) {
	fprintf(fp,"<center><font face=\"%s\" size=5>%s <font color=\"#900000\">%s</font></font></center>\n",
		LANG_HTML_FONT_FACE,
		LANG_DIAGNOSTICS_TITLE,
		viewName->Text());
      } else {
	fprintf(fp,"<center><font face=\"%s\" size=5>%s <font color=\"#900000\">%s</font></font></center>\n",
		LANG_HTML_FONT_FACE,
		LANG_DIAGNOSTICS_TITLE,
		category);

      }

      ndb_log_message_text(NDB_MSG_DEBUG,"Displaying values in %d rows",nRowsForm);
      
      fprintf(fp,"<br><ul>");
      k=0;

      istatus = istatusC = 2;
      for (j=0; j < nRowsForm; j++ ) { 
	ndb_log_message_text(NDB_MSG_DEBUG,"Displaying row %d layout %d",j,iLayout);
	// died here
	//	if (!detect_valid_row(iLayout, values[j], nColsForm)) continue;
	if (!detect_valid_row(iLayout, values[j], nColsView, itemList)) continue;
	k++;
	fprintf(fp,"<br><li><b>In row %d</b>", j);
	fprintf(fp,"<br><ul>");
	numMissMan = numMissOpt = 0;
	for (i=0; i < nColsView; i++) {
	  ndb_log_message_text(NDB_MSG_DEBUG,"**Displaying row %d column %d value %s",j,i,values[j][i]);
	  if (itemList[i].mandatoryCode == 2)  continue;
	  fprintf(fp,"<li> Value of item <b>%s</b> is:  <tt>%s</tt>\n",itemList[i].viewName,values[j][i]);
	  iok=html_integrity_check(fp, cb, itemList[i].item, values[j][i], itemList[i].mandatoryCode);
	  ndb_log_message_text(NDB_MSG_DEBUG,"++Displaying row %d column %d value %s",j,i,values[j][i]);
	  if (iok) continue;
	  if (itemList[i].mandatoryCode == 1) 
	    numMissMan++;
	  else
	    numMissOpt++;
	}

	if (numMissMan > 0) 
	  istatus = 2;
	else if (numMissOpt > 0) 
	  istatus = 1;
	else 
	  istatus = 0;

	if (istatus < istatusC) istatusC = istatus;

	fprintf(fp,"</ul>");
      }

      fprintf(fp,"</ul>");
      
      if (k == 0) {
	fprintf(fp,"<pre>\n\n\n\n\n</pre>\n");
	fprintf(fp,"");
	fprintf(fp,"<center><font size=5>No data entered ...</font></center>\n");
      }
      
      fprintf(fp,"</BODY>\n");
      fprintf(fp,"</HTML>\n");
      fclose(fp);
    }
    //
    //  Update category status ... 
    //

    strcpy(statePath,dirPath);
    strcat(statePath,HT_STATE_FILE);
    iCat = vobj->GetCategoryIndex(category);
    if (istatusC == 2) 
      cstat = '2';
    else if (istatusC == 1) 
      cstat = '1';
    else
      cstat = '0';

    CifStateObj * sobj = NULL;
    sobj = new CifStateObj(statePath, "state", APPEND_MODE, 0);
    if (sobj) {
      char *sString = sobj->GetSessionStateString();
      if (sString && (strlen(sString) > iCat)) {
	sString[iCat] = cstat;
	sobj->SetSessionStateString(sString);
      }
      sobj->Close();
    }

    ndb_log_message_text(NDB_MSG_DEBUG,"***Setting %s category %d status to %d",
			 category,iCat,istatusC);
    //    set_category_status(statePath,iCat,cstat);


    // ***************************************************************************
    //              Write this category
    // 

    ndb_log_message_text(NDB_MSG_DEBUG,"Saving category %s",category);
    if ((t=fobj->GetTablePtr(blockId,category)) != NULL) {
      nRows = t->GetNumRows();
      for (j=nRows-1; j >= 0; j--) {  // clear existing category 
	t->DeleteRow(j);
      }
      // BEGIN PATCH
      // This is a temporary patch to fix the problem in ADIT.
      // The table module has a problem when doing the following sequence:
      // table is of the file created in APPEND_MODE, delete all rows, then
      // add some rows and write a table. After this sequence, the tables
      // get corrupted in the binary file.
      // To temporarily fix this problem, the CompressTable() statement has
      // been added here in order to force removal of the deleted rows from the
      // table. After this statement, adding of rows does not create any
      // corruption in the tables. Proper fix requires fixing of the table
      // module methods.
      t->CompressTable();
      // END OF PATCH

      nRows = t->GetNumRows();
      nCols= t->GetNumColumns();
      ndb_log_message_text(NDB_MSG_DEBUG,"Found %d rows %d columns in table object %s",
			   nRows,nCols,category);

      colNamesView = vobj->GetCategoryItems(category);
      ind = xGetItemColumnIndices(t,colNamesView);

      if ( nColsView <= nCols && ind != NULL) {
	for (i=0; i < nColsView; i++){
	  ndb_log_message_text(NDB_MSG_DEBUG,"Column %s no %d",
			       (*colNamesView)[i].Text(),i);
	}
	ReVarCifArray<CifString> *qcolNames = t->GetItemNames();
	if (qcolNames) {
	  for (i=0; i < qcolNames->Length(); i++){
	    ndb_log_message_text(NDB_MSG_DEBUG,"Table Column %s index %d",
				 (*qcolNames)[i].Text(),ind[i]);
	  }
	} else {
	  ndb_log_message_text(NDB_MSG_DEBUG,"NO TABLE COLUMNS********");
	}

	k=0;
	rowValues = new ReVarCifArray<CifString>;
	tmpS.Clear(); tmpS.Copy("?");
	for (i=0; i < nCols; i++) {
	  rowValues->Add(tmpS);
	}
	
	for (j=0; j < nRowsForm; j++) {

	  if (!detect_valid_row(iLayout, values[j], nColsView, itemList)) continue;
	  t->AddRow();

	  for (i=0; i < nColsForm; i++) {
	    tmpS.Clear();
	    if ((values[j][i] != NULL) && (strlen(values[j][i]) > 0)) {
	      tmpS.Copy(values[j][i]);  
	    } else {
	      tmpS.Copy("?");
	    }
	    ndb_log_message_text(NDB_MSG_DEBUG,"category %s col %d value %s",
				 category,ind[i],tmpS.Text());
	    (*rowValues)[ind[i]].Clear(); (*rowValues)[ind[i]].Copy(tmpS);
	  }

	  // xxxxxJDWxxxxx

	  // if the persitent table has columns not in the view then
          // these indices are at the end of the ind[] array. Here
          // we update those extra cells.
	  //
	  tmpS.Clear();  tmpS.Copy("?");
	  ndb_log_message_text(NDB_MSG_DEBUG,"Form columns %d table columns %d",nColsForm,nCols);
	  for (i=nColsForm; i < nCols; i++) {
	    (*rowValues)[ind[i]].Clear(); (*rowValues)[ind[i]].Copy(tmpS);
	  }
	  ndb_log_message_text(NDB_MSG_DEBUG,"Update row index %d",k);
          for (int kk=0; kk < nCols; kk++) {
	    ndb_log_message_text(NDB_MSG_DEBUG,"Update column %d value %s",kk, (*rowValues)[ind[kk]].Text());
	  }
	  t->FillRow(*rowValues, k); k++;
	}

	if (k==0) { // insert one blank row if form is empty ... 
	  ndb_log_message_text(NDB_MSG_DEBUG,"Blank row at index %d",k);
	  t->AddRow();
	  tmpS.Copy("?");
	  for (i=0; i < nCols; i++) {
	    (*rowValues)[ind[i]].Clear(); (*rowValues)[ind[i]].Copy(tmpS); 
	  }
	  t->FillRow(*rowValues, k); k++;
	}

	if (rowValues) delete rowValues;
	ndb_log_message_text(NDB_MSG_DEBUG,"Number of rows on write is %d",t->GetNumRows());
	fobj->WriteTable(t,blockId,category);
      }
    } else {
      ndb_log_message_text(NDB_MSG_DEBUG,"Unable to get table pointer");
    }
    //    vobj->SetStateRowMaximum(category,k);
    //    vobj->SetStateRowCurrent(category,0);
    //    vobj->Close();
    //JDW debug - 
    // fobj->Write("/tmp/data1.cif");

    fobj->CloseFile(0);	       


    if (HT_APPL_CONTEXT_TYPE == HT_CONTEXT_DEPOSIT) { 
      ht_put_content_type_target(stdout,"other");
      display_raw_file(stdout, fn);

    } else {
      strcpy(fn_categories,HT_SESSION_REL_TMP_ROOT_PATH);
      strcat(fn_categories,ufid);
      strcat(fn_categories,"/");
      strcat(fn_categories,HT_CATEGORY_LIST_NAME);
      mk_category_frame_from_view_obj(fn_categories, ufid, vobj);
      
      // Now update 'category' and 'other' frames...
      
      //  strcat(fn_categories,"#");
      //  strcat(fn_categories,category);
      
      sprintf(script,"JavaScript:parent.Display2('category','%s','other','%s')",
	      fn_categories,fn_other);
      
      ndb_log_message(NDB_MSG_INFO,"Calling java script: %s",script);
      ht_put_content_type(stdout);
      fprintf(stdout,"<HTML><SCRIPT LANGUAGE=\"JavaScript\">%s</SCRIPT></HTML>",script);

    }
    
    ndb_close_log();    
    release_lock(dirPath);

    exit(0);
}
#if 1

static char *strip_special_chars(const char *in)
{
  char *value=NULL;
  int i, j, ilen;

  //  ndb_log_message_text(NDB_MSG_DEBUG,"strip_special_characters()");

  if (in == NULL || strlen(in) == 0 ) {
    value = (char *) calloc(1, sizeof(char));
    value[0] = '\0';
    return(value);

  }

  ilen = strlen(in);
  for (i=ilen; i >= 0 ; i-- ) {
    //     ndb_log_message_text(NDB_MSG_DEBUG,"[%d] -> [%d]",i,in[i]);
    if (in[i] > 32)
      break;
  }

  if (i < 0 || (i == 0 && in[i] == '?'))  {
    value = (char *) calloc(1, sizeof(char));
    value[0] = '\0';
    return(value);
  } 


  value = (char *) calloc(ilen+ 1, sizeof(char));
  for (i=0,j=0; i < ilen; i++){
    // ndb_log_message_text(NDB_MSG_DEBUG,"[%d] %d",i,in[i]);
    if ((in[i] > 31 && in[i] < 127) || in[i] == 10) {
      value[j]=in[i];
      j++;
    } else if (in[i] == 9) {
      value[j]=' ';
      j++;
    }
  }
  value[j]='\0';
  return(value);
}
#else
// old version ???
static char *strip_special_chars(const char *in)
{
  char *value=NULL;
  int i, j, ilen;

  //  ndb_log_message_text(NDB_MSG_DEBUG,"strip_special_characters()");

  if (in == NULL || strlen(in) == 0 ) {
    value = (char *) calloc(1, sizeof(char));
    value[0] = '\0';
    return(value);

  }

  ilen = strlen(in);
  for (i=ilen; i >= 0 ; i-- ) {
    //     ndb_log_message_text(NDB_MSG_DEBUG,"[%d] -> [%d]",i,in[i]);
    if (in[i] > 32)
      break;
  }

  if (i < 0 || (i == 0 && in[i] == '?'))  {
    value = (char *) calloc(1, sizeof(char));
    value[0] = '\0';
    return(value);
  } 


  value = (char *) calloc(ilen+ 1, sizeof(char));
  for (i=0,j=0; i < ilen; i++){
    // ndb_log_message_text(NDB_MSG_DEBUG,"[%d] %d",i,in[i]);
    if (in[i] != CR) {
      value[j]=in[i];
      j++;
    }
  }
  value[j]='\0';
  return(value);
}

#endif

static int detect_valid_row(int iLayout, char **row, int nCols, CIFVIEWOBJITEM *itemList)
  /*
   *   Returns 0 for a blank row or 1 otherwise.
   */
{
  int i, l;

  switch (iLayout) {

  case 1:  
    for (i=1; i < nCols; i++) {
      l=strlen(row[i]);
      if ( (l >0)  && itemList[i].defaultValue && !strcmp(itemList[i].defaultValue,row[i])) continue;
      if ( (l >1 ) || ((l==1) && (row[i][0] != '?') ) ) return(1);
    }
    return(0);


  case 3:  
    for (i=2; i < nCols; i++) {
      ndb_log_message_text(NDB_MSG_DEBUG,"column %d value %s",i,row[i]);
      l=strlen(row[i]);
      if ( (l >0)  && itemList[i].defaultValue && !strcmp(itemList[i].defaultValue,row[i])) continue;
      if ( (l >1 ) || ((l==1) && (row[i][0] != '?') ) ) return(1);
    }
    return(0);


  case 5:  
    for (i=3; i < nCols; i++) {
      ndb_log_message_text(NDB_MSG_DEBUG,"column %d value %s",i,row[i]);
      l=strlen(row[i]);
      if ( (l >0)  && itemList[i].defaultValue && !strcmp(itemList[i].defaultValue,row[i])) continue;
      if ( (l >1 ) || ((l==1) && (row[i][0] != '?') ) ) return(1);
    }
    return(0);

  case 6:  
    for (i=0; i < nCols; i++) {
      l=strlen(row[i]);
      if ( (l >0)  && itemList[i].defaultValue && !strcmp(itemList[i].defaultValue,row[i])) continue;
      if ( (l >1 ) || ((l==1) && (row[i][0] != '?') ) ) return(1);
    }
    return(0);


  default:
    return 1;
  }
}



static int html_integrity_check(FILE *fp, CifBuilder &cb, 
				  const char *item, char *value, int mCodeView)
{
  regex_t preg;
  regmatch_t pmatch[10];

  char *typeCode=NULL;

  char *typeCondition=NULL;
  int ret, icmp;
  uWord nMin, nMax;
  char **cmin=NULL, **cmax=NULL;
  int i, ival,iok, len;
  double  dval;

  ndb_log_message_text(NDB_MSG_DEBUG,"integrity check item %s value %s",item,value);

  //  fprintf(fp,"<pre><br>Checking %s = %s\n",item,value);

  fprintf(fp,"<ul>\n");

#if 0
  char *mandatoryCode=NULL;
  int   mandatory;
  mandatoryCode = cb.GetItemMandatoryCode(item);
  if (!strcmp(mandatoryCode,"no")) 
    mandatory = 0;
  else
    mandatory = 1;
  fprintf(fp,"Mandatory Code = %d\n",mandatory);
#endif

  //
  //  Check for missing values
  //

  if ((value == NULL) || (strlen(value) <= 0) || !strcmp(value,"?") ) {
    if (mCodeView==1 ) fprintf(fp,"<li><font color=\"#900000\">This mandatory item is missing!</font>\n");
    fprintf(fp,"</ul>\n");
    return (0);
  }



  typeCondition = cb.GetItemRegex(item);
  typeCode = cb.GetItemType(item);
  ndb_log_message_text(NDB_MSG_DEBUG,"typeCondition %s typeCode %s",typeCondition,typeCode);

  if (typeCode == NULL) {
    fprintf(fp,"</ul>\n");
    return(1);
  }

  if (typeCondition != NULL) {
    //    fprintf(fp,"Regex is %s\n",typeCondition);
    //    fprintf(fp,"value is %s\n",value);

    icmp=regcomp(&preg, typeCondition, REG_EXTENDED  );

    if (icmp==0) {
      ret= regexec(&preg,value,10,pmatch, 0);
      if (ret != 0) {
	fprintf(fp,"<li><b><font color=\"#900000\">This value does not match the pattern for a %s</font></b>\n",typeCode);
	fprintf(fp,"</ul>\n");
	return(0);
      } else {
	len = pmatch[0].rm_eo - pmatch[0].rm_so;
	if (len != strlen(value) && strcasecmp(typeCode,"text")) {
	  fprintf(fp,"<li><b><font color=\"#900000\">This value does not match the pattern for a %s</font></b>\n",typeCode);
	  fprintf(fp,"</ul>\n");
	  return(0);
	}
      }
      regfree(&preg);
    }

  }

  //
  // Range checks  ...
  //

  nMin = nMax = 0;
  


  if (!strcmp(typeCode,"float")) {
    //    fprintf(fp,"Item is type float\n");
    cmin = cb.GetItemRangeMin(item, nMin);
    cmax = cb.GetItemRangeMax(item, nMax);
    ndb_align_string(value);
    dval = atof(value);
    ndb_log_message_text(NDB_MSG_DEBUG,"integrity check item %s value %s",item,value);  

    if (nMin > 0 && nMin == nMax) {
      iok=0;
      for (i=0; i < nMin; i++) {
	if (cmin[i] == NULL && cmax[i] == NULL) {
	  continue;
	} else if (cmin[i] == NULL || (strlen(cmin[i]) == 0)) {
	  if ( dval < atof(cmax[i]) ) {
	    iok++;
	    break;
	  }

	} else if (cmax[i] == NULL || (strlen(cmax[i]) == 0)) {
	  if ( dval > atof(cmin[i]) ) {
	    iok++;
	    break;
	  }
	} else if (!strcmp(cmin[i],cmax[i])) {
	  if ( dval == atof(cmin[i]) ) {
	    iok++;
	    break;
	  }
	} else {
	  if ( dval < atof(cmax[i]) && dval > atof(cmin[i])) {
	    iok++;
	    break;
	  }
	}
      }

      if (iok == 0) {
	for (i=0; i < nMin; i++) {
	  if (cmin[i] == NULL && cmax[i] == NULL) {
	    continue;
	  } else if (cmin[i] == NULL || (strlen(cmin[i]) == 0)) {
	    if ( dval >= atof(cmax[i]) ) {
	      fprintf(fp,"<li><font color=\"#900000\">Value is >= %s </font>\n",cmax[i]);
	      fprintf(fp,"</ul>\n");
	      return(0);
	    }
	    
	  } else if (cmax[i] == NULL || (strlen(cmax[i]) == 0)) {
	    if ( dval <= atof(cmin[i]) ) {
	      fprintf(fp,"<li><font color=\"#900000\">Value is <= %s </font>\n",cmin[i]);
	      fprintf(fp,"</ul>\n");
	      return(0);
	    }
	  } else {
	    if ( dval >= atof(cmax[i]) && dval <= atof(cmin[i])) {
	      fprintf(fp,"<li><font color=\"#900000\">Value is <= %s OR >= %s</font>\n",cmin[i],cmax[i]);
	      fprintf(fp,"</ul>\n");
	      return(0);
	    }
	  }
	  
	}
      }
    }
    
  } else if (!strcmp(typeCode,"int")) {
    cmin = cb.GetItemRangeMin(item, nMin);
    cmax = cb.GetItemRangeMax(item, nMax);
    ndb_align_string(value);
    ival = atoi(value);
    ndb_log_message_text(NDB_MSG_DEBUG,"integrity check item %s value %s",item,value);  

    if (nMin > 0 && nMin == nMax) {
      iok=0;
      for (i=0; i < nMin; i++) {
	if (cmin[i] == NULL && cmax[i] == NULL) {
	  continue;
	} else if (cmin[i] == NULL || (strlen(cmin[i]) == 0)) {
	  if ( ival < atof(cmax[i]) ) {
	    iok++;
	    break;
	  }

	} else if (cmax[i] == NULL || (strlen(cmax[i]) == 0)) {
	  if ( ival > atof(cmin[i]) ) {
	    iok++;
	    break;
	  }
	} else if (!strcmp(cmin[i],cmax[i])) {
	  if ( ival == atof(cmin[i]) ) {
	    iok++;
	    break;
	  }
	} else {
	  if ( ival < atof(cmax[i]) && dval > atof(cmin[i])) {
	    iok++;
	    break;
	  }
	}
	
      }
      if (iok == 0) {
	for (i=0; i < nMin; i++) {
	  if (cmin[i] == NULL && cmax[i] == NULL) {
	    continue;
	  } else if (cmin[i] == NULL || (strlen(cmin[i]) == 0)) {
	    if ( ival >= atoi(cmax[i]) ) {
	      fprintf(fp,"<li><font color=\"#900000\">Value is >= %s </font>\n",cmax[i]);
	      fprintf(fp,"</ul>\n");
	      return(0);
	    }
	    
	  } else if (cmax[i] == NULL || (strlen(cmax[i]) == 0)) {
	    if ( ival <= atoi(cmin[i]) ) {
	      fprintf(fp,"<li><font color=\"#900000\">Value is <= %s </font>\n",cmin[i]);
	      fprintf(fp,"</ul>\n");
	      return(0);
	    }
	  } else {
	    if ( ival >= atoi(cmax[i]) && dval <= atoi(cmin[i])) {
	      fprintf(fp,"<li><font color=\"#900000\">Value is <= %s OR >= %s</font>\n",cmin[i],cmax[i]);
	      fprintf(fp,"</ul>\n");
	      return(0);
	    }
	  }
	  
	}
      }
    }
  }

  fprintf(fp,"</ul>\n");

  return(1);
}


static int * xGetItemColumnIndices(ISTable *t, ReVarCifArray<CifString>* viewItems) {

  int * ind=NULL;
  ReVarCifArray<CifString>  *items=NULL;
  
  int i,j,k,iok;
  
  if (!t) return ind;
  if ((t->GetName()) == NULL) return ind;
  if ( !viewItems  ||  viewItems->Length() <= 0 ) return ind;

  items = t->GetItemNames();
  if ( !items || items->Length() < viewItems->Length()) return ind;

  ind =   new int[items->Length()];
  k = 0;
  for (i=0; i < viewItems->Length(); i++) {
    for (j=0; j < items->Length(); j++) {
      if (!strcmp((*viewItems)[i].Text(), (*items)[j].Text())) {
	ind[k]=j; 	k++;
	break;
      }
    }
  }

// add items in *t (not in the view) at the end of the index list.

  ndb_log_message_text(NDB_MSG_DEBUG,"INDXX items length %d view items length %d k %d",
		       items->Length(),viewItems->Length(),k);
  if (k == 0) {
    delete ind;
    return NULL;
  }
  if (items->Length() > k) {  
    for (j=0; j < items->Length(); j++) {
      iok = 0;
      for (i=0; i < viewItems->Length(); i++) {
	if (!strcmp((*viewItems)[i].Text(), (*items)[j].Text())) {
	  iok=1;
	  break;
	}
      }
      if (!iok) {
	ind[k] = j; 
	k++;
      }
    }
  }
  if (items) delete items;
  return ind;
}

