/*
FILE:     html-form-util.C
*/
/*
VERSION:  0.904-beta
*/
/*
DATE:     8/14/2003
*/
/*
  Comments and Questions to: sw-help@rcsb.rutgers.edu
*/
/*
COPYRIGHT 1999-2003 Rutgers - The State University of New Jersey

This software is provided WITHOUT WARRANTY OF MERCHANTABILITY OR
FITNESS FOR A PARTICULAR PURPOSE OR ANY OTHER WARRANTY, EXPRESS OR
IMPLIED.  RUTGERS MAKE NO REPRESENTATION OR WARRANTY THAT THE
SOFTWARE WILL NOT INFRINGE ANY PATENT, COPYRIGHT OR OTHER
PROPRIETARY RIGHT.

The user of this software shall indemnify, hold harmless and defend
Rutgers, its governors, trustees, officers, employees, students,
agents and the authors against any and all claims, suits,
losses, liabilities, damages, costs, fees, and expenses including
reasonable attorneys' fees resulting from or arising out of the
use of this software.  This indemnification shall include, but is
not limited to, any and all claims alleging products liability.
*/
/*
               PDB SOFTWARE LICENSE AGREEMENT

BY CLICKING THE ACCEPTANCE BUTTON OR INSTALLING OR USING 
THIS "SOFTWARE, THE INDIVIDUAL OR ENTITY LICENSING THE  
SOFTWARE ("LICENSEE") IS CONSENTING TO BE BOUND BY AND IS 
BECOMING A PARTY TO THIS AGREEMENT.  IF LICENSEE DOES NOT 
AGREE TO ALL OF THE TERMS OF THIS AGREEMENT
THE LICENSEE MUST NOT INSTALL OR USE THE SOFTWARE.

1. LICENSE AGREEMENT

This is a license between you ("Licensee") and the Protein Data Bank (PDB) 
at Rutgers, The State University of New Jersey (hereafter referred to 
as "RUTGERS").   The software is owned by RUTGERS and protected by 
copyright laws, and some elements are protected by laws governing 
trademarks, trade dress and trade secrets, and may be protected by 
patent laws. 

2. LICENSE GRANT

RUTGERS grants you, and you hereby accept, non-exclusive, royalty-free 
perpetual license to install, use, modify, prepare derivative works, 
incorporate into other computer software, and distribute in binary 
and source code format, or any derivative work thereof, together with 
any associated media, printed materials, and on-line or electronic 
documentation (if any) provided by RUTGERS (collectively, the "SOFTWARE"), 
subject to the following terms and conditions: (i) any distribution 
of the SOFTWARE shall bind the receiver to the terms and conditions 
of this Agreement; (ii) any distribution of the SOFTWARE in modified 
form shall clearly state that the SOFTWARE has been modified from 
the version originally obtained from RUTGERS.  

2. COPYRIGHT; RETENTION OF RIGHTS.  

The above license grant is conditioned on the following: (i) you must 
reproduce all copyright notices and other proprietary notices on any 
copies of the SOFTWARE and you must not remove such notices; (ii) in 
the event you compile the SOFTWARE, you will include the copyright 
notice with the binary in such a manner as to allow it to be easily 
viewable; (iii) if you incorporate the SOFTWARE into other code, you 
must provide notice that the code contains the SOFTWARE and include 
a copy of the copyright notices and other proprietary notices.  All 
copies of the SOFTWARE shall be subject to the terms of this Agreement.  

3. NO MAINTENANCE OR SUPPORT; TREATMENT OF ENHANCEMENTS 

RUTGERS is under no obligation whatsoever to: (i) provide maintenance 
or support for the SOFTWARE; or (ii) to notify you of bug fixes, patches, 
or upgrades to the features, functionality or performance of the 
SOFTWARE ("Enhancements") (if any), whether developed by RUTGERS 
or third parties.  If, in its sole discretion, RUTGERS makes an 
Enhancement available to you and RUTGERS does not separately enter 
into a written license agreement with you relating to such bug fix, 
patch or upgrade, then it shall be deemed incorporated into the SOFTWARE 
and subject to this Agreement. You are under no obligation whatsoever 
to provide any Enhancements to RUTGERS or the public that you may 
develop over time; however, if you choose to provide your Enhancements 
to RUTGERS, or if you choose to otherwise publish or distribute your 
Enhancements, in source code form without contemporaneously requiring 
end users or RUTGERS to enter into a separate written license agreement 
for such Enhancements, then you hereby grant RUTGERS a non-exclusive,
royalty-free perpetual license to install, use, modify, prepare
derivative works, incorporate into the SOFTWARE or other computer
software, distribute, and sublicense your Enhancements or derivative
works thereof, in binary and source code form.

4. FEES.  There is no license fee for the SOFTWARE.  If Licensee
wishes to receive the SOFTWARE on media, there may be a small charge
for the media and for shipping and handling.  Licensee is
responsible for any and all taxes.

5. TERMINATION.  Without prejudice to any other rights, Licensor
may terminate this Agreement if Licensee breaches any of its terms
and conditions.  Upon termination, Licensee shall destroy all
copies of the SOFTWARE.

6. PROPRIETARY RIGHTS.  Title, ownership rights, and intellectual
property rights in the Product shall remain with RUTGERS.  Licensee 
acknowledges such ownership and intellectual property rights and will 
not take any action to jeopardize, limit or interfere in any manner 
with RUTGERS' ownership of or rights with respect to the SOFTWARE.  
The SOFTWARE is protected by copyright and other intellectual 
property laws and by international treaties.  Title and related 
rights in the content accessed through the SOFTWARE is the property 
of the applicable content owner and is protected by applicable law.  
The license granted under this Agreement gives Licensee no rights to such
content.

7. DISCLAIMER OF WARRANTY.  THE SOFTWARE IS PROVIDED FREE OF 
CHARGE, AND, THEREFORE, ON AN "AS IS" BASIS, WITHOUT WARRANTY OF 
ANY KIND, INCLUDING WITHOUT LIMITATION THE WARRANTIES THAT IT 
IS FREE OF DEFECTS, MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE 
OR NON-INFRINGING.  THE ENTIRE RISK AS TO THE QUALITY AND 
PERFORMANCE OF THE SOFTWARE IS BORNE BY LICENSEE.  SHOULD THE 
SOFTWARE PROVE DEFECTIVE IN ANY RESPECT, THE LICENSEE AND NOT 
LICENSOR ASSUMES THE ENTIRE COST OF ANY SERVICE AND REPAIR.  
THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF 
THIS AGREEMENT.  NO USE OF THE PRODUCT IS AUTHORIZED HEREUNDER 
EXCEPT UNDER THIS DISCLAIMER.

8. LIMITATION OF LIABILITY.  TO THE MAXIMUM EXTENT PERMITTED BY
APPLICABLE LAW,  IN NO EVENT WILL LICENSOR BE LIABLE FOR ANY 
INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
OUT OF THE USE OF OR INABILITY TO USE THE SOFTWARE, INCLUDING, 
WITHOUT LIMITATION, DAMAGES FOR LOSS OF GOODWILL, WORK 
STOPPAGE, COMPUTER FAILURE OR MALFUNCTION, OR ANY AND ALL 
OTHER COMMERCIAL DAMAGES OR LOSSES, EVEN IF ADVISED OF THE
POSSIBILITY THEREOF. 
*/

#include <iostream.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>
#include <sys/wait.h>


#include "ndb_misclib.h"
#include "interface-defs.h"
#include "ndb_htmllib.h"
#include "interface-lang.h"


#include "CifFileObj.h"
#include "CifViewObj.h"
#include "view-obj-util.h"
#include "html-form-util.h"



#define BGCOLOR_TABLE_TITLE "khaki"
#define BGCOLOR_TABLE       "lightsteelblue"

static int TEXT_WIDTH_TEXT    =  30;
static int TEXT_HEIGHT_TEXT   =  3;
static int TEXT_WIDTH_LINE    =  25;
static int TEXT_WIDTH_CODE    =  6;
static int TEXT_WIDTH_INT     =  6;
static int TEXT_WIDTH_UNKNOWN =  6;
static int TEXT_WIDTH_DATE    =  10;
static int TEXT_WIDTH_TIME    =  16;

//
static int get_item_type_code(const char *typeCode);

static void write_input_item_value(FILE *fp, const char *pName, const char *value, int typeCode);

static void write_input_enum_item_value(FILE *fp, const char *value, const char *pName, const char *pNameAlt,
				  const char **itenum, int nitenum, int allowAlternate);
static void display_category_help(FILE *fp, CifBuilder &cb, const char *category);
static char *get_table_attribute_name(const char *string);
static char **comma_list_to_array(const char *list, int *len);

static int get_additional_rows(const char *category, int defExtra);


static int get_additional_rows(const char *category, int defExtra)
{
  int iExtra;

  iExtra = defExtra;
  if (category != NULL && !strcasecmp(category,"audit_contact_author")) iExtra = 2;
  return(iExtra);
}

#if 0
static int sCompareSortU(const void * a, const void * b)
/* ----------------------------------------------------------------------------
   sCompareSort(): (string compare) is a function used by qsort() to sort an
   array of char *.
   --------------------------------------------------------------------------*/
{
  return strcasecmp(*((char **) a), *((char **) b)); 
}
#else
static int sCompareSortU(const void * a, const void * b)
/* ----------------------------------------------------------------------------
   sCompareSort(): (string compare) is a function used by qsort() to sort an
   array of char *.
   --------------------------------------------------------------------------*/
{
  return strcasecmp(*((char **) b), *((char **) a)); 
}

#endif

static int iCompareSortU(const void * a, const void * b)
/* ----------------------------------------------------------------------------
   iCompareSort(): (string as int compare) is a function used by qsort() to sort an
   array of char * containg integers.
   --------------------------------------------------------------------------*/
{
  int ia, ib;
  ia = atoi(*((char **) a));
  ib = atoi(*((char **) b));
  if (ia > ib)  return(1);
  if (ia < ib)  return(-1);
  if (ia == ib) return(0);

  return strcasecmp(*((char **) a), *((char **) b)); 
}


static char **get_sorted_enumeration_list(CifBuilder &cb, const char *sItem, uWord &nitenum) {

  char **itenum = NULL;
  int i, isNum, num;
  itenum = cb.GetItemEnumerationNDB(sItem,nitenum);
  if (nitenum == 0 && itenum == NULL)  itenum = cb.GetItemEnumeration(sItem,nitenum);

  if (itenum != NULL && nitenum > 0 && itenum[0] != NULL) {
    num = nitenum;
    isNum = 1;  
    for (i=0; i < strlen(itenum[0]); i++) {
      if ( !isdigit(itenum[0][i]) ) {
	isNum = 0;
	break;
      }
    }
    if (isNum == 0) qsort(itenum, num, sizeof(char *), sCompareSortU);
    if (isNum == 1) qsort(itenum, num, sizeof(char *), iCompareSortU);
  }
  return itenum;
}

static void display_category_help(FILE *fp, CifBuilder &cb, const char *category) {
  char * helpMessage = NULL;
  helpMessage =  cb.GetCategoryDescriptionNDB(category);
  if (helpMessage == NULL) helpMessage =  cb.GetCategoryDescription(category);
  ndb_log_message_text(NDB_MSG_DEBUG,"Help message is %s",helpMessage);
  display_category_help_message(fp,helpMessage);
  if (helpMessage) delete helpMessage;
}



void write_category_form_t0_S1(FILE *fp, CifBuilder &cb,  const char *blockId, const char *category,  
			       const char *categoryViewName,  
			       const char *ufid, 
			       const char **values, int rowCurrent, 
			       const CIFVIEWOBJITEM *itemList, int nitemsView,
			       int nCols)
/*
 *  Display a single row of a category with columns arranged as a vertical list.
 */
{
  int  i, j, k;
  char   *sItem=NULL;
  char ***itenum=NULL;
  uWord *nitenum=NULL;
  char *typeCode=NULL;
  int *iTypeCode=NULL;

  char pName[CIF_MAX_NAME_LENGTH];
  char pNameAlt[CIF_MAX_NAME_LENGTH];
   
  fprintf(fp,"<HTML>\n");
  fprintf(fp,"%s\n",LANG_HTML_BODY_SCHEME_ALT_2);
  fprintf(fp,"<center><font face=\"%s\" size=5>%s</font>",LANG_HTML_FONT_FACE,LANG_ENTER_DATA_TITLE);

  fprintf(fp,"<font size=5 color=\"#900000\"> %s</font></center>",categoryViewName);


  //
  //       Category help is displayed at the top of the display ...
  //
  display_category_help(fp, cb, category);


  fprintf(fp,"<FORM METHOD=\"POST\" ACTION=\"%s%s%s\" TARGET=\"other\">\n",
	  HT_SERVER_NAME,
	  HT_CGI_PATH,
	  HT_INTERFACE_READ_FORM_CATEGORY);
  
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_UNIQUE_ID, ufid);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_CATEGORY_ID,category);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_DATABLOCK_ID,blockId);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_NUM_ITEMS,nCols);  
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_ROW_ID,rowCurrent);  
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_NUM_ROWS,1);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_FORM_LAYOUT,6);

  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY);

  fprintf(fp,"<center><font size=4 color=\"#900000\"><INPUT TYPE=SUBMIT VALUE=\"Save %s\"></font></center>",
	  categoryViewName);

  nitenum    = (uWord *)  calloc(nCols, sizeof(int));
  itenum     = (char ***) calloc(nCols, sizeof(char **));
  iTypeCode  = (int *)    calloc(nCols, sizeof(int));

  for (k=0; k < nCols; k++) {
    sItem = get_dictionary_item_name(cb,itemList[k].item);
    if (sItem == NULL) continue;

    nitenum[k] = 0;
    itenum[k]=get_sorted_enumeration_list(cb,sItem, nitenum[k]);

    typeCode = cb.GetItemType(sItem);
    iTypeCode[k]=get_item_type_code(typeCode);
    ndb_log_message_text(NDB_MSG_DEBUG,"Item %s enumerates %d type %s type code %d",			
			 sItem,nitenum[k], typeCode, iTypeCode[k]);
    if (sItem) free(sItem);
    if (typeCode) free(typeCode);
  }

  fprintf(fp,"<center>");
  fprintf(fp,"<br><br>");
  fprintf(fp,"<table cellpadding=4 border bgcolor=\"%s\">",BGCOLOR_TABLE);
  fprintf(fp,"<tr><th colspan=5 bgcolor=\"%s\"><font size=4 color=\"#000000\"><b>%s</b></font></th></tr>\n",
	  BGCOLOR_TABLE_TITLE,categoryViewName);

  for (k=0; k < nCols; k++) {
    if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;

    fprintf(fp,"<tr>\n");
    // Column Name  ... 
    
    switch(itemList[k].mandatoryCode) {
    case VIEW_ITEM_IS_MANDATORY:
      fprintf(fp,"<td><FONT SIZE=3 COLOR=\"#900000\"><b>%s</b></FONT></td>\n",
	      get_table_attribute_name(itemList[k].viewName));
      break;
    case VIEW_ITEM_IS_NOT_MANDATORY:
      fprintf(fp,"<td><FONT SIZE=3><b>%s</b></FONT></td>\n",
	      get_table_attribute_name(itemList[k].viewName));
      
      break;
    }

    // Help,  Definitions, Examples ... 

    fprintf(fp,"<td><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>\n",
	    HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_HELP_VIEW,
	    HT_ATTRIBUTE_UNIQUE_ID,ufid,
	    HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
	    HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
	    HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
	    HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_HELP);
    
    fprintf(fp,"<td><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>\n",
	    HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_EXAMPLES_VIEW,
	    HT_ATTRIBUTE_UNIQUE_ID,ufid,
	    HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
	    HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
	    HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
	    HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_EXAMPLES);
    
    
    encode_table_param_name(pName,0,k,0);
    encode_table_param_name(pNameAlt,0,k,1);      
    
    fprintf(fp,"<td>");
    if (nitenum[k] == 0) { // Enumerated, No ...

      write_input_item_value(fp, pName, values[k], iTypeCode[k]);
    } else {  // Enumerated, Yes ... 

      write_input_enum_item_value(fp, values[k], pName, pNameAlt, (const char **) itenum[k], nitenum[k], 
			    itemList[k].allowAlternateCode);
    }
    fprintf(fp,"</td></tr>");
  }
  fprintf(fp,"</table><br><br>");

  // Hide items not in view ... 

  for (k=0; k < nCols; k++) {
    if (itemList[k].mandatoryCode != VIEW_ITEM_IS_HIDDEN) continue;
    encode_table_param_name(pName,0,k,0);    
    fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",pName,values[k]);    
  }
  
  fprintf(fp,"</center>");
  
  fprintf(fp,"<center><font size=4 color=\"#900000\"><INPUT TYPE=SUBMIT VALUE=\"Save %s\"></font></center>",
	  categoryViewName);
  
  fprintf(fp,"</FORM>\n");
  
  fprintf(fp,"</BODY>\n");
  fprintf(fp,"</HTML>\n");

  //
  // clean-up  
  //
  for (i=0; i < nCols; i++) {
    for (j=1; j < nitenum[i]; j++){
      if (itenum[i][j] != NULL) free(itenum[i][j]);
    }
    if (itenum[i] != NULL) free(itenum[i]);
  }
  if (nitenum != NULL )  free(nitenum); 


   if (iTypeCode != NULL )  free(iTypeCode);
}

static int get_item_type_code(const char *typeCode) {

  int iTypeCode;
  if (typeCode == NULL) {
    iTypeCode=VIEW_TYPE_UNKNOWN;
  } else if (!strcasecmp(typeCode,"text") ) {
    iTypeCode=VIEW_TYPE_TEXT;
  } else if (!strcasecmp(typeCode,"line") ) {
    iTypeCode=VIEW_TYPE_LINE;
  } else if (!strcasecmp(typeCode,"code") ) {
    iTypeCode=VIEW_TYPE_CODE;
  } else if (!strcasecmp(typeCode,"float") ) {
    iTypeCode=VIEW_TYPE_FLOAT;
  } else if (!strcasecmp(typeCode,"int") ) {
    iTypeCode=VIEW_TYPE_INT;
  } else if (!strcasecmp(typeCode,"yyyy-mm-dd:hh:mm") ) {
    iTypeCode=VIEW_TYPE_TIME;
  } else if (!strncasecmp(typeCode,"yyyy-mm-dd",10) ) {
    iTypeCode=VIEW_TYPE_DATE;
  } else {
    iTypeCode=VIEW_TYPE_UNKNOWN;
  }
  return(iTypeCode);
  
}


static void write_input_item_value(FILE *fp, const char *pName, const char *iValue, int typeCode) {

  char *value;
  char *blank = "";

  if (iValue == NULL || ((strlen(iValue) == 1) && (iValue[0] == '?')) )
    value = blank;
  else
    value = (char *) iValue;

  switch (typeCode) {
  case VIEW_TYPE_TEXT:
    fprintf(fp,"<TEXTAREA NAME=\"%s\" COLS=%d ROWS=%d>%s</TEXTAREA>\n",
	    pName,
	    TEXT_WIDTH_TEXT,
	    TEXT_HEIGHT_TEXT,
	    value);
    break;
  case VIEW_TYPE_LINE:
    fprintf(fp,"<INPUT ALIGN=LEFT TYPE=TEXT NAME=\"%s\" SIZE=%d VALUE=\"%s\">\n",
	    pName,
	    TEXT_WIDTH_LINE,
	    value);
    break;
  case VIEW_TYPE_CODE:
    fprintf(fp,"<INPUT ALIGN=LEFT TYPE=TEXT NAME=\"%s\" SIZE=%d VALUE=\"%s\">\n",
	    pName,
	    TEXT_WIDTH_CODE,
	    value);
    break;
  case VIEW_TYPE_FLOAT:
  case VIEW_TYPE_INT:
    fprintf(fp,"<INPUT ALIGN=LEFT TYPE=TEXT NAME=\"%s\" SIZE=%d VALUE=\"%s\">\n",
	    pName,
	    TEXT_WIDTH_INT,
	    value);
    break;
  case VIEW_TYPE_DATE:
    fprintf(fp,"<INPUT ALIGN=LEFT TYPE=TEXT NAME=\"%s\" SIZE=%d VALUE=\"%s\">\n",
	    pName,
	    TEXT_WIDTH_DATE,
	    value);
    break;
  case VIEW_TYPE_TIME:
    fprintf(fp,"<INPUT ALIGN=LEFT TYPE=TEXT NAME=\"%s\" SIZE=%d VALUE=\"%s\">\n",
	    pName,
	    TEXT_WIDTH_TIME,
	    value);
    break;
  case VIEW_TYPE_UNKNOWN:
    fprintf(fp,"<INPUT ALIGN=LEFT TYPE=TEXT NAME=\"%s\" SIZE=%d VALUE=\"%s\">\n",
	    pName,
	    TEXT_WIDTH_UNKNOWN,
	    value);
    break;
    
  }
}

static char **comma_list_to_array(const char *list, int *len)
{
  
  int i, num, n;
  char **array = NULL;
  char * buf = NULL, *p = NULL;
  *len = 0;

  if ((list == NULL) || (strlen(list) == 0)) return(array);

  num = 0;
  for (i=0; i < strlen(list); i++) {
    if (list[i] == ',') num++;
  }
  // ndb_log_message_text(NDB_MSG_DEBUG,"Separators  = %d",num);

  array = (char **) calloc(num+2, sizeof(char *));
  buf = (char *) calloc(strlen(list) + 1, sizeof(char));
  strcpy(buf,list);

  p = strtok(buf,",");
  n = 0;
  while (p != NULL && n < num+1) {
    array[n]  = (char *) calloc(strlen(p) + 1, sizeof(char));
    strcpy(array[n],p);
    //ndb_log_message_text(NDB_MSG_DEBUG,"List element %d of %d is  %s", n,num, array[n]);
    n++;
    p = strtok(NULL,",");
  }
  *len = n;
  return(array);
}

static void write_input_enum_item_value(FILE *fp, const char *value, const char *pName, 
					const char *pNameAlt, 
					const char **itenum, int nitenum, int allowAlternate) {
  int m, isOn, eLen, il, k;

  char ** array = NULL, *buf = NULL;
  int aLen, *isOnA;

  //  ndb_log_message_text(NDB_MSG_DEBUG,"write_input_enum_item_value: allowAlternate %d", allowAlternate);

  if (allowAlternate == VOBJ_ENUM_MULTI || allowAlternate == VOBJ_ENUM_MULTI_STRICT) {
    //    ndb_log_message_text(NDB_MSG_DEBUG,"value is %s", value);

    array = comma_list_to_array(value, &aLen);
    isOnA = (int *) calloc(aLen+1,sizeof(int));
    for (k=0; k < aLen; k++) {
      isOnA[k] = 0;
      //       ndb_log_message_text(NDB_MSG_DEBUG,"List element [%d] %s", k, array[k]);
    }
    
    fprintf(fp,"<FONT SIZE=2><SELECT MULTIPLE SIZE=4 NAME=\"%s\" >\n",pName);
    eLen = 0;    
    for (m=0; m < nitenum; m++){
      il = strlen(itenum[m]); if (il > eLen) eLen = il;
      isOn = 0;
      for (k=0; k < aLen; k++) {
	if (!strcasecmp(array[k],itenum[m])) {
	  isOn = 1; isOnA[k]= 1; break;
	}
      }
      if (isOn) {
	fprintf(fp,"<OPTION SELECTED VALUE=\"%s\">%s",itenum[m],itenum[m]);
      } else {
	fprintf(fp,"<OPTION VALUE=\"%s\">%s",itenum[m],itenum[m]);
      }
    }     
    fprintf(fp,"</SELECT></FONT>\n");

    if (allowAlternate == VOBJ_ENUM_MULTI) {
      eLen+=2;
      if (eLen>30) eLen=30;
      buf = (char *) calloc(strlen(value) + 1, sizeof(char));
      strcpy(buf,"");
      for (k=0; k < aLen; k++) {
	if (! isOnA[k] ) {
	  strcat(buf,array[k]);
	  strcat(buf,",");
	}
      }
      
      il = strlen(buf); 
      if (!il || (il == 1 && buf[0] == '?')) {
	fprintf(fp,"<br><b>If Other:</b> <FONT SIZE=3><INPUT TYPE=TEXT NAME=\"%s\" SIZE=%d VALUE=\"%s\"></FONT>\n",
		pNameAlt,eLen,"");
      } else {
	buf[il-1] = '\0';
	if (eLen < il) eLen = il;
	if (eLen > 30) eLen = 30;
	fprintf(fp,"<br><b>If Other:</b> <FONT SIZE=3><INPUT TYPE=TEXT NAME=\"%s\" SIZE=%d VALUE=\"%s\"></FONT>\n",
		pNameAlt,eLen,buf);
      }
    }


  } else {
    
    fprintf(fp,"<FONT SIZE=2><SELECT NAME=\"%s\" >\n",pName);
    
    // is the value on the current enum list?
    isOn=0;
    eLen = 0;
    for (m=0; m < nitenum; m++){
      il = strlen(itenum[m]); if (il > eLen) eLen = il;
      if (!strcasecmp(value,itenum[m])) {
	isOn =1; break;
      }
    }
    if (isOn) {
      fprintf(fp,"<OPTION SELECTED VALUE=\"%s\">%s",value,value);
      for (m=0; m < nitenum; m++){
	if (!strcasecmp(value,itenum[m])) {
	} else {
	  fprintf(fp,"<OPTION VALUE=\"%s\">%s",itenum[m],itenum[m]);
	}
      }
      if (strcmp(value,"?")) fprintf(fp,"<OPTION VALUE=\"?\">?"); // add placeholder
      fprintf(fp,"</SELECT></FONT>\n");
    } else {
      fprintf(fp,"<OPTION SELECTED VALUE=\"?\">?");
      for (m=0; m < nitenum; m++){
	fprintf(fp,"<OPTION VALUE=\"%s\">%s",itenum[m],itenum[m]);
      }
      fprintf(fp,"</SELECT></FONT>\n");
    }
    
    if (allowAlternate == VOBJ_ENUM_SINGLE) {
      eLen+=2;
      if (eLen>30) eLen=30;

      if (isOn || !strcmp(value,"?")) {
	fprintf(fp,"<br><b>If Other:</b> <FONT SIZE=3><INPUT TYPE=TEXT NAME=\"%s\" SIZE=%d VALUE=\"%s\"></FONT>\n",
		pNameAlt,eLen,"");
      } else {
        eLen = strlen(value);
	if (eLen>30) eLen=30;
	fprintf(fp,"<br><b>If Other:</b> <FONT SIZE=3><INPUT TYPE=TEXT NAME=\"%s\" SIZE=%d VALUE=\"%s\"></FONT>\n",
		pNameAlt,eLen,value);
      }
    }
    
  }
}



void make_category_form_from_view_t6(CifViewObj *vobj, CifBuilder &cb, CifFileObj * fobj, 
					    const char *dirPath, const char *blockId, const char *category,
					    const char *ufid, int istyle) 
  /* ****************************************************************************
   *   Build memory model for category display format T6
   * 
   *   
   *  Simple table display... 
   *
   *   istyle = 1:
   *     Builds a single table with column names and help displayed 
   *     horizontally at the top of the table.
   */
{
  char ***values=NULL;
  ISTable * t = NULL; 
  CIFVIEWOBJITEM *itemList;
  
  ReVarCifArray<CifString> *row = NULL, *colNamesView = NULL;
  int *ind=NULL;
  int maxRows=0, iExtra=5;
  int nCols = 0, nRows = 0,  i, j, k, irow, nColsView=0;


  FILE *fp=NULL;
  char fName[HT_MAX_NAME_LENGTH];

  ndb_log_message_text(NDB_MSG_DEBUG,"make_category_form_from_view_t6: Entering");

  t=fobj->GetTablePtr(blockId,category);
  if (t != NULL) 
    itemList = build_item_obj_list_w_table(vobj, category, &nColsView, t);
  else
    itemList = build_item_obj_list(vobj, category, &nColsView);

  ndb_log_message_text(NDB_MSG_DEBUG,"make_category_form_from_view_t6: view category %s has %d columns",
		       category,nColsView);

  iExtra = get_additional_rows(category, iExtra);

  if ( t != NULL) {
    nCols = t->GetNumColumns();
    nRows = t->GetNumRows();
    ndb_log_message_text(NDB_MSG_DEBUG,"Found existing table %s with %d rows and %d columns",
			 category,nRows, nCols);
    maxRows = nRows + iExtra;
    values = (char ***) calloc(maxRows,sizeof(char **));
    for (i=0; i < nRows; i++) { // allocate the rows of the category
      values[i] = (char **) calloc(nCols,sizeof(char *));
    }
    colNamesView = vobj->GetCategoryItems(category);
    ind = vobj->GetItemColumnIndices(t,colNamesView);
    
    for (j=0; j < nRows; j++) {
      ndb_log_message_text(NDB_MSG_DEBUG,"Getting row %d ",j);

      row=t->GetRow(j);
      //      if (row != NULL) {
      irow=j;
      for (k=0; k < nCols; k++) {  // Note:  Full column width of data loaded in values[][]
	ndb_log_message_text(NDB_MSG_DEBUG,"Fetching column %d index %d length %d",
			     k, ind[k],(*row)[ind[k]].Length());
	if ((*row)[ind[k]].Length() > 0 ) {
	  values[irow][k] = (char *) calloc(((*row)[ind[k]].Length()+1),sizeof(char));
	  strcpy(values[irow][k],(*row)[ind[k]].Text());
	} else {
	  values[irow][k] = (char *) calloc(2,sizeof(char));
	  strcpy(values[irow][k],"?");
	}
      }
      if (row) { 
	delete row;
	row = NULL;
      }
      //      }
    }
    for (j=nRows; j < maxRows; j++) {
      ndb_log_message_text(NDB_MSG_DEBUG,"Adding blank row %d",j);
      values[j] = get_blank_row_with_defaults(cb, itemList, nColsView,nCols);
    }

  } else {

    nRows = maxRows = 5;
    nCols = nColsView;
    ndb_log_message_text(NDB_MSG_DEBUG,"Creating table %s with %d rows and %d columns",
			 category,nRows, nCols);
    values = (char ***) calloc(nRows,sizeof(char **));
    for (i=0; i < nRows; i++) { // allocate the rows of the category
      values[i] = (char **) calloc(nCols,sizeof(char *));
    }

    for (j=0; j < nRows; j++) {
      values[j] = get_blank_row_with_defaults(cb, itemList, nColsView,nCols);
    }
  }

  //
  //    Write the form elements to stdout and to the cache file...
  //


  CifString * categoryViewName = vobj->GetViewCategory(category);
  ndb_log_message_text(NDB_MSG_DEBUG,"Creating table %s form view name %s", category,categoryViewName->Text());

  ht_put_content_type_target(stdout,"item");

  switch (istyle) {
  case 1:
    write_category_form_t6_S1(stdout, cb, blockId, category, categoryViewName->Text(), ufid, 
			      (const char ***)values, itemList, nColsView,  maxRows, nCols);
    break;
  case 0:
  default:
    write_category_form_t6(stdout, cb, blockId, category, categoryViewName->Text(), ufid, 
			   (const char ***)values, itemList, nColsView,  maxRows, nCols);
    break;
  }
  
  strcpy(fName,dirPath);
  strcat(fName,HT_ITEM_LIST_NAME);
  fp = fopen(fName,"w");

  switch (istyle) {
  case 1:
    write_category_form_t6_S1(fp, cb, blockId, category, categoryViewName->Text(), ufid, 
			      (const char ***)values, itemList, nColsView, maxRows, nCols);
    break;
  case 0:
  default:
    write_category_form_t6(fp, cb, blockId, category, categoryViewName->Text(), ufid, 
			   (const char ***)values, itemList, nColsView, maxRows, nCols);
    break;
  }

  fclose(fp);
  
}

void make_category_form_from_view_t6b(CifViewObj *vobj, CifBuilder &cb, CifFileObj * fobj, 
				      const char *dirPath, const char *blockId, const char *category,
				      const char *ufid, int istyle, int iColBlank) 
  /* ****************************************************************************
   *   Build memory model for category display format T6
   * 
   *   
   *  Simple table display... 
   *
   *   istyle = 1:
   *     Builds a single table with column names and help displayed 
   *     horizontally at the top of the table.
   *
   *  jdw = This version filters blank rows from display...
   *        if cols >= iColBlank are null the row is filtered.
   */
{
  char ***values=NULL;
  ISTable * t = NULL; 
  CIFVIEWOBJITEM *itemList;
  
  ReVarCifArray<CifString> *row = NULL, *colNamesView = NULL;
  int *ind=NULL;
  int maxRows=0, iExtra=5;
  int nCols = 0, nRows = 0,  i, j, k, irow, nColsView=0, iBlank;


  FILE *fp=NULL;
  char fName[HT_MAX_NAME_LENGTH];

  ndb_log_message_text(NDB_MSG_DEBUG,"make_category_form_from_view_t6: Entering");

  t=fobj->GetTablePtr(blockId,category);
  if (t != NULL) 
    itemList = build_item_obj_list_w_table(vobj, category, &nColsView, t);
  else
    itemList = build_item_obj_list(vobj, category, &nColsView);

  ndb_log_message_text(NDB_MSG_DEBUG,"make_category_form_from_view_t6: view category %s has %d columns",
		       category,nColsView);

  iExtra = get_additional_rows(category, iExtra);

  if ( t != NULL) {
    nCols = t->GetNumColumns();
    nRows = t->GetNumRows();
    ndb_log_message_text(NDB_MSG_DEBUG,"Found existing table %s with %d rows and %d columns",
			 category,nRows, nCols);
    maxRows = nRows + iExtra;
    values = (char ***) calloc(maxRows,sizeof(char **));
    for (i=0; i <  maxRows; i++) { // allocate the maxRowsof the category
      values[i] = (char **) calloc(nCols,sizeof(char *));
    }
    colNamesView = vobj->GetCategoryItems(category);
    ind = vobj->GetItemColumnIndices(t,colNamesView);
    irow=0;
    for (j=0; j < nRows; j++) {
      row=t->GetRow(j);

      iBlank = 1;
      for (k=iColBlank; k < nCols; k++) {
	if (((*row)[ind[k]].Length() > 0) && strcmp((*row)[ind[k]].Text(),"?") &&
					     strcmp((*row)[ind[k]].Text(),".") ) {
	  iBlank = 0;
	  break;
	}
      }
      if (iBlank) continue;

      for (k=0; k < nCols; k++) {  // Note:  Full column width of data loaded in values[][]
	ndb_log_message_text(NDB_MSG_DEBUG,"Fetching column %d index %d length %d",
			     k, ind[k],(*row)[ind[k]].Length());
	if ((*row)[ind[k]].Length() > 0 ) {
	  values[irow][k] = (char *) calloc(((*row)[ind[k]].Length()+1),sizeof(char));
	  strcpy(values[irow][k],(*row)[ind[k]].Text());
	} else {
	  values[irow][k] = (char *) calloc(2,sizeof(char));
	  strcpy(values[irow][k],"?");
	}
      }
      irow++;
      if (row) delete row;
    }

    for (j=irow; j < irow+iExtra; j++) {
      ndb_log_message_text(NDB_MSG_DEBUG,"Adding blank row %d",j);
      values[j] = get_blank_row_with_defaults(cb, itemList, nColsView,nCols);
    }
    nRows = irow + iExtra;

  } else {

    nRows = maxRows = 5;
    nCols = nColsView;
    ndb_log_message_text(NDB_MSG_DEBUG,"Creating table %s with %d rows and %d columns",
			 category,nRows, nCols);
    values = (char ***) calloc(nRows,sizeof(char **));
    for (i=0; i < nRows; i++) { // allocate the rows of the category
      values[i] = (char **) calloc(nCols,sizeof(char *));
    }

    for (j=0; j < nRows; j++) {
      values[j] = get_blank_row_with_defaults(cb, itemList, nColsView,nCols);
    }
  }

  //
  //    Write the form elements to stdout and to the cache file...
  //


  CifString * categoryViewName = vobj->GetViewCategory(category);
  ndb_log_message_text(NDB_MSG_DEBUG,"Creating table %s form view name %s", category,categoryViewName->Text());

  ht_put_content_type_target(stdout,"item");

  switch (istyle) {
  case 1:
    write_category_form_t6_S1(stdout, cb, blockId, category, categoryViewName->Text(), ufid, 
			      (const char ***)values, itemList, nColsView,  nRows, nCols);
    break;
  case 0:
  default:
    write_category_form_t6(stdout, cb, blockId, category, categoryViewName->Text(), ufid, 
			   (const char ***)values, itemList, nColsView,  nRows, nCols);
    break;
  }
  
  strcpy(fName,dirPath);
  strcat(fName,HT_ITEM_LIST_NAME);
  fp = fopen(fName,"w");

  switch (istyle) {
  case 1:
    write_category_form_t6_S1(fp, cb, blockId, category, categoryViewName->Text(), ufid, 
			      (const char ***)values, itemList, nColsView, nRows, nCols);
    break;
  case 0:
  default:
    write_category_form_t6(fp, cb, blockId, category, categoryViewName->Text(), ufid, 
			   (const char ***)values, itemList, nColsView, nRows, nCols);
    break;
  }

  fclose(fp);
  
}


void write_category_form_t6_S1(FILE *fp, CifBuilder &cb,  const char *blockId, const char *category,  
			       const char *categoryViewName,  
			       const char *ufid, 
			       const char ***values, 
			       const CIFVIEWOBJITEM *itemList, int nitemsView,
			       int nRows, int nCols)
  /*   
   *     Displays a single table with column names and help displayed 
   *     horizontally at the top of the table.
   */
{
  int  i, j, k, irow, numView;
  char   *sItem=NULL;
  char ***itenum=NULL;
  uWord *nitenum=NULL;
  char *typeCode=NULL;
  int *iTypeCode=NULL;

  char pName[CIF_MAX_NAME_LENGTH];
  char pNameAlt[CIF_MAX_NAME_LENGTH];

   
  fprintf(fp,"<HTML>\n");

  fprintf(fp,"%s\n",LANG_HTML_BODY_SCHEME_ALT_2);
  fprintf(fp,"<center><font face=\"%s\" size=5>%s</font>",LANG_HTML_FONT_FACE,LANG_ENTER_DATA_TITLE);


  fprintf(fp,"<font size=5 color=\"#900000\"> %s</font></center>",categoryViewName);

  //
  //       Category help is displayed at the top of the display ...
  //
  display_category_help(fp, cb, category);

  fprintf(fp,"<FORM METHOD=\"POST\" ACTION=\"%s%s%s\" TARGET=\"other\">\n",
	  HT_SERVER_NAME,
	  HT_CGI_PATH,
	  HT_INTERFACE_READ_FORM_CATEGORY);
  
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_UNIQUE_ID, ufid);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_CATEGORY_ID,category);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_DATABLOCK_ID,blockId);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_NUM_ITEMS,nCols);  
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_NUM_ROWS,nRows);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_FORM_LAYOUT,6);

  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY);

  fprintf(fp,"<center><font size=4 color=\"#900000\"><INPUT TYPE=SUBMIT VALUE=\"Save %s\"></font></center>",
	  categoryViewName);

  nitenum    = (uWord *)  calloc(nCols, sizeof(int));
  itenum     = (char ***)calloc(nCols, sizeof(char **));
  iTypeCode = (int *)  calloc(nCols, sizeof(int));



  for (k=0; k < nCols; k++) {
    nitenum[k] = 0;
    iTypeCode[k]=VIEW_TYPE_UNKNOWN;
    sItem = get_dictionary_item_name(cb,itemList[k].item);
    if (sItem == NULL) continue;
    itenum[k]=get_sorted_enumeration_list(cb,sItem, nitenum[k]);

    typeCode = cb.GetItemType(sItem);
    iTypeCode[k]=get_item_type_code(typeCode);
    ndb_log_message_text(NDB_MSG_DEBUG,"Item %s enumerates %d type %s type code %d",			
			 sItem,nitenum[k], typeCode, iTypeCode[k]);

    if (sItem) free(sItem);
    if (typeCode) free(typeCode);
  }

  numView=0;
  for (k=0; k < nitemsView; k++) {
    if (itemList[k].mandatoryCode != VIEW_ITEM_IS_HIDDEN) numView++;
  }


  for (j=0; j < nRows; j++) {
    irow = j;
    ndb_log_message_text(NDB_MSG_DEBUG,"starting row %d",j);
    if (j==0) {
      fprintf(fp,"<br><br>");
      fprintf(fp,"<center>");
      fprintf(fp,"<table cellpadding=4 border bgcolor=\"%s\">",BGCOLOR_TABLE);
      fprintf(fp,"<tr><th colspan=%d bgcolor=\"%s\"><font size=4 color=\"#000000\">%s</th></tr>",
	      numView*2,BGCOLOR_TABLE_TITLE,categoryViewName);
      
      
      fprintf(fp,"<tr>");
      for (k=0; k < nCols; k++) { //
	if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;
	switch(itemList[k].mandatoryCode) {
	  
	case VIEW_ITEM_IS_MANDATORY:
	  fprintf(fp,"<th colspan=2 bgcolor=\"%s\"><FONT SIZE=3 COLOR=\"#900000\"><b>%s</b></FONT></th>",
		  BGCOLOR_TABLE_TITLE,get_table_attribute_name(itemList[k].viewName));
	  break;
	case VIEW_ITEM_IS_NOT_MANDATORY:
	  fprintf(fp,"<th colspan=2 bgcolor=\"%s\"><FONT SIZE=3><b>%s</b></FONT></th>\n",
		  BGCOLOR_TABLE_TITLE,get_table_attribute_name(itemList[k].viewName));
	  
	  break;
	}
      }
      fprintf(fp,"</tr>");
      
      fprintf(fp,"<tr>");

      for (k=0; k < nCols; k++) {
	  if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;
	  fprintf(fp,"<td align=center><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>\n",
		  HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_HELP_VIEW,
		  HT_ATTRIBUTE_UNIQUE_ID,ufid,
		  HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
		  HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
		  HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
		  HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_HELP);
	  
	  
	  fprintf(fp,"<td align=center><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>",
		  HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_EXAMPLES_VIEW,
		  HT_ATTRIBUTE_UNIQUE_ID,ufid,
		  HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
		  HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
		  HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
		  HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_EXAMPLES);
      }
      fprintf(fp,"</tr>");
      ndb_log_message_text(NDB_MSG_DEBUG,"help header done");
    }
    fprintf(fp,"<tr>");

    for (k=0; k < nCols; k++) {
      ndb_log_message_text(NDB_MSG_DEBUG,"value at row %d col %d  is %s",irow,k,values[j][k]);
      encode_table_param_name(pName,irow,k,0);
      encode_table_param_name(pNameAlt,irow,k,1);      

      if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;
      fprintf(fp,"<td colspan=2>");

      if (nitenum[k] == 0) { // Enumerated, No ...
	
	write_input_item_value(fp, pName, values[irow][k], iTypeCode[k]);
      } else {  // Enumerated, Yes ... 
	
	write_input_enum_item_value(fp, values[irow][k], pName, pNameAlt, (const char **)itenum[k], nitenum[k], 
				    itemList[k].allowAlternateCode);
      }
      fprintf(fp,"</td>");
    }
    fprintf(fp,"</tr>");
  }
  fprintf(fp,"</table><br><br>");

  // Add hidden values ... 

  for (j=0; j < nRows; j++) { // Fill in data values for missing columns ... 
    irow = j;
    for (k=0; k < nCols; k++) {
      encode_table_param_name(pName,irow,k,0);
      if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) {
	fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",pName,values[irow][k]);
      }
    }
  }
  
  fprintf(fp,"</center>");
  
  fprintf(fp,"<center><font size=4 color=\"#900000\"><INPUT TYPE=SUBMIT VALUE=\"Save %s\"></font></center>",
	  categoryViewName);
  
  fprintf(fp,"</FORM>\n");
  fprintf(fp,"</BODY>\n");
  fprintf(fp,"</HTML>\n");
  
  for (i=0; i < nCols; i++) {
    for (j=1; j < nitenum[i]; j++){
      if (itenum[i][j] != NULL) free(itenum[i][j]);
    }
    if (itenum[i] != NULL) free(itenum[i]);
  }

  if (nitenum != NULL )  free(nitenum);
  if (iTypeCode != NULL )  free(iTypeCode);
}


void write_category_form_t6(FILE *fp, CifBuilder &cb,  const char *blockId, const char *category,  
			       const char *categoryViewName,  
				    const char *ufid, 
				    const char ***values, 
				    const CIFVIEWOBJITEM *itemList, int nitemsView,
				    int nRows, int nCols)
  /*   
   *     Displays a single table with column names and help displayed 
   *     horizontally at the top of the table.
   */
{
  int  i, j, k, irow, numView;
  char   *sItem=NULL;
  char ***itenum=NULL;
  uWord *nitenum=NULL;
  char *typeCode=NULL;
  int *iTypeCode=NULL;

  char pName[CIF_MAX_NAME_LENGTH];
  char pNameAlt[CIF_MAX_NAME_LENGTH];

   
  fprintf(fp,"<HTML>\n");

  fprintf(fp,"%s\n",LANG_HTML_BODY_SCHEME_ALT_2);
  fprintf(fp,"<center><font face=\"%s\" size=5>%s</font>",LANG_HTML_FONT_FACE,LANG_ENTER_DATA_TITLE);


  fprintf(fp,"<font size=5 color=\"#900000\"> %s</font></center>",categoryViewName);

  //
  //       Category help is displayed at the top of the display ...
  //
  display_category_help(fp, cb, category);


  fprintf(fp,"<FORM METHOD=\"POST\" ACTION=\"%s%s%s\" TARGET=\"other\">\n",
	  HT_SERVER_NAME,
	  HT_CGI_PATH,
	  HT_INTERFACE_READ_FORM_CATEGORY);
  
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_UNIQUE_ID, ufid);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_CATEGORY_ID,category);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_DATABLOCK_ID,blockId);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_NUM_ITEMS,nCols);  
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_NUM_ROWS,nRows);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_FORM_LAYOUT,6);

  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY);




  fprintf(fp,"<center><font size=4 color=\"#900000\"><INPUT TYPE=SUBMIT VALUE=\"Save %s\"></font></center>",
	  categoryViewName);

  nitenum    = (uWord *)  calloc(nCols, sizeof(int));
  itenum     = (char ***)calloc(nCols, sizeof(char **));
  iTypeCode = (int *)  calloc(nCols, sizeof(int));



  for (k=0; k < nCols; k++) {
    nitenum[k] = 0;
    iTypeCode[k]=VIEW_TYPE_UNKNOWN;
    sItem = get_dictionary_item_name(cb,itemList[k].item);
    if (sItem == NULL) continue;
    itenum[k]=get_sorted_enumeration_list(cb,sItem, nitenum[k]);
    typeCode = cb.GetItemType(sItem);
    iTypeCode[k]=get_item_type_code(typeCode);
    ndb_log_message_text(NDB_MSG_DEBUG,"Item %s enumerates %d type %s type code %d",			
			 sItem,nitenum[k], typeCode, iTypeCode[k]);

    if (sItem) free(sItem);
    if (typeCode) free(typeCode);
  }

  numView=0;
  for (k=0; k < nitemsView; k++) {
    if (itemList[k].mandatoryCode != VIEW_ITEM_IS_HIDDEN) numView++;
  }


  for (j=0; j < nRows; j++) {
    irow = j;
    ndb_log_message_text(NDB_MSG_DEBUG,"starting row %d",j);
    if (j==0) {
      fprintf(fp,"<br><br>");
      fprintf(fp,"<center>");
      fprintf(fp,"<table cellpadding=4 border bgcolor=\"%s\">",BGCOLOR_TABLE);
      fprintf(fp,"<tr><th colspan=%d bgcolor=\"%s\"><font size=4 color=\"#000000\">%s</th></tr>",
	      numView*3,BGCOLOR_TABLE_TITLE,categoryViewName);
      
      
      fprintf(fp,"<tr>");
      for (k=0; k < nCols; k++) { //
	if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;
	switch(itemList[k].mandatoryCode) {
	  
	case VIEW_ITEM_IS_MANDATORY:
	  fprintf(fp,"<th colspan=3 bgcolor=\"%s\"><FONT SIZE=3 COLOR=\"#900000\"><b>%s</b></FONT></th>",
		  BGCOLOR_TABLE_TITLE,get_table_attribute_name(itemList[k].viewName));
	  break;
	case VIEW_ITEM_IS_NOT_MANDATORY:
	  fprintf(fp,"<th colspan=3 bgcolor=\"%s\"><FONT SIZE=3><b>%s</b></FONT></th>\n",
		  BGCOLOR_TABLE_TITLE,get_table_attribute_name(itemList[k].viewName));
	  
	  break;
	}
      }
      fprintf(fp,"</tr>");
      
      fprintf(fp,"<tr>");

      for (k=0; k < nCols; k++) {
	  if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;
	  fprintf(fp,"<td align=center><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>\n",
		  HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_HELP_VIEW,
		  HT_ATTRIBUTE_UNIQUE_ID,ufid,
		  HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
		  HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
		  HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
		  HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_HELP);
	  
	  fprintf(fp,"<td align=center><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>\n",
		  HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_DESCRIPTION_VIEW,
		  HT_ATTRIBUTE_UNIQUE_ID,ufid,
		  HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
		  HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
		  HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
		  HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_DESCRIBE);
	  
	  
	  fprintf(fp,"<td align=center><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>",
		  HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_EXAMPLES_VIEW,
		  HT_ATTRIBUTE_UNIQUE_ID,ufid,
		  HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
		  HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
		  HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
		  HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_EXAMPLES);
      }
      fprintf(fp,"</tr>");
      ndb_log_message_text(NDB_MSG_DEBUG,"help header done");
    }
    fprintf(fp,"<tr>");
#if 0
    ndb_log_message_text(NDB_MSG_DEBUG,"Row %d value 0 is %s", irow, values[irow][0]);

    fprintf(fp,"<td colspan=3 align=center><font size=4><b>%s</b></font></td>\n",
	    values[irow][0]);

#endif
    for (k=0; k < nCols; k++) {
      ndb_log_message_text(NDB_MSG_DEBUG,"value at row %d col %d  is %s",irow,k,values[j][k]);
      encode_table_param_name(pName,irow,k,0);
      encode_table_param_name(pNameAlt,irow,k,1);      

      if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;
      fprintf(fp,"<td colspan=3>");

      if (nitenum[k] == 0) { // Enumerated, No ...
	
	write_input_item_value(fp, pName, values[irow][k], iTypeCode[k]);
      } else {  // Enumerated, Yes ... 
	
	write_input_enum_item_value(fp, values[irow][k], pName, pNameAlt, (const char **)itenum[k], nitenum[k], 
				    itemList[k].allowAlternateCode);
      }
      fprintf(fp,"</td>");
    }
    fprintf(fp,"</tr>");
  }
  fprintf(fp,"</table><br><br>");

  // Add hidden values ... 

  for (j=0; j < nRows; j++) { // Fill in data values for missing columns ... 
    irow = j;
#if 0
    encode_table_param_name(pName,irow,0,0);
    fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",pName,values[irow][0]);
#endif
    for (k=0; k < nCols; k++) {
      encode_table_param_name(pName,irow,k,0);
      if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) {
	fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",pName,values[irow][k]);
      }
    }
  }
  
  fprintf(fp,"</center>");
  
  
  fprintf(fp,"<center><font size=4 color=\"#900000\"><INPUT TYPE=SUBMIT VALUE=\"Save %s\"></font></center>",
	  categoryViewName);
  
  fprintf(fp,"</FORM>\n");
  fprintf(fp,"</BODY>\n");
  fprintf(fp,"</HTML>\n");
  
  for (i=0; i < nCols; i++) {
    for (j=1; j < nitenum[i]; j++){
      if (itenum[i][j] != NULL) free(itenum[i][j]);
    }
    if (itenum[i] != NULL) free(itenum[i]);
  }
  if (nitenum != NULL )  free(nitenum);
  if (iTypeCode != NULL )  free(iTypeCode);
}



void make_category_form_from_view_t2(CifViewObj *vobj, CifBuilder &cb, CifFileObj * fobj, 
					    const char *dirPath, const char *blockId, const char *category,
					    const char *ufid, int iTabType, int istyle) 
  /* ****************************************************************************
   *   Build memory model for category display format  T2
   * 
   *   View Column 0 - enumerated and primary key.  
   *   iTabType = 2:
   *     Builds a subtable for each key value (row) with the column names and 
   *     help information in each subtable displayed in a vertical list.
   *
   *   iTabType = 4:
   *     Builds a single columns displayed horizontally.
   */
{
  int errCode;
  char *sItem=NULL;
  char **itenum=NULL;
  uWord nitenum;
  
  char ***values=NULL;
  ISTable * t = NULL; 
  CIFVIEWOBJITEM *itemList;
  
  ReVarCifArray<CifString> * row = NULL, *colNamesView = NULL;
  int *ind=NULL;

  int nRows = 0, nCols = 0, maxRows=0, i, j, k, il, irow, nColsView=0, iExtra = 5;

  CifString cs;
  ReVarPCifArray<int> *iResult=NULL;

  FILE *fp=NULL;
  char fName[HT_MAX_NAME_LENGTH];

  ndb_log_message_text(NDB_MSG_DEBUG,"make_category_form_from_view_t2: Entering");

  t=fobj->GetTablePtr(blockId,category);
  if (t != NULL) 
    itemList = build_item_obj_list_w_table(vobj, category, &nColsView, t);
  else
    itemList = build_item_obj_list(vobj, category, &nColsView);

  ndb_log_message_text(NDB_MSG_DEBUG,"make_category_form_from_view_t2: view category %s has %d columns",
		       category,nColsView);

  //
  // Get enumeration list for the first column ...
  //
  sItem = get_dictionary_item_name(cb,itemList[0].item);
  ndb_log_message_text(NDB_MSG_DEBUG,"View item %s  item %s standard %s",
		       itemList[0].viewName,itemList[0].item,sItem);
  nitenum = 0;

  itenum = cb.GetItemEnumerationNDB(sItem,nitenum);
  if (nitenum == 0 && itenum == NULL)  itenum = cb.GetItemEnumeration(sItem,nitenum);

  ndb_log_message_text(NDB_MSG_DEBUG,"View item %s has enum length %d",itemList[0].viewName,nitenum);
  if (nitenum == 0) {
    ndb_log_message_text(NDB_MSG_DEBUG,"Column 0 must be enumerated for his display style");
    return;
  }
  // Note: Assume here that the input data obeys enumeration and is ordered starting with the 
  //       first enumerant.
  //
  if ( t != NULL) {
    nCols = t->GetNumColumns();
    nRows = t->GetNumRows();
    maxRows = nRows + iExtra;
    if (maxRows > nitenum) maxRows = nitenum;
    values = (char ***) calloc(maxRows,sizeof(char **));
    for (i=0; i < maxRows; i++) { // allocate the rows of the category
      values[i] = (char **) calloc(nCols,sizeof(char *));
    }
    colNamesView = vobj->GetCategoryItems(category);
    ind = vobj->GetItemColumnIndices(t,colNamesView);
    
    // Fill in values from the persistent table
    // search for the occurences of each enumerate
#if 0
    if (!t->isIndexed(ind[0])) {     // make column searchable if required ... 
      ReVarCifArray<CifString> *col0 = t->GetColumn(ind[0]);
      ReVarCifArray<CifString> *colNames = t->GetColumnNames();
      t->RemoveColumn(ind[0]); t->InsertColumn((*colNames)[ind[0]].Text(),ind[0],1);
      t->FillColumn(*col0,ind[0]);
    }
#endif

    for (i=0; i < maxRows; i++) {
      irow = i;
      cs.Clear(); cs.Copy(itenum[i]);
      iResult = t->SearchColumn(cs,ind[0],errCode);
      ndb_log_message_text(NDB_MSG_DEBUG,"Search target %s index %d errCode %d",cs.Text(),ind[0],errCode);
      if (!errCode && iResult && (iResult->Length() > 0)) {
	ndb_log_message_text(NDB_MSG_DEBUG,"Search length for %s is %d",cs.Text(),iResult->Length());
      	il = iResult->Length(); 
	if (il > 1) il = 1;
	for (j=0; j < il; j++) {
	  ndb_log_message_text(NDB_MSG_DEBUG,"Fetching row %d",(*iResult)[j]);
	  row=t->GetRow((*iResult)[j]);
	  for (k=0; k < nCols; k++) {  // Note:  Full column width of data loaded in values[][]
	    ndb_log_message_text(NDB_MSG_DEBUG,"Fetching column %d index %d length %d",
				 k, ind[k],(*row)[ind[k]].Length());
 	    if ((*row)[ind[k]].Length() > 0 ) {
	      values[irow][k] = (char *) calloc(((*row)[ind[k]].Length()+1),sizeof(char));
	      strcpy(values[irow][k],(*row)[ind[k]].Text());
	    } else {
	      values[irow][k] = (char *) calloc(2,sizeof(char));
	      strcpy(values[irow][k],"?");
	    }
	  }
	  if (row) delete row;
	}
      } else {
	values[irow] = get_blank_row_with_defaults(cb, itemList, nColsView,nCols);
	// Set the current enumerate value in column 0.
	free(values[irow][0]);
	values[irow][0] = (char *)calloc(strlen(itenum[i])+1,sizeof(char));  
	strcpy(values[irow][0],itenum[i]);
      }
      if (iResult) delete iResult;

    }
    CifString * categoryViewName = vobj->GetViewCategory(category);
    ndb_log_message_text(NDB_MSG_DEBUG,"Creating table %s form view name %s", category,categoryViewName->Text());

    //
    //    Write the form elements to stdout and to the cache file...
    //
    ht_put_content_type_target(stdout,"item");

    switch (istyle) {
    case 1:
      if (iTabType == 2) {
	write_category_form_t2A_S1(stdout, cb, blockId, category, categoryViewName->Text(), ufid, 
				(const char ***)values, itemList, nColsView,  maxRows, nCols);
      } else {
	
	write_category_form_t2B_S1(stdout, cb, blockId, category, categoryViewName->Text(), ufid, 
				(const char ***)values, itemList, nColsView,  maxRows, nCols);
      }
      break;

    case 0:
    default:
      if (iTabType == 2) {
	write_category_form_t2A(stdout, cb, blockId, category, categoryViewName->Text(), ufid, 
				(const char ***)values, itemList, nColsView,  maxRows, nCols);
      } else {
	
	write_category_form_t2B(stdout, cb, blockId, category, categoryViewName->Text(), ufid, 
				(const char ***)values, itemList, nColsView,  maxRows, nCols);
      }
      break;
    }
    
    strcpy(fName,dirPath);
    strcat(fName,HT_ITEM_LIST_NAME);
    fp = fopen(fName,"w");

    switch (istyle) {
    case 1:
      if (iTabType == 2) {
	write_category_form_t2A_S1(fp, cb, blockId, category, categoryViewName->Text(), ufid, 
				   (const char ***)values, itemList, nColsView, maxRows, nCols);
      } else {
	write_category_form_t2B_S1(fp, cb, blockId, category, categoryViewName->Text(), ufid, 
				   (const char ***)values, itemList, nColsView, maxRows, nCols);
      }
      break;
    case 0:
    default:
      if (iTabType == 2) {
	write_category_form_t2A(fp, cb, blockId, category, categoryViewName->Text(), ufid, 
				(const char ***)values, itemList, nColsView, maxRows, nCols);
      } else {
	write_category_form_t2B(fp, cb, blockId, category, categoryViewName->Text(), ufid, 
				(const char ***)values, itemList, nColsView, maxRows, nCols);
      }
      break;
    }
    fclose(fp);
    
  }
}


void write_category_form_t2B(FILE *fp, CifBuilder &cb,  const char *blockId, const char *category,  
			     const char *categoryViewName,  
			     const char *ufid, 
			     const char ***values, 
			     const CIFVIEWOBJITEM *itemList, int nitemsView,
			     int nRows, int nCols)
{
  int  i, j, k, irow, numView;
  char   *sItem=NULL;
  char ***itenum=NULL;
  uWord *nitenum=NULL;
  char *typeCode=NULL;
  int *iTypeCode=NULL;

  char pName[CIF_MAX_NAME_LENGTH];
  char pNameAlt[CIF_MAX_NAME_LENGTH];

   
  fprintf(fp,"<HTML>\n");
  fprintf(fp,"%s\n",LANG_HTML_BODY_SCHEME_ALT_2);
  fprintf(fp,"<center><font face=\"%s\" size=5>%s</font>",LANG_HTML_FONT_FACE,LANG_ENTER_DATA_TITLE);
  fprintf(fp,"<font size=5 color=\"#900000\"> %s</font></center>",categoryViewName);


  //
  //       Category help is displayed at the top of the display ...
  //
  display_category_help(fp, cb, category);


  fprintf(fp,"<FORM METHOD=\"POST\" ACTION=\"%s%s%s\" TARGET=\"other\">\n",
	  HT_SERVER_NAME,
	  HT_CGI_PATH,
	  HT_INTERFACE_READ_FORM_CATEGORY);
  
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_UNIQUE_ID, ufid);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_CATEGORY_ID,category);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_DATABLOCK_ID,blockId);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_NUM_ITEMS,nCols);  
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_NUM_ROWS,nRows);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_FORM_LAYOUT,1);

  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY);



  fprintf(fp,"<center><font size=4 color=\"#900000\"><INPUT TYPE=SUBMIT VALUE=\"Save %s\"></font></center>",
	  categoryViewName);

  nitenum    = (uWord *)  calloc(nCols, sizeof(int));
  itenum     = (char ***)calloc(nCols, sizeof(char **));
  iTypeCode = (int *)  calloc(nCols, sizeof(int));



  for (k=1; k < nCols; k++) {
    sItem = get_dictionary_item_name(cb,itemList[k].item);
    if (sItem == NULL) continue;
    nitenum[k] = 0;
    itenum[k]=get_sorted_enumeration_list(cb,sItem, nitenum[k]);

    typeCode = cb.GetItemType(sItem);
    iTypeCode[k]=get_item_type_code(typeCode);
    ndb_log_message_text(NDB_MSG_DEBUG,"Item %s enumerates %d type %s type code %d",			
			 sItem,nitenum[k], typeCode, iTypeCode[k]);

    if (sItem) free(sItem);
    if (typeCode) free(typeCode);
  }

  numView=0;
  for (k=0; k < nitemsView; k++) {
    if (itemList[k].mandatoryCode != VIEW_ITEM_IS_HIDDEN) numView++;
  }


  for (j=0; j < nRows; j++) {
    irow = j;
    ndb_log_message_text(NDB_MSG_DEBUG,"starting row %d",j);
    if (j==0) {
      fprintf(fp,"<br><br>");
      fprintf(fp,"<center>");
      fprintf(fp,"<table cellpadding=4 border bgcolor=\"%s\">",BGCOLOR_TABLE);
      fprintf(fp,"<tr><th colspan=%d bgcolor=\"%s\"><font size=4 color=\"#000000\">%s</th></tr>",
	      numView*3,BGCOLOR_TABLE_TITLE,categoryViewName);
      
      
      fprintf(fp,"<tr>");
      for (k=0; k < nCols; k++) {
	if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;
	switch(itemList[k].mandatoryCode) {
	  
	case VIEW_ITEM_IS_MANDATORY:
	  fprintf(fp,"<th colspan=3 bgcolor=\"%s\"><FONT SIZE=3 COLOR=\"#900000\"><b>%s</b></FONT></th>",
		  BGCOLOR_TABLE_TITLE,get_table_attribute_name(itemList[k].item));
	  break;
	case VIEW_ITEM_IS_NOT_MANDATORY:
	  fprintf(fp,"<th colspan=3 bgcolor=\"%s\"><FONT SIZE=3><b>%s</b></FONT></th>\n",
		  BGCOLOR_TABLE_TITLE,get_table_attribute_name(itemList[k].item));
	  
	  break;
	}
      }
      fprintf(fp,"</tr>");
      
      fprintf(fp,"<tr>");

      for (k=0; k < nCols; k++) {
	  if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;
	  fprintf(fp,"<td align=center><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>\n",
		  HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_HELP_VIEW,
		  HT_ATTRIBUTE_UNIQUE_ID,ufid,
		  HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
		  HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
		  HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
		  HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_HELP);
	  
	  fprintf(fp,"<td align=center><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>\n",
		  HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_DESCRIPTION_VIEW,
		  HT_ATTRIBUTE_UNIQUE_ID,ufid,
		  HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
		  HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
		  HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
		  HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_DESCRIBE);
	  
	  
	  fprintf(fp,"<td align=center><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>",
		  HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_EXAMPLES_VIEW,
		  HT_ATTRIBUTE_UNIQUE_ID,ufid,
		  HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
		  HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
		  HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
		  HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_EXAMPLES);
      }
      fprintf(fp,"</tr>");
      ndb_log_message_text(NDB_MSG_DEBUG,"help header done");
    }
    fprintf(fp,"<tr>");

    ndb_log_message_text(NDB_MSG_DEBUG,"Row %d value 0 is %s", irow, values[irow][0]);

    fprintf(fp,"<td colspan=3 align=center><font size=4><b>%s</b></font></td>\n",
	    values[irow][0]);


    for (k=1; k < nCols; k++) {
      ndb_log_message_text(NDB_MSG_DEBUG,"value at row %d col %d  is %s",irow,k,values[j][k]);
      encode_table_param_name(pName,irow,k,0);
      encode_table_param_name(pNameAlt,irow,k,1);      

      if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;
      fprintf(fp,"<td colspan=3>");

      if (nitenum[k] == 0) { // Enumerated, No ...
	
	write_input_item_value(fp, pName, values[irow][k], iTypeCode[k]);
      } else {  // Enumerated, Yes ... 
	
	write_input_enum_item_value(fp, values[irow][k], pName, pNameAlt, (const char **)itenum[k], nitenum[k], 
				    itemList[k].allowAlternateCode);
      }

      fprintf(fp,"</td>");
    }
    fprintf(fp,"</tr>");
  }
  fprintf(fp,"</table><br><br>");

  // Add hidden values ... 

  for (j=0; j < nRows; j++) { // Fill in data values for missing columns ... 
    irow = j;
    encode_table_param_name(pName,irow,0,0);
    fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",pName,values[irow][0]);
    for (k=1; k < nCols; k++) {
      encode_table_param_name(pName,irow,k,0);
      if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) {
	fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",pName,values[irow][k]);
      }
    }
  }
  
  fprintf(fp,"</center>");
  
  
  fprintf(fp,"<center><font size=4 color=\"#900000\"><INPUT TYPE=SUBMIT VALUE=\"Save %s\"></font></center>",
	  categoryViewName);
  
  fprintf(fp,"</FORM>\n");
  fprintf(fp,"</BODY>\n");
  fprintf(fp,"</HTML>\n");
  
  for (i=0; i < nCols; i++) {
    for (j=1; j < nitenum[i]; j++){
      if (itenum[i][j] != NULL) free(itenum[i][j]);
    }
    if (itenum[i] != NULL) free(itenum[i]);
  }

  if (nitenum != NULL )  free(nitenum);
  if (iTypeCode != NULL )  free(iTypeCode);
}


void write_category_form_t2A(FILE *fp, CifBuilder &cb,  const char *blockId, const char *category,  
			     const char *categoryViewName,  
			     const char *ufid, 
			     const char ***values, 
			     const CIFVIEWOBJITEM *itemList, int nitemsView,
			     int numTables, int nCols)
{
  int  i, j, k, irow;
  char   *sItem=NULL;
  char ***itenum=NULL;
  uWord *nitenum=NULL;
  char *typeCode=NULL;
  int *iTypeCode=NULL;

  char pName[CIF_MAX_NAME_LENGTH];
  char pNameAlt[CIF_MAX_NAME_LENGTH];

   
  fprintf(fp,"<HTML>\n");
  fprintf(fp,"%s\n",LANG_HTML_BODY_SCHEME_ALT_2);
  fprintf(fp,"<center><font face=\"%s\" size=5>%s</font>",LANG_HTML_FONT_FACE,LANG_ENTER_DATA_TITLE);

  fprintf(fp,"<font size=5 color=\"#900000\"> %s</font></center>",categoryViewName);


  //
  //       Category help is displayed at the top of the display ...
  //
  display_category_help(fp, cb, category);


  //

  fprintf(fp,"<FORM METHOD=\"POST\" ACTION=\"%s%s%s\" TARGET=\"other\">\n",
	  HT_SERVER_NAME,
	  HT_CGI_PATH,
	  HT_INTERFACE_READ_FORM_CATEGORY);
  
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_UNIQUE_ID, ufid);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_CATEGORY_ID,category);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_DATABLOCK_ID,blockId);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_NUM_ITEMS,nCols);  
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_NUM_ROWS,numTables);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_FORM_LAYOUT,1);

  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY);

  fprintf(fp,"<center><font size=4 color=\"#900000\"><INPUT TYPE=SUBMIT VALUE=\"Save %s\"></font></center>",
	  categoryViewName);

  nitenum    = (uWord *)  calloc(nCols, sizeof(int));
  itenum     = (char ***)calloc(nCols, sizeof(char **));
  iTypeCode = (int *)  calloc(nCols, sizeof(int));



  for (k=1; k < nCols; k++) {
    sItem = get_dictionary_item_name(cb,itemList[k].item);
    if (sItem == NULL) continue;
    nitenum[k] = 0;
    itenum[k]=get_sorted_enumeration_list(cb,sItem, nitenum[k]);

    typeCode = cb.GetItemType(sItem);
    iTypeCode[k]=get_item_type_code(typeCode);
    ndb_log_message_text(NDB_MSG_DEBUG,"Item %s enumerates %d type %s type code %d",			
			 sItem,nitenum[k], typeCode, iTypeCode[k]);

    if (sItem) free(sItem);
    if (typeCode) free(typeCode);
  }

  //  fprintf(fp,"<ul>");
  for (i=0; i < numTables; i++) {
    irow = i;
    
    
    fprintf(fp,"<center>");
    fprintf(fp,"<br><br>");
    fprintf(fp,"<table cellpadding=4 border bgcolor=\"%s\">",BGCOLOR_TABLE);
    fprintf(fp,"<tr><th colspan=5 bgcolor=\"%s\"><font size=4 color=\"#000000\">%s %s ",
	    BGCOLOR_TABLE_TITLE,categoryViewName,get_table_attribute_name(itemList[0].item));
    fprintf(fp,"= <font color=\"#900000\">%s</font></font></b></th></tr>\n",values[irow][0]);

    for (k=1; k < nCols; k++) {
      if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;
      fprintf(fp,"<tr>");
      // Column Name  ... 

      switch(itemList[k].mandatoryCode) {
      case VIEW_ITEM_IS_MANDATORY:
	fprintf(fp,"<td><FONT SIZE=3 COLOR=\"#900000\"><b>%s</b></FONT></td>",
		get_table_attribute_name(itemList[k].item));
	break;
      case VIEW_ITEM_IS_NOT_MANDATORY:
	fprintf(fp,"<td><FONT SIZE=3><b>%s</b></FONT></td>\n",
		get_table_attribute_name(itemList[k].item));
	
	break;
      }
      // Help,  Definitions, Examples ... 

      fprintf(fp,"<td><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>\n",
	      HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_HELP_VIEW,
	      HT_ATTRIBUTE_UNIQUE_ID,ufid,
		  HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
		  HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
		  HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
	      HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_HELP);
      
      fprintf(fp,"<td><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>\n",
	      HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_DESCRIPTION_VIEW,
	      HT_ATTRIBUTE_UNIQUE_ID,ufid,
		  HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
		  HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
		  HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
	      HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_DESCRIBE);
      
      
      fprintf(fp,"<td><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>",
	      HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_EXAMPLES_VIEW,
	      HT_ATTRIBUTE_UNIQUE_ID,ufid,
		  HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
		  HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
		  HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
	      HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_EXAMPLES);


      encode_table_param_name(pName,irow,k,0);
      encode_table_param_name(pNameAlt,irow,k,1);      
      
      fprintf(fp,"<td>");
      if (nitenum[k] == 0) { // Enumerated, No ...
	
	write_input_item_value(fp, pName, values[irow][k], iTypeCode[k]);
      } else {  // Enumerated, Yes ... 
	
	write_input_enum_item_value(fp, values[irow][k], pName, pNameAlt, (const char **)itenum[k], nitenum[k], 
				    itemList[k].allowAlternateCode);
      }
      fprintf(fp,"</td></tr>");
    }
    fprintf(fp,"</table><br><br>");
  }

 
  fprintf(fp,"</center>");

  if (numTables > 1)   fprintf(fp,"<center><font size=4 color=\"#900000\"><INPUT TYPE=SUBMIT VALUE=\"Save %s\"></font></center>",
			       categoryViewName);

  for (i=0; i < numTables; i++) { // Fill in data values for missing columns ... 
    irow = i;
    encode_table_param_name(pName,irow,0,0);
    fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",pName,values[irow][0]);
    for (k=1; k < nCols; k++) {
      encode_table_param_name(pName,irow,k,0);
      if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) {
	fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",pName,values[irow][k]);
      }
    }
  }
  
  fprintf(fp,"</FORM>\n");

  fprintf(fp,"</BODY>\n");
  fprintf(fp,"</HTML>\n");
  
  for (i=0; i < nCols; i++) {
    for (j=1; j < nitenum[i]; j++){
      if (itenum[i][j] != NULL) free(itenum[i][j]);
    }
    if (itenum[i] != NULL) free(itenum[i]);
  }
  if (nitenum != NULL )  free(nitenum);
  if (iTypeCode != NULL )  free(iTypeCode);
}


void write_category_form_t2B_S1(FILE *fp, CifBuilder &cb,  const char *blockId, const char *category,  
			       const char *categoryViewName,  
				const char *ufid, 
				const char ***values, 
				const CIFVIEWOBJITEM *itemList, int nitemsView,
				int nRows, int nCols)
{
  int  i, j, k, irow, numView;
  char   *sItem=NULL;
  char ***itenum=NULL;
  uWord *nitenum=NULL;
  char *typeCode=NULL;
  int *iTypeCode=NULL;

  char pName[CIF_MAX_NAME_LENGTH];
  char pNameAlt[CIF_MAX_NAME_LENGTH];

   
  fprintf(fp,"<HTML>\n");
  fprintf(fp,"%s\n",LANG_HTML_BODY_SCHEME_ALT_2);
  fprintf(fp,"<center><font face=\"%s\" size=5>%s</font>",LANG_HTML_FONT_FACE,LANG_ENTER_DATA_TITLE);
  fprintf(fp,"<font size=5 color=\"#900000\"> %s</font></center>",categoryViewName);


  //
  //       Category help is displayed at the top of the display ...
  //
  display_category_help(fp, cb, category);



  fprintf(fp,"<FORM METHOD=\"POST\" ACTION=\"%s%s%s\" TARGET=\"other\">\n",
	  HT_SERVER_NAME,
	  HT_CGI_PATH,
	  HT_INTERFACE_READ_FORM_CATEGORY);
  
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_UNIQUE_ID, ufid);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_CATEGORY_ID,category);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_DATABLOCK_ID,blockId);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_NUM_ITEMS,nCols);  
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_NUM_ROWS,nRows);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_FORM_LAYOUT,1);

  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY);



  fprintf(fp,"<center><font size=4 color=\"#900000\"><INPUT TYPE=SUBMIT VALUE=\"Save %s\"></font></center>",
	  categoryViewName);

  nitenum    = (uWord *)  calloc(nCols, sizeof(int));
  itenum     = (char ***)calloc(nCols, sizeof(char **));
  iTypeCode = (int *)  calloc(nCols, sizeof(int));



  for (k=1; k < nCols; k++) {
    sItem = get_dictionary_item_name(cb,itemList[k].item);
    if (sItem == NULL) continue;
    nitenum[k] = 0;
    itenum[k]=get_sorted_enumeration_list(cb,sItem, nitenum[k]);

    typeCode = cb.GetItemType(sItem);
    iTypeCode[k]=get_item_type_code(typeCode);
    ndb_log_message_text(NDB_MSG_DEBUG,"Item %s enumerates %d type %s type code %d",			
			 sItem,nitenum[k], typeCode, iTypeCode[k]);

    if (sItem) free(sItem);
    if (typeCode) free(typeCode);
  }

  numView=0;
  for (k=0; k < nitemsView; k++) {
    if (itemList[k].mandatoryCode != VIEW_ITEM_IS_HIDDEN) numView++;
  }


  for (j=0; j < nRows; j++) {
    irow = j;
    ndb_log_message_text(NDB_MSG_DEBUG,"starting row %d",j);
    if (j==0) {
      fprintf(fp,"<br><br>");
      fprintf(fp,"<center>");
      fprintf(fp,"<table cellpadding=4 border bgcolor=\"%s\">",BGCOLOR_TABLE);
      fprintf(fp,"<tr><th colspan=%d bgcolor=\"%s\"><font size=4 color=\"#000000\">%s</th></tr>",
	      numView*2,BGCOLOR_TABLE_TITLE,categoryViewName);
      
      
      fprintf(fp,"<tr>");
      for (k=0; k < nCols; k++) {
	if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;
	switch(itemList[k].mandatoryCode) {
	  
	case VIEW_ITEM_IS_MANDATORY:
	  fprintf(fp,"<th colspan=2 bgcolor=\"%s\"><FONT SIZE=3 COLOR=\"#900000\"><b>%s</b></FONT></th>",
		  BGCOLOR_TABLE_TITLE,get_table_attribute_name(itemList[k].viewName));
	  break;
	case VIEW_ITEM_IS_NOT_MANDATORY:
	  fprintf(fp,"<th colspan=2 bgcolor=\"%s\"><FONT SIZE=3><b>%s</b></FONT></th>\n",
		  BGCOLOR_TABLE_TITLE,get_table_attribute_name(itemList[k].viewName));
	  
	  break;
	}
      }
      fprintf(fp,"</tr>");
      
      fprintf(fp,"<tr>");

      for (k=0; k < nCols; k++) {
	  if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;
	  fprintf(fp,"<td align=center><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>\n",
		  HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_HELP_VIEW,
		  HT_ATTRIBUTE_UNIQUE_ID,ufid,
		  HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
		  HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
		  HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
		  HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_HELP);
	  
	  
	  fprintf(fp,"<td align=center><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>",
		  HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_EXAMPLES_VIEW,
		  HT_ATTRIBUTE_UNIQUE_ID,ufid,
		  HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
		  HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
		  HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
		  HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_EXAMPLES);
      }
      fprintf(fp,"</tr>");
      ndb_log_message_text(NDB_MSG_DEBUG,"help header done");
    }
    fprintf(fp,"<tr>");

    ndb_log_message_text(NDB_MSG_DEBUG,"Row %d value 0 is %s", irow, values[irow][0]);

    fprintf(fp,"<td colspan=2 align=center><font size=4><b>%s</b></font></td>\n",
	    values[irow][0]);


    for (k=1; k < nCols; k++) {
      ndb_log_message_text(NDB_MSG_DEBUG,"value at row %d col %d  is %s",irow,k,values[j][k]);
      encode_table_param_name(pName,irow,k,0);
      encode_table_param_name(pNameAlt,irow,k,1);      

      if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;
      fprintf(fp,"<td colspan=2>");

      if (nitenum[k] == 0) { // Enumerated, No ...
	
	write_input_item_value(fp, pName, values[irow][k], iTypeCode[k]);
      } else {  // Enumerated, Yes ... 
	
	write_input_enum_item_value(fp, values[irow][k], pName, pNameAlt, (const char **)itenum[k], nitenum[k], 
				    itemList[k].allowAlternateCode);
      }

      fprintf(fp,"</td>");
    }
    fprintf(fp,"</tr>");
  }
  fprintf(fp,"</table><br><br>");

  // Add hidden values ... 

  for (j=0; j < nRows; j++) { // Fill in data values for missing columns ... 
    irow = j;
    encode_table_param_name(pName,irow,0,0);
    fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",pName,values[irow][0]);
    for (k=1; k < nCols; k++) {
      encode_table_param_name(pName,irow,k,0);
      if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) {
	fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",pName,values[irow][k]);
      }
    }
  }
  
  fprintf(fp,"</center>");
  
  
  fprintf(fp,"<center><font size=4 color=\"#900000\"><INPUT TYPE=SUBMIT VALUE=\"Save %s\"></font></center>",
	  categoryViewName);
  
  fprintf(fp,"</FORM>\n");
  fprintf(fp,"</BODY>\n");
  fprintf(fp,"</HTML>\n");
  
  for (i=0; i < nCols; i++) {
    for (j=1; j < nitenum[i]; j++){
      if (itenum[i][j] != NULL) free(itenum[i][j]);
    }
    if (itenum[i] != NULL) free(itenum[i]);
  }
  if (nitenum != NULL )  free(nitenum);
  if (iTypeCode != NULL )  free(iTypeCode);
}


void write_category_form_t2A_S1(FILE *fp, CifBuilder &cb,  const char *blockId, const char *category,  
				const char *categoryViewName,  
				const char *ufid, 
				const char ***values, 
				const CIFVIEWOBJITEM *itemList, int nitemsView,
				int numTables, int nCols)
{
  int  i, j, k, irow;
  char   *sItem=NULL;
  char ***itenum=NULL;
  uWord *nitenum=NULL;
  char *typeCode=NULL;
  int *iTypeCode=NULL;


  char pName[CIF_MAX_NAME_LENGTH];
  char pNameAlt[CIF_MAX_NAME_LENGTH];

   
  fprintf(fp,"<HTML>\n");
  fprintf(fp,"%s\n",LANG_HTML_BODY_SCHEME_ALT_2);
  fprintf(fp,"<center><font face=\"%s\" size=5>%s</font>",LANG_HTML_FONT_FACE,LANG_ENTER_DATA_TITLE);

  fprintf(fp,"<font size=5 color=\"#900000\"> %s</font></center>",categoryViewName);


  //
  //       Category help is displayed at the top of the display ...
  //
  display_category_help(fp, cb, category);


  //

  fprintf(fp,"<FORM METHOD=\"POST\" ACTION=\"%s%s%s\" TARGET=\"other\">\n",
	  HT_SERVER_NAME,
	  HT_CGI_PATH,
	  HT_INTERFACE_READ_FORM_CATEGORY);
  
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_UNIQUE_ID, ufid);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_CATEGORY_ID,category);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_DATABLOCK_ID,blockId);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_NUM_ITEMS,nCols);  
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_NUM_ROWS,numTables);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_FORM_LAYOUT,1);

  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY);

  fprintf(fp,"<center><font size=4 color=\"#900000\"><INPUT TYPE=SUBMIT VALUE=\"Save %s\"></font></center>",
	  categoryViewName);

  nitenum    = (uWord *)  calloc(nCols, sizeof(int));
  itenum     = (char ***)calloc(nCols, sizeof(char **));
  iTypeCode = (int *)  calloc(nCols, sizeof(int));



  for (k=1; k < nCols; k++) {
    sItem = get_dictionary_item_name(cb,itemList[k].item);
    if (sItem == NULL) continue;
    nitenum[k] = 0;
    itenum[k]=get_sorted_enumeration_list(cb,sItem, nitenum[k]);

    typeCode = cb.GetItemType(sItem);
    iTypeCode[k]=get_item_type_code(typeCode);
    ndb_log_message_text(NDB_MSG_DEBUG,"Item %s enumerates %d type %s type code %d",			
			 sItem,nitenum[k], typeCode, iTypeCode[k]);

    if (sItem) free(sItem);
    if (typeCode) free(typeCode);
  }

  //  fprintf(fp,"<ul>");
  for (i=0; i < numTables; i++) {
    irow = i;
    
    
    fprintf(fp,"<center>");
    fprintf(fp,"<br><br>");
    fprintf(fp,"<table cellpadding=4 border bgcolor=\"%s\">",BGCOLOR_TABLE);
    fprintf(fp,"<tr><th colspan=4 bgcolor=\"%s\"><font size=4 color=\"#000000\"> %s ",
	    BGCOLOR_TABLE_TITLE,get_table_attribute_name(itemList[0].viewName));
    fprintf(fp,"= <font color=\"#900000\">%s</font></font></b></th></tr>\n",values[irow][0]);

    for (k=1; k < nCols; k++) {
      if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;
      fprintf(fp,"<tr>");
      // Column Name  ... 

      switch(itemList[k].mandatoryCode) {
      case VIEW_ITEM_IS_MANDATORY:
	fprintf(fp,"<td><FONT SIZE=3 COLOR=\"#900000\"><b>%s</b></FONT></td>",
		get_table_attribute_name(itemList[k].viewName));
	break;
      case VIEW_ITEM_IS_NOT_MANDATORY:
	fprintf(fp,"<td><FONT SIZE=3><b>%s</b></FONT></td>\n",
		get_table_attribute_name(itemList[k].viewName));
	
	break;
      }
      // Help,  Definitions, Examples ... 

      fprintf(fp,"<td><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>\n",
	      HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_HELP_VIEW,
	      HT_ATTRIBUTE_UNIQUE_ID,ufid,
		  HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
		  HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
		  HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
	      HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_HELP);
      
      
      fprintf(fp,"<td><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>",
	      HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_EXAMPLES_VIEW,
	      HT_ATTRIBUTE_UNIQUE_ID,ufid,
		  HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
		  HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
		  HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
	      HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_EXAMPLES);


      encode_table_param_name(pName,irow,k,0);
      encode_table_param_name(pNameAlt,irow,k,1);      
      
      fprintf(fp,"<td>");
      if (nitenum[k] == 0) { // Enumerated, No ...
	
	write_input_item_value(fp, pName, values[irow][k], iTypeCode[k]);
      } else {  // Enumerated, Yes ... 
	
	write_input_enum_item_value(fp, values[irow][k], pName, pNameAlt, (const char **)itenum[k], nitenum[k], 
				    itemList[k].allowAlternateCode);
      }
      fprintf(fp,"</td></tr>");
    }
    fprintf(fp,"</table><br><br>");
  }

 
  fprintf(fp,"</center>");

  if (numTables > 1)   fprintf(fp,"<center><font size=4 color=\"#900000\"><INPUT TYPE=SUBMIT VALUE=\"Save %s\"></font></center>",
			       categoryViewName);

  for (i=0; i < numTables; i++) { // Fill in data values for missing columns ... 
    irow = i;
    encode_table_param_name(pName,irow,0,0);
    fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",pName,values[irow][0]);
    for (k=1; k < nCols; k++) {
      encode_table_param_name(pName,irow,k,0);
      if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) {
	fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",pName,values[irow][k]);
      }
    }
  }
  
  fprintf(fp,"</FORM>\n");

  fprintf(fp,"</BODY>\n");
  fprintf(fp,"</HTML>\n");
  
  for (i=0; i < nCols; i++) {
    for (j=1; j < nitenum[i]; j++){
      if (itenum[i][j] != NULL) free(itenum[i][j]);
    }
    if (itenum[i] != NULL) free(itenum[i]);
  }

  if (nitenum != NULL )  free(nitenum);
  if (iTypeCode != NULL )  free(iTypeCode);
}



void make_category_form_from_view_t1(CifViewObj *vobj, CifBuilder &cb, CifFileObj * fobj, 
					    const char *dirPath, const char *blockId, const char *category, 
					    const char *ufid, int istyle) 
  /* ****************************************************************************
   *   Build memory model for category display format  T1
   * 
   *   View Column 0 - enumerated and not primary key.  
   *   Builds a subtable with maximum rows=rowIncrement for each enumerant.
   */
{
  int errCode;
  char *sItem=NULL;
  char **itenum=NULL;
  uWord nitenum;
  
  char ***values=NULL;
  ISTable * t = NULL; 
  CIFVIEWOBJITEM *itemList;
  
  ReVarCifArray<CifString> * row = NULL, *colNamesView = NULL;
  int *ind=NULL;

  int nCols = 0, i, j, k, il, irow, nColsView=0;
  int *eLen, maxLen = 0, nMatch=0, rowIncrement=0;
  int nTables = 0, iExtra = 10;

  CifString cs;
  ReVarPCifArray<int> *iResult=NULL;

  FILE *fp=NULL;
  char fName[HT_MAX_NAME_LENGTH];


  ndb_log_message_text(NDB_MSG_DEBUG,"make_category_form_from_view_t1: Entering");
  
  t=fobj->GetTablePtr(blockId,category);
  if (t != NULL) 
    itemList = build_item_obj_list_w_table(vobj, category, &nColsView, t);
  else
    itemList = build_item_obj_list(vobj, category, &nColsView);

  ndb_log_message_text(NDB_MSG_DEBUG,"make_category_form_from_view_t1: view category %s has %d columns",
		       category,nColsView);
  //
  // Get enumeration list for the first column ...
  //
  sItem = get_dictionary_item_name(cb,itemList[0].item);
  ndb_log_message_text(NDB_MSG_DEBUG,"View item %s  item %s standard %s",
		       itemList[0].viewName,itemList[0].item,sItem);
  nitenum = 0;
  itenum = cb.GetItemEnumerationNDB(sItem,nitenum);
  if (nitenum == 0 && itenum == NULL)  itenum = cb.GetItemEnumeration(sItem,nitenum);
  ndb_log_message_text(NDB_MSG_DEBUG,"View item %s has enum length %d",itemList[0].viewName,nitenum);
  if (nitenum == 0) {
    ndb_log_message_text(NDB_MSG_DEBUG,"Column 0 must be enumerated for his display style");
    return;
  }

  //
  // Search existing data for number matched enumerants and the length of each 
  // match list.

  if ( t != NULL) {
    nCols = t->GetNumColumns();

    colNamesView = vobj->GetCategoryItems(category);
    ind = vobj->GetItemColumnIndices(t,colNamesView);
    
#if 0
    if (!t->isIndexed(ind[0])) {     // make column searchable if required ... 
      ReVarCifArray<CifString> *col0 = t->GetColumn(ind[0]);
      ReVarCifArray<CifString> *colNames = t->GetColumnNames();
      t->RemoveColumn(ind[0]); t->InsertColumn((*colNames)[ind[0]].Text(),ind[0],1);
      t->FillColumn(*col0,ind[0]);
    }
#endif

    eLen = (int *) malloc(nitenum*sizeof(int));
    maxLen = 0;
    nMatch = 0;
    for (i=0; i < nitenum; i++) {
      eLen[i] = 0;
      cs.Clear(); cs.Copy(itenum[i]);
      iResult = t->SearchColumn(cs,ind[0],errCode);
      if (!errCode && iResult && (iResult->Length() > 0)) {
	ndb_log_message_text(NDB_MSG_DEBUG,"Search length for %s is %d",cs.Text(),iResult->Length());
      	eLen[i] = iResult->Length(); 
      }
      if (eLen[i] > maxLen) maxLen = eLen[i];
      if (eLen[i] > 0) nMatch=i+1;
    }
    nTables = nMatch + iExtra;
    if (nTables > nitenum) nTables = nitenum;
    rowIncrement = maxLen + iExtra;
    values = (char ***) calloc(nTables*rowIncrement,sizeof(char **));
    for (i=0; i < nTables*rowIncrement; i++) { // allocate the rows of the category
      values[i] = (char **) calloc(nCols,sizeof(char *));
    }
  }

  //
  //*jdw  
  if ( t != NULL) {

    for (i=0; i < nTables; i++) {
      cs.Clear(); cs.Copy(itenum[i]);
      iResult = t->SearchColumn(cs,ind[0],errCode);
      ndb_log_message_text(NDB_MSG_DEBUG,"Search target %s index %d errCode %d",cs.Text(),ind[0],errCode);
      if (!errCode && iResult && (iResult->Length() > 0)) {
	ndb_log_message_text(NDB_MSG_DEBUG,"Search length for %s is %d",cs.Text(),iResult->Length());
      	il = iResult->Length(); 
	if (il > rowIncrement) il = rowIncrement;
	for (j=0; j < il; j++) {
	  ndb_log_message_text(NDB_MSG_DEBUG,"Fetching row %d",(*iResult)[j]);
	  row=t->GetRow((*iResult)[j]);
	  irow = rowIncrement*i + j;
	  for (k=0; k < nCols; k++) {  // Note:  Full column width of data loaded in values[][]
	    ndb_log_message_text(NDB_MSG_DEBUG,"Fetching column %d index %d length %d",
				 k, ind[k],(*row)[ind[k]].Length());
	    if ((*row)[ind[k]].Length() > 0 ) {
	      values[irow][k] = (char *) calloc(((*row)[ind[k]].Length()+1),sizeof(char));
	      strcpy(values[irow][k],(*row)[ind[k]].Text());
	    } else {
	      values[irow][k] = (char *) calloc(2,sizeof(char));
	      strcpy(values[irow][k],"?");
	    }
	  }
	  if (row) delete row;
	}
	for (j=il; j < rowIncrement; j++) {  // fill in the rest of the table with blank rows.
	  irow = rowIncrement*i + j;
	  values[irow] = get_blank_row_with_defaults(cb, itemList, nColsView,nCols);
	  // Set the current enumerate value in column 0.
	  free(values[irow][0]);
	  values[irow][0] = (char *)calloc(strlen(itenum[i])+1,sizeof(char));
	  strcpy(values[irow][0],itenum[i]);
	}
      } else {
	for (j=0; j < rowIncrement; j++) {
	  irow = rowIncrement*i + j;
	  values[irow] = get_blank_row_with_defaults(cb, itemList, nColsView,nCols);
	  // Set the current enumerate value in column 0.
	  free(values[irow][0]);
	  values[irow][0] = (char *)calloc(strlen(itenum[i])+1,sizeof(char));  
	  strcpy(values[irow][0],itenum[i]);
	}
      }
      if (iResult) delete iResult;

    }

    CifString * categoryViewName = vobj->GetViewCategory(category);
    ndb_log_message_text(NDB_MSG_DEBUG,"Creating table %s form view name %s", category,categoryViewName->Text());
    //
    //    Write the form elements to stdout and to the cache file...
    //
    ht_put_content_type_target(stdout,"item");

    switch (istyle) {

    case 1:
      write_category_form_t1_S1(stdout, cb, blockId, category, categoryViewName->Text(), ufid, 
			     (const char ***)values, itemList, nColsView, nTables, rowIncrement, nCols);
      break;
    case 0:
    default:
      write_category_form_t1(stdout, cb, blockId, category, categoryViewName->Text(), ufid, 
			    (const char ***)values, itemList, nColsView, nTables, rowIncrement, nCols);
      break;
    }

    strcpy(fName,dirPath);
    strcat(fName,HT_ITEM_LIST_NAME);
    fp = fopen(fName,"w");

    switch (istyle) {

    case 1:
      write_category_form_t1_S1(fp, cb, blockId, category, categoryViewName->Text(), ufid, 
			      (const char ***)values, itemList, nColsView, nTables, rowIncrement, nCols);
      break;
    case 0:
    default:
      write_category_form_t1(fp, cb, blockId, category, categoryViewName->Text(), ufid, 
			      (const char ***)values, itemList, nColsView, nTables, rowIncrement, nCols);
      break;
    }

    fclose(fp);
    
  }
  
  
}


void make_category_form_from_view_t5(CifViewObj *vobj, CifBuilder &cb, CifFileObj * fobj, 
					    const char *dirPath, const char *blockId, const char *category, 
					    const char *ufid, int istyle)
  /* ****************************************************************************
   *   Build memory model for category display format  T5
   * 
   *   View Column 0 & 1 & 3 - enumerated and composite keys.  
   *   Builds a set of subtables for each enumerate of column 0 with number of tables defined
   *   defined by number of enumerates in column 1. The row length of each table is the 
   *   number of enumerates in column 3.
   */
{
  int errCode;
  char *sItem0=NULL, *sItem1=NULL, *sItem2=NULL;
  char **itenum0=NULL, **itenum1=NULL, **itenum2=NULL;
  uWord nitenum0, nitenum1=0, nitenum2=0;
  
  char ***values=NULL;
  ISTable * t = NULL; 
  CIFVIEWOBJITEM *itemList;
  
  ReVarCifArray<CifString> * row = NULL, *colNamesView = NULL;
  int *ind=NULL;

  int nCols = 0, i, j, k, m, irow, nColsView=0;

  CifString cs;
  ReVarPCifArray<int> *iResult0=NULL, *iResult1=NULL, *iResult2=NULL, *iResult3=NULL, *iResult=NULL;

  FILE *fp=NULL;
  char fName[HT_MAX_NAME_LENGTH];

  ndb_log_message_text(NDB_MSG_DEBUG,"make_category_form_from_view_t5: Entering");


  t=fobj->GetTablePtr(blockId,category);
  if (t != NULL) 
    itemList = build_item_obj_list_w_table(vobj, category, &nColsView, t);
  else
    itemList = build_item_obj_list(vobj, category, &nColsView);

  ndb_log_message_text(NDB_MSG_DEBUG,"make_category_form_from_view_t5: view category %s has %d columns",
		       category,nColsView);
  //
  // Get enumeration list for the first column ...
  //
  sItem0 = get_dictionary_item_name(cb,itemList[0].item);
  ndb_log_message_text(NDB_MSG_DEBUG,"View item %s  item %s standard name %s",
		       itemList[0].viewName,itemList[0].item,sItem0);

  nitenum0 = 0;
  itenum0 = cb.GetItemEnumerationNDB(sItem0,nitenum0);
  if (nitenum0 == 0 && itenum0 == NULL)  itenum0 = cb.GetItemEnumeration(sItem0,nitenum0);
  ndb_log_message_text(NDB_MSG_DEBUG,"View item %s has enum length %d",itemList[0].viewName,nitenum0);

  if (nitenum0 == 0) {
    ndb_log_message_text(NDB_MSG_DEBUG,"Column 0 must be enumerated for this display style");
    return;
  }

  sItem1 = get_dictionary_item_name(cb,itemList[1].item);
  ndb_log_message_text(NDB_MSG_DEBUG,"View item %s  item %s standard name %s",
		       itemList[1].viewName,itemList[1].item,sItem1);

  nitenum1 = 0;
  itenum1 = cb.GetItemEnumerationNDB(sItem1,nitenum1);
  if (nitenum1 == 0 && itenum1 == NULL)  itenum1 = cb.GetItemEnumeration(sItem1,nitenum1);
  ndb_log_message_text(NDB_MSG_DEBUG,"View item %s has enum length %d",itemList[1].viewName,nitenum1);

  if (nitenum1 == 0) {
    ndb_log_message_text(NDB_MSG_DEBUG,"Column 1 must be enumerated for this display style");
    return;
  }

  sItem2 = get_dictionary_item_name(cb,itemList[2].item);
  ndb_log_message_text(NDB_MSG_DEBUG,"View item %s  item %s standard name %s",
		       itemList[2].viewName,itemList[2].item,sItem2);

  nitenum2 = 0;
  itenum2 = cb.GetItemEnumerationNDB(sItem2,nitenum2);
  if (nitenum2 == 0 && itenum2 == NULL)  itenum2 = cb.GetItemEnumeration(sItem2,nitenum2);
  ndb_log_message_text(NDB_MSG_DEBUG,"View item %s has enum length %d",itemList[2].viewName,nitenum2);

  if (nitenum2 == 0) {
    ndb_log_message_text(NDB_MSG_DEBUG,"Column 2 must be enumerated for this display style");
    return;
  }

  
  if ( t != NULL) {
    nCols = t->GetNumColumns();
    values = (char ***) calloc(nitenum0*nitenum1*nitenum2, sizeof(char **));
    for (i=0; i < nitenum0*nitenum1*nitenum2; i++) { // allocate the rows of the category
      values[i] = (char **) calloc(nCols,sizeof(char *));
    }
    colNamesView = vobj->GetCategoryItems(category);
    ind = vobj->GetItemColumnIndices(t,colNamesView);

    for (i=0; i < nCols; i++ ) {
      ndb_log_message_text(NDB_MSG_DEBUG,"Column %s index %d", (*colNamesView)[i].Text(),ind[i]);
    }

    // Insert initial values including enumerates ...

    for (i=0; i < nitenum0; i++) {
      for (j=0; j < nitenum1; j++) {
	for (m=0; m < nitenum2; m++) {
	  irow = i*nitenum1*nitenum2 + j*nitenum2 + m;
	  values[irow] = get_blank_row_with_defaults(cb, itemList, nColsView,nCols);
	  free(values[irow][0]);
	  values[irow][0] = (char *)calloc(strlen(itenum0[i])+1,sizeof(char));
	  strcpy(values[irow][0],itenum0[i]);
	  free(values[irow][1]);
	  values[irow][1] = (char *)calloc(strlen(itenum1[j])+1,sizeof(char));
	  strcpy(values[irow][1],itenum1[j]);
	  free(values[irow][2]);
	  values[irow][2] = (char *)calloc(strlen(itenum2[m])+1,sizeof(char));
	  strcpy(values[irow][2],itenum2[m]);
	  
	}
      }
    }
    
    // Fill in values from the persistent table
    // search for the occurences of each enumerate
#if 0    
    if (!t->isIndexed(ind[0])) {     // make column 0 searchable if required ... 
      ReVarCifArray<CifString> *col0 = t->GetColumn(ind[0]);
      ReVarCifArray<CifString> *colNames0 = t->GetColumnNames();
      t->RemoveColumn(ind[0]); t->InsertColumn((*colNames0)[ind[0]].Text(),ind[0],1);
      t->FillColumn(*col0,ind[0]);
    }

    if (!t->isIndexed(ind[1])) {     // make column 1 searchable if required ... 
      ReVarCifArray<CifString> *col1 = t->GetColumn(ind[1]);
      ReVarCifArray<CifString> *colNames1 = t->GetColumnNames();
      t->RemoveColumn(ind[1]); t->InsertColumn((*colNames1)[ind[1]].Text(),ind[1],1);
      t->FillColumn(*col1,ind[1]);
    }

    if (!t->isIndexed(ind[2])) {     // make column 2 searchable if required ... 
      ReVarCifArray<CifString> *col2 = t->GetColumn(ind[2]);
      ReVarCifArray<CifString> *colNames2 = t->GetColumnNames();
      t->RemoveColumn(ind[2]); t->InsertColumn((*colNames2)[ind[2]].Text(),ind[2],1);
      t->FillColumn(*col2,ind[2]);
    }
#endif
    for (i=0; i < nitenum0; i++) {
      cs.Clear(); cs.Copy(itenum0[i]);
      iResult0 = t->SearchColumn(cs,ind[0],errCode);
      ndb_log_message_text(NDB_MSG_DEBUG,"Search target %s index %d errCode %d",cs.Text(),ind[0],errCode);
      if (!errCode && iResult0 && (iResult0->Length() > 0)) {
	ndb_log_message_text(NDB_MSG_DEBUG,"Search length for %s is %d",cs.Text(),iResult0->Length());
	for (j=0; j < nitenum1; j++) {
	  cs.Clear(); cs.Copy(itenum1[j]);
	  iResult1 = t->SearchColumn(cs,ind[1],errCode);
	  ndb_log_message_text(NDB_MSG_DEBUG,"XX Searching column %d for %s errCode is  %d",
			       ind[1],cs.Text(), errCode);

	  if (!errCode && iResult1 && (iResult1->Length() > 0)) {
	    ndb_log_message_text(NDB_MSG_DEBUG,"XX Search length for %s is %d",cs.Text(),iResult1->Length());
	    iResult3 = ISTable::SetIntersect(iResult0, iResult1);
	    if (iResult3 && (iResult3->Length() > 0)) {
	      for (m=0; m < nitenum2; m++) {
		irow = i*nitenum1*nitenum2 + j*nitenum2 + m;
		cs.Clear(); cs.Copy(itenum2[m]);
		iResult2 = t->SearchColumn(cs,ind[2],errCode);
		ndb_log_message_text(NDB_MSG_DEBUG,"Search target %s index %d errCode %d",cs.Text(),ind[2],errCode);
		if (!errCode && iResult2 && (iResult2->Length() > 0)) {
		  ndb_log_message_text(NDB_MSG_DEBUG,"YY Search length for %s is %d",cs.Text(),iResult2->Length());
		  iResult = ISTable::SetIntersect(iResult3, iResult2);
		  if (iResult && (iResult->Length() > 0)) {

		    ndb_log_message_text(NDB_MSG_DEBUG,"Final Intersect length is %d",iResult->Length());
		    row=t->GetRow((*iResult)[0]);
		    for (k=0; k < nCols; k++) {  // Note:  Full column width of data loaded in values[][]
		      ndb_log_message_text(NDB_MSG_DEBUG,"Fetching column %d index %d length %d",
					   k, ind[k],(*row)[ind[k]].Length());
		      if ((*row)[ind[k]].Length() > 0 ) {
			free(values[irow][k]);
			values[irow][k] = (char *) calloc(((*row)[ind[k]].Length()+1),sizeof(char));
			strcpy(values[irow][k],(*row)[ind[k]].Text());
		      } else {
			free(values[irow][k]);
			values[irow][k] = (char *) calloc(2,sizeof(char));
			strcpy(values[irow][k],"?");
		      }
		      ndb_log_message_text(NDB_MSG_DEBUG,"Value row %d col %d is %s",irow,k,values[irow][k]);
		    }
		    if (row) delete row;
		    if (iResult) delete iResult;
		  } 
		  if (iResult2) delete iResult2;
		}
	      }
	      if (iResult3) delete iResult3;
	
	    }
	    if (iResult1) delete iResult1;	    
	  }
	}
	if (iResult0) delete iResult0;
      }
    }

    CifString * categoryViewName = vobj->GetViewCategory(category);
    ndb_log_message_text(NDB_MSG_DEBUG,"Creating table %s form view name %s", category, categoryViewName->Text());
    //
    //    Write the form elements to stdout and to the cache file...
    //

    ht_put_content_type_target(stdout,"item");

    switch (istyle) {
    case 1:
      write_category_form_t5_S1(stdout, cb, blockId, category, categoryViewName->Text(), ufid, 
				(const char ***)values, itemList, nColsView, nitenum0, nitenum1, nitenum2, nCols);
      break;
    case 0:
    default:
      write_category_form_t5(stdout, cb, blockId, category, categoryViewName->Text(), ufid, 
			     (const char ***)values, itemList, nColsView, nitenum0, nitenum1, nitenum2, nCols);
      break;
    }
    
    strcpy(fName,dirPath);
    strcat(fName,HT_ITEM_LIST_NAME);
    fp = fopen(fName,"w");
    switch (istyle) {
    case 1:
      write_category_form_t5_S1(fp, cb, blockId, category, categoryViewName->Text(), ufid, 
				(const char ***)values, itemList, nColsView, nitenum0,  nitenum1, nitenum2,nCols);
      break;
    case 0:
    default:
      
      write_category_form_t5(fp, cb, blockId, category, categoryViewName->Text(), ufid, 
			     (const char ***)values, itemList, nColsView, nitenum0,  nitenum1, nitenum2,nCols);
      break;
    }
    fclose(fp);
    
  }
}


void write_category_form_t5_S1(FILE *fp, CifBuilder &cb,  const char *blockId, const char *category,  
			       const char *categoryViewName,  
			       const char *ufid, 
			       const char ***values, 
			       const CIFVIEWOBJITEM *itemList, int nitemsView,
			       int numTables, int numSubTables, int nRows, int nCols)
{
  int  i, j, k,  n, irow, numView;;
  char   *sItem=NULL;
  char ***itenum=NULL;
  uWord *nitenum=NULL;
  char *typeCode=NULL;
  int *iTypeCode=NULL;


  char pName[CIF_MAX_NAME_LENGTH];
  char pNameAlt[CIF_MAX_NAME_LENGTH];

   
  fprintf(fp,"<HTML>\n");
  fprintf(fp,"%s\n",LANG_HTML_BODY_SCHEME_ALT_2);
  fprintf(fp,"<center><font face=\"%s\" size=5>%s</font>",LANG_HTML_FONT_FACE,LANG_ENTER_DATA_TITLE);


  fprintf(fp,"<font size=5 color=\"#900000\"> %s</font></center>",categoryViewName);

  //
  //       Category help is displayed at the top of the display ...
  //
  display_category_help(fp, cb, category);



  fprintf(fp,"<FORM METHOD=\"POST\" ACTION=\"%s%s%s\" TARGET=\"other\">\n",
	  HT_SERVER_NAME,
	  HT_CGI_PATH,
	  HT_INTERFACE_READ_FORM_CATEGORY);
  
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_UNIQUE_ID, ufid);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_CATEGORY_ID,category);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_DATABLOCK_ID,blockId);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_NUM_ITEMS,nCols);  
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_NUM_ROWS,nRows*numTables*numSubTables);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_FORM_LAYOUT,5);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY);

  fprintf(fp,"<center><font size=4 color=\"#900000\"><INPUT TYPE=SUBMIT VALUE=\"Save %s\"></font></center>",
	  categoryViewName);

  nitenum    = (uWord *)  calloc(nCols, sizeof(int));
  itenum     = (char ***)calloc(nCols, sizeof(char **));
  iTypeCode = (int *)  calloc(nCols, sizeof(int));



  for (k=1; k < nCols; k++) {
    sItem = get_dictionary_item_name(cb,itemList[k].item);
    if (sItem == NULL) continue;
    nitenum[k] = 0;
    itenum[k]=get_sorted_enumeration_list(cb,sItem, nitenum[k]);

    typeCode = cb.GetItemType(sItem);
    iTypeCode[k]=get_item_type_code(typeCode);
    ndb_log_message_text(NDB_MSG_DEBUG,"Item %s enumerates %d type %s type code %d",			
			 sItem,nitenum[k], typeCode, iTypeCode[k]);

    if (sItem) free(sItem);
    if (typeCode) free(typeCode);
  }

  numView=0;
  for (k=1; k < nitemsView; k++) {
    if (itemList[k].mandatoryCode != VIEW_ITEM_IS_HIDDEN) numView++;
  }

  for (n=0; n < numTables; n++) {
    for (i=0; i < numSubTables; i++) {
      for (j=0; j < nRows; j++) {
	irow = n*nRows*numSubTables + nRows*i + j;

	if (j==0) {
	  fprintf(fp,"<br><br>");
	  fprintf(fp,"<center>");
	  fprintf(fp,"<table cellpadding=4 border bgcolor=\"%s\">",BGCOLOR_TABLE);
	  fprintf(fp,"<tr><th colspan=%d bgcolor=\"%s\"><font size=4 color=\"#000000\">%s %s ",
		  numView*2,BGCOLOR_TABLE_TITLE, 
		  categoryViewName,get_table_attribute_name(itemList[0].viewName));
	  fprintf(fp,"= <font color=\"#900000\">%s</font></font></b></th></tr>\n",values[irow][0]);
	  
	  
	  fprintf(fp,"<tr>");
	  for (k=1; k < nCols; k++) {
	    if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;
	    switch(itemList[k].mandatoryCode) {
	      
	    case VIEW_ITEM_IS_MANDATORY:
	      fprintf(fp,"<th colspan=2 bgcolor=\"%s\"><FONT SIZE=3 COLOR=\"#900000\"><b>%s</b></FONT></th>",
		      BGCOLOR_TABLE_TITLE,get_table_attribute_name(itemList[k].viewName));
	      break;
	    case VIEW_ITEM_IS_NOT_MANDATORY:
	      fprintf(fp,"<th colspan=2 bgcolor=\"%s\"><FONT SIZE=3><b>%s</b></FONT></th>\n",
		      BGCOLOR_TABLE_TITLE,get_table_attribute_name(itemList[k].viewName));

	      break;
	    }
	  }
	  fprintf(fp,"</tr>");

	  fprintf(fp,"<tr>");
	  for (k=1; k < nCols; k++) {
	    if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;
	    fprintf(fp,"<td align=center><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>\n",
		    HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_HELP_VIEW,
		    HT_ATTRIBUTE_UNIQUE_ID,ufid,
		    HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
		    HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
		  HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
		    HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_HELP);
	    
	    fprintf(fp,"<td align=center><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>",
		    HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_EXAMPLES_VIEW,
		    HT_ATTRIBUTE_UNIQUE_ID,ufid,
		    HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
		    HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
		  HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
		    HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_EXAMPLES);
	  }
	  fprintf(fp,"</tr>");
	}
	
	fprintf(fp,"<tr>");
	if (j ==0) {
	  fprintf(fp,"<td colspan=2 rowspan=%d valign=top align=center><font size=4><b>%s</b></font></td>\n",
		  nRows,values[irow][1]);
	}

	fprintf(fp,"<td colspan=2 valign=top align=center><font size=4><b>%s</b></font></td>\n",values[irow][2]);
      
	for (k=3; k < nCols; k++) {

	  encode_table_param_name(pName,irow,k,0);
	  encode_table_param_name(pNameAlt,irow,k,1);      

	  if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;
	  fprintf(fp,"<td colspan=2>");

	  if (nitenum[k] == 0) { // Enumerated, No ...
	    
	    write_input_item_value(fp, pName, values[irow][k], iTypeCode[k]);
	  } else {  // Enumerated, Yes ... 
	    
	    write_input_enum_item_value(fp, values[irow][k], pName, pNameAlt, (const char **)itenum[k], nitenum[k], 
				    itemList[k].allowAlternateCode);
	  }
	  fprintf(fp,"</td>");
	}
	fprintf(fp,"</tr>");
      }
      fprintf(fp,"</table><br><br>");

      for (j=0; j < nRows; j++) { // Fill in data values for missing columns ... 
	irow = n*nRows*numSubTables + nRows*i + j;
	encode_table_param_name(pName,irow,0,0);
	fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",pName,values[irow][0]);
	encode_table_param_name(pName,irow,1,0);
	fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",pName,values[irow][1]);
	encode_table_param_name(pName,irow,2,0);
	fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",pName,values[irow][2]);
	
	for (k=3; k < nCols; k++) {
	  encode_table_param_name(pName,irow,k,0);
	  if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) {
	    fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",pName,values[irow][k]);
	  }
	}
      }
    }
  }

  fprintf(fp,"</center>");    
  if (numTables > 1)   fprintf(fp,"<center><font size=4 color=\"#900000\"><INPUT TYPE=SUBMIT VALUE=\"Save %s\"></font></center>",
			       categoryViewName);
    
  fprintf(fp,"</FORM>\n");
  fprintf(fp,"</BODY>\n");
  fprintf(fp,"</HTML>\n");
  
  for (i=0; i < nCols; i++) {
    for (j=1; j < nitenum[i]; j++){
      if (itenum[i][j] != NULL) free(itenum[i][j]);
    }
    if (itenum[i] != NULL) free(itenum[i]);
  }

  if (nitenum != NULL )  free(nitenum);
  if (iTypeCode != NULL )  free(iTypeCode);
}


void write_category_form_t5(FILE *fp, CifBuilder &cb,  const char *blockId, const char *category,  
			    const char *categoryViewName,  
			    const char *ufid, 
			    const char ***values, 
			    const CIFVIEWOBJITEM *itemList, int nitemsView,
			    int numTables, int numSubTables, int nRows, int nCols)
{
  int  i, j, k,  n, irow, numView;;
  char   *sItem=NULL;
  char ***itenum=NULL;
  uWord *nitenum=NULL;
  char *typeCode=NULL;
  int *iTypeCode=NULL;


  char pName[CIF_MAX_NAME_LENGTH];
  char pNameAlt[CIF_MAX_NAME_LENGTH];

   
  fprintf(fp,"<HTML>\n");
  fprintf(fp,"%s\n",LANG_HTML_BODY_SCHEME_ALT_2);
  fprintf(fp,"<center><font face=\"%s\" size=5>%s</font>",LANG_HTML_FONT_FACE,LANG_ENTER_DATA_TITLE);


  fprintf(fp,"<font size=5 color=\"#900000\"> %s</font></center>",categoryViewName);

  //
  //       Category help is displayed at the top of the display ...
  //
  display_category_help(fp, cb, category);


  fprintf(fp,"<FORM METHOD=\"POST\" ACTION=\"%s%s%s\" TARGET=\"other\">\n",
	  HT_SERVER_NAME,
	  HT_CGI_PATH,
	  HT_INTERFACE_READ_FORM_CATEGORY);
  
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_UNIQUE_ID, ufid);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_CATEGORY_ID,category);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_DATABLOCK_ID,blockId);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_NUM_ITEMS,nCols);  
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_NUM_ROWS,nRows*numTables*numSubTables);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_FORM_LAYOUT,5);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY);

  fprintf(fp,"<center><font size=4 color=\"#900000\"><INPUT TYPE=SUBMIT VALUE=\"Save %s\"></font></center>",
	  categoryViewName);

  nitenum    = (uWord *)  calloc(nCols, sizeof(int));
  itenum     = (char ***)calloc(nCols, sizeof(char **));
  iTypeCode = (int *)  calloc(nCols, sizeof(int));



  for (k=1; k < nCols; k++) {
    sItem = get_dictionary_item_name(cb,itemList[k].item);
    if (sItem == NULL) continue;
    nitenum[k] = 0;
    itenum[k]=get_sorted_enumeration_list(cb,sItem, nitenum[k]);

    typeCode = cb.GetItemType(sItem);
    iTypeCode[k]=get_item_type_code(typeCode);
    ndb_log_message_text(NDB_MSG_DEBUG,"Item %s enumerates %d type %s type code %d",			
			 sItem,nitenum[k], typeCode, iTypeCode[k]);

    if (sItem) free(sItem);
    if (typeCode) free(typeCode);
  }

  numView=0;
  for (k=1; k < nitemsView; k++) {
    if (itemList[k].mandatoryCode != VIEW_ITEM_IS_HIDDEN) numView++;
  }

  for (n=0; n < numTables; n++) {
    for (i=0; i < numSubTables; i++) {
      for (j=0; j < nRows; j++) {
	irow = n*nRows*numSubTables + nRows*i + j;

	if (j==0) {
	  fprintf(fp,"<br><br>");
	  fprintf(fp,"<center>");
	  fprintf(fp,"<table cellpadding=4 border bgcolor=\"%s\">",BGCOLOR_TABLE);
	  fprintf(fp,"<tr><th colspan=%d bgcolor=\"%s\"><font size=4 color=\"#000000\">%s %s ",
		  numView*3,BGCOLOR_TABLE_TITLE, 
		  categoryViewName,get_table_attribute_name(itemList[0].item));
	  fprintf(fp,"= <font color=\"#900000\">%s</font></font></b></th></tr>\n",values[irow][0]);
	  
	  
	  fprintf(fp,"<tr>");
	  for (k=1; k < nCols; k++) {
	    if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;
	    switch(itemList[k].mandatoryCode) {
	      
	    case VIEW_ITEM_IS_MANDATORY:
	      fprintf(fp,"<th colspan=3 bgcolor=\"%s\"><FONT SIZE=3 COLOR=\"#900000\"><b>%s</b></FONT></th>",
		      BGCOLOR_TABLE_TITLE,get_table_attribute_name(itemList[k].viewName));
	      break;
	    case VIEW_ITEM_IS_NOT_MANDATORY:
	      fprintf(fp,"<th colspan=3 bgcolor=\"%s\"><FONT SIZE=3><b>%s</b></FONT></th>\n",
		      BGCOLOR_TABLE_TITLE,get_table_attribute_name(itemList[k].viewName));

	      break;
	    }
	  }
	  fprintf(fp,"</tr>");

	  fprintf(fp,"<tr>");
	  for (k=1; k < nCols; k++) {
	    if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;
	    fprintf(fp,"<td align=center><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>\n",
		    HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_HELP_VIEW,
		    HT_ATTRIBUTE_UNIQUE_ID,ufid,
		    HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
		    HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
		  HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
		    HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_HELP);
	    
	    fprintf(fp,"<td align=center><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>\n",
		    HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_DESCRIPTION_VIEW,
		    HT_ATTRIBUTE_UNIQUE_ID,ufid,
		    HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
		    HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
		  HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
		    HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_DESCRIBE);
	    
	    
	    fprintf(fp,"<td align=center><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>",
		    HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_EXAMPLES_VIEW,
		    HT_ATTRIBUTE_UNIQUE_ID,ufid,
		    HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
		    HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
		  HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
		    HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_EXAMPLES);
	  }
	  fprintf(fp,"</tr>");
	}
	
	fprintf(fp,"<tr>");
	if (j ==0) {
	  fprintf(fp,"<td colspan=3 rowspan=%d valign=top align=center><font size=4><b>%s</b></font></td>\n",
		  nRows,values[irow][1]);
	}

	fprintf(fp,"<td colspan=3 valign=top align=center><font size=4><b>%s</b></font></td>\n",values[irow][2]);
      
	for (k=3; k < nCols; k++) {

	  encode_table_param_name(pName,irow,k,0);
	  encode_table_param_name(pNameAlt,irow,k,1);      

	  if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;
	  fprintf(fp,"<td colspan=3>");

	  if (nitenum[k] == 0) { // Enumerated, No ...
	    
	    write_input_item_value(fp, pName, values[irow][k], iTypeCode[k]);
	  } else {  // Enumerated, Yes ... 
	    
	    write_input_enum_item_value(fp, values[irow][k], pName, pNameAlt, (const char **)itenum[k], nitenum[k], 
				    itemList[k].allowAlternateCode);
	  }
	  fprintf(fp,"</td>");
	}
	fprintf(fp,"</tr>");
      }
      fprintf(fp,"</table><br><br>");

      for (j=0; j < nRows; j++) { // Fill in data values for missing columns ... 
	irow = n*nRows*numSubTables + nRows*i + j;
	encode_table_param_name(pName,irow,0,0);
	fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",pName,values[irow][0]);
	encode_table_param_name(pName,irow,1,0);
	fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",pName,values[irow][1]);
	encode_table_param_name(pName,irow,2,0);
	fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",pName,values[irow][2]);
	
	for (k=3; k < nCols; k++) {
	  encode_table_param_name(pName,irow,k,0);
	  if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) {
	    fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",pName,values[irow][k]);
	  }
	}
      }
    }
  }

  fprintf(fp,"</center>");    
  if (numTables > 1)   fprintf(fp,"<center><font size=4 color=\"#900000\"><INPUT TYPE=SUBMIT VALUE=\"Save %s\"></font></center>",
			       categoryViewName);
    
  fprintf(fp,"</FORM>\n");
  fprintf(fp,"</BODY>\n");
  fprintf(fp,"</HTML>\n");
  
  for (i=0; i < nCols; i++) {
    for (j=1; j < nitenum[i]; j++){
      if (itenum[i][j] != NULL) free(itenum[i][j]);
    }
    if (itenum[i] != NULL) free(itenum[i]);
  }

  if (nitenum != NULL )  free(nitenum);
  if (iTypeCode != NULL )  free(iTypeCode);
}



void make_category_form_from_view_t3(CifViewObj *vobj, CifBuilder &cb, CifFileObj * fobj, 
					    const char *dirPath, const char *blockId, const char *category, 
					    const char *ufid, int istyle)
  /* ****************************************************************************
   *   Build memory model for category display format  T3
   * 
   *   View Column 0 & 1- enumerated and composite keys.  
   *   Builds a subtable for each enumerate of column 0 with number of rows defined
   *   by the number of enumerates of column 1.
   */
{
  int errCode;
  char *sItem0=NULL, *sItem1=NULL;
  char **itenum0=NULL, **itenum1=NULL;
  uWord nitenum0, nitenum1=0;
  
  char ***values=NULL;
  ISTable * t = NULL; 
  CIFVIEWOBJITEM *itemList;
  
  ReVarCifArray<CifString> * row = NULL, *colNamesView = NULL;
  int *ind=NULL;

  int nCols = 0, i, j, k, kk, irow, nColsView=0;

  CifString cs;
  ReVarPCifArray<int> *iResult0=NULL, *iResult1=NULL, *iResult=NULL;

  FILE *fp=NULL;
  char fName[HT_MAX_NAME_LENGTH];

  ndb_log_message_text(NDB_MSG_DEBUG,"make_category_form_from_view_t3: Entering");


  t=fobj->GetTablePtr(blockId,category);
  if (t != NULL) 
    itemList = build_item_obj_list_w_table(vobj, category, &nColsView, t);
  else
    itemList = build_item_obj_list(vobj, category, &nColsView);

  ndb_log_message_text(NDB_MSG_DEBUG,"make_category_form_from_view_t3: view category %s has %d columns",
		       category,nColsView);
  //
  // Get enumeration list for the first column ...
  //
  sItem0 = get_dictionary_item_name(cb,itemList[0].item);
  ndb_log_message_text(NDB_MSG_DEBUG,"View item %s  item %s standard name %s",
		       itemList[0].viewName,itemList[0].item,sItem0);

  nitenum0 = 0;
  itenum0 = cb.GetItemEnumerationNDB(sItem0,nitenum0);
  if (nitenum0 == 0 && itenum0 == NULL)  itenum0 = cb.GetItemEnumeration(sItem0,nitenum0);
  ndb_log_message_text(NDB_MSG_DEBUG,"View item %s has enum length %d",itemList[0].viewName,nitenum0);

  if (nitenum0 == 0) {
    ndb_log_message_text(NDB_MSG_DEBUG,"Column 0 must be enumerated for this display style");
    return;
  }

  sItem1 = get_dictionary_item_name(cb,itemList[1].item);
  ndb_log_message_text(NDB_MSG_DEBUG,"View item %s  item %s standard name %s",
		       itemList[1].viewName,itemList[1].item,sItem1);

  nitenum1 = 0;
  itenum1 = cb.GetItemEnumerationNDB(sItem1,nitenum1);
  if (nitenum1 == 0 && itenum1 == NULL)  itenum1 = cb.GetItemEnumeration(sItem1,nitenum1);
  ndb_log_message_text(NDB_MSG_DEBUG,"View item %s has enum length %d",itemList[1].viewName,nitenum1);

  if (nitenum1 == 0) {
    ndb_log_message_text(NDB_MSG_DEBUG,"Column 1 must be enumerated for this display style");
    return;
  }

  
  if ( t != NULL) {
    nCols = t->GetNumColumns();
    values = (char ***) calloc(nitenum0*nitenum1,sizeof(char **));
    for (i=0; i < nitenum0*nitenum1; i++) { // allocate the rows of the category
      values[i] = (char **) calloc(nCols,sizeof(char *));
    }
    colNamesView = vobj->GetCategoryItems(category);
    ind = vobj->GetItemColumnIndices(t,colNamesView);
    
    // Fill in values from the persistent table
    // search for the occurences of each enumerate
#if 0
    if (!t->isIndexed(ind[0])) {     // make column 0 searchable if required ... 
      ReVarCifArray<CifString> *col0 = t->GetColumn(ind[0]);
      ReVarCifArray<CifString> *colNames0 = t->GetColumnNames();
      t->RemoveColumn(ind[0]); t->InsertColumn((*colNames0)[ind[0]].Text(),ind[0],1);
      t->FillColumn(*col0,ind[0]);
    }

    if (!t->isIndexed(ind[1])) {     // make column 1 searchable if required ... 
      ReVarCifArray<CifString> *col1 = t->GetColumn(ind[1]);
      ReVarCifArray<CifString> *colNames1 = t->GetColumnNames();
      t->RemoveColumn(ind[1]); t->InsertColumn((*colNames1)[ind[1]].Text(),ind[1],1);
      t->FillColumn(*col1,ind[1]);
    }
#endif
    for (i=0; i < nitenum0; i++) {
      cs.Clear(); cs.Copy(itenum0[i]);
      iResult0 = t->SearchColumn(cs,ind[0],errCode);
      ndb_log_message_text(NDB_MSG_DEBUG,"Search target %s index %d errCode %d",cs.Text(),ind[0],errCode);
      if (!errCode && iResult0 && (iResult0->Length() > 0)) {
	ndb_log_message_text(NDB_MSG_DEBUG,"Search length for %s is %d",cs.Text(),iResult0->Length());
	for (j=0; j < nitenum1; j++) {
	  irow = nitenum1*i + j;
	  cs.Clear(); cs.Copy(itenum1[j]);
	  iResult1 = t->SearchColumn(cs,ind[1],errCode);
	  if (!errCode && iResult1 && (iResult1->Length() > 0)) {
	    ndb_log_message_text(NDB_MSG_DEBUG,"XX Search length for %s is %d",cs.Text(),iResult1->Length());

	    for (kk=0; kk < iResult0->Length(); kk++) {
	      ndb_log_message_text(NDB_MSG_DEBUG,"result 0 index %d is %d",kk,(*iResult0)[kk]);
	    }
	    for (kk=0; kk < iResult1->Length(); kk++) {
	      ndb_log_message_text(NDB_MSG_DEBUG,"result 1 index %d is %d",kk,(*iResult1)[kk]);
	    }

	    iResult = ISTable::SetIntersect(iResult0, iResult1);
	    if (iResult && (iResult->Length() > 0)) {
	      ndb_log_message_text(NDB_MSG_DEBUG,"Intersect length is %d",iResult->Length());
	      row=t->GetRow((*iResult)[0]);
	      for (k=0; k < nCols; k++) {  // Note:  Full column width of data loaded in values[][]
		ndb_log_message_text(NDB_MSG_DEBUG,"Fetching column %d index %d length %d",
				     k, ind[k],(*row)[ind[k]].Length());
		if ((*row)[ind[k]].Length() > 0 ) {
		  values[irow][k] = (char *) calloc(((*row)[ind[k]].Length()+1),sizeof(char));
		  strcpy(values[irow][k],(*row)[ind[k]].Text());
		} else {
		  values[irow][k] = (char *) calloc(2,sizeof(char));
		  strcpy(values[irow][k],"?");
		}
		ndb_log_message_text(NDB_MSG_DEBUG,"Value row %d col %d is %s",irow,k,values[irow][k]);
	      }
	      if (row) delete row;
	      if (iResult) delete iResult;
	    } else {
	      values[irow] = get_blank_row_with_defaults(cb, itemList, nColsView,nCols);
	      free(values[irow][0]);
	      values[irow][0] = (char *)calloc(strlen(itenum0[i])+1,sizeof(char));
	      strcpy(values[irow][0],itenum0[i]);
	      free(values[irow][1]);
	      values[irow][1] = (char *)calloc(strlen(itenum1[j])+1,sizeof(char));
	      strcpy(values[irow][1],itenum1[j]);
	    }

	  } else {
	      values[irow] = get_blank_row_with_defaults(cb, itemList, nColsView,nCols);
	      free(values[irow][0]);
	      values[irow][0] = (char *)calloc(strlen(itenum0[i])+1,sizeof(char));
	      strcpy(values[irow][0],itenum0[i]);
	      free(values[irow][1]);
	      values[irow][1] = (char *)calloc(strlen(itenum1[j])+1,sizeof(char));
	      strcpy(values[irow][1],itenum1[j]);
	  }
	  if (iResult1) delete iResult1;
	}
	if (iResult0) delete iResult0;
      } else {
      //jdw
	for (j=0; j < nitenum1; j++) {
	  irow = nitenum1*i + j;
	  values[irow] = get_blank_row_with_defaults(cb, itemList, nColsView,nCols);
	  free(values[irow][0]);
	  values[irow][0] = (char *)calloc(strlen(itenum0[i])+1,sizeof(char));
	  strcpy(values[irow][0],itenum0[i]);
	  free(values[irow][1]);
	  values[irow][1] = (char *)calloc(strlen(itenum1[j])+1,sizeof(char));
	  strcpy(values[irow][1],itenum1[j]);
	}
      }
      
    }

    CifString * categoryViewName = vobj->GetViewCategory(category);
    ndb_log_message_text(NDB_MSG_DEBUG,"Creating table %s form view name %s", category, categoryViewName->Text());
    //
    //    Write the form elements to stdout and to the cache file...
    //
    ht_put_content_type_target(stdout,"item");
    
    switch (istyle) {
    case 1:
      write_category_form_t3_S1(stdout, cb, blockId, category, categoryViewName->Text(), ufid, 
				(const char ***)values, itemList, nColsView, nitenum0, nitenum1, nCols);
      break;
    case 0:
    default:
      write_category_form_t3(stdout, cb, blockId, category, categoryViewName->Text(), ufid, 
			     (const char ***)values, itemList, nColsView, nitenum0, nitenum1, nCols);
      break;
    }
    
    strcpy(fName,dirPath);
    strcat(fName,HT_ITEM_LIST_NAME);
    fp = fopen(fName,"w");
    switch (istyle) {
    case 1:
      write_category_form_t3_S1(fp, cb, blockId, category, categoryViewName->Text(), ufid, 
				(const char ***)values, itemList, nColsView, nitenum0, nitenum1, nCols);
      break;

    case 0:
    default:
      write_category_form_t3(fp, cb, blockId, category, categoryViewName->Text(), ufid, 
			     (const char ***)values, itemList, nColsView, nitenum0,  nitenum1, nCols);
      break;
    }
    fclose(fp);
    
  }
}


void write_category_form_t3_S1(FILE *fp, CifBuilder &cb,  const char *blockId, const char *category,  
			       const char *categoryViewName,  
			       const char *ufid, 
			       const char ***values, 
			       const CIFVIEWOBJITEM *itemList, int nitemsView,
			       int numTables, int nRows, int nCols)
{
  int  i, j, k, irow, numView;
  char   *sItem=NULL;
  char ***itenum=NULL;
  uWord *nitenum=NULL;
  char *typeCode=NULL;
  int *iTypeCode=NULL;

  char pName[CIF_MAX_NAME_LENGTH];
  char pNameAlt[CIF_MAX_NAME_LENGTH];

   
  fprintf(fp,"<HTML>\n");
  fprintf(fp,"%s\n",LANG_HTML_BODY_SCHEME_ALT_2);
  fprintf(fp,"<center><font face=\"%s\" size=5>%s</font>",LANG_HTML_FONT_FACE,LANG_ENTER_DATA_TITLE);


  fprintf(fp,"<font size=5 color=\"#900000\"> %s</font></center>",categoryViewName);

  //
  //       Category help is displayed at the top of the display ...
  //
  display_category_help(fp, cb, category);



  fprintf(fp,"<FORM METHOD=\"POST\" ACTION=\"%s%s%s\" TARGET=\"other\">\n",
	  HT_SERVER_NAME,
	  HT_CGI_PATH,
	  HT_INTERFACE_READ_FORM_CATEGORY);
  
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_UNIQUE_ID, ufid);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_CATEGORY_ID,category);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_DATABLOCK_ID,blockId);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_NUM_ITEMS,nCols);  
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_NUM_ROWS,nRows*numTables);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_FORM_LAYOUT,3);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY);

  fprintf(fp,"<center><font size=4 color=\"#900000\"><INPUT TYPE=SUBMIT VALUE=\"Save %s\"></font></center>",
	  categoryViewName);

  nitenum    = (uWord *)  calloc(nCols, sizeof(int));
  itenum     = (char ***)calloc(nCols, sizeof(char **));
  iTypeCode = (int *)  calloc(nCols, sizeof(int));



  for (k=1; k < nCols; k++) {
    sItem = get_dictionary_item_name(cb,itemList[k].item);
    if (sItem == NULL) continue;
    nitenum[k] = 0;
    itenum[k]=get_sorted_enumeration_list(cb,sItem, nitenum[k]);

    typeCode = cb.GetItemType(sItem);
    iTypeCode[k]=get_item_type_code(typeCode);
    ndb_log_message_text(NDB_MSG_DEBUG,"Item %s enumerates %d type %s type code %d",			
			 sItem,nitenum[k], typeCode, iTypeCode[k]);

    if (sItem) free(sItem);
    if (typeCode) free(typeCode);
  }

  numView=0;
  for (k=0; k < nitemsView; k++) {
    if (itemList[k].mandatoryCode != VIEW_ITEM_IS_HIDDEN) numView++;
  }

  for (i=0; i < numTables; i++) {
    for (j=0; j < nRows; j++) {
      irow = nRows*i + j;

      if (j==0) {
	fprintf(fp,"<br><br>");
	fprintf(fp,"<center>");
	fprintf(fp,"<table cellpadding=4 border bgcolor=\"%s\">",BGCOLOR_TABLE);
	fprintf(fp,"<tr><th colspan=%d bgcolor=\"%s\"><font size=4 color=\"#000000\">%s",
		numView*2,BGCOLOR_TABLE_TITLE,categoryViewName);

	// fprintf(fp,"%s = <font color=\"#900000\">%s</font></font></b></th></tr>\n",
	//         get_table_attribute_name(itemList[0].viewName),
	//         values[irow][0]);
	

	fprintf(fp,"<tr>");
	for (k=0; k < nCols; k++) {
	  if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;
	  switch(itemList[k].mandatoryCode) {

	  case VIEW_ITEM_IS_MANDATORY:
	    fprintf(fp,"<th colspan=2 bgcolor=\"%s\"><FONT SIZE=3 COLOR=\"#900000\"><b>%s</b></FONT></th>",
		    BGCOLOR_TABLE_TITLE,get_table_attribute_name(itemList[k].viewName));
	    break;
	  case VIEW_ITEM_IS_NOT_MANDATORY:
	    fprintf(fp,"<th colspan=2 bgcolor=\"%s\"><FONT SIZE=3><b>%s</b></FONT></th>\n",
		    BGCOLOR_TABLE_TITLE,get_table_attribute_name(itemList[k].viewName));
	    break;
	  }
	}
	fprintf(fp,"</tr>");

	fprintf(fp,"<tr>");
	for (k=0; k < nCols; k++) {
	  if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;
	  fprintf(fp,"<td align=center><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>\n",
		  HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_HELP_VIEW,
		  HT_ATTRIBUTE_UNIQUE_ID,ufid,
		  HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
		  HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
		  HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
		  HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_HELP);
	  
	  fprintf(fp,"<td align=center><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>",
		  HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_EXAMPLES_VIEW,
		  HT_ATTRIBUTE_UNIQUE_ID,ufid,
		  HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
		  HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
		  HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
		  HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_EXAMPLES);
	}
	fprintf(fp,"</tr>");
      }

      fprintf(fp,"<tr>");
      if (j ==0) {
	fprintf(fp,"<td colspan=2 rowspan=%d valign=top align=center><font size=4><b>%s</b></font></td>\n",
	      nRows,values[irow][0]);
      }

      fprintf(fp,"<td colspan=2 valign=top align=center><font size=4><b>%s</b></font></td>\n",
      	      values[irow][1]);
      
      for (k=2; k < nCols; k++) {

	encode_table_param_name(pName,irow,k,0);
	encode_table_param_name(pNameAlt,irow,k,1);      

	if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;
	fprintf(fp,"<td colspan=2>");
	if (nitenum[k] == 0) { // Enumerated, No ...
	  
	  write_input_item_value(fp, pName, values[irow][k], iTypeCode[k]);
	} else {  // Enumerated, Yes ... 
	  
	  write_input_enum_item_value(fp, values[irow][k], pName, pNameAlt, (const char **)itenum[k], nitenum[k], 
				      itemList[k].allowAlternateCode);
	}
	fprintf(fp,"</td>");
      }
      fprintf(fp,"</tr>");
    }
    fprintf(fp,"</table><br><br>");
    for (j=0; j < nRows; j++) { // Fill in data values for missing columns ... 
      irow = nRows*i + j;
      encode_table_param_name(pName,irow,0,0);
      fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",pName,values[irow][0]);
      encode_table_param_name(pName,irow,1,0);
      fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",pName,values[irow][1]);

      for (k=2; k < nCols; k++) {
	encode_table_param_name(pName,irow,k,0);
	if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) {
	  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",pName,values[irow][k]);
	}
      }
    }

    fprintf(fp,"</center>");
  }
  //  fprintf(fp,"</ul>");
  
  if (numTables > 1)   fprintf(fp,"<center><font size=4 color=\"#900000\"><INPUT TYPE=SUBMIT VALUE=\"Save %s\"></font></center>",
			       categoryViewName);

  fprintf(fp,"</FORM>\n");
  fprintf(fp,"</BODY>\n");
  fprintf(fp,"</HTML>\n");

  for (i=0; i < nCols; i++) {
    for (j=1; j < nitenum[i]; j++){
      if (itenum[i][j] != NULL) free(itenum[i][j]);
    }
    if (itenum[i] != NULL) free(itenum[i]);
  }
  if (nitenum != NULL )  free(nitenum);
  if (iTypeCode != NULL )  free(iTypeCode);
}


void write_category_form_t3(FILE *fp, CifBuilder &cb,  const char *blockId, const char *category,  
			    const char *categoryViewName,  
			    const char *ufid, 
			    const char ***values, 
			    const CIFVIEWOBJITEM *itemList, int nitemsView,
			    int numTables, int nRows, int nCols)
{
  int  i, j, k, irow, numView;
  char   *sItem=NULL;
  char ***itenum=NULL;
  uWord *nitenum=NULL;
  char *typeCode=NULL;
  int *iTypeCode=NULL;

  char pName[CIF_MAX_NAME_LENGTH];
  char pNameAlt[CIF_MAX_NAME_LENGTH];

   
  fprintf(fp,"<HTML>\n");
  fprintf(fp,"%s\n",LANG_HTML_BODY_SCHEME_ALT_2);
  fprintf(fp,"<center><font face=\"%s\" size=5>%s</font>",LANG_HTML_FONT_FACE,LANG_ENTER_DATA_TITLE);


  fprintf(fp,"<font size=5 color=\"#900000\"> %s</font></center>",categoryViewName);

  //
  //       Category help is displayed at the top of the display ...
  //
  display_category_help(fp, cb, category);



  fprintf(fp,"<FORM METHOD=\"POST\" ACTION=\"%s%s%s\" TARGET=\"other\">\n",
	  HT_SERVER_NAME,
	  HT_CGI_PATH,
	  HT_INTERFACE_READ_FORM_CATEGORY);
  
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_UNIQUE_ID, ufid);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_CATEGORY_ID,category);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_DATABLOCK_ID,blockId);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_NUM_ITEMS,nCols);  
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_NUM_ROWS,nRows*numTables);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_FORM_LAYOUT,3);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY);

  fprintf(fp,"<center><font size=4 color=\"#900000\"><INPUT TYPE=SUBMIT VALUE=\"Save %s\"></font></center>",
	  categoryViewName);

  nitenum    = (uWord *)  calloc(nCols, sizeof(int));
  itenum     = (char ***)calloc(nCols, sizeof(char **));
  iTypeCode = (int *)  calloc(nCols, sizeof(int));



  for (k=1; k < nCols; k++) {
    sItem = get_dictionary_item_name(cb,itemList[k].item);
    if (sItem == NULL) continue;
    nitenum[k] = 0;
    itenum[k]=get_sorted_enumeration_list(cb,sItem, nitenum[k]);

    typeCode = cb.GetItemType(sItem);
    iTypeCode[k]=get_item_type_code(typeCode);
    ndb_log_message_text(NDB_MSG_DEBUG,"Item %s enumerates %d type %s type code %d",			
			 sItem,nitenum[k], typeCode, iTypeCode[k]);

    if (sItem) free(sItem);
    if (typeCode) free(typeCode);
  }

  numView=0;
  for (k=0; k < nitemsView; k++) {
    if (itemList[k].mandatoryCode != VIEW_ITEM_IS_HIDDEN) numView++;
  }

  for (i=0; i < numTables; i++) {
    for (j=0; j < nRows; j++) {
      irow = nRows*i + j;

      if (j==0) {
	fprintf(fp,"<br><br>");
	fprintf(fp,"<center>");
	fprintf(fp,"<table cellpadding=4 border bgcolor=\"%s\">",BGCOLOR_TABLE);
	fprintf(fp,"<tr><th colspan=%d bgcolor=\"%s\"><font size=4 color=\"#000000\">%s %s ",
		numView*3,BGCOLOR_TABLE_TITLE,categoryViewName,get_table_attribute_name(itemList[0].item));
	fprintf(fp,"= <font color=\"#900000\">%s</font></font></b></th></tr>\n",values[irow][0]);
	

	fprintf(fp,"<tr>");
	for (k=0; k < nCols; k++) {
	  if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;
	  switch(itemList[k].mandatoryCode) {

	  case VIEW_ITEM_IS_MANDATORY:
	    fprintf(fp,"<th colspan=3 bgcolor=\"%s\"><FONT SIZE=3 COLOR=\"#900000\"><b>%s</b></FONT></th>",
		    BGCOLOR_TABLE_TITLE,get_table_attribute_name(itemList[k].item));
	    break;
	  case VIEW_ITEM_IS_NOT_MANDATORY:
	    fprintf(fp,"<th colspan=3 bgcolor=\"%s\"><FONT SIZE=3><b>%s</b></FONT></th>\n",
		    BGCOLOR_TABLE_TITLE,get_table_attribute_name(itemList[k].item));
	    break;
	  }
	}
	fprintf(fp,"</tr>");

	fprintf(fp,"<tr>");
	for (k=0; k < nCols; k++) {
	  if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;
	  fprintf(fp,"<td align=center><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>\n",
		  HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_HELP_VIEW,
		  HT_ATTRIBUTE_UNIQUE_ID,ufid,
		  HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
		  HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
		  HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
		  HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_HELP);
	  
	  fprintf(fp,"<td align=center><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>\n",
		  HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_DESCRIPTION_VIEW,
		  HT_ATTRIBUTE_UNIQUE_ID,ufid,
		  HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
		  HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
		  HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
		  HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_DESCRIBE);
	  
	  
	  fprintf(fp,"<td align=center><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>",
		  HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_EXAMPLES_VIEW,
		  HT_ATTRIBUTE_UNIQUE_ID,ufid,
		  HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
		  HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
		  HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
		  HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_EXAMPLES);
	}
	fprintf(fp,"</tr>");
      }

      fprintf(fp,"<tr>");
      if (j ==0) {
	fprintf(fp,"<td colspan=3 rowspan=%d valign=top align=center><font size=4><b>%s</b></font></td>\n",
	      nRows,values[irow][0]);
      }

      fprintf(fp,"<td colspan=3 valign=top align=center><font size=4><b>%s</b></font></td>\n",
      	      values[irow][1]);
      
      for (k=2; k < nCols; k++) {

	encode_table_param_name(pName,irow,k,0);
	encode_table_param_name(pNameAlt,irow,k,1);      

	if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;
	fprintf(fp,"<td colspan=3>");
	if (nitenum[k] == 0) { // Enumerated, No ...
	  
	  write_input_item_value(fp, pName, values[irow][k], iTypeCode[k]);
	} else {  // Enumerated, Yes ... 
	  
	  write_input_enum_item_value(fp, values[irow][k], pName, pNameAlt, (const char **)itenum[k], nitenum[k], 
				      itemList[k].allowAlternateCode);
	}
	fprintf(fp,"</td>");
      }
      fprintf(fp,"</tr>");
    }
    fprintf(fp,"</table><br><br>");
    for (j=0; j < nRows; j++) { // Fill in data values for missing columns ... 
      irow = nRows*i + j;
      encode_table_param_name(pName,irow,0,0);
      fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",pName,values[irow][0]);
      encode_table_param_name(pName,irow,1,0);
      fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",pName,values[irow][1]);

      for (k=2; k < nCols; k++) {
	encode_table_param_name(pName,irow,k,0);
	if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) {
	  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",pName,values[irow][k]);
	}
      }
    }

    fprintf(fp,"</center>");
  }
  //  fprintf(fp,"</ul>");
  
  if (numTables > 1)   fprintf(fp,"<center><font size=4 color=\"#900000\"><INPUT TYPE=SUBMIT VALUE=\"Save %s\"></font></center>",
			       categoryViewName);

  fprintf(fp,"</FORM>\n");
  fprintf(fp,"</BODY>\n");
  fprintf(fp,"</HTML>\n");

  for (i=0; i < nCols; i++) {
    for (j=1; j < nitenum[i]; j++){
      if (itenum[i][j] != NULL) free(itenum[i][j]);
    }
    if (itenum[i] != NULL) free(itenum[i]);
  }
  if (nitenum != NULL )  free(nitenum);
  if (iTypeCode != NULL )  free(iTypeCode);
}



void write_category_form_t1(FILE *fp, CifBuilder &cb,  const char *blockId, const char *category,  
			    const char *categoryViewName,  
			    const char *ufid, 
			    const char ***values, 
			    const CIFVIEWOBJITEM *itemList, int nitemsView,
			    int numTables, int nRows, int nCols)
{
  int  i, j, k, irow, numView;
  char   *sItem=NULL;
  char ***itenum=NULL;
  uWord *nitenum=NULL;
  char *typeCode=NULL;
  int *iTypeCode=NULL;


  char pName[CIF_MAX_NAME_LENGTH];
  char pNameAlt[CIF_MAX_NAME_LENGTH];

   
  fprintf(fp,"<HTML>\n");
  fprintf(fp,"%s\n",LANG_HTML_BODY_SCHEME_ALT_2);
  fprintf(fp,"<center><font face=\"%s\" size=5>%s</font>",LANG_HTML_FONT_FACE,LANG_ENTER_DATA_TITLE);


  fprintf(fp,"<font size=5 color=\"#900000\"> %s</font></center>",categoryViewName);

  //
  //       Category help is displayed at the top of the display ...
  //
  display_category_help(fp, cb, category);



  fprintf(fp,"<FORM METHOD=\"POST\" ACTION=\"%s%s%s\" TARGET=\"other\">\n",
	  HT_SERVER_NAME,
	  HT_CGI_PATH,
	  HT_INTERFACE_READ_FORM_CATEGORY);
  
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_UNIQUE_ID, ufid);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_CATEGORY_ID,category);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_DATABLOCK_ID,blockId);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_NUM_ITEMS,nCols);  
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_NUM_ROWS,nRows*numTables);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_FORM_LAYOUT,1);

  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY);


  fprintf(fp,"<center><font size=4 color=\"#900000\"><INPUT TYPE=SUBMIT VALUE=\"Save %s\"></font></center>",
	  categoryViewName);

  nitenum    = (uWord *)  calloc(nCols, sizeof(int));
  itenum     = (char ***)calloc(nCols, sizeof(char **));
  iTypeCode = (int *)  calloc(nCols, sizeof(int));



  for (k=1; k < nCols; k++) {
    sItem = get_dictionary_item_name(cb,itemList[k].item);
    if (sItem == NULL) continue;
    nitenum[k] = 0;
    itenum[k]=get_sorted_enumeration_list(cb,sItem, nitenum[k]);

    typeCode = cb.GetItemType(sItem);
    iTypeCode[k]=get_item_type_code(typeCode);
    ndb_log_message_text(NDB_MSG_DEBUG,"Item %s enumerates %d type %s type code %d",			
			 sItem,nitenum[k], typeCode, iTypeCode[k]);

    if (sItem) free(sItem);
    if (typeCode) free(typeCode);
  }

  numView=0;
  for (k=0; k < nitemsView; k++) {
    if (itemList[k].mandatoryCode != VIEW_ITEM_IS_HIDDEN) numView++;
  }

  for (i=0; i < numTables; i++) {
    for (j=0; j < nRows; j++) {
      irow = nRows*i + j;

      if (j==0) {
	fprintf(fp,"<br><br>");
	fprintf(fp,"<center>");
	fprintf(fp,"<table cellpadding=4 border bgcolor=\"%s\">",BGCOLOR_TABLE);
	fprintf(fp,"<tr><th colspan=%d bgcolor=\"%s\"><font size=4 color=\"#000000\">%s %s ",
		numView*3,BGCOLOR_TABLE_TITLE,categoryViewName,get_table_attribute_name(itemList[0].viewName));
	fprintf(fp,"= <font color=\"#900000\">%s</font></font></b></th></tr>\n",values[irow][0]);
	

	fprintf(fp,"<tr>");
	for (k=0; k < nCols; k++) {
	  if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;
	  switch(itemList[k].mandatoryCode) {

	  case VIEW_ITEM_IS_MANDATORY:
	    fprintf(fp,"<th colspan=3 bgcolor=\"%s\"><FONT SIZE=3 COLOR=\"#900000\"><b>%s</b></FONT></th>",
		    BGCOLOR_TABLE_TITLE,get_table_attribute_name(itemList[k].viewName));
	    break;
	  case VIEW_ITEM_IS_NOT_MANDATORY:
	    fprintf(fp,"<th colspan=3 bgcolor=\"%s\"><FONT SIZE=3><b>%s</b></FONT></th>\n",
		    BGCOLOR_TABLE_TITLE,get_table_attribute_name(itemList[k].viewName));

	    break;
	  }
	}
	fprintf(fp,"</tr>");

	fprintf(fp,"<tr>");
	for (k=0; k < nCols; k++) {
	  if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;
	  fprintf(fp,"<td align=center><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>\n",
		  HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_HELP_VIEW,
		  HT_ATTRIBUTE_UNIQUE_ID,ufid,
		  HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
		  HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
		  HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
		  HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_HELP);
	  
	  fprintf(fp,"<td align=center><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>\n",
		  HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_DESCRIPTION_VIEW,
		  HT_ATTRIBUTE_UNIQUE_ID,ufid,
		  HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
		  HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
		  HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
		  HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_DESCRIBE);
	  
	  
	  fprintf(fp,"<td align=center><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>",
		  HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_EXAMPLES_VIEW,
		  HT_ATTRIBUTE_UNIQUE_ID,ufid,
		  HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
		  HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
		  HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
		  HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_EXAMPLES);
	}
	fprintf(fp,"</tr>");
      }
      fprintf(fp,"<tr>");


      if (j==0) fprintf(fp,"<td colspan=3 rowspan=%d valign=top align=center><font size=4><b>%s</b></font></td>\n",
	      nRows,values[irow][0]);

      for (k=1; k < nCols; k++) {

	encode_table_param_name(pName,irow,k,0);
	encode_table_param_name(pNameAlt,irow,k,1);      

	if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;
	fprintf(fp,"<td colspan=3>");
	if (nitenum[k] == 0) { // Enumerated, No ...
	  
	  write_input_item_value(fp, pName, values[irow][k], iTypeCode[k]);
	} else {  // Enumerated, Yes ... 
	  
	  write_input_enum_item_value(fp, values[irow][k], pName, pNameAlt, (const char **)itenum[k], nitenum[k], 
				      itemList[k].allowAlternateCode);
	}
	fprintf(fp,"</td>");
      }
      fprintf(fp,"</tr>");
    }
    fprintf(fp,"</table><br><br>");
    for (j=0; j < nRows; j++) { // Fill in data values for missing columns ... 
      irow = nRows*i + j;
      encode_table_param_name(pName,irow,0,0);
      fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",pName,values[irow][0]);
      for (k=1; k < nCols; k++) {
	encode_table_param_name(pName,irow,k,0);
	if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) {
	  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",pName,values[irow][k]);
	}
      }
    }

    fprintf(fp,"</center>");
  }
  
  if (numTables > 1)   fprintf(fp,"<center><font size=4 color=\"#900000\"><INPUT TYPE=SUBMIT VALUE=\"Save %s\"></font></center>",
			       categoryViewName);

  fprintf(fp,"</FORM>\n");
  fprintf(fp,"</BODY>\n");
  fprintf(fp,"</HTML>\n");

  for (i=0; i < nCols; i++) {
    for (j=1; j < nitenum[i]; j++){
      if (itenum[i][j] != NULL) free(itenum[i][j]);
    }
    if (itenum[i] != NULL) free(itenum[i]);
  }
  if (nitenum != NULL )  free(nitenum);
  if (iTypeCode != NULL )  free(iTypeCode);
}



void write_category_form_t1_S1(FILE *fp, CifBuilder &cb,  const char *blockId, const char *category,  
			       const char *categoryViewName,  
			       const char *ufid, 
			       const char ***values, 
			       const CIFVIEWOBJITEM *itemList, int nitemsView,
			       int numTables, int nRows, int nCols)
{
  int  i, j, k, irow, numView;
  char   *sItem=NULL;
  char ***itenum=NULL;
  uWord *nitenum=NULL;
  char *typeCode=NULL;
  int *iTypeCode=NULL;

  char pName[CIF_MAX_NAME_LENGTH];
  char pNameAlt[CIF_MAX_NAME_LENGTH];

   
  fprintf(fp,"<HTML>\n");
  fprintf(fp,"%s\n",LANG_HTML_BODY_SCHEME_ALT_2);
  fprintf(fp,"<center><font face=\"%s\" size=5>%s</font>",LANG_HTML_FONT_FACE,LANG_ENTER_DATA_TITLE);


  fprintf(fp,"<font size=5 color=\"#900000\"> %s</font></center>",categoryViewName);

  //
  //       Category help is displayed at the top of the display ...
  //
  display_category_help(fp, cb, category);


  fprintf(fp,"<FORM METHOD=\"POST\" ACTION=\"%s%s%s\" TARGET=\"other\">\n",
	  HT_SERVER_NAME,
	  HT_CGI_PATH,
	  HT_INTERFACE_READ_FORM_CATEGORY);
  
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_UNIQUE_ID, ufid);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_CATEGORY_ID,category);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_DATABLOCK_ID,blockId);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_NUM_ITEMS,nCols);  
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_NUM_ROWS,nRows*numTables);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_FORM_LAYOUT,1);

  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY);


  fprintf(fp,"<center><font size=4 color=\"#900000\"><INPUT TYPE=SUBMIT VALUE=\"Save %s\"></font></center>",
	  categoryViewName);

  nitenum    = (uWord *)  calloc(nCols, sizeof(int));
  itenum     = (char ***)calloc(nCols, sizeof(char **));
  iTypeCode = (int *)  calloc(nCols, sizeof(int));



  for (k=1; k < nCols; k++) {
    sItem = get_dictionary_item_name(cb,itemList[k].item);
    if (sItem == NULL) continue;
    nitenum[k] = 0;
    itenum[k]=get_sorted_enumeration_list(cb,sItem, nitenum[k]);

    typeCode = cb.GetItemType(sItem);
    iTypeCode[k]=get_item_type_code(typeCode);
    ndb_log_message_text(NDB_MSG_DEBUG,"Item %s enumerates %d type %s type code %d",			
			 sItem,nitenum[k], typeCode, iTypeCode[k]);

    if (sItem) free(sItem);
    if (typeCode) free(typeCode);
  }

  numView=0;
  for (k=0; k < nitemsView; k++) {
    if (itemList[k].mandatoryCode != VIEW_ITEM_IS_HIDDEN) numView++;
  }

  for (i=0; i < numTables; i++) {
    for (j=0; j < nRows; j++) {
      irow = nRows*i + j;

      if (j==0) {
	fprintf(fp,"<br><br>");
	fprintf(fp,"<center>");
	fprintf(fp,"<table cellpadding=4 border bgcolor=\"%s\">",BGCOLOR_TABLE);
	fprintf(fp,"<tr><th colspan=%d bgcolor=\"%s\"><font size=4 color=\"#000000\">%s\n",
		numView*2,BGCOLOR_TABLE_TITLE,categoryViewName);

	//	fprintf(fp,"%s = <font color=\"#900000\">%s</font></font></b></th></tr>\n",
	//	get_table_attribute_name(itemList[0].viewName));
	//	values[irow][0]);
	

	fprintf(fp,"<tr>");
	for (k=0; k < nCols; k++) {
	  if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;
	  switch(itemList[k].mandatoryCode) {

	  case VIEW_ITEM_IS_MANDATORY:
	    fprintf(fp,"<th colspan=2 bgcolor=\"%s\"><FONT SIZE=3 COLOR=\"#900000\"><b>%s</b></FONT></th>",
		    BGCOLOR_TABLE_TITLE,get_table_attribute_name(itemList[k].viewName));
	    break;
	  case VIEW_ITEM_IS_NOT_MANDATORY:
	    fprintf(fp,"<th colspan=2 bgcolor=\"%s\"><FONT SIZE=3><b>%s</b></FONT></th>\n",
		    BGCOLOR_TABLE_TITLE,get_table_attribute_name(itemList[k].viewName));

	    break;
	  }
	}
	fprintf(fp,"</tr>");

	fprintf(fp,"<tr>");
	for (k=0; k < nCols; k++) {
	  if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;
	  fprintf(fp,"<td align=center><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>\n",
		  HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_HELP_VIEW,
		  HT_ATTRIBUTE_UNIQUE_ID,ufid,
		  HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
		  HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
		  HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
		  HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_HELP);

	  
	  fprintf(fp,"<td align=center><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>",
		  HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_EXAMPLES_VIEW,
		  HT_ATTRIBUTE_UNIQUE_ID,ufid,
		  HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
		  HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
		  HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
		  HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_EXAMPLES);
	}
	fprintf(fp,"</tr>");
      }
      fprintf(fp,"<tr>");


      if (j==0) fprintf(fp,"<td colspan=2 rowspan=%d valign=top align=center><font size=4><b>%s</b></font></td>\n",
	      nRows,values[irow][0]);

      for (k=1; k < nCols; k++) {

	encode_table_param_name(pName,irow,k,0);
	encode_table_param_name(pNameAlt,irow,k,1);      

	if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;
	fprintf(fp,"<td colspan=2>");
	if (nitenum[k] == 0) { // Enumerated, No ...
	  
	  write_input_item_value(fp, pName, values[irow][k], iTypeCode[k]);
	} else {  // Enumerated, Yes ... 
	  
	  write_input_enum_item_value(fp, values[irow][k], pName, pNameAlt, (const char **)itenum[k], nitenum[k], 
				      itemList[k].allowAlternateCode);
	}
	fprintf(fp,"</td>");
      }
      fprintf(fp,"</tr>");
    }
    fprintf(fp,"</table><br><br>");
    for (j=0; j < nRows; j++) { // Fill in data values for missing columns ... 
      irow = nRows*i + j;
      encode_table_param_name(pName,irow,0,0);
      fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",pName,values[irow][0]);
      for (k=1; k < nCols; k++) {
	encode_table_param_name(pName,irow,k,0);
	if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) {
	  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",pName,values[irow][k]);
	}
      }
    }

    fprintf(fp,"</center>");
  }
  
  if (numTables > 1) {
    fprintf(fp,"<center><font size=4 color=\"#900000\"><INPUT TYPE=SUBMIT VALUE=\"Save %s\"></font></center>",
	    categoryViewName);
  }

  fprintf(fp,"</FORM>\n");
  fprintf(fp,"</BODY>\n");
  fprintf(fp,"</HTML>\n");

  //
  // Clean-up
  //
  for (i=0; i < nCols; i++) {
    for (j=1; j < nitenum[i]; j++){
      if (itenum[i][j] != NULL) free(itenum[i][j]);
    }
    if (itenum[i] != NULL) free(itenum[i]);
  }

  if (nitenum != NULL )  free(nitenum);
  if (iTypeCode != NULL )  free(iTypeCode);
}



void make_category_form_from_view_t0(CifViewObj *vobj, CifBuilder &cb, CifFileObj * fobj, 
				     const char *dirPath, const char *blockId, const char *category, 
				     const char *ufid, int rowCurrent, int rowMaximum, int istyle) 
/*
 *  Display a single row of a category with columns names arranged as a vertical list.
 */
{
    char **values=NULL;
    ISTable * t = NULL; 
    CIFVIEWOBJITEM *itemList;

    ReVarCifArray<CifString> * row = NULL, *colNamesView = NULL;
    int *ind=NULL;

    int nColsView = 0, nRow=0, nCols=0, i;
    FILE *fp=NULL;
    char fName[HT_MAX_NAME_LENGTH];

    ndb_log_message_text(NDB_MSG_DEBUG,"make_category_form_from_view_t0: Entering");

    t=fobj->GetTablePtr(blockId,category);
    if (t != NULL) 
      itemList = build_item_obj_list_w_table(vobj, category, &nColsView, t);
    else
      itemList = build_item_obj_list(vobj, category, &nColsView);

    ndb_log_message_text(NDB_MSG_DEBUG,"make_category_form_from_view_t0: View category %s has %d columns",
			 category,nColsView);
    //
    //
    //  Get the data for row, curRow....    If this is a "new" row then 
    //         supply the default values from dictionary object ...

    if (rowCurrent >= rowMaximum) {
	values = get_blank_row_with_defaults(cb, itemList, nColsView, nColsView);
    } else {
      ndb_log_message_text(NDB_MSG_DEBUG,"Fetching row %d in category %s",rowCurrent,category);
      if ( t  != NULL) {
	nRow = t->GetNumRows();
	nCols = t->GetNumColumns();
	colNamesView = vobj->GetCategoryItems(category);
	ind = vobj->GetItemColumnIndices(t,colNamesView);
	ndb_log_message_text(NDB_MSG_DEBUG,"Fetched %d rows %d columns in category %s",nRow,nCols,category);
	ndb_log_message_text(NDB_MSG_DEBUG,"Now at row %d of %d",rowCurrent, rowMaximum);
	if (rowCurrent < nRow) {
	  row = t->GetRow(rowCurrent);
	  values = (char **)calloc(nCols,sizeof(char*));
	  for (i=0; i < nCols; i++) {
	    if ((*row)[i].Length() > 0 ) {
	      values[i] = (char *) calloc(((*row)[ind[i]].Length()+1),sizeof(char));
	      strcpy(values[i],(*row)[ind[i]].Text());
	    } else {
	      values[i] = (char *) calloc(2,sizeof(char));
	      strcpy(values[i],"?");
	    }
	    ndb_log_message_text(NDB_MSG_DEBUG,"Fetched item %s value %s Mcode %d Acode %d (%s)",
				 itemList[i].item,values[i],itemList[i].mandatoryCode,
				 itemList[i].allowAlternateCode,itemList[i].item);
	  }
	} else {
	  ndb_log_message_text(NDB_MSG_ERR,"Table length inconsistency in %s at row %d length %d",
			  category,rowCurrent,nRow);
	  values = get_blank_row_with_defaults(cb, itemList, nColsView, nCols);
	}
      }
    }

    CifString * categoryViewName = vobj->GetViewCategory(category);
    ndb_log_message_text(NDB_MSG_DEBUG,"Creating table %s form view name %s", category, categoryViewName->Text());
//
//    Write the form elements to stdout and to the cache file...
//
    ht_put_content_type_target(stdout,"item");
    ndb_log_message_text(NDB_MSG_DEBUG,"Writing frame data now...");
    write_category_form_t0_S1(stdout, cb, blockId, category, categoryViewName->Text(), ufid, 
			      (const char **)values, rowCurrent, 
			      itemList, nColsView, nCols);

    strcpy(fName,dirPath);
    strcat(fName,HT_ITEM_LIST_NAME);
    fp = fopen(fName,"w");
    switch (istyle) {
    case 1:
      write_category_form_t0_S1(fp,cb,blockId,category,categoryViewName->Text(),ufid,
				(const char **)values,rowCurrent,
			     itemList,nColsView, nCols);
    case 0:
      write_category_form_t0_S1(fp,cb,blockId,category,categoryViewName->Text(),ufid,
				(const char **)values,rowCurrent,
			     itemList,nColsView, nCols);
    default:
      write_category_form_t0(fp,cb,blockId,category,categoryViewName->Text(),ufid,
			     (const char **)values,rowCurrent,
			     itemList,nColsView, nCols);
      break;

    }
    fclose(fp);
}


void write_category_form_t0(FILE *fp, CifBuilder &cb,  const char *blockId, const char *category,  
			    const char *categoryViewName,  
			    const char *ufid, 
			    const char **values, int rowCurrent, 
			    const CIFVIEWOBJITEM *itemList, int nitemsView,
			    int nCols)
  /*
   *  Display a single row of a category with columns arranged as a vertical list.
   */

{
  int  i, j, k;
  char   *sItem=NULL;
  char ***itenum=NULL;
  uWord *nitenum=NULL;
  char *typeCode=NULL;
  int *iTypeCode=NULL;


  char pName[CIF_MAX_NAME_LENGTH];
  char pNameAlt[CIF_MAX_NAME_LENGTH];
   
  fprintf(fp,"<HTML>\n");
  fprintf(fp,"%s\n",LANG_HTML_BODY_SCHEME_ALT_2);
  fprintf(fp,"<center><font face=\"%s\" size=5>%s</font>",LANG_HTML_FONT_FACE,LANG_ENTER_DATA_TITLE);

  fprintf(fp,"<font size=5 color=\"#900000\"> %s</font></center>",categoryViewName);


  //
  //       Category help is displayed at the top of the display ...
  //
  display_category_help(fp, cb, category);


  fprintf(fp,"<FORM METHOD=\"POST\" ACTION=\"%s%s%s\" TARGET=\"other\">\n",
	  HT_SERVER_NAME,
	  HT_CGI_PATH,
	  HT_INTERFACE_READ_FORM_CATEGORY);
  
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_UNIQUE_ID, ufid);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_CATEGORY_ID,category);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_DATABLOCK_ID,blockId);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_NUM_ITEMS,nCols);  
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_ROW_ID,rowCurrent);  
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_NUM_ROWS,1);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%d\">\n",HT_ATTRIBUTE_FORM_LAYOUT,6);

  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT);
  fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY);

  fprintf(fp,"<center><font size=4 color=\"#900000\"><INPUT TYPE=SUBMIT VALUE=\"Save %s\"></font></center>",
	  categoryViewName);

  nitenum    = (uWord *)  calloc(nCols, sizeof(int));
  itenum     = (char ***)calloc(nCols, sizeof(char **));
  iTypeCode = (int *)  calloc(nCols, sizeof(int));



  for (k=0; k < nCols; k++) {
    sItem = get_dictionary_item_name(cb,itemList[k].item);
    if (sItem == NULL) continue;
    nitenum[k] = 0;
    itenum[k]=get_sorted_enumeration_list(cb,sItem, nitenum[k]);

    typeCode = cb.GetItemType(sItem);
    iTypeCode[k]=get_item_type_code(typeCode);
    ndb_log_message_text(NDB_MSG_DEBUG,"Item %s enumerates %d type %s type code %d",			
			 sItem,nitenum[k], typeCode, iTypeCode[k]);

    if (sItem) free(sItem);
    if (typeCode) free(typeCode);
  }

  
  fprintf(fp,"<center>");
  fprintf(fp,"<br><br>");
  fprintf(fp,"<table cellpadding=4 border bgcolor=\"%s\">",BGCOLOR_TABLE);
  fprintf(fp,"<tr><th colspan=5 bgcolor=\"%s\"><font size=4 color=\"#000000\"><b>%s</b></font></th></tr>\n",
	  BGCOLOR_TABLE_TITLE,categoryViewName);

  for (k=0; k < nCols; k++) {
    if (itemList[k].mandatoryCode == VIEW_ITEM_IS_HIDDEN) continue;
    fprintf(fp,"<tr>\n");
    // Column Name  ... 
    
    switch(itemList[k].mandatoryCode) {
    case VIEW_ITEM_IS_MANDATORY:
      fprintf(fp,"<td><FONT SIZE=3 COLOR=\"#900000\"><b>%s</b></FONT></td>\n",
	      get_table_attribute_name(itemList[k].item));
      break;
    case VIEW_ITEM_IS_NOT_MANDATORY:
      fprintf(fp,"<td><FONT SIZE=3><b>%s</b></FONT></td>\n",
	      get_table_attribute_name(itemList[k].item));
      
      break;
    }
    // Help,  Definitions, Examples ... 

    fprintf(fp,"<td><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>\n",
	    HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_HELP_VIEW,
	    HT_ATTRIBUTE_UNIQUE_ID,ufid,
	    HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
	    HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
	    HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
	    HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_HELP);
    
    fprintf(fp,"<td><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>\n",
	    HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_DESCRIPTION_VIEW,
	    HT_ATTRIBUTE_UNIQUE_ID,ufid,
	    HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
	    HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
		  HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
	    HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_DESCRIBE);
      
    
    fprintf(fp,"<td><A HREF=\"%s%s%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s\" TARGET=\"other\"><font size=2>%s</font></A></td>\n",
	    HT_SERVER_NAME,HT_CGI_PATH,HT_INTERFACE_ITEM_EXAMPLES_VIEW,
	    HT_ATTRIBUTE_UNIQUE_ID,ufid,
	    HT_ATTRIBUTE_CONTEXT,HT_APPL_CONTEXT,
	    HT_ATTRIBUTE_PROJDIR,HT_ARCHIVE_DIRECTORY,
		  HT_ATTRIBUTE_EXP_METH, HT_EXP_METHOD,
	    HT_ATTRIBUTE_ITEM_ID,itemList[k].item,LANG_EXAMPLES);
    
    
    encode_table_param_name(pName,0,k,0);
    encode_table_param_name(pNameAlt,0,k,1);      
    
    fprintf(fp,"<td>");

    if (nitenum[k] == 0) { // Enumerated, No ...
      
      write_input_item_value(fp, pName, values[k], iTypeCode[k]);
    } else {  // Enumerated, Yes ... 
      
      write_input_enum_item_value(fp, values[k], pName, pNameAlt, (const char **)itenum[k], nitenum[k], 
				  itemList[k].allowAlternateCode);
    }
    fprintf(fp,"</td></tr>");
  }
  fprintf(fp,"</table><br><br>");

  // Hide items not in view ... 

  for (k=0; k < nCols; k++) {
    if (itemList[k].mandatoryCode != VIEW_ITEM_IS_HIDDEN) continue;
    encode_table_param_name(pName,0,k,0);    
    fprintf(fp,"<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">\n",pName,values[k]);    
  }
  
  fprintf(fp,"</center>");
  //  fprintf(fp,"</ul>");
  
  fprintf(fp,"<center><font size=4 color=\"#900000\"><INPUT TYPE=SUBMIT VALUE=\"Save %s\"></font></center>",
	  categoryViewName);
  
  fprintf(fp,"</FORM>\n");
  
  fprintf(fp,"</BODY>\n");
  fprintf(fp,"</HTML>\n");
  
  for (i=0; i < nCols; i++) {
    for (j=1; j < nitenum[i]; j++){
      if (itenum[i][j] != NULL) free(itenum[i][j]);
    }
    if (itenum[i] != NULL) free(itenum[i]);
  }

  if (nitenum != NULL )  free(nitenum);
  if (iTypeCode != NULL )  free(iTypeCode);
}


char **get_blank_row_with_defaults(CifBuilder &cb, const CIFVIEWOBJITEM *items, int nItems, int nCols)
{
    int i;
    char **values=NULL;
    char *defaultValue=NULL;
    ndb_log_message_text(NDB_MSG_DEBUG,"blank_row_with_defaults: nItems %d nCols %d",nItems,nCols);
    values = (char **) calloc(nCols,sizeof(char *));
    for (i=0; i < nItems; i++) {
	ndb_log_message_text(NDB_MSG_DEBUG,"Column %s num %d",items[i].item,i);
      	defaultValue = cb.GetItemDefaultValue(items[i].item);
	ndb_log_message_text(NDB_MSG_DEBUG,"Column %s num %d def %s ",items[i].item,i,defaultValue);
	if (defaultValue != NULL) {
	  ndb_log_message_text(NDB_MSG_DEBUG,"default value %s",defaultValue);
	  values[i] = (char *) calloc(strlen(defaultValue)+1,sizeof(char));
	  strcpy(values[i],defaultValue);
	  free(defaultValue);
	} else {
	    values[i] = (char *) calloc(2,sizeof(char));
	    strcpy(values[i],"?");
	}
    }
    for (i=nItems; i < nCols; i++) {
      ndb_log_message_text(NDB_MSG_DEBUG,"Column num %d  default value %s",i,"?");
      values[i] = (char *) calloc(2,sizeof(char));
      strcpy(values[i],"?");
    }
    return(values);
}



int delete_current_row_from_table(CifFileObj *fobj, const char *blockId, const char *category, int rowIndex)
{
  ISTable *t=NULL;
  int nRow, nAtt;
  ndb_log_message_text(NDB_MSG_DEBUG,"Deleting row %d in block %s category %s", rowIndex, blockId, category);
  
  nRow = 0;
  
  if (fobj->IsTablePresent(blockId,category)) {
    t=fobj->GetTablePtr(blockId,category);
    nRow = t->GetNumRows();
    nAtt = t->GetNumColumns();
    ndb_log_message_text(NDB_MSG_DEBUG,"Found %d rows %d columns in category %s",nRow,nAtt,category);
    if ( rowIndex < nRow) {
      t->DeleteRow(rowIndex);
    }
    nRow = t->GetNumRows();
    fobj->WriteTable(t,blockId,category);
  }
  return(nRow);
}


int insert_after_current_row_in_table(CifFileObj *fobj, const char *blockId, 
					     const char *category, int rowIndex)
{
  ISTable *t=NULL;
  int nRow, nAtt;
  ndb_log_message_text(NDB_MSG_DEBUG,"Inserting row at %d in block %s category %s",rowIndex,blockId,category);

  nRow = 0;
  
  if (fobj->IsTablePresent(blockId,category)) {
    t=fobj->GetTablePtr(blockId,category);
    nRow = t->GetNumRows();
    nAtt = t->GetNumColumns();
    ndb_log_message_text(NDB_MSG_DEBUG,"Found %d rows %d columns in category %s",nRow,nAtt,category);
    if ( rowIndex < nRow) {
      t->InsertRow(rowIndex);
    } else {
      t->InsertRow(rowIndex);
    }
    nRow = t->GetNumRows();
    fobj->WriteTable(t,blockId,category);
  }
  return(nRow);
}

static char *get_table_attribute_name(const char *string)
{
   char *p;

   p=strstr((char*)string," ");
   if (p != NULL) { // not tab.attrib form  
     p  = (char * )&string[0];
     return(p);
   }


   p=strstr((char*)string,".");

   if (p != NULL) {
     p++;
   } else {
     p  =  (char *) string;
   }

   return (p);
}

void display_category_help_message(FILE *fp, const char *helpMessage) {
  
      //    fprintf(fp,"<p><font size=4><pre>\n");
  // JDW OCT 21 bumped font to size 4
    fprintf(fp,"<p><font size=%d>\n", HT_DEFAULT_TEXT_FONT_SIZE);
      //    if (helpMessage != NULL) format_cif_definition(fp, helpMessage);
    if (helpMessage != NULL) fprintf(fp, "%s", helpMessage);
      //    fprintf(fp,"</font></pre>\n");
    fprintf(fp,"</font>\n");
}
